function! EasyMotion#migemo#utf8#load_dict()
    return {
      \ '!' : '\%([≠！!]\|感\_s*嘆\_s*符\)',
      \ '"' : '[”″“〃"]',
      \ '#' : '[＃#]',
      \ '$' : '[＄¢£\$]',
      \ '%' : '\%([％‰%]\|パ\_s*ー\_s*セ\_s*ン\_s*ト\)',
      \ '&' : '\%([＆&]\|ア\_s*ン\_s*\%(ド\|パ\_s*サ\_s*ン\_s*ド\)\)',
      \ "'" : '\%([ズ”″‘′´’'']\|ア\_s*ポ\_s*ス\_s*ト\_s*ロ\_s*フ\_s*ィ\)',
      \ '(' : '[（〔【『［(]',
      \ ')' : '[】』）］)]',
      \ '*' : '[＊×※\*]',
      \ '+' : '[±┿╋＋┼╂+]',
      \ ',' : '[，、,]',
      \ '-' : '\%([ｰ┫┤÷―−━ー‐〜─-]\|マ\_s*イ\_s*ナ\_s*ス\| \_s*…\_s* \)',
      \ '.' : '\%([‥。．・…\.]\|ド\_s*ッ\_s*ト\_s*\%(ネ\_s*ッ\_s*ト\|コ\_s*ム\)\)',
      \ '/' : '\%([≠÷／\/]\|s\_s*l\_s*a\_s*s\_s*h\_s*d\_s*o\_s*t\|ス\_s*ラ\_s*\%(ド\|ッ\_s*シ\_s*ュ\_s*ド\_s*ッ\_s*ト\)\)',
      \ '0' : '\%([〇０零0]\|ゼ\_s*ロ\|z\_s*e\_s*r\_s*o\)',
      \ '1' : '\%([十百千GMKhYZEPTnμmcyzdafp壱弌壹一１1]\|シ\_s*ッ\_s*ク\_s*ス\_s*テ\_s*ィ\_s*ー\_s*ン\|s\_s*\%(e\_s*v\_s*e\_s*n\_s*t\_s*e\_s*e\_s*n\|i\_s*x\_s*t\_s*e\_s*e\_s*n\)\|ト\_s*ウ\_s*ェ\_s*ル\_s*[ブヴ]\|イ\_s*レ\_s*\%(ブ\_s*ン\|ヴ\_s*ン\)\|ハ\_s*ン\_s*ド\_s*レ\_s*ッ\_s*ド\|サ\_s*\%(ー\_s*テ\_s*ィ\_s*ー\_s*ン\|ウ\_s*ザ\_s*ン\_s*ド\)\|g\_s*i\_s*g\_s*a\|ギ\_s*ガ\|メ\_s*ガ\|k\_s*i\_s*l\_s*o\|キ\_s*ロ\|ヘ\_s*ク\_s*ト\|e\_s*\%(i\_s*g\_s*h\_s*t\_s*e\_s*e\_s*n\|l\_s*e\_s*v\_s*e\_s*n\|x\_s*a\)\|エ\_s*\%(イ\_s*テ\_s*ィ\_s*ー\_s*ン\|ク\_s*サ\)\|ペ\_s*タ\|t\_s*\%(w\_s*e\_s*l\_s*v\_s*e\|h\_s*\%(i\_s*r\_s*t\_s*e\_s*e\_s*n\|o\_s*u\_s*s\_s*a\_s*n\_s*d\)\|e\_s*\%(n\|r\_s*a\)\)\|テ\_s*[ンラ]\|ナ\_s*\%(ノ\|イ\_s*ン\_s*テ\_s*ィ\_s*ー\_s*ン\)\|マ\_s*イ\_s*ク\_s*ロ\|ミ\_s*\%(リ\|ク\_s*ロ\)\|セ\_s*\%(ヴ\_s*ン\_s*テ\_s*ィ\_s*ー\_s*ン\|ブ\_s*ン\_s*テ\_s*ィ\_s*ー\_s*ン\|ン\_s*チ\)\|ヨ\_s*\%(タ\|ク\_s*ト\)\|ゼ\_s*\%(タ\|プ\_s*ト\)\|デ\_s*[カシ]\|ア\_s*ト\|ピ\_s*コ\|フ\_s*\%(ィ\_s*フ\_s*テ\_s*ィ\_s*ー\_s*ン\|ォ\_s*ー\_s*テ\_s*ィ\_s*ー\_s*ン\|ェ\_s*ム\_s*ト\|ァ\_s*ー\_s*ス\_s*ト\)\|ワ\_s*ン\|o\_s*n\_s*e\)',
      \ '2' : '\%([弍２二2]\|ト\_s*ウ\_s*ェ\_s*ン\_s*テ\_s*ィ\|セ\_s*カ\_s*ン\_s*ド\|t\_s*w\_s*\%(o\|e\_s*n\_s*t\_s*y\)\|ツ\_s*ー\)',
      \ '3' : '\%([三３3]\|・\_s*・\_s*・\|★\_s* \_s*★\_s* \_s*★\|サ\_s*ー\_s*\%(ド\|テ\_s*ィ\)\|ス\_s*リ\_s*ー\|t\_s*h\_s*\%(i\_s*r\_s*t\_s*y\|r\_s*e\_s*e\)\)',
      \ '4' : '\%([四４4]\|f\_s*o\_s*u\_s*r\|フ\_s*ォ\_s*ー\)',
      \ '5' : '\%([５五5]\|f\_s*i\_s*\%(f\_s*t\_s*y\|v\_s*e\)\|フ\_s*\%(ィ\_s*フ\_s*\%(ス\|テ\_s*ィ\)\|ァ\_s*イ\_s*ブ\)\)',
      \ '6' : '\%([六６6]\|s\_s*i\_s*x\|シ\_s*ッ\_s*ク\_s*ス\)',
      \ '7' : '\%([７七7]\|セ\_s*ブ\_s*ン\|s\_s*e\_s*v\_s*e\_s*n\)',
      \ '8' : '\%([８八8]\|エ\_s*イ\_s*\%([スト]\|テ\_s*ィ\)\|e\_s*i\_s*g\_s*h\_s*t\)',
      \ '9' : '\%([九９9]\|ナ\_s*イ\_s*ン\|n\_s*i\_s*n\_s*e\)',
      \ ':' : '[≒÷…：:]',
      \ ';' : '[；;]',
      \ '<' : '[＜<]',
      \ '=' : '[〒≒≠〓≡＝=]',
      \ '>' : '[＞>]',
      \ '?' : '[？?]',
      \ '@' : '[＠@]',
      \ 'A' : '\%([ｱ餅母渉閔恤憐慌遽鰒蚫鮑袷淡∃主衽歩袵垤蟻麁凡塔蘭露著表霰非抗諍検革更改現競爭争洗殿鉱豫予粗嵐禮殺彪恠妖絢怪綺肖彩漢過謝謬誤礼操綾飴菴黯罨鱇鮟餡闇行按諳晏鞍暗鶩鬚鰓顎喘発肋豈嫂兄崇騰県購贖网罔與咫鼎中新邊邉辺恰頭価價値游遊畔畦堋杏梓与衵袙憬孔坑案侮窖強貴讎讐徒仇痣黶欺鮮糾字嘲薊姐姉曙炮焙炙蜚薹膏脂油危鐙虻泡蹟能痕踪跡東預輯蒐乢纂遏聚軋誂羹壓惇集陸敦暑淳篤熱扱暖温遖斡私圧焦汗央奥桜櫻媼奧塰蜑餘周遍普剰蔗余尼雨甘天押凹楝樗溢艶鰺庵網戯簣鯵味軛渥堊圷憧欠踵幄握芥齷厚蜊漁鯏蕣淺麻浅龝煥晢晰呆亮晄聡亨朖璋啓昜輝顯旭光陽洸鑑滉昿曠諦朗哲顕晶彬賈章商穐晃彰晧昭秋欸埃瞹阨穢噫姶文隘粟曖鮎藹饗靉挨間相哀葭趾晨朝愛跛蹇跫脚蘆葦芦桎鐐足赫淦燈赧紅旃朱茜藜銅赭曉閼暁垢皸皹證絳灯暴証赤扇呷黝榮碧葵蒼煽仰青穴併宛亞痾明逢吾悪婀在遭該飫褪浴荒揚編和會椏合襾安挙或當哇有開厭唖韲阿嗚当娃敢倦彼惡遇飽充上擧あ藍金＠∧＆∩論&∠銀会∀域空→←↓⇒↑⇔⌒後Ц亜米¨´｀＾’≒〜ＡÅаαАアΑA]\|厦\_s*門\|廈\_s*門\|沫\_s*雪\|食\_s*蟻\_s*獣\|H\_s*a\_s*l\_s*o\_s*r\_s*a\_s*g\_s*a\_s*l\_s*e\_s*s\|浣\_s*熊\|菖\_s*蒲\|豆\_s*汁\|蛙\_s*鳴\_s*蝉\_s*噪\|塩\_s*梅\|家\_s*鴨\|趺\_s*坐\|Z\_s*\%(n\|i\_s*n\_s*c\)\|浮\_s*子\|痘\_s*痕\|窪\_s*地\|醤\_s*蝦\|糠\_s*蝦\|信\_s*天\_s*翁\|左\_s*沢\|雅\_s*典\|校\_s*倉\|小\_s*豆\|四\_s*阿\|鴉\_s*\%(片\|鷺\_s*合\_s*戦\_s*物\_s*語\)\|綽\_s*名\|渾\_s*名\|化\_s*野\|翌\_s*檜\|飛\_s*[魚鳥]\|総\_s*角\|通\_s*草\|木\_s*通\|L\_s*a\_s*r\_s*d\_s*i\_s*z\_s*a\_s*b\_s*a\_s*l\_s*a\_s*c\_s*e\_s*a\_s*e\|花\_s*鶏\|我\_s*\%(妻\|孫\_s*子\)\|数\_s*多\|奄\_s*美\|灰\_s*汁\|a\_s*\%(t\_s*t\_s*o\|c\_s*c\_s*e\_s*n\_s*t\)\|胡\_s*[座坐床葱]\|日\_s*明\|碩\_s*宏\|祥\_s*[仁彦]\|蜻\_s*蛉\|E\_s*\%(s\|i\_s*n\_s*s\_s*t\_s*e\_s*i\_s*n\_s*i\_s*u\_s*m\)\|生\_s*憎\|匕\_s*首\|英\_s*\%([保田]\|虞\_s*湾\|賀\_s*保\)\|靄\_s*[靄々]\|Ｉ\_s*\%(Ｐ\_s*電\_s*話\|Ｃ\_s*\%(タ\_s*グ\|カ\_s*ー\_s*ド\)\)\|I\_s*\%(r\_s*i\_s*d\_s*a\_s*l\_s*e\_s*s\|P\_s*\%(電\_s*話\|ア\_s*ド\_s*レ\_s*ス\)\|D\_s*カ\_s*ー\_s*ド\|C\_s*\%(タ\_s*グ\|カ\_s*ー\_s*ド\)\)\|走\_s*目\|鹹\_s*草\|馬\_s*酔\_s*木\|海\_s*[豹女士人部驢]\|R\_s*u\_s*b\_s*i\_s*a\_s*\%(l\_s*e\_s*s\|c\_s*e\_s*a\_s*e\)\|褐\_s*毛\_s*和\_s*種\|石\_s*蓴\|白\_s*馬\|水\_s*[馬黽綿]\|M\_s*a\_s*l\_s*v\_s*a\_s*l\_s*e\_s*s\|ト\_s*リ\_s*プ\_s*ル\_s*A\| \_s*ア\_s*ク\_s*シ\_s*ア\_s*ム\|公\_s*理\|砒\_s*素\|ヒ\_s*素\|京\_s*都\_s*高\_s*度\_s*技\_s*術\_s*研\_s*究\_s*所\|代\_s*入\|遺\_s*産\|抽\_s*象\|G\_s*o\_s*l\_s*d\|自\_s*動\_s*\%(現\_s*金\_s*取\_s*り\_s*扱\_s*い\_s*機\|預\_s*貯\_s*金\_s*機\)\|属\_s*性\|何\_s*か\|か\_s*つ\|お\_s*よ\_s*び\|セ\_s*ン\_s*ト\_s*キ\_s*ッ\_s*ツ\_s*ネ\|S\_s*\%(b\|i\_s*l\_s*v\_s*e\_s*r\)\|利\_s*用\_s*可\_s*能\|使\_s*用\_s*可\_s*能\|算\_s*法\|割\_s*り\_s*当\_s*て\|オ\_s*\%(レ\|ギ\_s*ュ\_s*ス\_s*タ\_s*ン\|ド\_s*レ\_s*イ\|ン\_s*グ\_s*ス\_s*ト\_s*ロ\_s*ー\_s*ム\|ル\_s*\%(ト\_s*キ\_s*ー\|タ\_s*\%([ーナ]\|ネ\_s*\%(ー\_s*ト\|イ\_s*ト\)\)\)\|ー\_s*\%([クガサトラル]\|ニ\_s*ン\_s*グ\|キ\_s*シ\_s*ン\|ブ\_s*リ\_s*ー\|バ\_s*ー\_s*ド\|ベ\_s*ル\_s*ジ\_s*ュ\|ギ\_s*ュ\_s*ス\_s*\%(ト\|タ\_s*ン\)\|ゾ\_s*ン\_s*ヌ\|ス\_s*\%(チ\_s*ン\|テ\_s*ィ\_s*ン\|タ\_s*ー\|ト\_s*\%(リ\_s*ア\|ラ\_s*リ\_s*ア\)\)\|ド\_s*リ\_s*ー\|ジ\_s*\%([ェー]\|オ\_s*ロ\_s*ジ\)\|デ\_s*ィ\_s*\%(オ\|エ\_s*ン\_s*ス\|シ\_s*ョ\_s*ン\|ト\_s*リ\_s*ア\_s*ム\)\|タ\_s*ム\|ソ\_s*\%(リ\_s*テ\_s*ィ\|ラ\_s*イ\_s*ズ\)\|セ\_s*ン\_s*テ\_s*ィ\_s*ッ\_s*ク\|ロ\_s*ラ\)\)\|配\_s*列\|バ\_s*イ\_s*ト\|ハ\_s*ル\_s*マ\_s*ゲ\_s*ド\_s*ン\|引\_s*数\|人\_s*工\_s*\%(現\_s*実\_s*感\|知\_s*能\)\|イ\_s*\%(ー\_s*ジ\_s*ス\|オ\_s*ン\|ソ\_s*ッ\_s*プ\)\|マ\_s*ル\_s*ド\_s*ゥ\_s*ー\_s*ク\|紫\_s*\%(陽\_s*花\|水\_s*晶\|石\_s*英\)\|付\_s*録\|応\_s*用\|エ\_s*\%([ニメアーイ]\|ッ\_s*チ\|ン\_s*\%(ド\_s*ラ\_s*ン\|ジ\_s*ェ\_s*\%(ル\|リ\_s*ッ\_s*ク\)\|ゼ\_s*ル\)\|リ\_s*ア\|オ\_s*リ\_s*ア\|ス\_s*テ\|プ\_s*ロ\_s*ン\)\)',
      \ 'B' : '\%([鯔鰡堀本凡盆煩梵骨凹歿鈕釦沒渤没睦穆樸目濮攵攴朴木僕墨卜牧星黽蠎髦罔袤鋩氓瑁虻卯茆貌謗网旄抱甍儚胞蟒肪旁鵬牟眸冐鉾蒡榜懋乏惘妨帽昴忙剖冒忘茅膀妄厖尨膨貿防紡滂茫望亡傍某謀乾牡掘姆保慕簿惚模戊墓拇菩謨暮呆干暈姥褒彫坊募誉母ぼ覓幎汨冖羃巾冪紅韈瞥鼈蔑塀汳采抃辯辧卞辨湎宀遍瓣辮眄冕勉娩弁可辺邉邊べ船房笛鞭渊斑淵縁渕樗椈太袋深蓋葢盖豚節勿佛物震勃蚋風鰤馼蚊聞文錻葡侮葺蒲憮舞撲撫廡毋無嘸誣悔奉吹蕪撃部伏打振武歩拭分不ぶ米謐人匹浸額鐚跛！広開繆別謬緡泯罎岷梹旻紊檳頻壜愍瓶鬢閔憫敏貧便闢百辟帛白杪緲猫票憑″鋲屏眇渺平錨苗秒描廟病琵弾未比眉毘尾靡瀰寐微糜媚備引麋美濔弭火枇縻嵋贔日糒び早速林針尿拂腹散払祓原幡悗蠻塙旛鑁旙鷭挽判棒絆版輓蕃板播礬阪坂磐番盤晩萬蛮万箱蠅芒挟伴桴鉢枹蜂撥働畑畠屎糞端花鼻離話V魅許秤拔魃罸筏閥走橋箸柱藐貘寞獏暴漠瀑麥縛博駁莫驀爆杯唄霾賣狽吠楳苺憊培煤黴貝焙賠買売陪倍梅媒跋伐末幕曝抜罰場貼馬刄芭化葉庭羽張這塲罵刃晴歯馳婆ば“仏■□⊥底下×−‖｜＼∵麦ボバ］［｝｛ＢブビΒБбβベB]\|ｯ\_s*\%(ﾎ\_s*ﾞ\|ﾍ\_s*ﾞ\|ﾌ\_s*ﾞ\|ﾋ\_s*ﾞ\|ﾊ\_s*ﾞ\)\|ッ\_s*[ボベブビバ]\|っ\_s*[ぼべぶびば]\|ﾎ\_s*ﾞ\|小\_s*火\|襤\_s*褸\|孟\_s*買\|P\_s*a\_s*e\_s*o\_s*n\_s*i\_s*a\_s*\%(l\_s*e\_s*s\|c\_s*e\_s*a\_s*e\)\|南\_s*瓜\|耄\_s*耋\|孑\_s*孑\|包\_s*丁\|ﾍ\_s*ﾞ\|袂\_s*別\|箆\_s*棒\|篦\_s*棒\|胼\_s*胝\|ﾌ\_s*ﾞ\|補\_s*任\|毒\_s*島\|醜\_s*[女男]\|山\_s*毛\_s*欅\|F\_s*a\_s*g\_s*a\_s*l\_s*e\_s*s\|布\_s*団\|茯\_s*苓\|Ｖ\_s*\%(字\|ネ\_s*ッ\_s*ク\|シ\_s*ネ\_s*マ\)\|附\_s*子\|付\_s*子\|鞦\_s*韆\|豊\_s*[前後]\|ﾋ\_s*ﾞ\|魚\_s*[籠篭]\|b\_s*i\_s*o\_s*t\_s*o\_s*p\_s*e\|彌\_s*縫\|弥\_s*[漫縫]\|吃\_s*驚\|天\_s*鵞\_s*絨\|緬\_s*甸\|賓\_s*頭\_s*盧\|編\_s*木\|柏\_s*槙\|S\_s*a\_s*n\_s*t\_s*a\_s*l\_s*a\_s*l\_s*e\_s*s\|兵\_s*[衛法]\|拍\_s*[板子]\|表\_s*紙\|ﾊ\_s*ﾞ\|囃\_s*子\|巴\_s*爾\_s*幹\|R\_s*o\_s*s\_s*a\_s*l\_s*e\_s*s\|薔\_s*薇\|蟠\_s*踞\|鈑\_s*金\|A\_s*n\_s*n\_s*o\_s*n\_s*a\_s*c\_s*e\_s*a\_s*e\|発\_s*条\|祖\_s*母\_s*さ\_s*ん\|梯\_s*子\|伯\_s*\%([林労楽]\|剌\_s*西\_s*爾\)\|莪\_s*原\|飛\_s*[車蝗]\|蝗\_s*虫\|掲\_s*示\_s*板\|プ\_s*ル\_s*コ\_s*ギ\|作\_s*業\_s*域\|オ\_s*ー\_s*ト\_s*バ\_s*イ\|基\_s*[礎底]\|フ\_s*ァ\_s*ゴ\_s*ッ\_s*ト\|背\_s*景\|北\_s*京\|ペ\_s*\%(キ\_s*ン\|テ\_s*ル\_s*ギ\_s*ウ\_s*ス\)\|臭\_s*素\|イ\_s*ギ\_s*リ\_s*ス\|硼\_s*素\|ホ\_s*ウ\_s*素\)',
      \ 'C' : '\%([ｺ恐怖惟怺※米暦轉頃悃鶤獻艮鯤很袞坤壼琿狠建棍魂蒟菎滾梱溷献痕渾墾恨懇根杪王挙泥裔樸鞐熟枹醴蛩徑蹊径溢毀零錯苔拒亊箏斷判諺理断盡尽辞琴言異事今壽寿鯒冀希礫鯉拱齣狛細腓昆拳瘤鮗兄近谺応應答爰是凩惚榾兀忽輿甑腰拵拗鐺鏝桁杲磽絖昊耗闔狎靠冓汞湟塙慌嫦效頁礦冦淆遘仰昴誥鬨鴿鏗浤哮砿伉烋熕洽訌閧困鮫逅糠槹哽盍稾亙壙覯隍遑洸餃惶寇鵁皋黌椌扣晄矼肓頏蛤呷詬匣昿皐崗肱徨峇袷敲爻藁倥釦棡凰犒吭窖畊岡猴胱絋傚啌蚣缸紘湊搆閤峺羔鍠幌鱇扛肴恆紺鈩絳閘蒙冰氷郡蛟槁候楮媾溘后蝗酵嚆犢稿亢哄睾梗慷笄郊効岬肛項巷鑛洪佼狡叩昂勾喉晃滉糀晧剛曠宏控恍侯皓港膏耿皎坑煌向江膠虹巧鴻鉱興衡浩厚耕弘綱抗購講恒薨溝鋼航孝更校行肯光皇好荒高梏谷哭槲尅釛斛轂詰棘告刻酷穀踰懲蝴鴣袴觚虍粐乎沽餬胯菰瞽楜娘壺錮込葫⌒虚兒杞估冴漕痩虎冱倒戸呱媚粉夸詁木鈷捏濃故濾箍漉黄恋拠誇壷放転鼓股罟女己乕琥跨滬越古去糊滸扈瑚皷混怙弧辜戀蠱超児雇孤湖瓠蛄凅肥こｾ芹鬩槧羶甎揃倩翦箋燹濺苫栫槫孱孅簽吮纖湶纎亘筌蟾磚荐茜斬綫箭舩喘錢專僊贍鐫仟旃痊涎銛饌僣韆沾刋擶薦舛牋阡濳癬筅殱殲闡賎餞羨顫甅竰糎陝銓踐閃∨潺遷銑栴剪煽譫僉瞻践栓跣疝詮銭穿尠戰腺繊僭泉嬋淺仙擅鮮専扇浅蘚船線撰宣洗選煎戦尖先忙伜倅逼狹狭蝉旋洩椄§卩渫絏鱈泄攝啜紲緤薛刹褻浙竊截窃殺説拙摂節切蹐績蹠蓆籍跡跖晰威螫迹瘠勣裼晢夕鶺雪寂∫∬碩惜析席隻情甥躋貰淒婿嘶醒睛擠撕牲萋菁犀韲瀞穽齏筬晟齊歳栖棲掣腥逝惺斉臍旌悽整凄靖製晴急世堰攻脊丗迫勢畆糶塞瀬畝せｸ配椪栩櫪檪椡椚箜櫟含纐婚糞癖潛潜鵠凹窪縊跟軛頚珞頸諄窟鞋履狐轡覆沓碎砕条降件頽崩屑釘莖茎陸杙杭掘崛倔鶏鐃藥擽薬楠誓梳串釧與与挫籖鯀鯨鬮籤隈熊艸嚔藾叢鏈腐鎖ξΞ茸菌楔草圀邦國国嗽漱吻劫刧腔φ粂皹勳熏裙醺桾皸崑燻訓勲葷君委钁企咥銜桑某暝峅眛昏冥鮓比闇位鞍藏暗倉廚厨涅〃仝ヽゞヾ々ゝ公曇雲蜘佝栗狂包胡俥梍枢畔鐵★玄黒玖供苦九枸鳩煦狗来徠吼工絎駒朽眩垢口窶区劬繰呉宮暮貢久嶇來奇９庫惧組衢紅句吁懼區桍孔怐瞿汲くｼ埀謐Σσ蕋蘂蕊痺褥茵鵐蔀鷸鴫入責霑蔵嶌了縞嶋島凋搾澀澁渋縛暫屡柴荵凌鎬忍慕簧舖↓襪認从從．舌扱罔θ虐Θ粃秕椎椣貎尿肉臠猪衣榻黙蜆恵楙誠茂成繁鋪惻陣頻閾櫁樒汐鹽潮隰瑟嫉櫛蛭蟋疾隲悉漆躾膝失室沒鎭沈滴雫賤鎮靜静顰尓爾聢乍然併■□◇◆倖幸貭叱征質柵卯滋撓品鬼錣鍜錏凝痼而拉設垂萎栞襞吝咳什導汁徴験著記印☆〇銀城報調蝨虱白濕湿標七僕笞楚霜臀退斥後尻寫卸者炙冩柘舍砂＃♯暹諜喋煮這西娑沙謝紗鯱奢赦洒捨鮭瀉炸抉決皙勺釋蜥爍鑠妁斫蹟刳昔芍酌爵折癪笏赤綽灼杓石尺赭写鷓積遮舎車射斜釈社蛛麈諏洙殳娶娵鬚侏銖繻菽叔俶戚蓿倏蹙肅淑夙粛宿縮珠殊趣恤蟀卆出繍楢葺溲泅酬逎遒緝岫螽萩鷲甃駲楸穐蹤讎售讐洲綉收驟囚舅姑蓚皺鞦銹脩輯醜習羞酋聚舟秀祝袖拾啾蒐収執衆愁就臭蹴週終褶州宗集秋椶棕朱撞種修周手酒首須儁皴悛濬惷蕣雋墫順蠢舜旬浚竣峻駿逡筍瞬俊嗔蓁縉蔘鷏忱甄鷆寢岑畛矧疹槙齔臻娠譛譖哂脣袗怎晉瀋箴軫榛秦襯診鉐津駸讖紳斟唇針呻蜃賑芯瞋振殿侵薪晨辰震宸森伸愼眞慎寝晋進審深親臣鍼申心宍信真新藷墅薯杵岨胥蜍黍渚砠處嶼狙苜苴曙背緒雎蔗庶処署所暑誚篠聲橡奬觴舂囁蛸懾燮厰錆獎枩稍甞韶炒淞陞顳咲腫井摺嶂橸浹愴星升鍬樅簫慯廂霎庠剿筱鬆秤鯖政訟廠樵鷦邵愀妝璋湫艢劭峭殤梢將敞醤青慫従逍倡竦爿薔笙樟装肖菖＜≦湘誦聳檣稱声裳蒋蕉嘯慴盛精霄清鈔粧彰悚鏘悄蕭哨瀟焦憔匠鍾償鞘瘴漿頌詔妾沼請薑唱庄渉障奨牀娼床椒荘抄聖宵傷性生相召銷賞猩症昭燒猖昌少憧紹晶祥尚承證将焼笑照招消章詳証硝掌商昇小觸穡屬稷嗇禝寔稙昃謖軾矚拭属燭贖囑嘱織蝕式喰蜀殖初諸触埴植食職砥姉摯誣侈髭肆仔及岐址梔咫刺贄沚旨誌資豕鷙凍厮粢齒雌耜枝齎領篩四嗤貲諮巵止死強仕熾市師指厶妛諡祗閇姿駟嗜衰偲嗣趾此染締詞茲釶〆覗弛士徙至嘴駛屎占啻之揣如知錙糸絞孜尸獅瓷緊笥始泗咨觜只匙輜廝使敷恃思痴漬脂氏蚩時紫沁俟絲巳祉矢恣若賜次浸詩志識司弑笶翅謚示梓伺視緇自祠史試私痣滲茨肢歯幟祀施竢舐卮耆呰芝阯しｶ癢糜粥痒麹輕骨業軽鰈鰔餉通龜瓶甕亀鳫獵鴈殯K猟雁釀鳬鳧髢氈鴨巛側躱廁厠磧瓦獺翡為皮裘→紮〜搦苧碓柄躯躰軆體身体鴉犂烏絡空唐榧茅澗鸛厂蒄啣卷淦扞杆骭歛瞰讙奐戡豢坎瀚皖稈鐶拑酣陷繝嫺驩篏樌莟勸捍撼澣盥羹嫻鑵寰丱康懽憾羮揀歡潤罕觀橄涵渙堪覡巫鉋随萱簪舘艱咸翰柬駻悍燗槓浣邯攷稽宦考棺潅閂煥鉗疳癇函凾鹹緘款桓箝諫諌轗坩旱侃鰥　館莞橇韓患灌勧菅奸刊柑肝看桿寒緩干嵌廣広竿貫巻敢漢環喊陥監喚甘間歓閑寛管慣完汗艦乾幹官観壁椛屍姓庇鞄芳蔓千鯑一勘蜻⊃影陰蔭景＊棧梯筧庚辛柧門廉乞癩Κ川κ合’）《‘”｛〈“｝》〉囓柁鮖悴舵鰍梶錺餝飾篭籠歸孵卻皈還省顧楓槭却帰反返守帋督祇髮韮主裃雷髪紙鉦曲矩予鐘樺沫偏騙語潟刀象模仇固硬傍難容忝辱頑形旁方型肩風滓翳微幽掠緕纃綛絣擦糟鎹粕春戞猾曷剋黠瞎鞨恰∧濶蠍筈蝎羯喝轄餓蛞聒劼擔刮蘰鬘桂闊括嘗捷豁渇担滑松堅鰹功割戛活疽暈鵲瘡傘嵩重襲葛笠堵硴墻牆蠣蛎柿掲關罹抱踵嬶嚊拘関係顏貌郁薫顔母感釡罐窰鴎框叺喧竃竈窯釜缶蒲鎌數数槝栢膳傅畏賢橿姦樫爨炊圍喞託囲鈎「『鉤」』限鍵傾（禿蕪鏑頭齧被兜哉適敵必要称彜彝鬲鼎叶片哀愛悲鋺蛇鉄蜩神奏金楫裹磆餅徒褐粮糧茖椁覺幗槨貉擴壑隱愨寉殼癨嚇穫咯膕骼膈∠掴狢埆蠖覈霍礁恪擱匿撹攪喀廓較郭〕【［】］〔殻挌劃閣格隠覚矍革馘鶴攫核獲拡客隔角確廨囘隗嵬觧榿蠏匯徊迴壞褂獪丐械枴畍誨揩醢誡夬懈喙椢恠峡价櫂茴蛙瑰乖浬鰄傀糴柏街鳰懷蛔蠶蚕邂蟹潰壊恢腕芥垣楷會拐悔詼諧皆界疥魁偕改繪貝胛絵快甲灰槐晦懐介塊解廻回階戒開会怪海縢篝炬耀赫輝冠鑒鑑各屈鏡柯噛箇上苛暇蚊廈易嘩ヵ描苅枯佳彼兼哥缺霞藉架啝下渦踝堝闕華嗄荷馨刈假夥河科個蝸迦軻咼黴舸繋書賀夏萪支卦掛掻蝦痂謌渮歌過香禾狩買變家枷克駈花賈畫珂呵替代訶袈咬画顆貸價淅飼和ヶ果糅厦課可醸葭勝仮搗嘉墟嗅譌日斯禍換窩苟貨蝌価懸欠化罅伽賭翔靴且嚼訛何駆驅个嫁譁借跏戈稼寡涸耶崋鹿笳火茄菓遐舁か・…塩閉倶錫呼∩取籐加交ФГДАжБъйдзьЖНкёЗрЭцУТвСЮюЪЯЁЛИноыбВмМХЬЕэаепПКЩсШщяхЫштОРилгуЙф♪╂┼×╋┿◎○●銅∪χΧ子Чч株Ц珈、，色ク衝競構簡制≡変接カ┏┓└┌┛┘┗┐正コシセＣ℃¢C]\|ｯ\_s*[ｺｾｸｼｶ]\|ッ\_s*[コセクシカ]\|っ\_s*[子こせくしか]\|焜\_s*炉\|嫡\_s*妻\|二\_s*合\_s*半\|牛\_s*尾\_s*魚\|巨\_s*勢\|独\_s*楽\|居\_s*士\|特\_s*牛\|粫\_s*門\|甦\_s*生\|f\_s*o\_s*o\_s*t\_s* \_s*a\_s*n\_s*d\_s* \_s*m\_s*o\_s*u\_s*s\_s*e\_s* \_s*d\_s*i\_s*s\_s*e\_s*a\_s*s\_s*e\|傴\_s*僂\|A\_s*\%(r\_s*c\_s*h\_s*i\_s*c\_s*h\_s*l\_s*a\_s*m\_s*y\_s*d\_s*e\_s*a\_s*e\|p\_s*i\_s*a\_s*l\_s*e\_s*s\)\|U\_s*m\_s*b\_s*e\_s*l\_s*l\_s*i\_s*f\_s*l\_s*o\_s*r\_s*a\_s*e\|台\_s*詞\|懺\_s*法\|前\_s*[妻栽]\|妹\_s*尾\|嘲\_s*笑\|儕\_s*輩\|斎\_s*次\|済\_s*[民済々]\|蒸\_s*[篭籠]\|救\_s*世\|莎\_s*草\|百\_s*[濟済]\|恭\_s*敬\|9\_s*[日月]\|秧\_s*鶏\|究\_s*竟\|釉\_s*掛\|典\_s*薬\_s*寮\|探\_s*湯\|球\_s*磨\|六\_s*合\|地\_s*祇\|都\_s*子\|群\_s*衆\|慈\_s*姑\|旧\_s*\%(訳\|唐\_s*書\)\|内\_s*蔵\_s*助\|H\_s*e\_s*l\_s*l\_s*e\_s*b\_s*o\_s*r\_s*o\_s*i\_s*d\_s*e\_s*a\_s*e\|J\_s*u\_s*g\_s*l\_s*a\_s*n\_s*d\_s*a\_s*l\_s*e\_s*s\|R\_s*h\_s*a\_s*m\_s*n\_s*a\_s*l\_s*e\_s*s\|老\_s*舗\|望\_s*潮\|健\_s*か\|L\_s*a\_s*\%(u\_s*r\_s*\%(a\_s*c\_s*e\_s*a\_s*e\|o\_s*i\_s*d\_s*e\_s*a\_s*e\)\|m\_s*i\_s*n\_s*a\_s*l\_s*e\_s*s\|b\_s*i\_s*a\_s*t\_s*a\_s*e\)\|埋\_s*葬\_s*虫\|幣\_s*原\|卓\_s*袱\|桎\_s*梏\|柳\_s*葉\_s*魚\|汚\_s*点\|蠹\_s*魚\|惠\_s*雄\|舗\_s*石\|磯\_s*城\|W\_s*i\_s*n\_s*t\_s*e\_s*r\_s*a\_s*c\_s*e\_s*a\_s*e\|倭\_s*文\|云\_s*[云々]\|明\_s*\%(々\_s*後\_s*日\|明\_s*後\_s*日\)\|７\_s*月\|7\_s*月\|文\_s*月\|４\_s*[分月]\|4\_s*月\|竹\_s*[篦刀]\|羊\_s*[齒歯]\|爲\_s*\%([留難置果送極手兼合業]\|ん\_s*方\|來\_s*り\|納\_s*め\)\|I\_s*\%(l\_s*l\_s*i\_s*c\_s*i\_s*a\_s*c\_s*e\_s*a\_s*e\|s\_s*o\_s*p\_s*y\_s*r\_s*o\_s*i\_s*d\_s*e\_s*a\_s*e\)\|素\_s*[魚人面]\|不\_s*[忍知]\|注\_s*連\|軍\_s*鶏\|髑\_s*髏\|三\_s*\%(味\|鞭\_s*酒\)\|吃\_s*逆\|差\_s*[別異]\|叉\_s*手\|輸\_s*[出贏]\|卒\_s*去\|B\_s*r\|隼\_s*[朗郎]\|笋\_s*[干羹]\|参\_s*差\|財\_s*産\|枌\_s*所\|縦\_s*容\|睫\_s*毛\|M\_s*\%(e\_s*t\_s*a\_s*c\_s*h\_s*l\_s*a\_s*m\_s*y\_s*d\_s*e\_s*a\_s*e\|u\_s*s\_s*a\_s*l\_s*e\_s*s\)\|S\_s*\%([ge]\|p\_s*e\_s*r\_s*m\_s*a\_s*t\_s*o\_s*p\_s*h\_s*y\_s*t\_s*a\|c\_s*i\_s*t\_s*a\_s*m\_s*i\_s*n\_s*e\_s*a\_s*e\)\|Z\_s*i\_s*n\_s*g\_s*i\_s*b\_s*e\_s*r\_s*a\_s*l\_s*e\_s*s\|続\_s*\%(日\_s*本\_s*\%(紀\|後\_s*紀\)\|後\_s*撰\_s*和\_s*歌\_s*集\)\|離\_s*れ\_s*離\_s*れ\|掃\_s*部\|羚\_s*羊\|土\_s*器\|蝙\_s*蝠\|魚\_s*狗\|P\_s*\%(i\_s*p\_s*e\_s*r\_s*a\_s*\%(l\_s*e\_s*s\|c\_s*e\_s*a\_s*e\)\|t\_s*e\_s*r\_s*i\_s*d\_s*o\_s*s\_s*p\_s*e\_s*r\_s*m\_s*\%(a\_s*l\_s*e\_s*s\|i\_s*d\_s*a\_s*e\)\|o\_s*\%(t\_s*a\_s*s\_s*s\_s*i\_s*u\_s*m\|d\_s*o\_s*s\_s*t\_s*e\_s*m\_s*o\_s*n\_s*a\_s*l\_s*e\_s*s\)\)\|連\_s*枷\|枳\_s*殻\|機\_s*関\|落\_s*葉\_s*松\|凵\_s*繞\|檻\_s*車\|顴\_s*骨\|T\_s*\%(h\_s*a\_s*l\_s*i\_s*c\_s*t\_s*o\_s*i\_s*d\_s*e\_s*a\_s*e\|u\_s*b\_s*i\_s*f\_s*l\_s*o\_s*r\_s*a\_s*e\)\|南\_s*瓜\|量\_s*子\|山\_s*\%(海\_s*経\|梔\_s*子\|陽\_s*道\)\|蜉\_s*蝣\|陽\_s*炎\|破\_s*片\|脚\_s*気\|旗\_s*魚\|鍛\_s*[治冶]\|挿\_s*頭\|駕\_s*\%(籠\|輿\_s*丁\)\|長\_s*[月官]\|剃\_s*刀\|天\_s*\%(牛\|鼠\_s*矢\)\|帷\_s*子\|酢\_s*漿\_s*草\|O\_s*x\_s*a\_s*l\_s*i\_s*d\_s*a\_s*c\_s*e\_s*a\_s*e\|飛\_s*[沫白]\|曽\_s*て\|曾\_s*て\|燕\_s*子\_s*花\|牡\_s*[蛎蠣]\|民\_s*部\|部\_s*曲\|E\_s*\%(b\_s*e\_s*n\_s*a\_s*l\_s*e\_s*s\|l\_s*a\_s*n\_s*a\_s*l\_s*e\_s*s\)\|案\_s*山\_s*子\|梭\_s*\%(魚\|子\_s*魚\)\|螳\_s*螂\|蟷\_s*螂\|瓜\_s*\%(田\|呂\_s*根\)\|拍\_s*手\|瑕\_s*[瑾疵]\|東\_s*\%([風雲]\|海\_s*林\|京\_s*都\_s*立\_s*科\_s*学\_s*技\_s*術\_s*大\_s*学\)\|気\_s*[質触]\|(\_s*株\_s*)\|贏\_s*ち\_s*得\|歩\_s*兵\|恁\_s*く\|杜\_s*\%(若\|父\_s*魚\)\|梅\_s*花\_s*皮\|頴\_s*田\|膾\_s*炙\|契\_s*経\|中\_s*央\_s*処\_s*理\_s*装\_s*置\|伊\_s*藤\_s*忠\_s*テ\_s*ク\_s*ノ\_s*サ\_s*イ\_s*エ\_s*ン\_s*ス\|分\_s*類\|ス\_s*リ\_s*ー\_s*ズ\|範\_s*疇\|ト\_s*ラ\_s*ン\_s*プ\|c\_s*\%(e\_s*n\_s*t\_s*i\|r\_s*e\_s*s\_s*c\)\|水\_s*[鶏母手夫晶]\|複\_s*雑\_s*命\_s*令\_s*セ\_s*ッ\_s*ト\_s*計\_s*算\_s*機\|サ\_s*\%(ン\_s*チ\_s*ー\_s*ム\|エ\_s*ラ\|イ\_s*\%(ト\_s*カ\_s*イ\_s*ン\|ラ\_s*ス\|ク\_s*\%([ルロ]\|リ\_s*\%(ン\|ッ\_s*ク\)\)\|ボ\_s*\%(ウ\_s*ズ\|ー\_s*グ\)\|バ\_s*\%(ー\|ネ\_s*テ\_s*ィ\_s*\%(ッ\_s*ク\|ク\_s*ス\)\)\|リ\_s*ュ\_s*ー\_s*ム\|ダ\_s*ー\|フ\_s*ァ\_s*ー\|ネ\_s*リ\_s*ア\)\|ー\_s*\%(テ\_s*ィ\_s*フ\_s*ィ\_s*ケ\_s*ー\_s*シ\_s*ョ\_s*ン\|ク\_s*ル\|カ\_s*\%(ス\|ム\_s*ス\_s*ク\_s*\%(ラ\_s*イ\_s*ブ\|リ\_s*プ\_s*シ\_s*ョ\_s*ン\)\)\|キ\_s*\%(ュ\_s*\%(ラ\_s*ー\|レ\_s*ー\_s*\%(タ\_s*ー\|シ\_s*ョ\_s*ン\)\)\|ッ\_s*ト\)\)\)\|マ\_s*ド\_s*ラ\_s*ス\|茶\_s*筅\|ケ\_s*\%([月アイ]\|フ\_s*ェ\_s*ウ\_s*ス\|プ\_s*ス\_s*ト\_s*ラ\_s*[ムル]\|チ\_s*ャ\_s*ッ\_s*プ\|ン\_s*\%(タ\_s*ウ\_s*\%(リ\|ロ\_s*ス\)\|ブ\_s*リ\_s*ッ\_s*ジ\)\|ー\_s*\%([キジブプスン]\|ク\_s*ウ\_s*ォ\_s*ー\_s*ク\|ソ\_s*ン\|タ\_s*リ\_s*ン\_s*グ\|パ\_s*\%(ー\|ビ\_s*リ\_s*テ\_s*ィ\)\|シ\_s*ン\_s*グ\|リ\_s*ー\)\|ル\_s*\%(ト\|ベ\_s*ロ\_s*ス\|テ\_s*ィ\_s*ッ\_s*ク\|ビ\_s*\%(ム\|ー\_s*ニ\)\)\|ミ\_s*\%(カ\_s*ル\|ス\_s*ト\)\)\|キ\_s*\%(ヤ\_s*ノ\_s*ン\|プ\_s*ロ\_s*ス\|ケ\_s*ロ\|ュ\_s*\%([イーア]\|ヴ\_s*ェ\|ビ\_s*\%(ズ\_s*ム\|ス\_s*ム\)\|ロ\_s*\%(ス\|ッ\_s*ト\)\|レ\_s*ー\_s*タ\_s*ー\|ラ\_s*ソ\_s*ー\|リ\_s*\%(ー\|ウ\_s*ム\|ア\_s*ス\|オ\_s*シ\_s*テ\_s*ィ\)\)\|ア\_s*\%(ラ\|ー\_s*ラ\|ン\_s*テ\_s*ィ\)\|チ\_s*ン\|ト\_s*サ\_s*ン\|メ\_s*ラ\|マ\_s*イ\_s*ラ\|ッ\_s*カ\|レ\_s*ー\_s*ト\|ャ\_s*\%([ドパスブンラ]\|デ\_s*\%(ィ\|ラ\_s*ッ\_s*ク\)\|ビ\_s*\%([アンネ]\|テ\_s*\%(ィ\|ー\_s*シ\_s*ョ\_s*ン\)\)\|ベ\_s*ツ\|バ\_s*\%(リ\_s*[エア]\|レ\_s*ー\)\|ト\_s*ル\|シ\_s*ー\|サ\_s*リ\_s*ン\|タ\_s*ピ\_s*ラ\|ピ\_s*\%(ト\_s*ル\|タ\_s*\%(ル\|リ\_s*ズ\_s*ム\)\)\|プ\_s*\%(ラ\|シ\_s*ョ\_s*ン\|テ\_s*ン\|チ\_s*ャ\)\|セ\_s*\%(イ\|ロ\_s*ー\_s*ル\)\|ッ\_s*\%([ツトチプ]\|サ\_s*バ\|ス\_s*ル\|シ\_s*\%(ュ\|ン\_s*グ\|ャ\_s*\%(ー\|ブ\_s*ル\)\)\)\|ニ\_s*\%(オ\_s*ン\|ス\_s*タ\_s*ー\)\|ナ\_s*ル\|ノ\_s*\%(ン\|ー\_s*ラ\|ピ\_s*ー\)\|ミ\_s*ソ\_s*ー\_s*ル\|メ\_s*\%(ル\|ロ\_s*\%(ン\|ッ\_s*ト\)\)\|ロ\_s*\%(ル\|ウ\_s*ェ\_s*イ\|リ\_s*ン\|ラ\_s*イ\_s*[ンナ]\|ッ\_s*ト\)\|レ\_s*ッ\_s*ト\|リ\_s*\%([コーア]\|バ\_s*ー\|ブ\_s*レ\_s*ー\_s*シ\_s*ョ\_s*ン\|ッ\_s*ジ\|ン\_s*グ\)\|ズ\_s*ム\)\|リ\_s*\%(コ\|ス\_s*ト\|シ\_s*タ\_s*ン\)\)\|総\_s*角\|チ\_s*\%([タリンマア]\|ワ\_s*ワ\|ラ\_s*ー\|ル\_s*ド\|ム\_s*ニ\_s*ー\|コ\_s*リ\|ッ\_s*\%([プク]\|テ\_s*リ\_s*オ\|タ\_s*ゴ\_s*ン\)\|キ\_s*\%(ン\|ー\_s*タ\)\|ュ\_s*\%(ア\_s*ブ\_s*ル\|ー\_s*イ\_s*ン\_s*ガ\_s*ム\)\|ー\_s*\%([フトプクズ]\|パ\_s*ー\|タ\_s*ー\)\|ェ\_s*\%([ロスカコアン]\|ザ\_s*\%(レ\|ー\_s*レ\)\|ル\_s*\%(ニ\_s*ー\|シ\_s*ー\|ノ\_s*ブ\_s*イ\_s*リ\)\|リ\_s*\%(ー\|ス\_s*ト\|ッ\_s*シ\_s*ュ\|モ\_s*ヤ\)\|レ\_s*\%(ス\_s*タ\|ン\_s*コ\_s*フ\)\|ビ\_s*チ\_s*ェ\_s*フ\|ダ\_s*ー\|チ\_s*ェ\_s*ン\|ッ\_s*\%([トクカ]\|キ\_s*ン\_s*グ\)\|イ\_s*\%([スン]\|ニ\_s*ー\|サ\_s*ー\|シ\_s*ン\_s*グ\)\|ー\_s*\%(ン\|ザ\_s*レ\|ホ\_s*フ\)\)\|ャ\_s*\%([オフドインコリウ]\|ツ\_s*ネ\|ク\_s*ラ\|プ\_s*タ\_s*ー\|パ\_s*テ\_s*ィ\|ペ\_s*\%(ル\|ッ\_s*ク\)\|チ\_s*ャ\|ネ\_s*\%(ル\|ラ\_s*ー\|リ\_s*ン\_s*グ\)\|ッ\_s*\%([クト]\|ピ\_s*ー\|プ\_s*\%(マ\_s*ン\|リ\_s*ン\)\)\|タ\_s*\%(レ\_s*[イー]\|リ\_s*ン\_s*グ\)\|ル\_s*マ\_s*ー\_s*ス\|レ\_s*ン\_s*ジ\|モ\_s*ロ\|ー\_s*\%([チタトムジ]\|ビ\_s*ル\|ミ\_s*\%(ー\|ン\_s*グ\)\|リ\_s*ー\|ル\_s*\%([ズス]\|ト\_s*ン\)\)\|ラ\_s*ン\_s*ゴ\)\|ョ\_s*\%([ンコ]\|イ\_s*ス\|ム\_s*ス\_s*キ\_s*ー\|ー\_s*\%(ク\|サ\_s*ー\|カ\_s*ー\|キ\_s*ン\_s*グ\)\|ゴ\_s*リ\|ッ\_s*\%(プ\|ピ\_s*ー\|パ\_s*ー\)\|リ\_s*ソ\)\)\|座\_s*標\|喜\_s*劇\|互\_s*換\|共\_s*\%(通\|産\_s*主\_s*義\_s*者\)\|継\_s*続\|ツ\_s*\%(ァ\_s*ー\|ィ\_s*リ\_s*ル\|ェ\_s*\%(ー\|ル\_s*ニ\_s*ー\|ラ\_s*ン\)\)\|炭\_s*素\)',
      \ 'D' : '\%([共吃巴錚鑼鶏鳥響嫩緞丼呑曇貪鈍肭遠蚌溝隣鄰塢床処所年時鯲鰍鰌讀得徳獨髑毒読僮萄鐃耨嫐橈儂撓陶働ゞ桐通閙藤々恫瞳憧鬧≡⇔慟撞導仝〃洞堂瞠獰艟胴銅童動同道堵戸奴退取呶解怒土駑留努録何止度弩融孥ど瓰竕凸竍籵瓧禰泥捏溺寺棯甸黏沺佃鈿畋淀澱臀傳殿電照でヅ鶴辛強妻綱勤伝筒包做造作尽机月塚遣冢疲使連付突積吊詰漬津図釣づヂ中近力痔持地ぢ種棚倒彩濃逹畳諾゛濁默球玉魂騙谷点館舘竹嶽岳高凧蛸怛妲獺奪脱梯餒迺岱廼戴弟臺平内醍橙］［題＞≧第台代大鱈頼便誰懶樽怠斷椴灘黙旦煖彈暖談段断檀団團壇弾男柁舵駄雫娜橢拏朶蛇墮拿佗垂沱溜懦楕炊鴕陀儺唾騨澑建荼立田惰抱陏駝打兌妥堕出だ直◎，丶、．\.‥・…＄”“↓†‡―┤達℃°独Ｄド÷◇◆ダジДдΔδデ∂D]\|ｯ\_s*\%(ﾄ\_s*ﾞ\|ﾃ\_s*ﾞ\|ﾂ\_s*ﾞ\|ﾁ\_s*ﾞ\|ﾀ\_s*ﾞ\)\|ッ\_s*[ドデヅヂダ]\|っ\_s*[どでづぢだ]\|ﾄ\_s*ﾞ\|都\_s*々\_s*逸\|褞\_s*袍\|S\_s*a\_s*u\_s*r\_s*u\_s*r\_s*a\_s*c\_s*e\_s*a\_s*e\|C\_s*\%(u\|o\_s*p\_s*p\_s*e\_s*r\)\|満\_s*天\_s*星\|豆\_s*腐\|如\_s*何\|ﾃ\_s*ﾞ\|刑\_s*事\|粘\_s*葉\_s*装\|手\_s*間\|木\_s*偶\|丁\_s*[稚抹]\|蝸\_s*牛\|ﾂ\_s*ﾞ\|頭\_s*[腦痛]\|ﾁ\_s*ﾞ\|調\_s*子\|茶\_s*碗\|知\_s*恵\|忸\_s*怩\|ﾀ\_s*ﾞ\|忠\_s*幸\|壁\_s*蝨\|伊\_s*達\|山\_s*車\|韃\_s*靼\|提\_s*婆\_s*達\_s*多\|太\_s*\%([刀宰鼓]\|平\_s*広\|上\_s*天\_s*皇\|政\_s*\%(官\|大\_s*臣\)\)\|乃\_s*[公毅]\|体\_s*操\|葮\_s*竹\|演\_s*\%(し\_s*物\|繹\_s*デ\_s*ー\_s*タ\_s*ベ\_s*ー\_s*ス\)\|コ\_s*ロ\_s*ン\_s*ビ\_s*ア\|ズ\_s*\%(ロ\_s*ー\_s*ス\|ッ\_s*ク\)\|イ\_s*ル\_s*カ\|医\_s*者\|博\_s*士\|文\_s*書\|行\_s*列\_s*式\|発\_s*見\_s*す\_s*る\|ハ\_s*ー\_s*グ\|拒\_s*否\_s*さ\_s*れ\_s*た\|破\_s*壊\_s*\%(者\|す\_s*る\)\|消\_s*滅\_s*子\|記\_s*述\_s*子\|十\_s*進\_s*数\|ゼ\_s*ッ\_s*ケ\_s*ン\|復\_s*号\_s*化\|省\_s*略\|金\_s*剛\_s*石\|d\_s*\%(b\_s*m\_s*s\|e\_s*c\_s*\%([ia]\|r\_s*e\_s*s\)\|o\_s*u\_s*b\_s*l\_s*e\_s* \_s*i\_s*n\_s*c\_s*o\_s*m\_s*e\_s*,\_s* \_s*n\_s*o\_s* \_s*k\_s*i\_s*d\_s*s\|i\_s*m\)\|辞\_s*書\)',
      \ 'E' : '\%([ｴ瘧腮偉鰓衿撰襟魘捐覃櫞湲檐薗篶￥渕鹽簷轅悁渊讌艷黶垣閼圜蜒爰掾媛鳶鴛焉宛嫣閻衍臙閹槐⌒援筵淹厭寃淵掩烟嚥圓沿宴蜿奄袁煙艶焔炎怨鉛園苑偃冤延婉遠堰燕演塩円縁刔刳抉猿狗描択鰕箙蛯蝦狄貊胡戎夷乢靨鉞戉粤咽噎桟悦閲謁亦繹伯懌掖蜴奕越役驛疫易益腋駅液咏瓔珱曵衡殪贏裔洩楹娃潁蠑瑩翳纓塋營頴瀛睿泳縊榮瑛暎曳盈郢影詠穎嬰鋭叡映営栄永枝会選衣依榎繪囘懷画絵衛會畫猥回恵獲惠慧衞荏重得餌江杖笑柄え━─┳┬┰┯┸┻┴┷фФ＝≡⇔∋∈РрмМН→英∃式！ηΗＥсСЛлεЭэエΕE]\|A\_s*\%([面判型級]\|V\_s*\%(機\_s*器\|女\_s*優\)\|B\_s*\%(型\|C\_s*順\)\)\|Ａ\_s*\%([面判型級]\|Ｖ\_s*\%(機\_s*器\|女\_s*優\)\|Ｂ\_s*型\)\|M\_s*サ\_s*イ\_s*ズ\|Ｍ\_s*サ\_s*イ\_s*ズ\|豪\_s*物\|Ｌ\_s*\%(サ\_s*イ\_s*ズ\|Ｌ\_s*サ\_s*イ\_s*ズ\)\|L\_s*\%(サ\_s*イ\_s*ズ\|L\_s*\%(サ\_s*イ\_s*ズ\|教\_s*室\)\)\|羨\_s*道\|豌\_s*豆\|C\_s*\%(l\|h\_s*l\_s*o\_s*r\_s*i\_s*n\_s*e\)\|似\_s*\%(非\|而\_s*非\)\|桧\_s*原\_s*湖\|烏\_s*帽\_s*子\|吉\_s*方\|胞\_s*衣\|淮\_s*南\_s*子\|埃\_s*及\|干\_s*支\|岐\_s*路\|支\_s*繞\|壊\_s*[疽死]\|葡\_s*萄\|蛭\_s*子\|愛\_s*\%([莉理媛]\|知\_s*川\)\|N\_s*極\|Ｎ\_s*\%([個極響]\|次\_s*元\|角\_s*形\|Ｈ\_s*Ｋ\_s*ホ\_s*ー\_s*ル\)\|斉\_s*魚\|兄\_s*鼓\|ヱ\_s*ス\_s*ビ\_s*ー\_s*食\_s*品\|S\_s*\%([式極]\|サ\_s*イ\_s*ズ\|N\_s*比\|F\_s*小\_s*説\)\|Ｓ\_s*\%([波字席極]\|サ\_s*イ\_s*ズ\|Ｎ\_s*比\|Ｆ\_s*小\_s*説\)\|穢\_s*[多土]\|Ｘ\_s*\%([軸脚線]\|染\_s*色\_s*体\)\|X\_s*\%([軸脚]\|O\_s*醤\|染\_s*色\_s*体\)\|海\_s*\%(老\|鷂\_s*魚\)\|帝\_s*都\_s*高\_s*速\_s*度\_s*交\_s*通\_s*営\_s*団\|ワ\_s*ー\_s*ク\_s*ス\_s*テ\_s*ー\_s*シ\_s*ョ\_s*ン\|欧\_s*\%(州\|羅\_s*巴\)\|歐\_s*\%(州\|羅\_s*巴\)\|ヨ\_s*ー\_s*ロ\_s*\%(ピ\_s*ア\_s*ン\|ッ\_s*パ\)\|ユ\_s*\%(ア\_s*ン\|ウ\_s*ロ\_s*ピ\_s*ウ\_s*ム\|リ\_s*イ\_s*カ\|ー\_s*\%(ロ\|ノ\_s*ス\|ニ\_s*ス\|ジ\_s*\%(ン\|ー\_s*ン\)\|ド\_s*ラ\|レ\_s*カ\|ラ\_s*\%(ス\|シ\_s*ア\)\|フ\_s*\%(ラ\_s*テ\_s*ス\|ォ\_s*\%(リ\_s*ア\|ニ\_s*ア\_s*ム\)\)\|ク\_s*リ\_s*ッ\_s*ド\|カ\_s*リ\)\)\|編\_s*集\|強\_s*調\|ｅ\_s*ｍ\_s*ａ\_s*ｃ\_s*ｓ\|電\_s*子\_s*メ\_s*\%(ー\_s*ル\|イ\_s*ル\)\|発\_s*展\|評\_s*価\_s*す\_s*る\|符\_s*号\_s*化\|百\_s*科\_s*事\_s*典\|カ\_s*プ\_s*セ\_s*ル\_s*化\|オ\_s*\%(ー\|イ\_s*\%(ラ\_s*ー\|ゲ\_s*ン\)\)\|実\_s*行\|拡\_s*張\|例\_s*外\|感\_s*嘆\_s*符\|ア\_s*\%([ンイ]\|ニ\_s*ド\|ー\_s*\%([マスル]\|ウ\_s*ィ\_s*ン\|ラ\_s*ン\|ニ\_s*ー\|ネ\_s*ス\_s*ト\|ミ\_s*ン\|シ\_s*ー\|リ\_s*ー\)\)\|設\_s*立\|e\_s*\%(x\_s*a\|コ\_s*マ\_s*ー\_s*ス\|ラ\_s*ー\_s*ニ\_s*ン\_s*グ\)\|イ\_s*\%([ブヴアラー]\|ジ\_s*ェ\_s*ク\_s*ト\|フ\_s*ェ\_s*ク\_s*[トタ]\|コ\_s*\%(ー\_s*ル\|ラ\_s*イ\_s*[ズザ]\)\|プ\_s*シ\_s*ロ\_s*ン\|ミ\_s*ュ\_s*レ\_s*\%(ー\_s*[トタ]\|イ\_s*タ\)\|ベ\_s*ン\_s*\%(ト\|タ\_s*ー\)\|ノ\_s*ッ\_s*ク\|ネ\_s*ー\_s*ブ\_s*ル\|ギ\_s*リ\_s*ス\|ン\_s*グ\_s*\%(ラ\_s*ン\_s*ド\|リ\_s*ッ\_s*シ\_s*ュ\)\|ッ\_s*チ\|ヤ\_s*\%(ー\|リ\_s*ン\_s*グ\|フ\_s*ォ\_s*ン\|ホ\_s*ン\)\|グ\_s*ジ\_s*\%(ッ\_s*ト\|ス\_s*ト\)\|ク\_s*\%(ス\|ア\_s*リ\_s*テ\_s*ィ\)\|ス\_s*フ\_s*ァ\_s*ハ\_s*ン\|リ\_s*[アヤ]\|レ\_s*\%(ー\_s*\%(ス\|ザ\_s*ー\|サ\_s*ー\)\|イ\_s*\%(ン\|ザ\_s*ー\|サ\_s*ー\)\|ブ\_s*ン\)\)\|ウ\_s*\%(ー\|ジ\_s*ェ\_s*ー\_s*ヌ\)\)',
      \ 'F' : '\%([麓梺冬′枌賁汾濆吩刎氛雰糞褌忿墳吻紛焚扮分粉揮旧舊顫故震篩奮隹古衾襖贅燻筆鰒絃総惣總房閼鬱塞鞴章郁史艦簡札耽吭鰾笛文罧節苳蕗淦舩艙舷舟船肥太懷懐≧≪≠≫＜＞≦渊淵渕縁葢盖再弍蓋双藤鯊潭蒸鱶楓殕瘋封諷黻祓拂怫髴彿恚慍憤二払沸拒防茯蔔愎輹蝠箙腓⊇⊃膨脹嚢梟袋含⊆⊂袱覆輻腹幅復馥服副複福経俘麸賦麩蜉坿父附訃婦誣仆經舗咐符臥膚斧冨腑更俛觝怖腐斑踏深趺降畉譜履葺觸老敷歩布赴狂殖振夫苻噴罘伏匐賻風柎不巫蹈孵拭普芙郛埠鋪鯆付吹阜拊生桴溥榑扶俯触践負増傅鮒孚府芬呎ﾌ飜翻ふ鉄♀∀¶富⌒金仏佛偽誤Ｆ♭弗浮フΦфФφF]\|ｯ\_s*ﾌ\|ッ\_s*フ\|っ\_s*ふ\|鞦\_s*韆\|睾\_s*丸\|陰\_s*嚢\|乱\_s*吹\|相\_s*応\|E\_s*u\_s*p\_s*t\_s*e\_s*l\_s*e\_s*a\_s*c\_s*e\_s*a\_s*e\|回\_s*回\_s*教\|書\_s*司\|図\_s*書\_s*寮\|海\_s*蘿\|補\_s*\%(任\|陀\_s*[洛落]\)\|頭\_s*垢\|雲\_s*脂\|鳧\_s*鐘\|款\_s*冬\|菜\_s*蕗\|蒲\_s*団\|M\_s*y\_s*r\_s*t\_s*a\_s*l\_s*e\_s*s\|釜\_s*[中山]\|雙\_s*葉\|B\_s*u\_s*d\_s*d\_s*l\_s*e\_s*j\_s*a\_s*c\_s*e\_s*a\_s*e\|渓\_s*井\|G\_s*e\_s*r\_s*a\_s*n\_s*i\_s*a\_s*\%(c\_s*e\_s*a\_s*e\|l\_s*e\_s*s\)\|２\_s*[人つ日]\|宿\_s*酔\|2\_s*\%([人つ日]\|通\_s*り\)\|○\_s*○\_s*○\|□\_s*□\_s*□\|△\_s*△\_s*△\|×\_s*×\_s*×\|帛\_s*紗\|河\_s*豚\|比\_s*律\_s*賓\|I\_s*r\_s*o\_s*n\|極\_s*東\_s*放\_s*送\|論\_s*理\_s*式\|形\_s*式\|ホ\_s*\%(ワ\_s*イ\_s*エ\|イ\_s*ル\|ル\_s*\%(マ\_s*\%(ン\_s*ト\|リ\_s*ン\)\|ム\_s*ア\_s*\%(ミ\_s*ド\|ル\_s*デ\_s*ヒ\_s*ド\)\)\)\|一\_s*杯\|機\_s*能\|関\_s*数\|汎\_s*関\_s*数\|修\_s*正\|ヒ\_s*\%(レ\|ュ\_s*ー\_s*[ズム]\)\|第\_s*1\_s*要\_s*素\|１\_s*\%(／\_s*ｆ\_s*ゆ\_s*ら\_s*ぎ\|ｓ\_s*ｔ\)\|失\_s*敗\|ハ\_s*\%(エ\|ン\_s*ブ\_s*ル\|ロ\_s*ン\)\|柔\_s*軟\_s*な\|周\_s*波\_s*数\|エ\_s*フ\|f\_s*\%(e\_s*m\_s*t\_s*o\|o\_s*\%(n\_s*t\_s*-\_s*f\_s*a\_s*m\_s*i\_s*l\_s*y\|r\_s*t\_s*e\)\)\)',
      \ 'G' : '\%([頃殺米諢魂權艮勤権鮴好蓙応駒事琴亊若毎如鏝埖込塵氷声肥聲腰拵心戀恋石国獄刧盒熬軣嗷壕敖噛濠哈遨拷囂轟毫傲鼇郷劫≡号豪剛沍五瑚晤珸呉超児檎庫互娯吾午極越護5篌兒冴茣梧誤寤５碁醐伍子唔忤期炬齬牾悟蜈后後宕ご〓戟屐鬩隙郤檄闃鷁撃激劇貎黥皃麑倪霓囈猊迎鯨芸藝蘖囓齧彦軒痃愿呟广監芫舷眩源儼衒弦絃験言諺現限幻玄減原拐実觧偈睨夏解下蹴毛げ靴草腐種口薬糞癖胡萸茱串藕遇嵎宮寓隅偶黒栗鞍倉蔵位昏麕羣郡群軍苦周包車狂惧組虞具弘暮食壷愚狗倶颶壺禺麌ぐ衣君嫌裂際牛垠崟斤岑憖吟銀圉圄禦馭魚嶷閠玉漁曉痙繞澆尭御翹嶢堯蟯驍僥仰業暁凝行謔瘧虐逆祇気曦議伎僞巍祁羲決城切艤礒擬沂犠萓嶬誼偽蟻宜斬疑木妓義犧技魏着欺戯儀戲ぎ巛皮川革乾側通殻絡辛柄鴉烏嵒頷巖厳嚴貫阮鳫偐岸厂⊃贋龕強翫岩鴈丸雁玩癌元願眼巌含頑神上紙髮髪金鐘係皈歸肯帰返潟固方語刀難型形鰹歹垳顏顔蟇釜鎌窯蒲蟹笠重傘號垣樫頭月合斈諤鄂壑鍔齶樂學萼愕嶽咢鰐額岳顎楽学乂既崖崕磑亥葢剴礙垓劾漑愾盖啀涯睚艾駭皚該咳階孩芥碍害鎧街凱慨概蓋骸外訛我伽臥哦換変借駕駆鵝貸画衙替代畫呀牙蛾訝勝ヶ果賀書餓芽河雅峩狩莪買峨掛ケヵ娥鵞刈俄が≫＞Ｇ瓦≧ガゴΨβλΣΕΖΗΚΘοΤσνΠρΑκξιΝθμΜΩεΧδΞψΔπατΒΙυΦΥζΡφΟχΛηωギグгγΓゲГG]\|ｯ\_s*\%(ｺ\_s*ﾞ\|ｹ\_s*ﾞ\|ｸ\_s*ﾞ\|ｷ\_s*ﾞ\|ｶ\_s*ﾞ\)\|ッ\_s*[ゴゲグギガ]\|っ\_s*[ごげぐぎが]\|ｺ\_s*ﾞ\|小\_s*屋\|蒙\_s*御\_s*免\|巨\_s*頭\_s*鯨\|欣\_s*求\|独\_s*楽\|P\_s*e\_s*r\_s*s\_s*o\_s*n\_s*a\_s*l\_s*e\_s*s\|瞽\_s*女\|歩\_s*行\_s*虫\|向\_s*拝\|皐\_s*月\|穀\_s*潰\|寄\_s*居\_s*虫\|降\_s*魔\|格\_s*\%([間縁]\|天\_s*井\)\|恒\_s*河\_s*沙\|江\_s*\%([津湖商州]\|談\_s*抄\)\|豆\_s*[油汁]\|ｹ\_s*ﾞ\|蚰\_s*蜒\|景\_s*色\|化\_s*粧\|鴃\_s*舌\|稽\_s*古\|懸\_s*魚\|還\_s*[向俗]\|拳\_s*[万固骨]\|喧\_s*嘩\|顕\_s*界\|ｸ\_s*ﾞ\|救\_s*世\_s*菩\_s*薩\|工\_s*合\|供\_s*[奉祭香進]\|紅\_s*蓮\|ｷ\_s*ﾞ\|毬\_s*杖\|岐\_s*\%([南阜]\|セ\_s*ン\)\|棋\_s*将\_s*谷\|求\_s*\%([法道肥]\|不\_s*得\_s*苦\|聞\_s*持\_s*法\)\|A\_s*g\|S\_s*\%(c\_s*r\_s*o\_s*p\_s*h\_s*u\_s*l\_s*a\_s*r\_s*i\_s*a\_s*c\_s*e\_s*a\_s*e\|y\_s*m\_s*p\_s*e\_s*t\_s*a\_s*l\_s*a\_s*e\|i\_s*l\_s*v\_s*e\_s*r\)\|希\_s*臘\|杏\_s*葉\|餃\_s*子\|刑\_s*部\|ｶ\_s*ﾞ\|搦\_s*み\|鑑\_s*真\|仮\_s*名\|蝦\_s*[蟆蟇]\|T\_s*y\_s*p\_s*a\_s*l\_s*e\_s*s\|鉤\_s*状\_s*部\|菓\_s*子\|甲\_s*斐\|会\_s*社\|g\_s*\%(i\_s*g\_s*a\|h\_s*o\_s*s\_s*t\_s*s\_s*c\_s*r\_s*i\_s*p\_s*t\)\|ヌ\_s*ー\|ｇ\_s*ｎ\_s*ｕ\_s*ｓ\|ニ\_s*ュ\_s*ー\_s*ズ\|ノ\_s*ー\_s*ム\|総\_s*司\_s*令\_s*部\|連\_s*合\_s*国\_s*軍\_s*総\_s*司\_s*令\_s*部\|ヒ\_s*ル\|ク\_s*ッ\_s*パ\|硝\_s*子\|ハ\_s*ボ\_s*ロ\_s*ー\_s*ネ\|瞿\_s*曇\|ヨ\_s*ー\_s*テ\_s*ボ\_s*リ\|エ\_s*ー\_s*テ\_s*ボ\_s*リ\|イ\_s*ェ\_s*\%(ー\_s*テ\_s*ボ\_s*リ\|テ\_s*ボ\_s*リ\)\|得\_s*る\|ヘ\_s*\%(ラ\_s*ル\_s*ド\|ル\_s*マ\_s*ン\)\|ド\_s*イ\_s*ツ\|成\_s*吉\_s*思\_s*汗\|ゼ\_s*\%(ラ\_s*\%(チ\_s*ン\|ニ\_s*ウ\_s*ム\)\|ム\_s*ク\_s*リ\_s*ッ\_s*プ\|ノ\_s*ア\|ン\_s*ト\_s*ル\_s*マ\_s*ン\|ネ\_s*\%(コ\_s*ン\|ラ\_s*\%(ル\|リ\_s*ス\_s*ト\)\)\)\|大\_s*\%(蚊\|学\_s*院\_s*生\)\|ジ\_s*\%([ムルジグノナオンー]\|プ\_s*シ\_s*ー\|ア\_s*ン\|ッ\_s*ド\|イ\_s*ド\|タ\_s*ン\|ゼ\_s*ル\|リ\_s*ア\_s*ン\|レ\_s*ッ\_s*ト\|ゴ\_s*ロ\|ラ\_s*\%(フ\|ル\_s*\%(ド\|デ\_s*ィ\_s*ー\_s*ノ\)\)\|ロ\_s*\%(ー\|ン\_s*ド\)\|バ\_s*ン\_s*シ\_s*ー\|ブ\_s*\%(リ\|ラ\_s*ル\_s*タ\_s*ル\)\|ベ\_s*\%(ル\_s*ナ\_s*ウ\|レ\_s*リ\_s*ン\)\|ネ\_s*ッ\_s*ト\|ョ\_s*\%(ッ\_s*ト\|ヴ\_s*ァ\_s*ン\_s*[ニナ]\|バ\_s*ン\_s*[ニナ]\|コ\_s*\%(ー\_s*ソ\|ン\_s*ダ\)\|ル\_s*\%(ジ\|ダ\_s*ー\_s*ノ\)\|ー\_s*\%(ジ\|ゼ\_s*ッ\_s*ト\)\)\|ャ\_s*\%(ン\|イ\_s*\%(ロ\|ル\_s*ズ\|ア\_s*ン\_s*[ツト]\)\|コ\_s*\%(モ\|メ\_s*ッ\_s*テ\_s*ィ\)\|ー\_s*マ\_s*ン\)\|ニ\_s*ー\|ュ\_s*\%([レネ]\|ゼ\_s*ッ\_s*ペ\|リ\_s*\%(ア\|ー\_s*ニ\|エ\_s*ッ\_s*タ\)\|ヌ\_s*\%(ビ\_s*エ\_s*ー\_s*ブ\|ヴ\_s*ィ\_s*エ\_s*ー\_s*ヴ\)\)\|ェ\_s*\%([リルフムマネ]\|ス\_s*チ\_s*ャ\_s*ー\|ロ\_s*ニ\_s*モ\|ラ\_s*\%(ー\_s*[トルド]\|ル\_s*\%(ド\|デ\_s*ィ\_s*ン\|ダ\_s*イ\_s*ン\)\)\|ミ\_s*ニ\|ニ\_s*ー\|ノ\_s*\%([アバ]\|ヴ\_s*ァ\|ワ\_s*ー\_s*ズ\|サ\_s*イ\_s*ド\)\|ン\_s*\%(マ\|ト\_s*\%(ル\|リ\_s*[ィー]\)\|ダ\_s*ー\)\)\)\)',
      \ 'H' : '\%([ﾎ洞亡袰滅幌濠壕畚笨略檣艢焔炎仄朖朗塊程施滸幾殆缶熱解屠榾螢蛍骨細本＊※糒恣縦擅星戟戈桙綻祠誇埃鉾矛堀頬袍垉膀鞄抔磅峯堋弸皰舫篷麭怦呆蔀棚褓泙枋棒勹鴇朴峰豐苞葬琺寳炮鵬寶繃魴鋒髣逢朋烹鳳彗箒俸焙蓬烽幇抱崩訪泡澎彷縫捧萌萠彭包胞倣邦飽疱庖奉豊砲報硼宝攴攵瀑蹼樮北恍掘畝譽保穗賞埔餔咆惚穂葡抛哮耄堡脯哺襃黼捕彫褒欲吼舖輔葆浦逋誉ほﾍ謙遜篦廰廳貶褊胼諞篇駢蝙翩變∂遍返騙編扁変丿暼諛諂隔凹臍巳蛇蔕蒂瓸竡粨躄闢癖甓璧劈碧壁聘餅箆坪竝嬖幤閇娉病塀蔽并陛屏炳斃瓶弊幣併敝閉並辺邉減屁圧歴邊折舳戸へﾌ麓梺冬♭′枌賁汾濆吩氛雰糞褌忿墳吻紛焚扮分粉揮旧舊顫故震篩奮隹古衾襖贅燻鰒陰絃総惣總房閼鬱塞章郁艦簡補札耽吭鰾笛芬呎文罧節苳蕗淦舩艙舷舟船蒲懷懐≧≪≫＞≦渊淵渕縁葢盖弍蓋双B藤潭蒸鱶楓殕瘋封諷黻怫髴佛彿恚慍憤仏F弗沸Φφ拒防茯蔔愎輹蝠箙⊇⊃嚢梟袋含⊆⊂袱覆輻復馥副複福経俘麸賦麩蜉坿父附訃婦誣仆經舗咐符臥斧冨更俛觝怖腐踏深趺富降畉譜葺觸敷歩赴狂殖振夫苻噴罘伏匐賻風柎不巫蹈孵拭普芙郛埠鋪鯆付吹阜拊桴溥榑扶俯触践負増傅鮒孚府ふﾋ鶸彬禀斌蘋嬪繽殯賓擯牝貧頻瀕稟品怯葫晝飜蒜蛭昼綬胙紐鰭∝衡片鮃閃鵯辟百媛姫仭擴絋仞展尋宥太拡拓拾祐恕紘煕泰熙寛啓弘宏洋裕浩廣広髟馮飃飆殍冰冫凭俵驫彪雹飄豹漂驃慓剽嫖兵憑票評標平表燧老撚拈捫捻歪籤籖柊旱魃秀跪膝蜩羆攣佗−低隙閑暇雛髯鬚髭¬蹄濳潜潛顰密窃鬻提瓠蠡瓢匏壽央恒廂尚寿久率蟆痙蟇丙丁孤女史獨独稘斎均倫準斉等≠單偏単他仁瞳人1１柆蔆拉杓柄犇◇◆菱醢醤曾蘖彦酷浸漬鶲額聖肱肘熈芒光膕控皸皹響罅僻鰉蹕匹逼篳畢疋柩棺弼櫃謐坤未羊筆必襞養饑（＜「【←『左緋罷引披惹轡丕卑碑彼昜痺砒鞁退匪否毘皮蜚干疲蓖氷比匕桧日梭曳牽費扉魅肥痞灯豼鞴斐狒碾秕杼冷贔俾挽索被貔暃避火朏菲裨秘髀轢乾臂泌庇批紕脾霏檜飛悲妣妃樋祕陳鄙譬ひﾊ布鱧釖鉤蝟梁鍼磔針肚禳腑腸孕原拂祓払遼温玄請腹陽悠遙東遥治春捷頓鮠鶻駿疾囃林隼畔磐泛鈑潘膰樊笵釆胖拌絆蟠氾坂范凡燔楾洪瘢翻板攀゜大伴煩槃斑袢判範藩繙蕃版搬叛班阪般販犯汎帆頒反侍鯊櫨祝？硲間烈激勵劇励速蝿蠅省飯彈勢外筈弭辱逸育毓齦浮難掵阻憚幅巾柞母翅幟側圃旌旙旛将傍働鰰機叩疥畠籏幡畑旗斜鴿再鳩開秦跣膚肌裸弾薑椒元弌壹哉壱甫一創馨始鋼芳剪夾鋏螯挾挟脛萩贐餞離塙英蕚萼衂衄縹譚咄放噺話洟甚鼻華花觜赱迸枦奔艀婢梯燥箸柱走橋箪匣凾□筐繁方運匚筥箱函佰珀魄陌亳狛柏愽栢岶蘗粕膊璞擘箔舶泊搏迫帛拍諮測企圖秤謀量計図儚捗袴伯博墓秡癶髮釟溌肇廿二初椀蓮♪８鉢蜂發髪服法半醗白薄八発擺旆盃珮湃坏碚琲睥霈埴牌拜裴孛吠入沛榛杯悖―廢腓徘誹稗癈俳肺憊輩背鷂胚廃排拝敗灰配蛤濱浜跳馳霸羞爆禿杷碆叭匍怕栄玻撥穿愧歯膨破恥晴巴生派暎端覇着帚刃填腫吐刷菷刎菠羽琶張這頗簸佩耻早映履慙坡榮果脹跛陂葉播笆葩矧霽食芭把刄捌垪剥爬掃帶齒嵌貼は━─┛┘┷┸┻┴┓┐┬┳┯┰┫┥┤┨╋┿┼╂波‐フ☆★非ＨヒホヘハH]\|ｯ\_s*[ﾎﾍﾌﾋﾊ]\|ッ\_s*[ホヘフヒハ]\|っ\_s*[ほへふひは]\|寄\_s*生\|珠\_s*鶏\|混\_s*一\_s*色\|紅\_s*[幇中]\|T\_s*r\_s*i\_s*u\_s*r\_s*i\_s*d\_s*a\_s*l\_s*e\_s*s\|微\_s*[酔笑]\|子\_s*規\|蜀\_s*魂\|杜\_s*[鵑宇]\|時\_s*鳥\|上\_s*枝\|鬼\_s*灯\|酸\_s*漿\|叢\_s*祠\|和\_s*了\|鮑\_s*魚\|謗\_s*法\|黒\_s*子\|部\_s*屋\|竹\_s*\%(畚\|麦\_s*魚\)\|巻\_s*子\|綜\_s*麻\|下\_s*手\|糸\_s*瓜\|h\_s*e\_s*c\_s*t\_s*o\|霹\_s*靂\|c\_s*l\_s*a\_s*u\_s*s\_s*t\_s*r\_s*o\_s*p\_s*h\_s*o\_s*b\_s*i\_s*a\|鞦\_s*韆\|睾\_s*丸\|乱\_s*吹\|相\_s*応\|E\_s*\%(r\_s*i\_s*o\_s*c\_s*a\_s*u\_s*l\_s*a\_s*l\_s*e\_s*s\|u\_s*p\_s*t\_s*e\_s*l\_s*e\_s*a\_s*c\_s*e\_s*a\_s*e\)\|回\_s*\%(鍋\_s*肉\|回\_s*教\)\|書\_s*司\|頭\_s*垢\|鳧\_s*鐘\|款\_s*冬\|菜\_s*蕗\|f\_s*\%(o\_s*r\_s*t\_s*e\|e\_s*m\_s*t\_s*o\)\|釜\_s*[中山]\|雙\_s*葉\|渓\_s*井\|G\_s*e\_s*r\_s*a\_s*n\_s*i\_s*a\_s*\%(c\_s*e\_s*a\_s*e\|l\_s*e\_s*s\)\|宿\_s*酔\|○\_s*○\_s*○\|△\_s*△\_s*△\|×\_s*×\_s*×\|河\_s*\%(豚\|底\_s*撈\_s*魚\)\|神\_s*[庫籬]\|領\_s*巾\|肩\_s*巾\|素\_s*見\|曹\_s*白\_s*魚\|枚\_s*[田方]\|敬\_s*昌\|幸\_s*展\|容\_s*靖\|晃\_s*道\|宙\_s*子\|欧\_s*子\|祥\_s*加\|終\_s*日\|翡\_s*翠\|曽\_s*祖\_s*父\|豪\_s*将\|偉\_s*紀\|周\_s*[行男]\|茅\_s*蜩\|向\_s*日\_s*葵\|七\_s*宗\|桶\_s*坂\|永\_s*和\|蟾\_s*蜍\|抽\_s*\%([斗出]\|き\_s*出\_s*し\)\|告\_s*天\_s*子\|雲\_s*[脂雀]\|為\_s*人\|緊\_s*[と々]\|鎮\_s*火\_s*\%(祭\|の\_s*祭\)\|A\_s*\%(s\|r\_s*s\_s*e\_s*n\_s*i\_s*c\|n\_s*g\_s*i\_s*o\_s*s\_s*p\_s*e\_s*r\_s*m\_s*a\_s*e\)\|粃\_s*糠\_s*疹\|只\_s*管\|直\_s*[向走垂隠]\|常\_s*陸\|鹿\_s*尾\_s*菜\|撲\_s*り\_s*倒\|同\_s*胞\|赦\_s*い\|青\_s*春\|哈\_s*爾\_s*浜\|美\_s*佳\|流\_s*行\|勇\_s*[樹人]\|韓\_s*流\|漢\_s*堡\|汗\_s*国\|盤\_s*陀\|R\_s*S\_s*I\|蔓\_s*延\|沙\_s*魚\|蝦\_s*虎\_s*魚\|馬\_s*銜\|狭\_s*間\|南\_s*風\|延\_s*\%(縄\|い\_s*て\)\|義\_s*母\|旅\_s*籠\|N\_s*e\_s*l\_s*u\_s*m\_s*b\_s*o\_s*n\_s*a\_s*c\_s*e\_s*a\_s*e\|黄\_s*[酒櫨]\|土\_s*[方生師]\|嘔\_s*[吐気]\|支\_s*倉\|長\_s*谷\|接\_s*ぎ\_s*合\|纏\_s*頭\|煙\_s*火\|麻\_s*疹\|階\_s*[上子]\|嘴\_s*\%(細\_s*鴉\|太\_s*鴉\)\|学\_s*胤\|２\_s*\%([人つ日]\|０\_s*[歳日]\)\|2\_s*\%([人つ日]\|通\_s*り\|0\_s*日\)\|淡\_s*竹\|8\_s*月\|客\_s*家\|P\_s*\%(t\|o\_s*t\_s*a\_s*m\_s*o\_s*g\_s*e\_s*t\_s*o\_s*n\_s*a\_s*l\_s*e\_s*s\|l\_s*a\_s*t\_s*i\_s*n\_s*u\_s*m\)\|海\_s*\%([鞘永蘿星牙]\|拉\_s*爾\|底\_s*撈\_s*月\)\|M\_s*\%(y\_s*r\_s*t\_s*a\_s*l\_s*e\_s*s\|e\_s*r\_s*c\_s*u\_s*r\_s*y\)\|色\_s*調\|呼\_s*和\_s*浩\_s*特\|ウ\_s*ー\_s*ゴ\|ユ\_s*\%(ー\|ペ\_s*ー\_s*ル\|ベ\_s*ー\_s*ル\|イ\_s*ス\_s*マ\_s*ン\_s*ス\|ゴ\_s*ー\|グ\_s*ノ\_s*ー\|マ\_s*ニ\_s*\%(テ\|ス\_s*[トム]\)\)\|現\_s*代\|十\_s*六\_s*進\_s*数\|高\_s*さ\|香\_s*港\|イ\_s*\%(ダ\_s*ル\_s*ゴ\|ス\_s*パ\_s*ニ\_s*ア\|レ\_s*ー\_s*ル\|エ\_s*ロ\)\|オ\_s*\%([ラー]\|ナ\_s*ー\|ノ\_s*レ\|ン\_s*フ\_s*ル\_s*ー\_s*ル\|ネ\_s*\%(ス\_s*\%(ト\|テ\_s*ィ\)\|ゲ\_s*ル\)\|テ\_s*ル\|ル\_s*ガ\_s*ー\|マ\_s*ー\_s*ジ\_s*ュ\)\|ア\_s*\%(ン\_s*\%(リ\|ベ\_s*ー\_s*ル\)\|ネ\_s*ス\_s*ト\|ワ\_s*ー\|ダ\_s*マ\_s*ー\_s*ル\|シ\_s*ェ\_s*ッ\_s*ト\|ビ\_s*タ\_s*シ\_s*オ\_s*ン\|ー\_s*\%(ネ\_s*ス\_s*ト\|ノ\_s*ン\_s*ク\_s*ー\_s*ル\)\)\|エ\_s*\%(デ\_s*ィ\|ン\_s*リ\_s*ケ\|レ\_s*\%(ナ\|ー\_s*ヌ\)\|ロ\_s*イ\_s*ー\_s*ズ\|ク\_s*ト\_s*ル\|ル\_s*\%(ゲ\_s*ラ\|ヴ\_s*ェ\|メ\_s*ス\|マ\_s*ン\|ミ\_s*\%(ッ\_s*ト\|ー\_s*ト\)\|ブ\_s*ラ\_s*ン\|ナ\_s*ン\_s*デ\_s*ス\|キ\_s*ュ\_s*ー\_s*ル\)\|ノ\_s*ク\|イ\_s*チ\|ッ\_s*チ\)\|水\_s*[銀平素]\)',
      \ 'I' : '\%([ｲηΗ賤鄙卑苟嫌弥薯妹芋藷夢艷鑪鈩彩鱗色鯆忽綺貸甍答応愈圦杁茵胤飮寅尹婬贇韵隱蚓氤酳霪蔭堙湮廴音飲慇韻咽淫殞姻隕院允隠殷陰窟巖巌頌祝鰮鰛鰯岩磐円￥鼾歪弋弑抱懐肬贅疣狗戌乾犬諱在坐未汝戒誡警縛今Εε曰禾稻員因蝗嘶鰍電引躄誘動≦忿鵤錨碇怒霆霹雷凧桴筏魚S菴庵彌雖家尿荊棘茨祈祷命豕猯古伍聿乙鎰鴪軼樹慈悼愴慯労格到至傷鼬頂戴病徒致鈑痛板柞沙砂聊些潔諍烈功諫勳勇勲漁諌憇＝憩粹熱粋憤域閾勢勤忙急磯孰焉湶泉厳何弄苛≧鎔范啀毬訝燻息挑絲縷厭營営愛幼稚緒遑暇糸弌壹肆莓苺櫟著市碑鐓礎甃臀弩石牲犧犠池溢Y佚壱1１鬻毓燠礇粥的戦戰軍郁幾育一稲否飯違居矮ゐ猪五煎彝醫斐逶貽善胆位萎可詑僞鑄熬活容依要斎行怡異衣逝猗胃洟好矣鋳揖椅去惟云懿熨痿射凍尉移将囗肄夷率囲姨慰頤忌唯緯逸噫挿鮪易偽苡彜莞往以韋遺炒謂李生威為維意倚良如彙已出淹言亥鰄井蔚痍圍幃渭堰饐医爲癒帷恚偉委詒畏い氷Йй→⇒⊂⊃▼▽伊印入∞吋∈∋∬∫∩ＩイИΙи私ιI]\|E\_s*メ\_s*ー\_s*ル\|灼\_s*然\|祖\_s*谷\|湯\_s*文\_s*字\|文\_s*身\|郎\_s*[女子]\|蕁\_s*麻\|刺\_s*[青草]\|U\_s*r\_s*t\_s*i\_s*c\_s*a\_s*l\_s*e\_s*s\|海\_s*[豚参]\|西\_s*表\|鸚\_s*哥\|影\_s*青\|況\_s*ん\_s*や\|所\_s*謂\|D\_s*i\_s*a\_s*p\_s*e\_s*n\_s*s\_s*i\_s*a\_s*l\_s*e\_s*s\|藺\_s*草\|J\_s*u\_s*n\_s*c\_s*a\_s*l\_s*e\_s*s\|田\_s*舎\|膝\_s*行\|十\_s*六\_s*夜\|寝\_s*穢\|英\_s*\%(蘭\|吉\_s*利\)\|斑\_s*鳩\|烏\_s*賊\|玉\_s*筋\_s*魚\|硫\_s*黄\|夜\_s*来\_s*香\|N\_s*a\_s*j\_s*a\_s*d\_s*a\_s*l\_s*e\_s*s\|牛\_s*膝\|稜\_s*威\|常\_s*春\_s*藤\|5\_s*[つ日]\|５\_s*[つ日]\|惡\_s*戲\|甚\_s*振\|潮\_s*来\|悪\_s*戯\|交\_s*喙\|細\_s*小\_s*魚\|小\_s*魚\|鯨\_s*魚\|鶏\_s*魚\|経\_s*緯\|礒\_s*[山田]\|P\_s*\%(o\_s*a\_s*l\_s*e\_s*s\|l\_s*u\_s*m\_s*b\_s*a\_s*g\_s*i\_s*n\_s*a\_s*l\_s*e\_s*s\)\|和\_s*泉\|気\_s*吹\|Ｅ\_s*\%(Ａ\_s*Ｓ\_s*Ｔ\|Ｖ\_s*Ｅ\)\|指\_s*宿\|拠\_s*所\|従\_s*[弟妹姉兄]\|鴨\_s*脚\_s*樹\|公\_s*孫\_s*樹\|G\_s*\%(r\_s*a\_s*m\_s*i\_s*n\_s*a\_s*l\_s*e\_s*s\|l\_s*u\_s*m\_s*i\_s*f\_s*l\_s*o\_s*r\_s*a\_s*e\|i\_s*n\_s*k\_s*g\_s*o\_s*p\_s*s\_s*i\_s*d\_s*a\)\|銀\_s*杏\|鳶\_s*尾\|檪\_s*本\|巫\_s*子\|神\_s*巫\|睦\_s*月\|都\_s*方\_s*流\|縊\_s*[殺死首]\|蝟\_s*[集縮]\|埋\_s*け\_s*[火炭]\|許\_s*[嫁婚]\|<\_s*=\_s*=\_s*>\|必\_s*要\_s*十\_s*分\_s*条\_s*件\|ヤ\_s*ン\|日\_s*本\_s*ア\_s*イ\_s*・\_s*ビ\_s*ー\_s*・\_s*エ\_s*ム\_s*株\_s*式\_s*会\_s*社\|国\_s*際\_s*\%(基\_s*督\_s*教\_s*大\_s*学\|標\_s*準\_s*化\_s*機\_s*構\)\|逆\_s*離\_s*散\_s*フ\_s*ー\_s*リ\_s*エ\_s*変\_s*換\|識\_s*別\_s*子\|即\_s*興\_s*曲\|な\_s*ら\_s*ば\|項\_s*目\|逐\_s*次\_s*型\|ｉ\_s*ノ\_s*ー\_s*ド\|i\_s*\%(ア\_s*プ\_s*リ\|P\_s*o\_s*d\|モ\_s*ー\_s*ド\|M\_s*a\_s*c\|ノ\_s*ー\_s*ド\)\|誤\_s*っ\_s*た\|無\_s*\%(花\_s*果\|効\_s*な\)\|帰\_s*納\_s*法\|字\_s*下\_s*げ\|不\_s*\%([可如足]\|充\_s*分\)\|具\_s*体\_s*化\|情\_s*報\|導\_s*入\|整\_s*数\|完\_s*全\|ヨ\_s*\%(ア\_s*ン\|シ\_s*フ\|ー\_s*ド\|ウ\_s*素\)\|ア\_s*\%(イ\|ー\_s*\%(ヴ\_s*ィ\_s*ン\|ビ\_s*ン\)\|ン\_s*\%(プ\_s*ロ\_s*ン\_s*プ\_s*\%(チ\_s*ュ\|テ\_s*ュ\)\|デ\_s*パ\_s*ン\_s*ダ\_s*ン\|フ\_s*ォ\_s*ル\_s*\%(メ\_s*ル\|マ\_s*テ\_s*ィ\_s*ー\_s*ク\)\)\)\)',
      \ 'J' : '\%([塩嶋島嶌縞橲竺衂衄宍舳忸軸舌喰食直凝實昵実印尻侭仞刄臣恁儘潯贐稔進盡仭糂訊俥蕁迅刃靱荏甚靭燼櫁樒塵尽尋陣腎壬人敍莇茹杼洳敘汝蜍耡恕舒縟褥蓐辱溽所抒鋤徐絮序叙助帖穰疂聶疊驤襄淨讓繩禳絛蕘諚仗壌滌繞生靜蟐壤仍茸嬲疉塲乘遶星瀞拯釀躡孃如剩娘嬢錠静醸縄女尉饒丈成烝擾嫋穣丞盛場杖條条蒸貞状攘畳剰冗定浄乗情城上常譲懦愀鷲竪嬬戍得濡咒讐讎就聚笋篤盾徇凖楯詢隼筍蓴惇洵淳閏恂諄馴旬荀潤循醇巡遵順准殉純準襦誦需朮戌宿孰塾珠熟恤術述豎孺呪儒綬樹受授壽揉從澀狃中戎拾廿鞣从縱澁糅蹂神汁獸絨縦渋柔什充十従獣住銃重事迩爺滋除怩尓痔璽至児士寿茲孳染嗣柱寺磁仕死爾路而仁辞塒時岻粫持恃敷焦字只地轜侍瓷亊知辭餌冶邇弍似祀以子峙二史自畤兒示耳慈司蒔次珥膩醤鮭着鉐惹搦尺雀寂若弱邪戯者蛇麝闍じ┃│┝┣├┠┌┏．еЕ治яЯ日ЮюＪЁёйЙジJ]\|ｯ\_s*ｼ\_s*ﾞ\|ッ\_s*ジ\|っ\_s*じ\|G\_s*\%(メ\_s*ン\|パ\_s*ン\)\|D\_s*y\|Ｇ\_s*\%(メ\_s*ン\|パ\_s*ン\)\|支\_s*度\|試\_s*合\|２\_s*乗\|2\_s*乗\|祖\_s*父\_s*\%(さ\_s*ん\|祖\_s*母\)\|獅\_s*子\|甲\_s*乙\_s*丙\_s*丁\_s*戊\_s*己\_s*庚\_s*辛\_s*壬\_s*癸\|k\_s*\$\_s*_\_s*{\_s*e\_s*f\_s*f\_s*}\_s*\$\|Z\_s*\%(r\|i\_s*r\_s*c\_s*o\_s*n\_s*i\_s*u\_s*m\)\|深\_s*\%(秘\|大\_s*寺\)\|秦\_s*泉\_s*寺\|沈\_s*\%(香\|丁\_s*花\)\|晨\_s*朝\|濁\_s*世\|判\_s*官\|諍\_s*論\|長\_s*夜\|漏\_s*斗\|↑\_s*↓\_s*←\_s*→\|焼\_s*酎\|鐘\_s*石\|橈\_s*脚\_s*類\|承\_s*久\|朱\_s*里\|C\_s*a\_s*b\_s*o\_s*m\_s*b\_s*o\_s*i\_s*d\_s*e\_s*a\_s*e\|絢\_s*子\|頌\_s*偈\|数\_s*珠\|入\_s*[魂牢来洛院内水棺]\|霜\_s*月\|１\_s*\%(２\|６\_s*進\|０\_s*[進月]\|１\_s*月\|８\_s*禁\)\|師\_s*走\|極\_s*月\|紐\_s*帯\|1\_s*\%(0\|1\_s*月\|8\_s*禁\|2\_s*月\)\|ｼ\_s*ﾞ\|爪\_s*哇\|射\_s*礼\|砂\_s*利\|謝\_s*花\|三\_s*味\_s*線\|雑\_s*魚\|著\_s*語\|杓\_s*子\|共\_s*同\_s*企\_s*業\_s*体\|j\_s*\%(T\_s*e\_s*X\|L\_s*a\_s*T\_s*e\_s*X\|B\_s*i\_s*b\_s*T\_s*e\_s*X\)\|ゼ\_s*リ\_s*ー\|エ\_s*\%(ホ\_s*バ\|リ\_s*コ\|レ\_s*ミ\_s*ヤ\|ル\_s*サ\_s*レ\_s*ム\|ッ\_s*サ\_s*イ\)\|ヘ\_s*\%(レ\_s*ス\|ス\_s*ス\)\|ヒ\_s*メ\_s*ネ\_s*ス\|チ\_s*ゲ\|北\_s*陸\_s*先\_s*端\_s*\%(大\|科\_s*学\_s*技\_s*術\_s*大\_s*学\_s*院\_s*大\_s*学\)\|ハ\_s*\%(イ\_s*メ\|ラ\_s*ペ\_s*ー\_s*ニ\_s*ョ\)\|碧\_s*玉\|ヤ\_s*\%([リンニナー]\|イ\_s*ル\|エ\_s*ル\|ル\_s*ノ\|レ\_s*ド\|ヌ\_s*\%(ス\|シ\_s*ュ\)\|ス\_s*パ\_s*ー\_s*ス\|コ\_s*[ビブ]\|ッ\_s*ケ\)\|フ\_s*\%(ァ\_s*[ンナ]\|リ\_s*[オア]\)\|ズ\_s*ボ\_s*ン\|ユ\_s*\%([ハリダノ]\|ル\_s*ゲ\_s*ン\|ー\_s*\%([リノ]\|ゲ\_s*ン\_s*ト\|デ\_s*ィ\_s*ッ\_s*ト\)\|ン\_s*\%(グ\|ケ\_s*ル\|カ\_s*ー\)\|ピ\_s*テ\_s*ル\|ッ\_s*[カシ]\)\|イ\_s*\%(エ\_s*\%([ナス]\|ン\_s*\%(ス\|セ\_s*ン\)\|ズ\_s*ス\)\|ェ\_s*\%(ナ\|ン\_s*\%(ス\|ゼ\_s*ン\|セ\_s*ン\)\|ー\_s*ガ\_s*ー\|ル\_s*\%(ク\|サ\_s*レ\_s*ム\)\)\)\|ホ\_s*\%([タセ]\|ル\_s*ヘ\|ホ\_s*バ\|ア\_s*\%(ン\|キ\_s*ン\)\)\|ヨ\_s*\%([ブナ]\|ル\_s*\%(グ\|ダ\_s*ン\)\|エ\_s*ル\|ア\_s*\%(キ\_s*ム\|ヒ\_s*ム\)\|ゼ\_s*フ\|シ\_s*\%(フ\|ュ\_s*ア\)\|ー\_s*\%([ドト]\|デ\_s*ル\|ゼ\_s*フ\)\|セ\_s*フ\|ハ\_s*[ナンネ]\)\)',
      \ 'K' : '\%([ｺ怖之旃惟怺薦米暦轉殺悃鶤艮鯤很袞坤壼琿狠漿棍魂菎滾梱溷痕渾墾恨懇根梢杪王泥裔樸鞐熟枹醴聲声蛩凍溢零錯苔亊箏斷判諺理断盡悉尽辞詞殊事壽寿鯒礫鯉齣狛腓昆瘤鮗谺応應答爰茲是試志心凩笏惚榾兀輿甑腰拵拗鐺鏝衝杲磽絖昊耗闔狎靠冓汞湟塙慌嫦礦冦淆遘亘仰昴誥鬨鴿鏗浤哮砿鎬伉熕洽訌閧困縞鮫逅糠槹哽盍稾亙壙覯隍簧遑洸餃惶寇鵁皋黌椌扣晄倖矼肓頏蛤呷詬匣昿皐崗肱徨峇袷敲爻藁倥釦棡凰犒吭窖畊岡猴胱絋傚啌蚣缸紘湊搆閤峺羔鍠幌鱇扛肴恆紺鈩絳閘蒙冰氷郡蛟槁候楮媾溘蝗酵嚆犢稿亢哄睾慷郊岬肛項巷鑛洪佼狡叩昂勾喉晃滉糀晧剛曠宏控恍侯皓港膏耿皎坑江絞膠虹巧鴻鉱衡浩厚耕幸弘綱抗購攻講恒薨溝鋼航行肯光皇好荒高梏谷哭槲尅釛斛轂石告酷穀踰懲蝴鴣袴焦觚虍粐乎沽餬胯菰瞽請楜娘壺錮込葫痼兒估冴漕痩虎冱倒戸呱媚粉夸詁子鈷捏濃故濾箍漉恋呼誇壷放転仔鼓小股罟女乕琥跨滬越古糊滸扈瑚皷混怙弧辜戀蠱超児雇凝孤湖此瓠蛄凅肥こｹ峻欅獸騫剱儉惓劵蜷謇鉉鵑綣幵娟險劒虔瞼俔顯臉圈釼歉權慊縣暄愃愆涓黔劔獻搴諠椦妍檢甄験慳捲倦遣羂嶮蹇鹸狷譴腱驗軒憲繭謙圏険硯倹献犬絢顕券劍剣見権拳研眷牽県建烟鑷言獣蓋涜吝削畩閲検貶健桁嗾竭訐亅碣杰譎偈抉厥蕨歇襭刔頡獗尻訣孑頁纈蹶桀穴傑結血憇夐彑勍攜迥冏檠絅蹊煢笄醯枅憬盻綮詣冂挈黥剄匸徑奚挂兮鮭瓊畦逕繼惠慧謦鷄系┻┣┠┨┝┴│┿┰╋━┛┬┥╂┤┸┯┼─┷├┏┳┫┃┓罫痙奎脛谿溪螢蛍渓閨憩圭携硅恵刑継勁珪計啓異毛蹴褻けｸ姑配椪栩櫪檪椡橡椚湫箜櫟含纐柵婚屎糞癖潛潜鵠凹窪縊跟軛頚珞頸首諄窟鞋履轡覆沓碎砕条降件頽崩屑釘莖茎陸杙杭掘崛倔鶏鐃藥擽薬樟楠梳櫛串釧與与挫籖鯀鯨籤隈熊艸嚔藾叢鏈腐鎖種ξΞ臭楔草圀邦國国髭嗽漱吻嘴脣唇梔腔φ粂皹勳熏裙醺桾皸崑燻訓勲葷委钁精詳鍬咥銜桑某暝峅眛昏罔冥鮓比闇位鞍藏暗倉廚厨涅曇蜘佝栗包俥車梍枢畔鐵玄蔵黒喰苦枸煦焼倶狗吼刳工絎駒眩垢口窶区劬繰呉暮貢嶇酌庫惧組衢紅食句吁懼區桍孔怐瞿くｷ段痍疵絆紲傷築鱚稷嚴黍帛後碪砧絹萌兆刻椈鞫掬辟君牙檗蘗迄訖狐屹詰佶拮吃鞠橘菊喫‥＼£、♀〇∵≡．＆＾‰▲‡｀§¶′＿〓☆；□↑↓・％■¢＝／≒←−￣★々≠♂〆ゝ◎―＄¨♭＋？ヽ…†♪‖＠゜◆ヾ´。±｜≪⌒≧○÷，≫＜∞●◇∴≦△！℃゛▼♯¬°▽‐ー∽￥：∨＞Ц＃∝∫〃仝Å″〒ゞ煙蚶衣更細妃后楸蕈茸乙雉轢杵軋岸桔汚穢北樵際裂燦煌雲嫌胆竏粁瓩浄澄淳潔清雰錐蛬吉霧檮桐襟磬釁覲箘掀噤衿鈞檎瑾忻饉箟听芹衾釿懃斤蒟径窘擒巾菌公禽筋錦欣僅琴均禁謹緊欽近勤鉅秬擧渠踞據舉筥嘘苣慶倨距歔遽鋸醵拠拒去勗亟蕀洫跼旭局挙許居巨虚頃峽筴鍄陜卿竟筺僵狹竅洶誑羌抂炯烱劫經刧襁繦蕎篋況徼恊恟棘轎竸况廾荊亰姜梗孝亨跫敬筐梟饗矯挾矜挟校拱嬌響鞏杏向興匈嚮享警競喬怯兄彊僑兢狂供橋莢凶郷兇驕叫夾匡侠狭恐経疆協境胸強驚脅共恭今教玖赳鬮舊蚯逑恷歙貅扱樛９烋摎邱笈皀疚岌厳胡翕朽泣穹糺糾及躬汲窮灸弓臼宮久柩究給丘求鳩級球休救急旧吸九瞶來著喜旡决羈祈揮窺起聞弃伎燬憙毅綺麾基机棄希噐棋其尋祁熹奇肌跂稀覬暉企黄愾欹几稘城軌諱岐決詭極記猗喟槻竒季碕鰭悸切禧消己效朞淇驥揆麒嬉崎僖匱屓既毀杞危卉器貴徽癸虧畿忌耆曁伐紀晞畸饑酒碁樹生木覊聽剪截櫃熈嵜冀跪气愧煕期効斬訊飢妓箕祺圻熙餽来徠鬼譏羇馗着寄倚氣利幾汽欷姫饋聴唏剞鑽騏逵騎掎規幃棊きｶ癢糜粥痒麹輕骨業軽鰈鰔餉通龜瓶甕亀鳫獵鴈殯猟雁釀鳬鳧髢鴨巛側躱廁厠磧瓦獺翡皮裘→紮搦苧碓柄枳躯躰軆體体鴉犂烏機絡空唐榧茅澗鸛厂蒄啣卷淦扞杆骭歛瞰讙奐戡豢坎瀚皖稈鐶拑酣陷繝嫺驩篏樌莟勸捍撼澣盥羹嫻鑵寰丱康懽憾羮揀歡潤罕觀橄涵渙凵堪覡巫鉋萱簪舘艱咸翰柬駻悍燗槓浣邯攷稽宦考棺潅閂煥鉗疳癇函凾鹹顴緘款桓箝諫諌轗坩旱侃鰥　館莞橇韓患灌勧菅簡奸刊柑肝看桿寒緩干嵌廣広竿貫巻敢漢環喊陥監喚甘間歓閑寛管慣完艦乾幹官観壁椛屍姓庇鞄芳蔓鯑一勘⊃影陰蔭景＊棧梯筧庚辛┘┐柧┌門廉脚乞癩∪川合’）《‘”｛〈“｝》〉囓柁旗鮖悴舵鰍鍛梶錺餝飾篭籠歸孵卻皈還省顧楓却帰反返守帋督祇髮韮裃雷髪紙鉦曲矩予鐘樺沫偏騙語潟刀象模仇固硬傍難容忝辱頑形旁方型肩風滓翳微幽掠緕纃綛絣擦糟鎹粕戞猾曷剋黠瞎鞨恰∧濶∩蠍筈蝎羯喝轄餓蛞聒劼擔刮蘰鬘桂闊括嘗捷豁渇担滑堅鰹割戛活疽暈鵲瘡傘嵩重襲葛笠堵硴墻牆蠣蛎柿掲關罹抱踵嬶嚊拘関係顏貌郁薫顔母感釡罐窰鴎框叺構喧竃竈釜缶蒲鎌數数槝栢膳傅瑕畏賢橿姦樫爨炊圍喞託囲鈎「『鉤」』限鍵傾禿蕪鏑頭齧気被兜哉適敵必要彜彝鬲鼎叶片哀愛悲鋺蛇鉄蜩神奏楫裹磆餅徒褐粮糧茖椁覺幗槨貉擴壑隱愨寉殼癨嚇穫咯膕骼膈∠掴狢埆蠖覈霍礁恪擱匿撹攪喀廓較郭〕【［】］〔殻挌劃閣格隠覚矍革馘鶴攫核獲拡客隔角確廨囘隗嵬觧榿蠏匯徊迴壞褂獪丐械枴畍誨揩醢誡夬懈喙椢恠峡价櫂茴蛙瑰乖浬鰄傀糴柏街鳰懷蛔蠶蚕邂蟹潰壊恢腕芥垣楷會拐悔詼諧契皆界疥魁偕改繪貝胛絵快甲灰槐晦懐介塊解廻回階戒開会怪海縢篝炬耀赫輝冠鑒鑑各屈鏡柯噛箇上苛暇蚊廈易嘩ヵ描苅枯佳彼兼哥缺霞藉架啝下渦踝堝闕華嗄荷馨刈假夥河科珈個蝸迦軻咼黴舸繋書賀夏萪支卦掛掻蝦痂謌渮歌過香禾狩買變家枷克駈花賈畫珂呵替代訶袈咬画顆貸價淅飼和ヶ果糅厦課可醸葭勝仮搗嘉墟嗅譌日斯禍換窩苟貨蝌価懸欠化罅伽賭翔靴且嚼訛交何駆驅个嫁譁借加跏戈稼寡涸耶変崋鹿笳火茄菓遐舁か京節└┗※хХ忽コ汗〜功株（Ｋク×金窯κキΧカКΚкχケK]\|ｯ\_s*[ｺｹｸｷｶ]\|ッ\_s*[コケクキカ]\|っ\_s*[子こけくきか]\|蟀\_s*谷\|焜\_s*炉\|前\_s*妻\|嫡\_s*妻\|二\_s*合\_s*半\|秋\_s*桜\|牛\_s*尾\_s*魚\|庶\_s*幾\|独\_s*楽\|特\_s*牛\|粫\_s*門\|甦\_s*生\|M\_s*e\_s*t\_s*a\_s*c\_s*h\_s*l\_s*a\_s*m\_s*y\_s*d\_s*e\_s*a\_s*e\|f\_s*o\_s*o\_s*t\_s* \_s*a\_s*n\_s*d\_s* \_s*m\_s*o\_s*u\_s*s\_s*e\_s* \_s*d\_s*i\_s*s\_s*e\_s*a\_s*s\_s*e\|外\_s*連\_s*味\|螻\_s*蛄\|罌\_s*粟\|滅\_s*紫\|S\_s*i\|莎\_s*草\|百\_s*[濟済]\|9\_s*[日月]\|秧\_s*鶏\|釉\_s*掛\|典\_s*薬\_s*寮\|L\_s*a\_s*u\_s*r\_s*\%(a\_s*c\_s*e\_s*a\_s*e\|o\_s*i\_s*d\_s*e\_s*a\_s*e\)\|探\_s*湯\|誓\_s*湯\|六\_s*合\|地\_s*祇\|都\_s*子\|州\_s*光\|群\_s*衆\|慈\_s*姑\|c\_s*r\_s*e\_s*s\_s*c\|内\_s*蔵\_s*助\|H\_s*e\_s*l\_s*l\_s*e\_s*b\_s*o\_s*r\_s*o\_s*i\_s*d\_s*e\_s*a\_s*e\|J\_s*u\_s*g\_s*l\_s*a\_s*n\_s*d\_s*a\_s*l\_s*e\_s*s\|仁\_s*彦\|啄\_s*木\_s*鳥\|X\_s*e\|如\_s*月\|私\_s*市\|昨\_s*日\|素\_s*地\|布\_s*地\|欺\_s*罔\|k\_s*i\_s*l\_s*o\|聖\_s*[之子美]\|沈\_s*菜\|蟋\_s*蟀\|螽\_s*斯\|G\_s*o\_s*l\_s*d\|A\_s*\%(u\|r\_s*c\_s*h\_s*i\_s*c\_s*h\_s*l\_s*a\_s*m\_s*y\_s*d\_s*e\_s*a\_s*e\|s\_s*t\_s*e\_s*r\_s*a\_s*l\_s*e\_s*s\|c\_s*a\_s*n\_s*t\_s*h\_s*a\_s*c\_s*e\_s*a\_s*e\)\|菫\_s*青\_s*石\|槿\_s*花\|R\_s*\%(h\_s*\%(o\_s*e\_s*a\_s*d\_s*a\_s*l\_s*e\_s*s\|a\_s*m\_s*n\_s*a\_s*l\_s*e\_s*s\)\|u\_s*n\_s*u\_s*n\_s*c\_s*u\_s*l\_s*o\_s*i\_s*d\_s*e\_s*a\_s*e\|a\_s*n\_s*\%(u\_s*n\_s*c\_s*u\_s*l\_s*a\_s*\%(l\_s*e\_s*s\|c\_s*e\_s*a\_s*e\)\|a\_s*l\_s*e\_s*s\)\)\|裾\_s*礁\|脇\_s*[侍息]\|姉\_s*[妹弟]\|頬\_s*[骨筋]\|毬\_s*果\|舅\_s*姑\|厩\_s*\%([肥舎]\|務\_s*員\)\|廐\_s*舎\|離\_s*れ\_s*離\_s*れ\|掃\_s*部\|羚\_s*羊\|氈\_s*瓜\|土\_s*器\|蝙\_s*蝠\|魚\_s*狗\|為\_s*替\|連\_s*枷\|身\_s*体\|落\_s*葉\_s*松\|随\_s*神\|檻\_s*車\|T\_s*\%(h\_s*a\_s*l\_s*i\_s*c\_s*t\_s*o\_s*i\_s*d\_s*e\_s*a\_s*e\|u\_s*b\_s*i\_s*f\_s*l\_s*o\_s*r\_s*a\_s*e\)\|南\_s*瓜\|量\_s*子\|千\_s*典\|山\_s*\%(梔\_s*子\|陽\_s*道\)\|蜉\_s*蝣\|陽\_s*炎\|蜻\_s*蛉\|破\_s*片\|挿\_s*頭\|駕\_s*\%(籠\|輿\_s*丁\)\|槭\_s*樹\|長\_s*[月官]\|主\_s*[紀計神]\|剃\_s*刀\|天\_s*\%(牛\|鼠\_s*矢\)\|帷\_s*子\|酢\_s*漿\_s*草\|O\_s*x\_s*a\_s*l\_s*i\_s*d\_s*a\_s*c\_s*e\_s*a\_s*e\|飛\_s*白\|春\_s*日\|C\_s*\%([ormfda]\|h\_s*r\_s*o\_s*m\_s*i\_s*u\_s*m\|i\_s*r\_s*c\_s*a\_s*e\_s*a\_s*s\_s*t\_s*e\_s*r\_s*a\_s*c\_s*e\_s*a\_s*e\|u\_s*r\_s*i\_s*u\_s*m\|y\_s*p\_s*e\_s*r\_s*a\_s*l\_s*e\_s*s\|e\_s*r\_s*c\_s*i\_s*d\_s*i\_s*p\_s*h\_s*y\_s*l\_s*l\_s*a\_s*c\_s*e\_s*a\_s*e\)\|曽\_s*て\|曾\_s*て\|松\_s*魚\|燕\_s*子\_s*花\|牡\_s*[蛎蠣]\|民\_s*部\|部\_s*曲\|E\_s*\%(b\_s*e\_s*n\_s*a\_s*l\_s*e\_s*s\|l\_s*a\_s*n\_s*a\_s*l\_s*e\_s*s\)\|案\_s*山\_s*子\|梭\_s*\%(魚\|子\_s*魚\)\|螳\_s*螂\|蟷\_s*螂\|瓜\_s*\%(田\|呂\_s*根\)\|拍\_s*手\|水\_s*[鶏母手夫]\|東\_s*\%(風\|京\_s*都\_s*立\_s*科\_s*学\_s*技\_s*術\_s*大\_s*学\)\|(\_s*株\_s*)\|称\_s*子\|贏\_s*ち\_s*得\|歩\_s*兵\|恁\_s*く\|杜\_s*\%(若\|父\_s*魚\)\|梅\_s*花\_s*皮\|頴\_s*田\|膾\_s*炙\|ノ\_s*\%([ブウ]\|ー\_s*ン\|ッ\_s*\%([トク]\|テ\_s*ィ\_s*ン\_s*グ\|カ\_s*ー\|キ\_s*ン\_s*グ\)\)\|ナ\_s*\%(ッ\_s*\%(ク\|プ\_s*\%(サ\_s*ッ\_s*ク\|ザ\_s*ッ\_s*ク\)\)\|レ\_s*ッ\_s*ジ\|イ\_s*[フトツ]\)\|ニ\_s*\%(ー\|ッ\_s*\%(ト\|テ\_s*ィ\_s*ン\_s*グ\)\)\|ホ\_s*\%(ー\_s*\%(ミ\_s*ー\|メ\_s*イ\)\|メ\_s*イ\_s*ニ\)\|フ\_s*\%(ビ\_s*ラ\_s*イ\|ル\_s*シ\_s*チ\_s*ョ\_s*フ\)\|ハ\_s*\%(ン\|ラ\_s*シ\_s*ョ\_s*ー\|ー\_s*ン\|バ\_s*ロ\_s*フ\_s*ス\_s*ク\|ル\_s*ツ\_s*ー\_s*ム\|チ\_s*ャ\_s*ト\_s*ゥ\_s*リ\_s*ア\_s*ン\)\|P\_s*\%(i\_s*p\_s*e\_s*r\_s*a\_s*\%(l\_s*e\_s*s\|c\_s*e\_s*a\_s*e\)\|a\_s*p\_s*a\_s*v\_s*e\_s*r\_s*a\_s*l\_s*e\_s*s\|o\_s*\%(d\_s*o\_s*s\_s*t\_s*e\_s*m\_s*o\_s*n\_s*a\_s*l\_s*e\_s*s\|t\_s*a\_s*s\_s*s\_s*i\_s*u\_s*m\)\)\)',
      \ 'L' : '\%([ｫォぉｪェぇｩゥぅｨィぃｧァぁ＜≪＿￣≦李左←∃∨¬∀⊃ルＬ∧レラ£ЛλлΛL]\|ｯ\_s*[ｫｪｩｨｧ]\|ッ\_s*[ォェゥィァ]\|っ\_s*[ぉぇぅぃぁ]\|液\_s*晶\|最\_s*小\_s*2\_s*乗\_s*法\|\.\_s*\.\_s*\.\|拉\_s*薩\|l\_s*-\_s*メ\_s*ン\_s*ト\_s*ー\_s*ル\|ｌ\_s*ｉ\_s*ｓ\_s*ｐ\_s*ｅ\_s*ｒ\|聯\_s*想\|補\_s*題\|檸\_s*檬\|手\_s*紙\|学\_s*習\|施\_s*錠\|局\_s*所\|論\_s*理\|ロ\_s*\%([キイアロリブボトメウスコゴグー]\|ペ\_s*ス\|ワ\_s*ー\_s*ル\|エ\_s*ベ\|ヨ\_s*ラ\|フ\_s*ト\|ル\_s*カ\|ベ\_s*リ\_s*ア\|ビ\_s*\%(ー\|ン\_s*グ\|イ\_s*\%(ス\_s*ト\|ン\_s*グ\)\)\|テ\_s*ィ\|サ\_s*ン\_s*\%(ジ\_s*ェ\_s*ル\_s*ス\|ゼ\_s*ル\_s*ス\)\|ニ\_s*ー\|ク\_s*リ\_s*ア\_s*ン\|ッ\_s*\%([ジタテトク]\|キ\_s*\%(ン\_s*グ\|ー\_s*ド\)\|カ\_s*ー\)\|ケ\_s*ー\_s*\%([トタル]\|シ\_s*ョ\_s*ン\)\|カ\_s*ー\_s*ル\|ガ\_s*ー\|ギ\_s*ン\_s*グ\|ジ\_s*\%(ー\|テ\_s*ッ\_s*ク\|ス\_s*テ\_s*ィ\_s*\%(ク\|ッ\_s*ク\)\|カ\_s*ル\|ク\_s*ー\_s*ル\|ッ\_s*[トク]\)\|ラ\_s*ン\|ン\_s*\%([ゴグダ]\|ボ\_s*\%(ク\|ッ\_s*ク\)\|バ\_s*ル\_s*デ\_s*ィ\|ズ\_s*デ\_s*ー\_s*ル\|リ\_s*[ーィ]\|ジ\_s*ン\|ド\_s*ン\)\|レ\_s*\%(ア\_s*ル\|ッ\_s*タ\|ー\_s*ヌ\|イ\_s*ン\|ン\_s*\%([ソス]\|ツ\_s*ォ\)\)\)\|\\\_s*L\_s*a\_s*T\_s*e\_s*X\|研\_s*究\_s*室\|リ\_s*\%([ィセズザサスダポルラリマナノンヌブアー]\|ャ\_s*マ\|ヤ\_s*ド\_s*ロ\|ヨ\_s*ン\|ゾ\_s*チ\_s*ー\_s*ム\|コ\_s*\%(リ\_s*ス\|ピ\_s*ン\)\|ク\_s*ー\_s*ド\|カ\_s*\%(ー\|オ\_s*ン\)\|ジ\_s*[ンー]\|デ\_s*[ィル]\|ド\_s*カ\_s*イ\_s*ン\|プ\_s*ト\_s*ン\|パ\_s*ー\_s*ゼ\|グ\_s*\%(ニ\_s*ン\|ナ\_s*ン\)\|フ\_s*\%([エト]\|タ\_s*ー\|テ\_s*ィ\_s*ン\_s*グ\)\|テ\_s*ラ\_s*[ルシ]\|チ\_s*ウ\_s*ム\|ソ\_s*\%(ソ\_s*ー\_s*ム\|グ\_s*ラ\_s*フ\_s*ィ\)\|タ\_s*ー\|ト\_s*\%([レル]\|マ\_s*ス\|ア\_s*ニ\_s*ア\|グ\_s*ラ\_s*フ\|バ\_s*ル\_s*ス\_s*キ\_s*ー\)\|オ\_s*\%(タ\_s*ー\_s*ル\|ネ\_s*ル\)\|ミ\_s*\%(テ\_s*ッ\_s*ド\|ッ\_s*[タト]\)\|モ\_s*\%(ー\_s*ジ\_s*ュ\|ネ\_s*ン\|ン\_s*チ\_s*ェ\_s*ッ\_s*ロ\)\|ム\_s*ジ\_s*ン\|キ\_s*\%(ッ\_s*ド\|ュ\_s*ー\_s*ル\|テ\_s*ン\_s*\%(シ\_s*ュ\_s*タ\_s*イ\_s*ン\|ス\_s*タ\_s*イ\_s*ン\)\)\|エ\_s*\%(ゾ\_s*ン\|ー\_s*ジ\_s*ュ\)\|ヒ\_s*テ\_s*ン\_s*シ\_s*ュ\_s*タ\_s*イ\_s*ン\|ネ\_s*\%([アン]\|ッ\_s*ト\|ー\_s*ジ\_s*ュ\)\|ニ\_s*ア\|ベ\_s*\%([ロラ]\|リ\_s*ア\|レ\_s*ー\_s*シ\_s*ョ\_s*ン\|ル\_s*テ\)\|ビ\_s*\%([アー]\|ド\_s*ー\|ン\_s*グ\)\|ュ\_s*\%([スー]\|ブ\_s*リ\_s*ャ\_s*ー\_s*ナ\|リ\_s*ュ\|ド\_s*ミ\_s*ラ\|ク\_s*サ\_s*ン\_s*ブ\_s*ー\_s*ル\|ッ\_s*ク\|シ\_s*ア\_s*ン\|ミ\_s*エ\_s*ー\_s*ル\)\|ロ\_s*\%(イ\|ン\_s*グ\_s*ウ\_s*ェ\)\|ヴ\_s*\%(ィ\_s*ン\_s*グ\_s*ス\_s*ト\_s*ン\|ァ\_s*\%(プ\_s*ー\_s*ル\|イ\_s*ア\_s*サ\_s*ン\)\)\|バ\_s*\%(テ\_s*ィ\|タ\_s*リ\_s*ア\_s*\%(ン\|ニ\_s*ズ\_s*ム\)\|プ\_s*ー\_s*ル\|イ\_s*ア\_s*サ\_s*ン\)\|ッ\_s*\%([ドピプタクチト]\|ス\_s*ン\)\)\|エ\_s*ル\)',
      \ 'M' : '\%([ﾓ脆醪師諸催靄舫腿銛杜森捫聞匁紋問玩翫擡齎靠凭鵙鴃縺悶樅籾椛楓蛻濳潛艾潜殯黐餠用糯餅桃者懶專専物尤勿畚許故悖旧戻下乖求礎素基本元綟捩文默沐杢黙芒网莽檬罔耗耄朦魍艨矇濛曚亡蒙毛孟猛網漏裳望喪揉持母燃若藻以摸楙貰洩姆保茂模糢もﾒ麪緜眄緬麺門棉綿面蓍珎珍♀娶貭粧妾牝瞽盲娚暈繞萌惠慈恵萠溟暝滅謎姪瞑盟酩銘鳴芽睨召奴瑪碼賞減雌女めﾑ羣榁室簇屯邨連邑叢村紫梅葎宜憤葮毳槿椋酬報尨骸躯旨難睦酷麥麦邀対百迎昔虚空鞅宗棟胸掬娘結笞鞭徒蝕蠧蠹蟲席莚蓆寧筵虫毟貉狢豸貪壻聟婿无謀霧矛毋無鵡夢梦剥六群牟務蒸噎武向咽むﾐ渠霙溝妊澪薨岑嶺峰峯亂紊婬淫妄濫猥乱◇※■＊簔穣簑蓑醜儖慘短惨幹研耳壥廛店操陵鶚崎岬巫尊敕勅詔＞」砌頻汀→】』右翠碧緑認幣蹊径倫導途通路道瞠髻鬟湖自蹼蛟瑞癸禊晦漲源鏖港湊南櫁瞶謐水調貢密甕帝蜜覩幸脉脈韮韭竓粍瓱榠螟茗名妙命冥都宮罠閔皆眠明民魅深觀身實彌観己診看味美盈三御充稔視壬巳靡弥箕みﾏ毬鞠紕蝮麿転稀賓客檀繭黛眉囘巡周防衛衞護守荳菽豆槫・圓．◯°゜。）（丸鬘謾幡縵懣鰻幔蹣蔓瞞卍饅漫滿慢迄笆貧幻瞼蔟疎眩回廻設申儲招繚統纒的蟶孫彎弯籬擬免猿亮純信実委罷壗侭圸飯儘継随髷任蒭芻耙紛鮪見猯塗斈學眥眦眼俎愛学斑枡斗鱒舛升桝萬蠱呪薪槙槇牧窗惑悗円窓甼襠区街町前複亦俣叉跨全瞬木胯股又鍖枕膜幕參眛参瑁詣妹哩迷枚米賄賂埋昧邁毎秣靺抹沫枩奉祀纏祭睫末大秀太勝柾弄優成盛將松匡鉞賢征誠昌希将政正仁雅媽万俟茉満目先麼未卷散磨枉眞益真増負蒔坐交馬捲舞嘛雑在放墹痲撒待播間摩敗巻混曲魔ま光月♪♭♯ム⊃∴≦∞÷≫≧≪⌒±∈∀⊂∬∫∝∨∽Δ¬⇒⊥∃∠∧⊆⇔∵≡∩×⊇∂∋≠√∪∇≒♂曼麻◎〇○●モＭ〒′−マ最ミМΜμメM]\|ｯ\_s*[ﾓﾒﾑﾐﾏ]\|ッ\_s*[モメムミマ]\|っ\_s*[もめむみま]\|双\_s*\%([手墨親]\|向\_s*き\|差\_s*し\)\|蜀\_s*黍\|唐\_s*土\_s*\%(書\|文\_s*字\)\|両\_s*\%([角親刃]\|差\_s*し\)\|楊\_s*梅\_s*皮\|主\_s*水\|旺\_s*角\|紅\_s*[絹染葉]\|強\_s*請\|虎\_s*落\|痘\_s*瘡\|莫\_s*斯\_s*科\|固\_s*よ\_s*り\|一\_s*徳\|O\_s*l\_s*e\_s*a\_s*l\_s*e\_s*s\|惘\_s*然\|乙\_s*張\|赤\_s*目\_s*魚\|針\_s*孔\|妻\_s*[君合沼]\|墨\_s*西\_s*哥\|鍍\_s*金\|繍\_s*眼\_s*児\|夫\_s*婦\|乳\_s*母\|布\_s*の\_s*子\|没\_s*\%([薬後入却有]\|義\_s*道\|食\_s*子\)\|B\_s*\%(e\_s*r\_s*b\_s*e\_s*r\_s*i\_s*d\_s*a\_s*c\_s*e\_s*a\_s*e\|i\_s*o\_s*r\_s*r\_s*a\_s*g\_s*i\_s*n\_s*a\_s*l\_s*e\_s*s\)\|浮\_s*腫\|６\_s*日\|6\_s*日\|崇\_s*田\|刀\_s*背\|襁\_s*褓\|零\_s*余\_s*子\|蜈\_s*蚣\|産\_s*霊\|息\_s*子\|k\_s*\$\_s*_\_s*{\_s*i\_s*n\_s*f\_s*}\_s*\$\|蚯\_s*蚓\|A\_s*\%(b\_s*i\_s*e\_s*s\|p\_s*e\_s*t\_s*a\_s*l\_s*a\_s*e\|c\_s*r\_s*o\_s*s\_s*t\_s*i\_s*c\_s*h\_s*u\_s*m\)\|山\_s*陵\|雎\_s*鳩\|親\_s*王\|嬰\_s*児\|亨\_s*治\|陸\_s*奥\|皇\_s*[子女國]\|３\_s*[つ日]\|3\_s*[つ日]\|角\_s*[鴟子髪]\|七\_s*寸\|鳩\_s*尾\|鷦\_s*鷯\|孤\_s*児\|凝\_s*視\|兎\_s*唇\|R\_s*u\_s*t\_s*a\_s*l\_s*e\_s*s\|神\_s*[子輿酒]\|苗\_s*字\|海\_s*[雲蘊藻布蜂松山]\|P\_s*o\_s*d\_s*o\_s*p\_s*h\_s*y\_s*l\_s*l\_s*a\_s*c\_s*e\_s*a\_s*e\|土\_s*[龍竜産]\|京\_s*都\|横\_s*浜\_s*マ\_s*リ\_s*ノ\_s*ス\|忠\_s*実\|肉\_s*刺\|翻\_s*\%(筋\_s*斗\|車\_s*魚\)\|H\_s*a\_s*m\_s*a\_s*m\_s*e\_s*l\_s*i\_s*d\_s*a\_s*l\_s*e\_s*s\|不\_s*\%(味\|見\_s*[転点]\)\|兇\_s*々\|凶\_s*鳥\|澗\_s*潟\|勾\_s*玉\|禍\_s*[々禍言事]\|況\_s*し\|澳\_s*門\|苧\_s*麻\|茅\_s*台\_s*酒\|丈\_s*夫\|倍\_s*達\|微\_s*[塵妙睡]\|燐\_s*寸\|驀\_s*地\|L\_s*o\_s*g\_s*a\_s*n\_s*i\_s*a\_s*c\_s*e\_s*a\_s*e\|豫\_s*て\|陪\_s*臣\|売\_s*僧\|C\_s*\%(a\_s*s\_s*u\_s*a\_s*r\_s*i\_s*n\_s*a\_s*l\_s*e\_s*s\|e\_s*r\_s*a\_s*t\_s*o\_s*p\_s*y\_s*l\_s*l\_s*a\_s*c\_s*e\_s*a\_s*e\)\|S\_s*\%(a\_s*p\_s*i\_s*n\_s*d\_s*a\_s*l\_s*e\_s*s\|c\_s*h\_s*i\_s*s\_s*a\_s*n\_s*d\_s*r\_s*a\_s*c\_s*e\_s*a\_s*e\)\|理\_s*[之元]\|允\_s*彦\|祐\_s*史\|晶\_s*子\|公\_s*[美則輝]\|斉\_s*加\_s*年\|方\_s*夫\|多\_s*言\_s*語\_s*化\|ｍ\_s*-\_s*Ｒ\_s*Ｎ\_s*Ａ\|ニ\_s*ー\_s*モ\_s*ニ\_s*ッ\_s*ク\|単\_s*量\_s*体\|会\_s*議\|和\_s*布\_s*[刈蕪]\|中\_s*間\_s*子\|薄\_s*荷\_s*脳\|行\_s*[幸列]\|写\_s*像\|日\_s*\%(米\_s*相\_s*互\_s*防\_s*衛\_s*援\_s*助\_s*協\_s*定\|本\_s*製\)\|m\_s*\%(u\_s*l\_s*t\_s*i\_s*l\_s*i\_s*n\_s*g\_s*u\_s*a\_s*l\_s*i\_s*z\_s*a\_s*t\_s*i\_s*o\_s*n\|i\_s*\%(c\_s*r\_s*o\|l\_s*l\_s*i\)\|e\_s*\%(g\_s*a\|z\_s*z\_s*o\_s* \_s*\%(f\_s*o\_s*r\_s*t\_s*e\|p\_s*i\_s*a\_s*n\_s*o\)\)\|a\_s*\%(k\_s*e\_s*フ\_s*ァ\_s*イ\_s*ル\|d\_s*e\_s* \_s*i\_s*n\_s* \_s*J\_s*a\_s*p\_s*a\_s*n\)\)\|計\_s*算\_s*機\|手\_s*紙\|ザ\_s*ッ\_s*ヘ\_s*ル\_s*＝\_s*マ\_s*ゾ\_s*ッ\_s*ホ\|嗜\_s*虐\_s*的\_s*趣\_s*味\|被\_s*虐\_s*\%(淫\_s*乱\_s*症\|趣\_s*味\)\|修\_s*士\|仮\_s*面\|移\_s*送\|エ\_s*ム\)',
      \ 'N' : '\%([ﾉ麕咒燧烽詛呪悳孔伯朔弼雅教糊矩憲規哲宜紀範典惟亘修允攵展順暢信則法後罵吭咽喉鑿蚤々湾宣曰臨覘稀望覗遺殘残鋸芒禾騰幟昇登上簷檐軒遁逸衲瑙碯曩王皇腦嚢膿能脳農野伸嚥−陳除濃熨飲退飮延載之呑廼乘乗述埜のﾈ塒姉聹侫檸嚀濘寧佞鼡鼠拗猫嫉妬希願捏熱犒労葱狙閨睡棔眠然稔棯懇拈撚燃念年根寝音涅子捻禰袮練値錬粘捩祢寢嶺煉ねﾇ絖饅垈帛幣鵺主蛻拭温布沼盜偸窃盗抽擢緯糠額縫抜貫拔怒奴塗濡脱ぬﾆ楡蒻潦鷄鶏瀑庭繞獰女尿韭眈薤睨韮儿刄姙葫蒜刃忍∀妊認任人乳擔蜷担濁賑握俄鳰臭匂沸錵贄偐僞贋偽柔靤如苦膠霓滲虹躙廿》《◎∬『』悪憎兄螺鯡鰊錦西入新肉‖岻仁逃似邇弍荷貳弐２二尼迩煮2丹貮児迯にﾅ靡抔嫐嬲鯆屶釶鉈泥薺詰若慨歎嘆抛擲撲毆殴慰治癒等猶直泪波辺邉邊鍋浪某棘棗懷懐夏擦梨情懶譌艶訛鉛鯰癜鮠膾鱠韲憖怠鈍腥捺准準擬凖謎涙洋宥傾灘詠霖眺痼乍存流轅永和梛椥渚長莫毋勿半・媒仲中７斜七蔑乃尚内繩畷縄苗滑鞣惱悩就哉也斉形業徳娚垂喃∵楠爾尓汝男軟難何倣肄双枹均列柞→⇒⊃楢習嘗投爲綯啾啼熟那鳴泣慣生為儺舐菜奈涕並納痿嚶撫茄凪無哭做狎南萎竝魚娜薙亡馴拿失な┘┛│┃┨┫┤┥┣┝├┠╋┿╂┼成＃∋∇名┗└日≒ニネＮ¬〜≠ナヌノнνΝНN]\|ｯ\_s*[ﾉﾈﾇﾆﾅ]\|ッ\_s*[ノネヌニナ]\|っ\_s*[のねぬにな]\|帳\_s*面\|狼\_s*[烟煙]\|惚\_s*気\|暖\_s*[簾気]\|礼\_s*江\|功\_s*晶\|賀\_s*子\|訓\_s*子\|祈\_s*子\|式\_s*部\_s*省\|記\_s*代\|倫\_s*[明子宗]\|敬\_s*之\|賭\_s*弓\|誠\_s*也\|敦\_s*子\|悦\_s*旦\|祝\_s*[女詞]\|仰\_s*け\_s*反\|盧\_s*泰\_s*愚\|逆\_s*上\|凌\_s*霄\_s*花\|姐\_s*さ\_s*ん\|杜\_s*松\|強\_s*請\|合\_s*歓\|微\_s*温\|零\_s*余\_s*子\|酸\_s*漿\|鐃\_s*鉢\|鰾\_s*膠\|I\_s*I\_s*部\|耳\_s*根\|面\_s*皰\|M\_s*y\_s*r\_s*i\_s*s\_s*t\_s*i\_s*c\_s*a\_s*c\_s*e\_s*a\_s*e\|莞\_s*爾\|L\_s*e\_s*a\_s*d\|P\_s*b\|海\_s*[苔鼠]\|C\_s*\%(e\_s*l\_s*a\_s*s\_s*t\_s*r\_s*a\_s*\%(c\_s*e\_s*a\_s*e\|l\_s*e\_s*s\)\|a\_s*r\_s*y\_s*o\_s*p\_s*h\_s*y\_s*l\_s*l\_s*a\_s*l\_s*e\_s*s\)\|雪\_s*崩\|竹\_s*節\_s*虫\|7\_s*[日個]\|地\_s*震\|行\_s*[木方]\|大\_s*\%(蒜\|理\_s*石\)\|蛞\_s*蝓\|弱\_s*竹\|追\_s*儺\|済\_s*\%(し\_s*崩\|り\_s*物\)\|可\_s*成\|平\_s*城\|不\_s*成\|空\_s*リ\_s*ス\_s*ト\|T\_s*h\_s*e\_s* \_s*N\_s*e\_s*t\_s*w\_s*o\_s*r\_s*k\_s* \_s*I\_s*n\_s*f\_s*o\_s*r\_s*m\_s*a\_s*t\_s*i\_s*o\_s*n\_s* \_s*C\_s*e\_s*n\_s*t\_s*e\_s*r\|S\_s*o\_s*\%(l\_s*a\_s*n\_s*a\_s*l\_s*e\_s*s\|d\_s*i\_s*u\_s*m\)\|ｎ\_s*\%(個\|次\_s*元\|ｅ\_s*ｍ\_s*ａ\_s*ｃ\_s*ｓ\)\|紐\_s*育\|フ\_s*ォ\_s*ン\_s*・\_s*ノ\_s*イ\_s*マ\_s*ン\|ヤ\_s*ー\_s*ノ\_s*ッ\_s*シ\_s*ュ\_s*・\_s*フ\_s*ォ\_s*ン\_s*・\_s*ノ\_s*イ\_s*マ\_s*ン\|オ\_s*ラ\_s*ン\_s*ダ\|ア\_s*メ\_s*リ\_s*カ\_s*ネ\_s*ッ\_s*ト\_s*ワ\_s*ー\_s*ク\|番\_s*号\|節\_s*点\|夜\_s*想\_s*曲\|n\_s*\%(次\|a\_s*n\_s*o\|o\_s*t\_s* \_s*o\_s*r\)\|諾\_s*威\|正\_s*常\|エ\_s*ヌ\|窒\_s*素\)',
      \ 'O' : '\%([ｵ俺游泳指妖畢在澱檻氈拇親愚疎颪卸念錘惟慮赴徐趣俤羈主想表重面瘟隱園Å怨♀妾温恩悍鈍臣覺溺朦朧思覚榲現朮桶威嚇踴戯縅棘駭愕驚躍踊傲奢驕嚴厳痴遣瘧怒行怠蒹補荻懼惧獺虞怐畏恐襲甥笈及綬葹ヽゞ〃仝ゝヾ々同唖繦襁鴛鴦教几忍筬收兎抑稚長幼理収治修遲檍納後遅饋賻諡贈送憶袵臆拜拝峻侵奇冒犯崗阜陵岳女陸丘岡欄斧自己各戦鬼衰劣囮頤訪貶乙漢♂音弟阿脅怯首夥誘屋膃億穩穏煽熈煕熾燠諚掟興隠沖翁鴬澳嚶毆泓浤惶罌瓮泱閘蓊墺悒凰殃徃奧秧襖枉姶鸚懊媼嫗鴎怏鏖謳旺凹櫻鴨樗欒楝殴朷甌汪横往鞅歐嘔陷陥遠果応掩蔽應夛奄蓋概欧公邑麋薤被仰扇皇狼弁鵬鴻鳳黄奥多衽覆粱凡鰲頁王穂怖桜壓緒居起降落墮将帶麻央小牡勇捺圧措唹織追悪苧汚下御置帯生折朗於負郎擱押推雄塢老男夫逐墜尾惜嗚乎堕終淤お大◎∞和∝♪∪∨開Ｏ○ωΟОオΩοоO]\|濠\_s*太\_s*剌\_s*利\|父\_s*[娘子]\|母\_s*[娘子屋]\|万\_s*年\_s*青\|本\_s*懸\_s*魚\|玩\_s*具\|沢\_s*瀉\|A\_s*l\_s*i\_s*s\_s*m\_s*a\_s*t\_s*a\_s*l\_s*e\_s*s\|厭\_s*離\|乳\_s*母\_s*日\_s*傘\|陰\_s*[陽地]\|飲\_s*[食酒]\|慍\_s*色\|婦\_s*系\_s*図\|手\_s*術\|螻\_s*蛄\|十\_s*八\_s*番\|鉄\_s*漿\|海\_s*髪\_s*海\_s*苔\|虎\_s*魚\|花\_s*魁\|美\_s*味\|含\_s*羞\_s*草\|白\_s*粉\|渡\_s*島\|訳\_s*語\|通\_s*事\|晩\_s*[稲生]\|可\_s*笑\|惡\_s*寒\|傍\_s*[目惚見]\|叔\_s*[父母]\|伯\_s*[父母]\|姨\_s*捨\|少\_s*女\|侠\_s*気\|D\_s*i\_s*l\_s*l\_s*e\_s*n\_s*i\_s*a\_s*l\_s*e\_s*s\|G\_s*u\_s*t\_s*t\_s*i\_s*f\_s*e\_s*r\_s*a\_s*l\_s*e\_s*s\|H\_s*y\_s*p\_s*e\_s*r\_s*i\_s*c\_s*a\_s*l\_s*e\_s*s\|霊\_s*屋\|蝌\_s*蚪\|飫\_s*肥\|佩\_s*物\|良\_s*人\|纓\_s*田\|C\_s*o\_s*p\_s*t\_s*i\_s*d\_s*o\_s*i\_s*d\_s*e\_s*a\_s*e\|鷹\_s*揚\|椀\_s*飯\_s*振\_s*\%(舞\|る\_s*舞\)\|相\_s*知\|鶯\_s*語\|近\_s*江\|零\_s*落\|越\_s*[生訴智知度]\|彼\_s*方\|祖\_s*[神父母]\|車\_s*前\|従\_s*祖\_s*[母父]\|青\_s*[梅海木]\|太\_s*\%(田\|安\_s*万\_s*侶\|上\_s*天\_s*皇\)\|巨\_s*頭\|逢\_s*[魔瀬隈坂]\|そ\_s*の\_s*他\|承\_s*知\_s*し\_s*ま\_s*し\_s*た\_s*\.\|烏\_s*[滸龍]\|t\_s*h\_s*e\_s* \_s*O\_s*b\_s*j\_s*e\_s*c\_s*t\_s* \_s*M\_s*a\_s*n\_s*a\_s*g\_s*e\_s*m\_s*e\_s*n\_s*t\_s* \_s*G\_s*r\_s*o\_s*u\_s*p\|立\_s*石\_s*電\_s*機\|職\_s*業\|楕\_s*円\|ウ\_s*\%(ィ\|ー\_s*\%(ズ\|ロ\_s*ン\)\|ロ\_s*ボ\_s*ロ\_s*ス\)\|出\_s*力\|ア\_s*\%(ワ\|ザ\_s*ー\|ウ\_s*\%([チト]\|タ\_s*ー\)\)\|基\_s*本\_s*ソ\_s*フ\_s*ト\_s*ウ\_s*ェ\_s*ア\|一\_s*\%(昨\_s*[年日]\|対\_s*一\)\|ワ\_s*ン\|ま\_s*た\_s*は\|論\_s*理\_s*和\|聖\_s*譚\_s*曲\|水\_s*中\_s*酸\_s*素\_s*破\_s*壊\_s*剤\|蛋\_s*白\_s*石\|最\_s*適\_s*化\|歌\_s*劇\|演\_s*算\_s*子\|操\_s*作\|酸\_s*素\)',
      \ 'P' : '\%([本磅椪烹方砲報法舖歩舗ぽ併蔽閇閉×邊編片邉辺遍篇屁ぺ幅服風分布符腐泌匹憑票俵品筒平日版幇搬板犯腹払発發走箱朴駮博拍泊愽包放敗杯盃配牌八播波破羽張ぱ鉛ψΨぴ±＋ぷφΦ┣├∝北┴‰Ｐ．％£〒点・プポ頁）（∂¶‖ペパПπピпΠ燐P]\|ｯ\_s*\%(ﾎ\_s*ﾟ\|ﾍ\_s*ﾟ\|ﾌ\_s*ﾟ\|ﾋ\_s*ﾟ\|ﾊ\_s*ﾟ\)\|ッ\_s*[ポペプピパ]\|っ\_s*[ぽぺぷぴぱ]\|ﾎ\_s*ﾟ\|先\_s*斗\_s*町\|ﾍ\_s*ﾟ\|祕\_s*[露魯]\|ﾌ\_s*ﾟ\|釜\_s*山\|普\_s*魯\_s*西\|ﾋ\_s*ﾟ\|皮\_s*蛋\|光\_s*一\|ﾊ\_s*ﾟ\|麺\_s*麭\|巴\_s*\%(里\|奈\_s*馬\)\|S\_s*y\_s*n\_s*a\_s*n\_s*t\_s*h\_s*a\_s*e\|C\_s*y\_s*c\_s*l\_s*a\_s*n\_s*t\_s*h\_s*a\_s*l\_s*e\_s*s\|排\_s*骨\|B\_s*r\_s*o\_s*m\_s*e\_s*l\_s*i\_s*a\_s*l\_s*e\_s*s\|L\_s*e\_s*a\_s*d\|白\_s*[板酒金]\|シ\_s*\%(ュ\_s*ー\_s*ド\|ロ\_s*シ\_s*ビ\_s*ン\)\|サ\_s*\%(ー\_s*ム\|イ\_s*\%([ズクケコ]\|ロ\_s*シ\_s*ビ\_s*ン\|リ\_s*ウ\_s*ム\|キ\_s*ッ\_s*ク\)\)\|+\_s*α\|ホ\_s*\%(ン\|ス\_s*ゲ\_s*ン\)\|ヒ\_s*ロ\_s*ポ\_s*ン\|比\_s*\%(布\|律\_s*賓\)\|フ\_s*\%(リ\_s*ジ\_s*ア\_s*ン\|レ\_s*\%(ー\_s*\%(ズ\|ジ\_s*ン\_s*グ\)\|イ\_s*ジ\_s*ン\_s*グ\)\|タ\_s*レ\_s*イ\_s*ン\|ォ\_s*\%([ーンノト]\|ボ\_s*ス\|ビ\_s*ア\|ス\_s*フ\_s*ァ\_s*ー\|ニ\_s*ー\)\|ァ\_s*\%(イ\|ラ\_s*オ\|ー\_s*\%([ジマ]\|ミ\_s*ン\_s*グ\)\|ン\_s*\%(ト\_s*ム\|タ\_s*ズ\_s*[ムマ]\)\|ル\_s*[ツス]\|レ\_s*ノ\_s*プ\_s*シ\_s*ス\)\|ィ\_s*\%([ロル]\|ジ\_s*\%(ッ\_s*ク\_s*ス\|カ\_s*ル\)\|ー\_s*ビ\_s*ー\|ッ\_s*シ\_s*ン\_s*グ\|レ\_s*モ\_s*ン\|ラ\_s*デ\_s*ル\_s*フ\_s*ィ\_s*ア\|リ\_s*\%([スーアパ]\|ッ\_s*[プパ]\|ピ\_s*\%(ン\|ー\_s*ヌ\)\)\)\|ェ\_s*\%(ー\_s*\%([ベズ]\|ジ\_s*ン\_s*グ\)\|イ\_s*ズ\|ロ\_s*モ\_s*ン\|ニ\_s*\%(ル\|ッ\_s*ク\_s*ス\|キ\_s*ア\|ー\_s*ル\)\|ノ\_s*\%(キ\_s*シ\|ー\_s*ル\)\)\)\|述\_s*語\|証\_s*明\|タ\_s*ン\_s*パ\_s*ク\_s*質\|処\_s*理\|手\_s*続\_s*き\|進\_s*行\|算\_s*譜\|利\_s*潤\|南\_s*瓜\|公\_s*告\|宣\_s*伝\|真\_s*珠\|永\_s*続\|カ\_s*リ\_s*ウ\_s*ム\|葡\_s*萄\_s*牙\|重\_s*合\_s*体\|多\_s*相\_s*型\|バ\_s*テ\_s*レ\_s*ン\|貼\_s*り\_s*付\_s*け\|論\_s*文\|偏\_s*執\_s*[狂病]\|引\_s*数\|p\_s*\%(T\_s*e\_s*X\|H\_s*メ\_s*ー\_s*タ\|e\_s*\%(t\_s*a\|r\_s*l\_s*ス\_s*ク\_s*リ\_s*プ\_s*ト\)\|i\_s*\%(c\_s*o\|a\_s*n\_s*\%(o\|i\_s*s\_s*s\_s*i\_s*\%(m\_s*o\|s\_s*s\_s*i\_s*m\_s*o\)\)\)\)\|リ\_s*ン\)',
      \ 'Q' : '\%([配椪栩櫪椢檪椡橡椚湫櫟含纐柵婚屎糞癖潛潜鵠裹凹窪馘括縊踵跟軛頚珞頸首諄窟鞋履寛狐轡覆靴沓碎砕管条降件頽崩屑葛釘莖茎陸杙株杭掘崛倔鶏鐃藥擽薬樟楠酒髪梳櫛串釧與与挫籖鯀鯨鬮籤隈熊艸嚔藾叢鏈腐鎖種ξΞ臭日茸菌楔草圀邦國国髭嗽漱吻喙嘴脣唇蛇梔劫刧腔φ　空粂皹勳熏裙醺桾皸下薫燻訓勲葷君委钁精詳企鍬加咥銜桑塊某暝競峅眛昏晦罔冥鮓比較闇位鞍藏暗倉廚厨涅〃仝ヽゞヾ々ゝ曇雲蜘栗狂包俥車廓曲郭梍枢踝畔鉄鐵★●■玄蔵黒玖柧供喰苦九枸鳩煦悔焼功倶狗来拘徠吼刳工絎駒朽眩垢口屈窶駈区劬繰呉宮暮貢久嶇來矩奇鉤９酌庫惧躯組衢紅食句吁懼區桍孔驅駆怐瞿汲ｸくＱ”‘’“♪ケ？ク¶Q]\|ｯ\_s*ｸ\|ッ\_s*ク\|っ\_s*く\|姑\_s*娘\|箜\_s*篌\|救\_s*世\|莎\_s*草\|傀\_s*儡\|被\_s*下\_s*度\|百\_s*[濟済]\|果\_s*物\|恭\_s*敬\|長\_s*月\|9\_s*月\|秧\_s*鶏\|究\_s*竟\|釉\_s*掛\|典\_s*薬\_s*寮\|天\_s*鼠\_s*矢\|L\_s*a\_s*u\_s*r\_s*\%(a\_s*c\_s*e\_s*a\_s*e\|o\_s*i\_s*d\_s*e\_s*a\_s*e\)\|探\_s*湯\|誓\_s*湯\|球\_s*磨\|六\_s*合\|地\_s*祇\|都\_s*子\|州\_s*光\|山\_s*梔\_s*子\|崑\_s*央\|群\_s*衆\|慈\_s*姑\|旧\_s*\%(訳\|唐\_s*書\)\|c\_s*r\_s*e\_s*s\_s*c\|水\_s*[鶏母]\|海\_s*月\|内\_s*蔵\_s*助\|K\_s*r\|H\_s*e\_s*l\_s*l\_s*e\_s*b\_s*o\_s*r\_s*o\_s*i\_s*d\_s*e\_s*a\_s*e\|公\_s*\%([家方卿界美事文]\|出\_s*挙\)\|佝\_s*僂\_s*病\|J\_s*u\_s*g\_s*l\_s*a\_s*n\_s*d\_s*a\_s*l\_s*e\_s*s\|胡\_s*桃\|C\_s*\%(r\|h\_s*r\_s*o\_s*m\_s*i\_s*u\_s*m\)\|R\_s*h\_s*a\_s*m\_s*n\_s*a\_s*l\_s*e\_s*s\|珠\_s*穆\_s*朗\_s*瑪\|チ\_s*ョ\_s*モ\_s*ラ\_s*ン\_s*マ\|『\_s*』\|コ\_s*\%(ー\_s*ラ\_s*ン\|ン\_s*テ\_s*ィ\_s*フ\_s*ァ\_s*イ\_s*ア\)\|問\_s*合\_s*せ\|カ\_s*\%(ザ\_s*ン\|タ\_s*ー\_s*ル\|ス\_s*バ\|ー\_s*ヌ\_s*ー\_s*ン\|ナ\_s*ー\_s*ト\|ダ\_s*フ\_s*ィ\|リ\_s*テ\|ド\_s*リ\_s*ー\_s*[ユル]\|ル\_s*\%(チ\_s*[ェエ]\|テ\_s*\%(ィ\_s*エ\|ッ\_s*ト\)\)\|ン\_s*タ\_s*[ムスン]\)\|質\_s*問\|キ\_s*\%(ト\|ブ\_s*ラ\|ホ\_s*ー\_s*テ\|ハ\_s*ー\_s*ダ\|ル\_s*\%(ト\|テ\_s*ィ\_s*ン\_s*グ\)\|ー\_s*ン\|ノ\_s*ン\|ッ\_s*シ\_s*ュ\|ュ\_s*\%(ー\|エ\_s*リ\)\)\)',
      \ 'R' : '\%([ﾛ侖崙崘堽栄論祿漉轆碌肋勒麓禄鹿６録弄榔薐勞琅實樓焜瓏潦簍僂咾鑞柆螂臈槞瑯哢隴朖蘢螻滝朧壟撈臘郎瘻廊牢浪蝋癆聾楼篭籠狼漏朗轤瀘廬櫓櫨艪顱驢蕗鷺鹵蘆枦櫚炉輅艫滷臚爐賂髏ろﾚ洌澪蛉儷犁勵鴒齢苓綟砺囹糲唳聆〇蛎齡蠡黎羚戻禮祈隸茘麗玲隷伶癘励零冷例冽劣烈裂列靂檪癧轣鬲櫪瀝礫轢歴濂戀匳嗹奩斂鏈瀲漣鎌縺輦簾櫺∧聨憐恋蓮煉錬攣練聯廉連れﾙ♪路盧縲泪壘瘰誄涙羸塁累類縷璢鏤屡褸婁陋るﾘ犂篥葎率慄栗勠淕六戮陸律擽畧暦掠略澑苙嶐瀏鏐瑠窿餾鉚旒瘤畄霤嚠笠榴溜硫琉留立柳粒劉隆流躪藺醂痳棆懍鄰菻躙鈴廩麟P淪厘凜霖琳悋綸淋禀稟凛鱗倫吝隣林燐臨絽踉侶梠膂虜呂慮仂力緑魎粮獵靈粱裲倆怜輌鷯繆廖凉鬣椋楞崚嶺暸兩鐐蓼輛燎瞭聊陵令梁糧諒霊遼凌龍漁亮寮⇔涼撩繚綾療竜量菱僚領了寥稜喨両料閭旅璃籬履釐悧裏梨俚里離浬莅驪痢李哩罹俐漓吏利裡詈理莉りﾗΛλ婪儖繿纜嬾覧瀾臠亂檻欒欖攬籃襴巒覽襤懶爛藍鸞卵濫闌嵐欄乱蘭労剌溂老埓埒猟辣薤喇珞樂犖絡駱酪烙楽落洛徠醴罍櫑耒賚蕾籟擂儡莱磊癩來礼雷頼来螺拉裸們良蘿騾等邏鑼ら右→ДжАГБФдзъЧйёЗкНЖьЭцТУСвюЮЁЯЪЛВбХМмЦоынИэа露епЕЬКПЩсчщя魯ШглушЫхОитфЙ輪√根羅ロ々ＲラルレリРρрΡR]\|ｯ\_s*[ﾛﾚﾙﾘﾗ]\|ッ\_s*[ロレルリラ]\|っ\_s*[ろれるりら]\|鱸\_s*魚\|芦\_s*[有花]\|濾\_s*[胞過紙]\|水\_s*無\_s*月\|6\_s*[時月]\|檸\_s*檬\|坩\_s*堝\|C\_s*\%(a\_s*l\_s*y\_s*c\_s*a\_s*n\_s*t\_s*h\_s*a\_s*c\_s*e\_s*a\_s*e\|h\_s*o\_s*r\_s*i\_s*p\_s*e\_s*t\_s*a\_s*l\_s*a\_s*e\)\|A\_s*\%(c\_s*t\_s*a\_s*e\_s*a\|p\_s*o\_s*p\_s*e\_s*t\_s*a\_s*l\_s*a\_s*e\)\|鯉\_s*[魚城]\|二\_s*\%(索\|翻\_s*縛\)\|V\_s*e\_s*r\_s*t\_s*i\_s*c\_s*i\_s*l\_s*l\_s*a\_s*t\_s*a\_s*e\|O\_s*r\_s*c\_s*h\_s*i\_s*d\_s*a\_s*l\_s*e\_s*s\|M\_s*i\_s*c\_s*r\_s*o\_s*s\_s*p\_s*e\_s*r\_s*m\_s*a\_s*e\|L\_s*\%([ruia]\|e\_s*i\_s*t\_s*n\_s*e\_s*r\_s*i\_s*a\_s*l\_s*e\_s*s\|A\_s*N\_s*ケ\_s*ー\_s*ブ\_s*ル\)\|海\_s*獺\|G\_s*\%(e\_s*n\_s*t\_s*i\_s*a\_s*n\_s*a\_s*l\_s*e\_s*s\|y\_s*\%(n\_s*a\_s*n\_s*d\_s*r\_s*a\_s*e\|m\_s*n\_s*o\_s*s\_s*p\_s*e\_s*r\_s*m\_s*a\_s*e\)\)\|関\_s*係\_s*デ\_s*ー\_s*タ\_s*ベ\_s*ー\_s*ス\|数\_s*理\_s*解\_s*析\_s*研\_s*究\_s*所\|京\_s*都\_s*大\_s*学\_s*数\_s*理\_s*解\_s*析\_s*研\_s*究\_s*所\|東\_s*北\_s*大\_s*\%(通\_s*研\|学\_s*電\_s*気\_s*通\_s*信\_s*研\_s*究\_s*所\)\|電\_s*気\_s*通\_s*信\_s*研\_s*究\_s*所\|限\_s*定\_s*命\_s*令\_s*セ\_s*ッ\_s*ト\_s*計\_s*算\_s*機\|範\_s*囲\|規\_s*則\|紅\_s*玉\|r\_s*u\_s*b\_s*y\_s*ス\_s*ク\_s*リ\_s*プ\_s*ト\|要\_s*求\|検\_s*索\|復\_s*帰\|返\_s*[信事]\|拒\_s*否\|反\_s*射\_s*鏡\|参\_s*\%(考\_s*文\_s*献\|照\_s*型\)\|機\_s*能\_s*回\_s*復\_s*訓\_s*練\|再\_s*帰\_s*的\|認\_s*識\|正\_s*規\_s*表\_s*現\|ア\_s*ー\_s*ル\)',
      \ 'S' : '\%([ｿ似杣灌傍峙毓育具供備害底苑薗園儲貮酘妬埆埣譏讒詆誹謗濡外猝率喞熄仄息足促束測側赱澡鯵嗾掫筝竃裝弉髞瀧勦輳嗽搶蔟爭偬瘡窗菷葱剏梍壯竈譟崢蚤笊嫂薮雙帚叟諍屮滝槽贈湊箱艘愡甑箒艚抓燥樔奘懆歃孀窓踪匝噪遭艙爪糟莊倉怱曹匆淙繰宋漕簇槍躁鎗箏綜痩喪藻艸葬壮操掻掃奏蹌滄争草層創蒼叢僧走惣送叛乖抑諳某橇轌艝拵噂巽邨鱒忖蹲樽孫遜存尊損噌其反踈組粗租胙俎礎爼詛麁囎蔬姐塑甦疎副措訴愬疽酥逸鼡沮蘓徂沿阻齟疏祖鼠咀想祚そｾ芹鬩槧羶甎揃倩翦箋燹濺苫栫槫孱孅簽吮纖湶纎亘筌蟾磚荐茜綫箭舩喘錢專僊贍鐫仟旃痊涎巛銛饌僣氈韆籤沾刋擶舛牋阡濳籖癬潛筅殱殲闡釧賎餞羨顫甅竰糎¢陝銓踐閃潺遷銑栴川剪煽譫僉瞻践栓跣疝詮銭穿戰腺繊僭泉嬋淺擅鮮専潜扇浅蘚船線撰宣洗煎戦千忙伜倅逼蝉旋洩椄卩屑絏鱈泄攝紲緤薛褻浙竊℃窃拙摂接節楔淅蹐績蹠蓆籍磧跡跖關藉晰威迹瘠勣裼晢夕鶺潟碩惜析関席隻情甥躋貰淒婿嘶睛擠撕牲萋菁韲瀞穽齏筬晟掣腥逝惺旌蜻整靖誓制晴競急世堰攻脊丗勢畆糶瀬畝せｽ鯣鋭坐座李既已昴術辷全滑皇脛臑裾双英村選優営寸漱薦啌勸雪濯啜勧芒薄煤賺鼈捩筋頗丞輔佑亮甫祐介助蘇裔陶曽乃曾即則淳漁凉鑾篶漫硯雀涼鱸鮓鮨遊椙犂犁耒篦隙尽末眇縋管菅頽廢廃窘救掬寡尠糘粭菫速純鈴炭角墨隅】【鄒數菘陬雛芻嵩崇趨樞∝∫∠∞≫∧∋÷⇒∬∃∂∴±∩≒Δ¬∇×∀∈⌒≪≧≠∨∵⇔枢翆榱陲悴隹粹瘁帥騅萃邃錘捶忰誰醉遂膵燧彗綏錐穂炊翠⊥H吹粋推水酔睡掏鋤總巣直簾拗耡醋棲総過饐剃澄籔空透磨壽澂寿統梳喫栖棄据吸擂剥住好漉ｼ埀謐蕋蘂蕊痺褥茵鵐蔀鷸鴫入霑蔵嶌縞嶋島凋澀沫澁渋縛暫屡荵凌鎬忍慕簧舖↓襪健認随从啝從．舌扱罔θ虐Θ粃秕椎椣卓貎尿肉臠猪榻黙蜆楙誠茂成繁重鋪惻陣頻閾櫁樒汐鹽潮隰瑟嫉櫛蛭蟋疾隲漆躾膝失室沒鎭沈滴雫賤鎮靜顰尓爾確聢併◇◆鹿貭叱征質卯滋撓科品鬼錣鍜錏凝痼而拉設萎栞襞吝咳爲什導怪汁徴験著記印〇○』銀城代『報調蝨濕湿七僕笞楚霜臀退斥尻寫卸者炙冩柘舍暹諜喋煮這謝鯱奢赦捨瀉嚼抉決皙勺釋蜥爍鑠妁斫蹟刳昔芍酌爵折癪笏赤綽灼石尺借赭写鷓積舎車斜釈社蛛株麈諏洙殳娶娵鬚侏銖繻卒菽粥叔俶戚蓿倏蹙槭肅淑夙粛縮取珠殊趣恤蟀卆出鰍繍楢葺溲泅嗅楫酬逎遒緝岫螽萩鷲甃駲楸穐蹤讎售讐洲綉收驟囚舅姑蓚鞦脩輯醜習羞酋聚舟秀祝袖拾啾蒐収執衆襲愁就臭蹴週終褶州宗椶棕守朱撞種修周手首狩須儁皴悛惷蕣雋墫順蠢舜旬竣峻駿逡筍春瞬俊嗔蓁縉蔘鷏忱簪甄鷆寢岑畛矧疹槙齔臻娠譛譖哂脣袗怎晉瀋箴軫榛秦襯診鉐津駸讖紳斟唇針呻蜃賑芯瞋振殿侵辛薪晨辰震宸森伸愼眞慎寝晋身進審深親臣鍼心宍信神藷墅薯杵岨胥蜍黍渚砠處嶼且狙苜苴曙背塩緒枌雎蔗庶処所書暑誚聲橡奬觴舂蛸懾燮厰姓獎枩稍甞韶炒淞陞顳腫井摺嶂橸浹愴星升鍬樅嘗簫慯廂霎庠剿筱鬆秤政訟廠樵鷦礁邵餉愀妝璋湫艢劭峭殤梢將敞醤慫従逍倡竦爿牆墻薔笙樟装肖菖＜≦湘誦聳檣稱声裳（）蒋蕉嘯慴精霄鈔粧彰悚鏘悄蕭哨瀟焦憔匠鍾償瘴漿頌詔妾沼請衝薑唱庄渉奨牀娼床椒鉦荘翔抄宵傷踵召銷賞猩症昭燒猖昌少憧松捷紹晶尚象承證正将称焼笑照勝招消章詳証鐘硝掌省商昇穡屬稷嗇禝寔稙昃謖軾矚拭餝属燭贖色飾囑嘱織蝕式喰蜀殖初諸埴植食職砥姉摯誣侈髭肆仔及岐址梔咫贄沚旨誌資豕鷙凍厮粢齒雌耜枝齎領篩四祇嗤貲諮巵死強紙熾市師厶妛飼諡祗閇姿駟嗣趾此染締詞茲釶柿覗弛徙至屍嘴斯駛屎占啻之揣如閉錙糸絞孜尸滓獅瓷緊笥始泗咨觜只輜廝使敷恃思帋痴漬脂氏蚩時紫沁俟絲巳祉矢恣若賜次浸詩志識司弑笶翅謚示梓伺視緇自祠史試子痣滲茨肢歯幟祀施竢舐卮耆呰為芝阯しｻ杓雨寤鮫清鞘莢觸騷触椹鰆爽騒澤沢濬掠新攫渫杷浚更士桾申白素汕纉潸餐蒜衫讚粲芟爨鑚蠶戔嶄跚驂慘攅斬彡杉秋桑…≡簒纂鯢燦珊繖棧刪卅參蚕鑽算傘３▼▽贊3参賛O散惨産酸嘸摩遉樣彷碍妨様山漣貶蔑垂鮭叫仙鏥寞寥皺淋生鯆虱鯖捌偖扨偵宿禎貞定哘誘蝎蠍授皿祥桟匙簓障囁私篠支捧笹逧迫讃鐸蛹宛真碕嵜尖前崎魁遮峺哢囀候侍核実説俚了達逹暁叡聰敏諭慧哲知訓郷恵聡智悟理杆里小棹竿箚扎刹紮皐撮搜寒捜相主盛盞柧觚杯盃榮栄倒肴魚界阪堺境酒泝逆賢坂榊猿麾挟鷺拶撒擦颯先数察薩刷札綵衰縡偲腮樶責哉殺霽崔淬顋寨切洒纔碎晒犲濟凄砦灑釵靫悽摧倖豺呵苛幸猜塞蔡栽儕采齊財臍截載孥宰済齋犀際災柴賽菜砕採斉斎祭妻債催才細鰓裁歳最埼捉辟柞縒咋簀筰齪筴窄册槊酢嘖朔柵遡溯鑿索搾昨炸冊策錯櫻桜裟提砂乍去射狭狹紗刺唆曝柤蓑裂捺做梭磋褪銹荒插醒挫差莎削止冷早避些槎嵳嵯嗟沙娑然再渣蹉扠詐割咲注覚嗄茶螫簑瑣下左搓瑳冴寂鎖挿叉査佐作覺点冱錆さ√錫す／仕指製西　┓┐〆□■шШ上＃♯щЩ添∪日⊂⊆⊃⊇文静★☆＊標嗜青三聖土彩△▲悉署〜∽‘’┌┏集＼探§″性セサＳシソス秒σΣСсS]\|ｯ\_s*[ｿｾｽｼｻ]\|ッ\_s*[ソセスシサ]\|っ\_s*[そせすしさ]\|遽\_s*走\|蕎\_s*麦\|内\_s*障\|彼\_s*杵\|諷\_s*歌\|幾\_s*許\|錚\_s*[錚々]\|十\_s*\%(路\|露\_s*盤\)\|冬\_s*青\|微\_s*風\|虚\_s*言\|宙\_s*組\|夫\_s*[々夫]\|返\_s*田\|傴\_s*僂\|U\_s*m\_s*b\_s*e\_s*l\_s*l\_s*i\_s*f\_s*l\_s*o\_s*r\_s*a\_s*e\|台\_s*詞\|c\_s*e\_s*n\_s*t\_s*i\|妹\_s*尾\|嘲\_s*笑\|海\_s*象\|蒸\_s*[篭籠]\|魑\_s*魅\|凡\_s*て\|典\_s*侍\|季\_s*雄\|天\_s*[皇蛾]\|蘿\_s*蔔\|V\_s*i\_s*o\_s*l\_s*a\_s*l\_s*e\_s*s\|N\_s*y\_s*m\_s*p\_s*h\_s*a\_s*e\_s*\%(a\_s*c\_s*e\_s*a\_s*e\|o\_s*i\_s*d\_s*e\_s*a\_s*e\)\|夊\_s*繞\|隧\_s*道\|Ｃ\_s*\%(型\|言\_s*語\)\|老\_s*舗\|望\_s*潮\|飛\_s*沫\|L\_s*a\_s*\%(m\_s*i\_s*n\_s*a\_s*l\_s*e\_s*s\|b\_s*i\_s*a\_s*t\_s*a\_s*e\)\|埋\_s*葬\_s*虫\|幣\_s*原\|桎\_s*梏\|柳\_s*葉\_s*魚\|衣\_s*魚\|汚\_s*点\|蠹\_s*魚\|惠\_s*雄\|舗\_s*石\|磯\_s*城\|W\_s*i\_s*n\_s*t\_s*e\_s*r\_s*a\_s*c\_s*e\_s*a\_s*e\|倭\_s*文\|閑\_s*[谷か]\|云\_s*[云々]\|明\_s*\%(々\_s*後\_s*日\|明\_s*後\_s*日\)\|７\_s*月\|7\_s*月\|４\_s*[分月]\|4\_s*月\|羊\_s*[齒歯]\|I\_s*\%(l\_s*l\_s*i\_s*c\_s*i\_s*a\_s*c\_s*e\_s*a\_s*e\|s\_s*o\_s*p\_s*y\_s*r\_s*o\_s*i\_s*d\_s*e\_s*a\_s*e\)\|不\_s*[忍知]\|後\_s*\%([輪口志目]\|込\_s*み\)\|軍\_s*鶏\|香\_s*菜\|吃\_s*逆\|蝦\_s*蛄\|輸\_s*[出贏]\|隼\_s*[朗郎]\|笋\_s*[干羹]\|縦\_s*容\|睫\_s*毛\|翡\_s*翠\|東\_s*\%(雲\|海\_s*林\)\|Z\_s*i\_s*n\_s*g\_s*i\_s*b\_s*e\_s*r\_s*a\_s*l\_s*e\_s*s\|続\_s*\%(日\_s*本\_s*\%(紀\|後\_s*紀\)\|後\_s*撰\_s*和\_s*歌\_s*集\)\|髑\_s*髏\|匣\_s*鉢\|復\_s*習\|百\_s*日\_s*紅\|胡\_s*孫\_s*眼\|←\_s*→\|霰\_s*弾\|弥\_s*生\|懺\_s*\%(法\|悔\_s*懺\_s*悔\)\|流\_s*[離石]\|蠑\_s*螺\|覇\_s*王\_s*樹\|C\_s*\%([es]\|y\_s*c\_s*a\_s*d\_s*\%(i\_s*d\_s*a\_s*e\|o\_s*\%(p\_s*s\_s*i\_s*d\_s*a\|f\_s*i\_s*l\_s*i\_s*c\_s*a\_s*l\_s*e\_s*s\)\)\|h\_s*l\_s*o\_s*r\_s*a\_s*n\_s*t\_s*h\_s*a\_s*c\_s*e\_s*a\_s*e\|言\_s*語\|D\_s*店\|型\_s*肝\_s*炎\|a\_s*\%(s\_s*s\_s*y\_s*t\_s*h\_s*o\_s*i\_s*d\_s*e\_s*a\_s*e\|c\_s*t\_s*a\_s*l\_s*e\_s*s\)\)\|竹\_s*[篦刀筒]\|大\_s*角\_s*豆\|防\_s*人\|曩\_s*に\|向\_s*坂\|一\_s*昨\_s*\%(昨\_s*[年日]\|々\_s*[年日]\)\|實\_s*藤\|甘\_s*藷\|五\_s*月\|月\_s*代\|匂\_s*坂\|税\_s*所\|雑\_s*賀\|骰\_s*子\|P\_s*\%(a\_s*r\_s*i\_s*e\_s*t\_s*a\_s*l\_s*e\_s*s\|t\_s*e\_s*r\_s*i\_s*d\_s*o\_s*s\_s*p\_s*e\_s*r\_s*m\_s*\%(a\_s*l\_s*e\_s*s\|i\_s*d\_s*a\_s*e\)\|r\_s*i\_s*m\_s*u\_s*l\_s*a\_s*l\_s*e\_s*s\)\|A\_s*\%(p\_s*i\_s*a\_s*l\_s*e\_s*s\|r\_s*a\_s*l\_s*e\_s*s\|n\_s*t\_s*i\_s*m\_s*o\_s*n\_s*y\)\|s\_s*f\_s*o\_s*r\_s*z\_s*a\_s*n\_s*d\_s*o\|瑞\_s*[典西]\|B\_s*\%(r\|シ\_s*ェ\_s*ル\)\|拡\_s*張\_s*子\|ｓ\_s*ｕ\_s*ｎ\|部\_s*分\|置\_s*換\|ア\_s*ン\_s*チ\_s*モ\_s*ン\|構\_s*造\_s*体\|D\_s*o\_s*n\_s*a\_s*t\_s*i\_s*o\_s*n\_s* \_s*A\_s*l\_s*p\_s*h\_s*o\_s*n\_s*s\_s*e\_s* \_s*F\_s*r\_s*a\_s*n\_s*c\_s*o\_s*i\_s*s\_s* \_s*d\_s*e\_s* \_s*S\_s*a\_s*d\_s*e\|M\_s*\%(e\_s*r\_s*c\_s*u\_s*r\_s*y\|u\_s*s\_s*a\_s*l\_s*e\_s*s\|a\_s*r\_s*q\_s*u\_s*i\_s*s\_s* \_s*d\_s*e\_s* \_s*S\_s*a\_s*d\_s*e\)\|加\_s*\%(之\|虐\_s*\%(淫\_s*乱\_s*症\|趣\_s*味\)\)\|T\_s*\%(e\_s*t\_s*r\_s*a\_s*c\_s*e\_s*n\_s*t\_s*r\_s*a\_s*c\_s*e\_s*a\_s*e\|i\_s*n\|h\_s*e\_s* \_s*S\_s*i\_s*m\_s*p\_s*l\_s*e\_s* \_s*A\_s*P\_s*I\_s* \_s*f\_s*o\_s*r\_s* \_s*e\_s*v\_s*e\_s*n\_s*t\_s*-\_s*b\_s*a\_s*s\_s*e\_s*d\_s* \_s*X\_s*M\_s*L\_s* \_s*p\_s*a\_s*r\_s*s\_s*i\_s*n\_s*g\)\|ケ\_s*イ\_s*素\|珪\_s*素\|計\_s*測\_s*自\_s*動\_s*制\_s*御\_s*学\_s*会\|ネ\_s*ッ\_s*ト\_s*サ\_s*ー\_s*ビ\_s*ス\|ザ\_s*\%(ッ\_s*ク\|ク\_s*セ\_s*ン\|ビ\_s*ー\_s*ネ\|ウ\_s*バ\_s*ー\|ワ\_s*ー\_s*ク\_s*ラ\_s*ウ\_s*ト\|ム\_s*ザ\|ル\_s*ツ\|イ\_s*\%([ルン]\|ラ\_s*ー\|デ\_s*ル\)\|ー\_s*\%([ルラ]\|メ\_s*ン\)\)\|意\_s*味\|ゼ\_s*ミ\|ナ\_s*ト\_s*リ\_s*ウ\_s*ム\|ゾ\_s*\%(ル\|ン\_s*デ\|ー\_s*\%(ム\|リ\_s*ン\_s*ゲ\_s*ン\)\|フ\_s*ィ\_s*ー\)\|ジ\_s*\%(ム\|ー\_s*\%([グク]\|メ\_s*ン\_s*[ズス]\)\|グ\_s*ム\_s*ン\_s*ト\|ン\_s*\%(メ\_s*ル\|グ\_s*シ\_s*ュ\_s*ピ\_s*ー\_s*ル\|テ\_s*ー\_s*ゼ\)\)\|硫\_s*黄\|エ\_s*ス\)',
      \ 'T' : '\%([ﾄ乕囚寅虎瀞侶舮靹供纜燭艫朋倶鞆輩讎讐伴共友巴沌惇丼飩團暾団遯燉遁豚鷄禽酉砦塞俘擒虜豐恍惚枢乏塒迚科咎篷笘攴苫鶏伽唱稱鄰隣朿棘刺整鎖處処所床享鴟鵄扉鳶嫁訥晨穐秋刻鴇鬨斎頓幄幃帷柮杤栃閼軣轟屆届咄吶凸世暁祀駿壽繁稔寿豊歳俊利敏年慝牘悳黷犢匿督徳涜∃得特磴稻鞜剳宕滕鬥纛櫂讀盜綯橦叨桶盪竇抖縢礑荅閙塘罩帑棹兜檮納亠嶋棠搨档嶝溏鞳夲蘯道黨酘陦榻樋梼沓涛朸淌篤吋擣萄釖鬧籘諮迯儻潼鐙嶌逗螳蟷稲■幢滔鼕掏當峠読饕疼淘濤籐董悼棟搭痘套＝豆燈桃韜遠統騰橈冬討骰祷藤灯島橙凍刀陶糖謄唐答投等桐兎砿外富止礪研閇觧疾莵梳穫融録問砥採飛杜賭翔留冨図熔人途登菟畄蠧泊戸跿荼蠹十蚪砺盗屠渡解取執溶睹兔脱妬鍍磨説摂覩鎔堵秉獲汢塗肚圖とﾃ瑛晃輝衒寺靦囀躔忝、鷆鷏碾巓，槙沾殄霑腆壥諂廛轉‥．：輾填甜奠顛纒癲恬殿纏覘展篆添梃輦輟鐡耋咥餮垤跌屮銕姪迭俶逖荻鏑狄糴廸笛覿擲迪滴轍的哲敵撤剔徹鐵鉄酲眤碵羝觝幀嚔嚏渟柢酊掟睇楴詆棣汀騁鵜叮遉釘弟碇剃蹄邸締梯悌訂程底偵廷遞逓抵牴呈艇鄭涕啼庭定低弖照てﾂ模幹劈聾列辛貫面液汁露冷錘舶紡系艷艶絃鉉寉橡剱劒釼劍劔剣弦蔓敦鶴幣兵鉗噤鶫償桓恆典恒常夙務勉努勤拙拐倹抓嬬撮詳審爪褄妻募角晦螺瞑円呟礫具粒辻辟罪捉捕閊把曹阜丘元首寮司官柄仕掴遣攫搏疲使窄莟蕾局壷壺坪綱繋壌蝪培霾戊己伝傳鐔翅翼鍔燕唾續約皷鼓続葛綴番栂槌縋弊費序潰終墜遂鎚椎追做殱殲捏繕傍旁創造作熟机佃蹲拒欟坏鴾槻月裹砲障躑榴謹慎筒愼恙包堤痛椄衝告點附撞繼津搗継嗣支突積尾漬詰尽通憑浸次盡攣連就接付つﾁ吃釁岐巷衢粽粡因杠契鵆児交腟帙膣些蟄N窒斉秩父捷矗筑築逐盟税力親邇誓迩近苣尖縮鏤塵朕珎趁抻鎭碪狆亭跛闖鴆砧椿枕鎮陳珍沈賃杖找摘茶嫡着潴儲豬箸紵竚躇瀦墸杼苧緒樗楮⊥陟飭敕捗稙躅猪勅著悵髫廳樢微聽鵈楪齠甼漲佻膓吊鼎趙迢萇誂廰澂脹疔輙昶糶蔦窕晁鬯塚輒雕挺凋帖掉停諜跳眺貼鐇澄提喋頭銚ー蝶暢帳丁牒重逃鳥張弔懲肇嘲徴兆釣聴彫潮町頂調庁貂腸超挑朝丶黜寵儔冑肘蟲惆鍮晝紬綢廚籌※冢丑胄稠酎紐鑄冲沖偸宙虫｝［｛］厨誅鋳紂仲註駐柱衷注籀昼抽中躓蜘踟褫魑夊黐笞黹池値夂輊治耻千薙家血岻痴散地稚遲知茅恥置穉緻致智遅乳禿癡馳ちﾀ便党屯椽榱架樽弛膤鰔蕩鱈盥戯俵袂保躊為樣様爲啗猯擔疸餤湍覃彖亶鄲靼綻站潭憺酖殫膽襌賺毯摶袒檀褝槫緞椴憚攤壇慱湯澹‡†蛋耽W旦痰啖坦眈反C嘆歎誕胆箪譚担淡鍛單短探貪単覊栲妙戲訊攜携尋訪比畴疇類民髱娯樂恃頼愉楽喩例譬激滾斃仆嵶垰殕倒嫋旅貍狸讃称賛敲蹈踏祟湛鬪戰斗戦闘彳佇叩疊疂疉畳箍鏨違互畉耕畊掌店棚到炭辿燵撻斬韃闥巽辰佐扶＋援相佑輔弼助襷髻椨誑胤種塔龍竜糜糺爛漂維伊理貞是直禎忠惟匡徒唯只窘嗜慥確鮹鱆胝凧蛸嶽哮誥茸英豪威毅猛笋筍酣雄健丈斌武靈彈珪承賚珠霊魂卵偶適環弾球玉丹謀莨束縱｜盾鬣奉楯蓼縦竪質城達館忽橘舘瀑薪滝瀧峪溪渓谿谷尭亨臣任集宇昂楼小剛恭岳洪喬嵩孚尚尊敬孝崇隆貴鷹竹篁簟寶財高寳宝但濯綰鐸倬澤拆柝擢柘戳啅擇鈬魄畜企啄磔匠巧択沢逞琢蓄度宅託卓謫托拓躰隶殆抬靆黛紿替滯體碓帶軆平駘擡逮腿当怠玳諦岱鯛對颱袋戴堆頽態苔滞待代帝貸隊褪胎帯体退泰大対足手斷垂佗闌経炊撓焚矯溜躱經咤食發朶薫詫誰他詑耐太強蛇起逹貯給堪長揉閉埀発断勃多澑岔截絶田立裁汰点夛侘建它賜たцЦ〜天時×型火土→吐都東上噸瓲┃│台表第木スジ∴Θθザ正ツ¨転透▲△▼▽トチ…・試端タＴт┝Τ┯┰┣┷┸┤┬┥┴┻┠τ┫┳├〒Т┨テT]\|ｯ\_s*[ﾄﾃﾂﾁﾀ]\|ッ\_s*[トテツチタ]\|っ\_s*[とてつちた]\|門\_s*渡\_s*り\|薯\_s*蕷\|船\_s*尾\_s*座\|公\_s*[明暁]\|倫\_s*[子明]\|邑\_s*中\|蜻\_s*蛉\|A\_s*c\_s*o\_s*n\_s*i\_s*t\_s*u\_s*m\|蜷\_s*局\|跡\_s*[絶切]\|蜥\_s*蜴\|舎\_s*人\|馴\_s*鹿\|野\_s*老\|瓊\_s*脂\|永\_s*[遠久]\|宿\_s*直\|朱\_s*鷺\|左\_s*見\_s*右\_s*見\|朽\_s*木\|H\_s*y\_s*d\_s*r\_s*o\_s*c\_s*h\_s*a\_s*r\_s*i\_s*t\_s*a\_s*l\_s*e\_s*s\|独\_s*鈷\|季\_s*[衣道栄]\|聡\_s*[明徳]\|祈\_s*年\_s*祭\|淑\_s*[夫子]\|洞\_s*爺\|光\_s*男\|晧\_s*史\|紅\_s*娘\|瓢\_s*虫\|F\_s*e\|I\_s*r\_s*o\_s*n\|劇\_s*村\|滌\_s*除\|２\_s*×\_s*４\|悪\_s*阻\|石\_s*\%(蕗\|竜\_s*子\)\|心\_s*[太算]\|自\_s*\%(摸\|模\_s*和\)\|氷\_s*柱\|倩\_s*々\|黴\_s*雨\|入\_s*梅\|梅\_s*雨\|再\_s*見\|悉\_s*に\|備\_s*に\|旋\_s*[風毛]\|B\_s*a\_s*l\_s*a\_s*n\_s*o\_s*p\_s*h\_s*o\_s*r\_s*a\_s*l\_s*e\_s*s\|１\_s*\%(日\|０\_s*日\)\|朔\_s*日\|1\_s*\%(日\|0\_s*日\)\|美\_s*人\_s*局\|E\_s*\%(u\_s*p\_s*h\_s*o\_s*r\_s*b\_s*i\_s*a\_s*l\_s*e\_s*s\|r\_s*i\_s*c\_s*a\_s*l\_s*e\_s*s\)\|字\_s*\%(牌\|一\_s*色\)\|少\_s*と\|義\_s*父\|主\_s*[殿税]\|周\_s*夫\|睦\_s*子\|渠\_s*睦\_s*子\|萵\_s*苣\|身\_s*柱\|似\_s*指\|清\_s*\%(老\_s*頭\|一\_s*色\)\|青\_s*\%([幇島]\|梗\_s*菜\|椒\_s*肉\_s*絲\)\|全\_s*帯\|昌\_s*洙\|J\_s*i\_s*a\_s*n\_s*g\_s*s\_s*u\|江\_s*蘇\|焼\_s*豚\|叉\_s*焼\|察\_s*哈\_s*爾\|餃\_s*子\|雑\_s*砕\|炒\_s*[麺飯]\|北\_s*谷\|甘\_s*露\_s*子\|錯\_s*和\|総\_s*角\|一\_s*[日寸]\|植\_s*字\|魚\_s*[屋蝨]\|金\_s*魚\_s*蝨\|草\_s*石\_s*蚕\|春\_s*\%(麗\|宮\_s*坊\)\|九\_s*\%(十\_s*九\|連\_s*宝\_s*[灯燈]\)\|揺\_s*蕩\|容\_s*易\|白\_s*痴\|猶\_s*豫\|蜑\_s*民\|段\_s*銭\|蒲\_s*公\_s*英\|騨\_s*州\|M\_s*\%(e\_s*n\_s*i\_s*s\_s*p\_s*e\_s*r\_s*m\_s*a\_s*c\_s*e\_s*a\_s*e\|o\_s*n\_s*o\_s*\%(p\_s*e\_s*t\_s*a\_s*l\_s*a\_s*e\|c\_s*\%(h\_s*l\_s*a\_s*m\_s*y\_s*d\_s*e\_s*a\_s*e\|o\_s*t\_s*y\_s*l\_s*e\_s*d\_s*o\_s*n\_s*e\_s*a\_s*e\)\)\)\|仮\_s*令\|打\_s*[擲坐]\|七\_s*\%(夕\|対\_s*子\)\|活\_s*計\|方\_s*便\|無\_s*料\|黄\_s*\%(昏\|蜀\_s*葵\)\|章\_s*魚\|胼\_s*胝\|P\_s*\%(\.\_s*S\_s*\.\|o\_s*l\_s*y\_s*\%(g\_s*o\_s*n\_s*a\_s*l\_s*e\_s*s\|c\_s*a\_s*r\_s*p\_s*i\_s*c\_s*a\_s*e\)\|a\_s*n\_s*d\_s*a\_s*n\_s*a\_s*l\_s*e\_s*s\)\|壮\_s*聡\|煙\_s*草\|殺\_s*陣\|賢\_s*明\|性\_s*質\|怱\_s*ち\|亢\_s*ぶ\|堂\_s*子\|学\_s*聡\|能\_s*[文之]\|内\_s*匠\|松\_s*明\|奈\_s*子\|幇\_s*間\|切\_s*符\|デ\_s*ィ\_s*ス\|３\_s*ｒ\_s*ｄ\|閾\_s*値\|ソ\_s*\%(ー\_s*[トンプ]\|ロ\_s*ー\)\|ヘ\_s*ー\_s*グ\|ゼ\_s*[インムア]\|セ\_s*\%(オ\|ル\_s*マ\|ロ\_s*\%(ン\|ニ\_s*ア\_s*ス\)\|ラ\_s*ピ\_s*\%(ー\|ス\_s*ト\)\)\|シ\_s*\%(ン\|ッ\_s*ク\|ス\_s*ル\|ア\_s*タ\_s*ー\|ソ\_s*ー\_s*ラ\_s*ス\|オ\_s*ド\_s*ア\|ー\_s*[フタ]\)\|サ\_s*\%([イム]\|ミ\_s*ン\_s*グ\|ウ\_s*ザ\_s*ン\_s*ド\|ラ\_s*ブ\_s*レ\_s*ッ\_s*ド\|ー\_s*\%([ドモ]\|テ\_s*ィ\|ス\_s*ト\_s*ン\|ズ\_s*デ\_s*[イィー]\|マ\_s*ル\)\|ッ\_s*チ\_s*ャ\_s*ー\|ン\_s*\%(ク\|ダ\_s*ー\|キ\_s*ュ\_s*ー\)\|リ\_s*ド\_s*マ\_s*イ\_s*ド\)\|ポ\_s*リ\_s*ペ\_s*プ\_s*チ\_s*ド\|三\_s*\%(和\_s*土\|連\_s*文\_s*字\)\|\\\_s*T\_s*e\_s*X\|文\_s*字\_s*列\|教\_s*科\_s*書\|t\_s*e\_s*\%(r\_s*a\|m\_s*p\_s*o\_s*r\_s*a\_s*r\_s*y\)\|用\_s*語\|電\_s*\%([視話]\|気\_s*通\_s*信\_s*研\_s*究\_s*所\)\)',
      \ 'U' : '\%([ｳ孳蛤礼敬恭洞鱗愛潤煩騒粳漆閏患慯悄恙騷愁呻楳梅嫐釉噂褞吽曇紜耘黄云繧慍蘊薀暈運錙怏麗羨卦憾怨恨占卜末嬉心裏浦糶瓜汝己畦疇畆畴畝疎踈宜諾奪姥腕莵兔驢鑿穿嗽魘唸促令項頷訴鷽獺嘯嘘蠢蠕動覘窺伺海萼台詠謌唱唄宴讌転詩謠謳謡疑歌葎鯏鴬鶯ヱゑゐヰ鶉疼堆踞蹲渦舂臼碓羅薄筌食槽朮肯凵魚巧茨廏廐厩鰻午甘秣孫餞馬旨蔚寫暎冩遷噐器移慈俯映写現虚美笂靭靱靫空鰾萍初蛆雲氏上後喪艮丑潮牛裡鬱欝中袿梁家内紆嫗羽打禹請浮攴得雨有飢熟于埋倦鵜迂生賣挧受撃泛傴憂茹射膿売撲菟盂搏齲右胡承卯攵績産芋討夘兎植饂宇享失烏う¨↑∪ＵуウΥυУU]\|武\_s*漢\|狼\_s*狽\|夏\_s*枯\_s*草\|蟒\_s*蛇\|蠎\_s*蛇\|譫\_s*言\|琅\_s*珠\|温\_s*[麺気州]\|C\_s*u\_s*c\_s*u\_s*r\_s*b\_s*i\_s*t\_s*a\_s*l\_s*e\_s*s\|自\_s*惚\|采\_s*女\|乳\_s*母\|姨\_s*捨\_s*山\|独\_s*活\|優\_s*\%(婆\_s*[塞夷]\|曇\_s*華\)\|合\_s*格\|親\_s*族\|斥\_s*候\|泡\_s*沫\|雅\_s*楽\_s*[頭寮]\|楽\_s*官\|干\_s*莉\|維\_s*納\|太\_s*秦\|護\_s*田\_s*鳥\_s*尾\|淡\_s*\%(青\|口\_s*醤\_s*油\)\|五\_s*\%(加\|月\_s*蝿\)\|稲\_s*魂\|誓\_s*約\|石\_s*\%(女\|斑\_s*魚\)\|不\_s*生\_s*女\|味\_s*酒\|苜\_s*蓿\|A\_s*r\_s*i\_s*s\_s*t\_s*o\_s*l\_s*o\_s*c\_s*h\_s*i\_s*a\_s*\%(c\_s*e\_s*a\_s*e\|l\_s*e\_s*s\)\|伝\_s*染\|呆\_s*気\_s*者\|茴\_s*香\|外\_s*郎\|餓\_s*\%(死\|え\_s*死\_s*に\)\|裲\_s*襠\|団\_s*扇\|イ\_s*ギ\_s*リ\_s*ス\|オ\_s*マ\_s*ル\|識\_s*別\_s*不\_s*能\|共\_s*\%(用\_s*体\|有\_s*体\)\|ア\_s*\%([スン]\|グ\_s*リ\_s*ー\|ー\_s*\%(シ\_s*ュ\_s*ラ\|ジ\_s*ェ\_s*ン\_s*ト\|バ\_s*ン\)\|ル\_s*テ\_s*ィ\_s*メ\_s*ッ\_s*ト\|ポ\_s*ン\|ッ\_s*\%(プ\|パ\_s*ー\|シ\_s*ャ\_s*ー\)\)\|単\_s*\%(位\|一\_s*化\)\|ユ\_s*\%([タニー]\|ト\_s*\%(リ\_s*ロ\|レ\_s*ヒ\_s*ト\)\|リ\_s*\%(ア\|シ\_s*ー\_s*ズ\)\|プ\_s*シ\_s*ロ\_s*ン\|ネ\_s*ス\_s*コ\|ナ\_s*\%(カ\_s*イ\_s*ト\|イ\_s*テ\_s*ッ\_s*ド\)\|ビ\_s*キ\_s*\%(タ\_s*ス\|ノ\_s*ン\)\)\)',
      \ 'V' : '\%([：├値Ｖ⊥版в↓В∨ヴV]\|ｯ\_s*ｳ\_s*ﾞ\|ッ\_s*ヴ\|っ\_s*ヴ\|ｳ\_s*ﾞ\|ｖ\_s*ｓ\_s*．\|v\_s*e\_s*r\_s*s\_s*u\_s*s\|チ\_s*ェ\_s*ロ\|ヰ\_s*タ\| \_s*ビ\_s*ク\_s*ト\_s*ー\_s*ル\|視\_s*覚\|仮\_s*想\|ニ\_s*ス\|変\_s*数\|恒\_s*真\|ワ\_s*\%(デ\_s*ィ\_s*ム\|ギ\_s*ナ\|ニ\_s*ス\|セ\_s*リ\_s*ン\|ク\_s*チ\_s*ン\|ル\_s*キ\_s*ュ\_s*ー\_s*レ\|レ\_s*リ\_s*ー\|ー\_s*ニ\_s*ャ\)\|語\_s*彙\|ボ\_s*\%(ス\_s*ト\_s*ー\_s*ク\|ン\_s*ゴ\_s*レ\|ル\_s*\%([ガボトタ]\|テ\_s*\%(ッ\_s*ク\_s*ス\|ー\_s*[ジル]\)\)\|リ\_s*ュ\_s*ー\_s*ム\|ラ\_s*ン\_s*\%(チ\|テ\_s*ィ\_s*ア\|タ\_s*リ\_s*ー\)\|レ\_s*ー\|コ\_s*ー\_s*ダ\|ー\_s*\%([ントグ]\|ル\_s*ト\|ド\_s*ビ\_s*\%(ル\|リ\_s*ア\_s*ン\)\|パ\_s*ル\|ダ\_s*フ\_s*ォ\_s*ン\|カ\_s*\%(ル\|リ\_s*ス\_s*ト\)\)\|キ\_s*ャ\_s*ブ\_s*ラ\_s*リ\|イ\_s*\%([ドス]\|ジ\_s*ャ\_s*ー\|シ\_s*ン\_s*グ\)\)\|ヘ\_s*ッ\_s*ト\|冗\_s*長\_s*な\|垂\_s*直\|フ\_s*\%(ァ\_s*\%(ン\|ド\_s*ー\_s*ツ\)\|ォ\_s*\%(ン\|ル\_s*\%(ク\|カ\_s*ー\)\)\|ェ\_s*ル\_s*メ\_s*ー\_s*ル\)\|ウ\_s*\%(ラ\_s*\%(デ\_s*ィ\_s*ミ\_s*ー\_s*ル\|ジ\_s*\%(ー\_s*ミ\_s*ル\|ミ\_s*ー\_s*ル\|オ\_s*ス\_s*ト\_s*\%(ク\|ッ\_s*ク\)\)\)\|ィ\_s*\%(ン\_s*ナ\|ル\_s*ス\)\|ォ\_s*ッ\_s*カ\|イ\_s*\%(ル\_s*ス\|ン\_s*ナ\_s*ー\)\|ェ\_s*\%(ル\_s*ギ\_s*リ\_s*ウ\_s*ス\|ヌ\_s*ス\)\)\|ビ\_s*\%([アラブバスザ]\|ガ\_s*ー\|ハ\_s*ー\_s*ラ\|タ\_s*ミ\_s*ン\|レ\_s*\%(ッ\_s*ジ\|ロ\_s*イ\)\|ビ\_s*\%(ア\_s*ン\|ッ\_s*ド\)\|ッ\_s*\%(ク\|キ\_s*ー\)\|セ\_s*ン\_s*テ\|ク\_s*\%(タ\_s*ー\|ト\_s*\%(ル\|リ\_s*[ーア]\)\)\|シ\_s*\%(ャ\_s*ス\|ソ\_s*ワ\_s*ー\_s*ズ\)\|ン\_s*\%([チス]\|ソ\_s*ン\|テ\_s*ー\_s*ジ\|セ\_s*ン\_s*ト\)\|ネ\_s*\%(ガ\_s*ー\|グ\_s*レ\_s*ッ\_s*ト\)\|ニ\_s*\%([ール]\|リ\_s*デ\_s*ン\)\|ュ\_s*ー\|エ\_s*ン\_s*チ\_s*ャ\_s*ン\|ジ\_s*\%(ャ\|ッ\_s*ト\|タ\_s*ー\|ョ\_s*\%(ン\|ナ\_s*リ\_s*ー\)\|ュ\_s*ア\_s*\%(ル\|ラ\_s*イ\_s*\%(ズ\|ゼ\_s*ー\_s*シ\_s*ョ\_s*ン\)\)\)\|ダ\_s*ル\|デ\_s*オ\|ル\_s*\%(ゴ\|ヌ\_s*ー\_s*ブ\)\|オ\_s*ラ\|リ\_s*ジ\_s*ア\_s*ン\|ィ\_s*ー\_s*ナ\_s*ス\|ー\_s*\%(ボ\|ル\_s*ス\|ク\_s*ル\|ナ\_s*ス\)\)\|ベ\_s*\%([ガラン]\|ト\_s*ナ\_s*ム\|イ\_s*ダ\_s*ー\|ー\_s*\%(ル\|ダ\_s*ー\)\|テ\_s*ラ\_s*ン\|ッ\_s*セ\_s*ル\|ス\_s*\%([トタパ]\|ビ\_s*オ\)\|ク\_s*\%(タ\|ト\_s*ル\)\|ジ\_s*タ\_s*\%(ブ\_s*ル\|リ\_s*ア\_s*ン\)\|リ\_s*\%([ィー]\|フ\_s*ァ\_s*イ\|サ\_s*イ\_s*ン\)\|ロ\_s*\%(ナ\|シ\_s*テ\_s*ィ\|ー\_s*ナ\|ニ\_s*[カク]\)\|ル\_s*\%(デ\|ベ\_s*ッ\_s*ト\|ダ\_s*ン\|レ\_s*ー\_s*ヌ\|サ\_s*\%(ー\_s*チ\|イ\_s*ユ\)\|モ\_s*ッ\_s*ト\)\|ノ\_s*ム\|ニ\_s*[スヤア]\|ネ\_s*\%(シ\_s*ャ\_s*ン\|チ\_s*ア\|ツ\_s*ィ\_s*ア\|ズ\_s*エ\_s*ラ\)\)\|ブ\_s*\%(イ\|ラ\_s*\%(ド\|ッ\_s*ド\)\|ー\_s*ド\_s*ゥ\_s*ー\)\|バ\_s*\%([ルン]\|イ\_s*\%([アブンオ]\|パ\_s*ー\|タ\_s*\%(ル\|リ\_s*テ\_s*ィ\)\|キ\_s*ン\_s*グ\|ザ\_s*ー\|シ\_s*ャ\)\|ッ\_s*ト\|チ\_s*カ\_s*ン\|ギ\_s*ナ\|ガ\_s*ボ\_s*ン\_s*ド\|ラ\_s*\%(ナ\_s*シ\|エ\_s*テ\_s*ィ\)\|サ\_s*ロ\|ス\_s*\%(コ\|ケ\_s*ス\)\|カ\_s*ン\_s*ス\|ケ\_s*ー\_s*シ\_s*ョ\_s*ン\|キ\_s*ュ\_s*ー\_s*ム\|ウ\_s*チ\_s*ャ\_s*ー\|リ\_s*\%(ン\|エ\_s*ー\_s*シ\_s*ョ\_s*ン\|ュ\_s*ー\|ア\_s*\%(ブ\_s*ル\|ン\_s*ト\)\|ッ\_s*ド\|デ\_s*ー\_s*シ\_s*ョ\_s*ン\)\|ヌ\_s*ア\_s*ツ\|ニ\_s*\%(ラ\|ー\_s*ユ\)\|レ\_s*\%([ラー]\|ロ\_s*ン\|リ\_s*ー\|ン\_s*\%(シ\_s*ア\|チ\_s*ノ\|タ\_s*イ\_s*ン\)\)\|ー\_s*\%([ゴグ]\|チ\_s*ャ\_s*ル\|リ\_s*ト\_s*ゥ\_s*ー\_s*ド\|バ\_s*ル\|ボ\_s*ス\|ベ\_s*ナ\|テ\_s*ィ\_s*カ\_s*ル\|サ\_s*ス\|ジ\_s*\%(ン\|ニ\_s*ア\|ョ\_s*ン\)\|ノ\_s*ン\|ニ\_s*ア\|モ\_s*ン\_s*ト\|ミ\_s*\%(リ\_s*オ\_s*ン\|キ\_s*ュ\_s*ラ\_s*イ\_s*ト\)\)\|ナ\_s*\%(キ\_s*ュ\_s*ラ\_s*ー\|ジ\_s*ウ\_s*ム\)\)\)',
      \ 'W' : '\%([ｦヲ女翁緒牡小雄汚惜尾男をｳ孳蛤礼敬恭洞鱗愛潤騒粳漆閏慯悄恙騷愁呻楳梅嫐釉噂褞吽曇紜耘云繧慍蘊薀暈運錙怏麗羨U卦憾怨恨占卜末嬉心裏浦糶瓜汝己Υυ畦疇畆畴畝疎踈宜諾奪姥莵兔驢鑿穿嗽魘唸促令項頷訴鷽獺嘯嘘蠢蠕動覘窺伺萼台詠謌唱唄宴讌転詩謠謳謡疑歌葎鯏鴬鶯ヱゑ鶉疼堆踞蹲渦舂臼碓羅薄筌食槽朮肯凵魚巧茨廏廐厩鰻午甘秣孫餞馬旨蔚寫暎冩遷噐器移慈俯映写現虚美笂靭靱靫空鰾萍初蛆氏↑上後喪艮丑潮牛裡鬱欝中袿梁家内紆嫗打禹請浮攴得雨有飢熟于埋倦鵜迂生賣挧受撃泛傴憂茹射膿売撲菟盂搏齲右胡承卯攵績産芋討夘兎植饂宇享失烏うヰ居ゐﾜ叫喚惡÷悪原稿嗤妾蕨童藁鞋笑灣綰萬豌万弯彎椀雲腕碗湾横黄皇往羂罠毫纔微僅患煩伎術厄禍災態業技佗王鰐忘掖弁腋譯腸緜渉亙道航弥亘棉渡綿私隈薈賄淮脇矮猥歪轍海蟠儂∪解頒觧判訣別稚若或枠惑鷲沸詫輪和涌湧我吾把話侘杷訳破萵啝割倭環分琶羽わ幅水∧波ＷウワW]\|ｯ\_s*[ｦヱｳヰﾜ]\|ッ\_s*[ヲヱウヰワ]\|っ\_s*[をゑうゐわ]\|乎\_s*古\_s*止\_s*点\|武\_s*漢\|狼\_s*狽\|夏\_s*枯\_s*草\|蟒\_s*蛇\|蠎\_s*蛇\|譫\_s*言\|琅\_s*珠\|温\_s*[麺気州]\|C\_s*u\_s*c\_s*u\_s*r\_s*b\_s*i\_s*t\_s*a\_s*l\_s*e\_s*s\|自\_s*惚\|采\_s*女\|乳\_s*母\|姨\_s*捨\_s*山\|独\_s*活\|優\_s*\%(婆\_s*[塞夷]\|曇\_s*華\)\|合\_s*格\|親\_s*族\|斥\_s*候\|泡\_s*沫\|雅\_s*楽\_s*[頭寮]\|楽\_s*官\|干\_s*莉\|維\_s*納\|護\_s*田\_s*鳥\_s*尾\|淡\_s*\%(青\|口\_s*醤\_s*油\)\|五\_s*\%(加\|月\_s*蝿\)\|稲\_s*魂\|誓\_s*約\|石\_s*\%(女\|斑\_s*魚\)\|不\_s*生\_s*女\|味\_s*酒\|苜\_s*蓿\|A\_s*r\_s*i\_s*s\_s*t\_s*o\_s*l\_s*o\_s*c\_s*h\_s*i\_s*a\_s*\%(c\_s*e\_s*a\_s*e\|l\_s*e\_s*s\)\|伝\_s*染\|呆\_s*気\_s*者\|茴\_s*香\|外\_s*郎\|餓\_s*\%(死\|え\_s*死\_s*に\)\|裲\_s*襠\|団\_s*扇\|草\_s*鞋\|（\_s*笑\_s*）\|(\_s*笑\_s*)\|戦\_s*慄\|俳\_s*優\|勿\_s*忘\_s*草\|早\_s*[生稲]\|山\_s*葵\|戯\_s*奴\|度\_s*会\|Ｙ\_s*\%(軸\|シ\_s*ャ\_s*ツ\|染\_s*色\_s*体\)\|Y\_s*\%(軸\|シ\_s*ャ\_s*ツ\|染\_s*色\_s*体\)\|華\_s*盛\_s*頓\|裙\_s*蔕\_s*菜\|理\_s*[由解]\|公\_s*魚\|病\_s*葉\|大\_s*東\_s*亜\_s*戰\_s*爭\|太\_s*\%(秦\|平\_s*洋\_s*戦\_s*争\)\|歐\_s*州\_s*大\_s*戰\|第\_s*\%(二\_s*次\_s*世\_s*界\_s*大\_s*戦\|一\_s*次\_s*世\_s*界\_s*大\_s*戦\)\|ブ\_s*ル\_s*ツ\_s*ブ\_s*ル\_s*ク\|ロ\_s*ン\_s*グ\|レ\_s*\%(ン\|イ\_s*ス\|ッ\_s*カ\_s*ー\|ス\_s*\%(ラ\_s*ー\|リ\_s*ン\_s*グ\)\)\|リ\_s*\%(ー\_s*ス\|ン\_s*ク\_s*ル\|ス\_s*ト\)\|書\_s*き\_s*込\_s*み\|ラ\_s*\%(ッ\_s*\%([プパ]\|ピ\_s*ン\_s*グ\)\|イ\_s*\%([タト]\|テ\_s*ィ\_s*ン\_s*グ\)\)\|ボ\_s*ル\_s*フ\|フ\_s*\%([ムー]\|ァ\_s*イ\_s*ル\|ィ\_s*\%(ー\_s*ト\|ッ\_s*チ\)\)\|ホ\_s*\%(エ\_s*[ーイア]\|ー\_s*ル\|イ\_s*\%(ー\_s*\%(ル\|ラ\_s*ー\)\|ッ\_s*\%(プ\|ス\_s*ル\|パ\_s*ー\|ト\_s*\%(ニ\_s*ー\|マ\_s*ン\)\)\)\|ワ\_s*\%(イ\|ッ\_s*[トツ]\)\)\|ベ\_s*ル\_s*ナ\_s*ー\|w\_s*e\_s*b\_s*サ\_s*\%(イ\_s*ト\|ー\_s*\%(バ\|ビ\_s*ス\)\)\|警\_s*告\|バ\_s*ル\_s*タ\_s*ー\|ヴ\_s*\%(ュ\_s*ル\_s*ツ\_s*ブ\_s*ル\_s*ク\|ォ\_s*ル\_s*フ\|ィ\_s*\%([ーム]\|ル\_s*\%(ム\|ヘ\_s*ル\_s*ム\)\)\|ェ\_s*\%(ン\_s*ダ\_s*ー\_s*ス\|ル\_s*ナ\_s*ー\|ー\_s*バ\_s*ー\|イ\_s*ユ\)\|ァ\_s*\%(イ\_s*[ンス]\|ー\_s*グ\_s*ナ\_s*ー\|ン\_s*ダ\|ル\_s*\%(タ\_s*ー\|キ\_s*ュ\_s*ー\_s*レ\)\)\)\|T\_s*\%(h\_s*e\_s* \_s*W\_s*o\_s*r\_s*l\_s*d\_s* \_s*W\_s*i\_s*d\_s*e\_s* \_s*W\_s*e\_s*b\_s* \_s*C\_s*o\_s*n\_s*s\_s*o\_s*r\_s*t\_s*i\_s*u\_s*m\|u\_s*n\_s*g\_s*s\_s*t\_s*e\_s*n\)\|ダ\_s*ブ\_s*リ\_s*ュ\_s*ー\|タ\_s*ン\_s*グ\_s*ス\_s*テ\_s*ン\)',
      \ 'X' : '\%([ｫォぉｪェぇｩゥぅｨィぃｧァぁＸξ×ХхΞX]\|ｯ\_s*[ｫｪｩｨｧ]\|ッ\_s*[ォェゥィァ]\|っ\_s*[ぉぇぅぃぁ]\|シ\_s*ロ\_s*\%(フ\_s*ォ\_s*ン\|ホ\_s*ン\)\|ジ\_s*オ\_s*ン\|ゼ\_s*\%(ビ\_s*ウ\_s*ス\|ロ\_s*\%(ッ\_s*ク\_s*ス\|グ\_s*ラ\_s*フ\_s*ィ\)\)\|ハ\_s*ビ\_s*エ\_s*ル\|ザ\_s*\%(ン\|ビ\_s*エ\_s*ル\)\|キ\_s*\%(シ\_s*\%(ロ\|レ\_s*ン\|リ\_s*ト\_s*ー\_s*ル\)\|セ\_s*ノ\_s*ン\|サ\_s*ン\_s*\%(チ\_s*ン\|タ\_s*ン\)\)\|E\_s*x\_s*t\_s*e\_s*n\_s*s\_s*i\_s*b\_s*l\_s*e\_s* \_s*M\_s*a\_s*r\_s*k\_s*u\_s*p\_s* \_s*L\_s*a\_s*n\_s*g\_s*u\_s*a\_s*g\_s*e\|ク\_s*\%(シ\_s*ー\|ロ\_s*ス\_s*ポ\_s*ス\_s*ト\|セ\_s*\%(ナ\_s*キ\_s*ス\|ノ\_s*フ\_s*ォ\_s*ン\)\|ザ\_s*ヴ\_s*ィ\_s*エ\|サ\_s*\%(イ\|ン\_s*\%(ト\_s*ス\|テ\_s*ィ\_s*ッ\_s*ペ\|チ\_s*ッ\_s*ペ\)\)\|リ\_s*ス\_s*マ\_s*ス\)\|エ\_s*\%(ク\_s*ス\|ッ\_s*ク\_s*ス\)\)',
      \ 'Y' : '\%([ﾖ艾蒿蓬娵嫁齡齢據頼弱歓憙鎧万萬過便婚汚涎捩峪杙翊緘慾欲翌翼抑米比裝粧装澱淀縦誼祥葭悦宜克純圭禎葦慶淑禧美喜芳吉義癰穃慂踴遙榕幺怏曄陶甬瀁燿珱踊暘廱樣蓉恙慵泱姚雍癢瑶昜瘍痒孕窰謠漾鷹瓔煬邀遥拗擁瑤窯徭膺窈殀耀曜庸夭揚葉蛹腰羊熔杳沃壅様妖溶用佯謡陽洋嘉宵蘇甦蘓奸辟横攀豫世与酔縒輿読讀訓預與喚予醉誉余憑能４舁蕷四譱畭譽餘撚呼詠除選飫歟丗代避よﾕ潤赦緩弛聴岼閖梦努纈∴故濯檠穰豐豊倖志裄之幸雪趾梼讓譲牀紫縁浴床攸犹黝俑邑熊猷悒酉蝣蚰囿莠尢蕕佳尤佑〒右郵涌祐侑游猶湧融宥夕幽悠釉友雄憂有楡油諭瘉汰徃柚逾揺弓踰諛愉瑜臾渝遊結覦腴由兪喩揃蝓淘揄輸茹征搖ゆｲηΗ賤鄙卑苟嫌妹湯芋藷夢艷鑪鈩彩鱗色鯆忽綺貸甍答応愈圦杁茵胤飮寅尹婬贇韵隱蚓氤酳霪蔭堙湮吋廴I音慇韻咽淫殞姻隕院允隠殷陰窟巖巌頌祝鰮鰛鰯岩磐鼾歪弋弑抱懐肬贅疣狗戌乾犬諱在坐未汝戒誡警縛今Εε曰禾稻員因蝗印嘶鰍電引躄誘動≦忿鵤錨碇怒霆霹雷凧桴筏Ιι魚菴庵雖尿荊棘茨祈祷命豕猯古伍聿乙鎰鴪軼樹慈悼愴慯労格到至傷鼬頂戴徒致鈑痛板柞沙砂聊些潔諍烈功諫勳勇勲漁諌憇＝憩粹熱粋憤域閾勢勤忙急磯孰焉湶泉厳何弄苛≧鎔范啀毬訝燻息指挑拠絲縷厭營営愛幼緒遑暇糸Ｉ弌壹肆莓苺櫟著市碑鐓礎甃臀弩石牲犧犠池溢佚壱1１鬻毓燠礇粥的戦戰軍郁幾一稲許否飯違居矮ゐ猪五煎彝醫斐逶貽善胆位萎可詑僞鑄熬活容依要斎行怡異衣入逝猗胃洟好矣鋳揖椅去惟云懿熨痿射凍移将囗肄夷率囲姨慰頤忌唯緯逸噫挿鮪伊偽苡彜莞往以韋遺炒謂李生威為維意倚良如彙出淹言亥鰄井蔚痍圍幃渭堰饐医爲癒帷恚偉委詒畏いﾔ稚稍飲鎗鑓槍孀寡鰥Я碼傭雇闇敗吝藪薮殕脂寄宿櫓軈軅簗梁S漸鋏刃灸軟柔和窶鱧奴僕萢優柳喧宅館舘輩族鏃鑰≒籥繹譯葯蜴檪藥龠扼益厄疫躍約役訳薬疾岾疚楊谺邪薯豺犲《》〈〉山邸壥廛豢養社鑢育尉寧廉裕恭泰易休康保安靖妬已瘠弥辭埜辞家輻矢痩屋灼笶八罷冶焼破夜爺谷也殺⇒病耶演⇔野燒遣彌熄椰止哉揶やＹеЕ円￥→↑↓←Ёё─━ユヤヨыイЙΥυЫйY]\|ｯ\_s*[ﾖﾕｲﾔ]\|ッ\_s*[ヨユイヤ]\|っ\_s*[よゆいや]\|歐\_s*羅\_s*巴\|欧\_s*羅\_s*巴\|尸\_s*童\|蹌\_s*踉\|蹣\_s*跚\|終\_s*夜\|4\_s*\%([項者つ日]\|番\_s*目\|種\_s*類\)\|y\_s*o\_s*\%(t\_s*t\_s*a\|c\_s*t\_s*o\)\|他\_s*所\|仁\_s*史\|隆\_s*克\|尚\_s*武\|孝\_s*高\|悌\_s*也\|彬\_s*伯\|賀\_s*[子悟]\|栄\_s*伸\|新\_s*生\|昌\_s*[美男]\|宗\_s*生\|暢\_s*[子一]\|永\_s*沈\|８\_s*日\|8\_s*日\|黄\_s*泉\|左\_s*手\|百\_s*合\|L\_s*i\_s*l\_s*i\_s*\%(o\_s*p\_s*s\_s*i\_s*d\_s*a\|a\_s*\%(c\_s*e\_s*a\_s*e\|l\_s*e\_s*s\)\)\|Ｕ\_s*\%(字\|タ\_s*ー\_s*ン\)\|鞦\_s*韆\|強\_s*請\|梅\_s*桃\|桜\_s*桃\|靫\_s*負\|宙\_s*美\|礼\_s*暁\|温\_s*\%(雄\|泉\_s*津\)\|長\_s*庚\|昨\_s*夜\|又\_s*木\|木\_s*綿\|E\_s*\%(u\|メ\_s*ー\_s*ル\)\|祖\_s*谷\|文\_s*身\|郎\_s*[女子]\|蕁\_s*麻\|刺\_s*[青草]\|U\_s*\%(字\|タ\_s*ー\_s*ン\|r\_s*t\_s*i\_s*c\_s*a\_s*l\_s*e\_s*s\)\|海\_s*[豚参]\|西\_s*表\|鸚\_s*哥\|影\_s*[向青]\|況\_s*ん\_s*や\|所\_s*[以縁謂]\|D\_s*i\_s*a\_s*p\_s*e\_s*n\_s*s\_s*i\_s*a\_s*l\_s*e\_s*s\|藺\_s*草\|J\_s*u\_s*\%(l\_s*i\_s*a\_s*n\_s*i\_s*a\_s*l\_s*e\_s*s\|n\_s*c\_s*a\_s*l\_s*e\_s*s\)\|田\_s*舎\|膝\_s*行\|十\_s*六\_s*夜\|寝\_s*穢\|英\_s*\%([一桃蘭]\|吉\_s*利\)\|斑\_s*鳩\|烏\_s*賊\|玉\_s*筋\_s*魚\|硫\_s*黄\|N\_s*a\_s*j\_s*a\_s*d\_s*a\_s*l\_s*e\_s*s\|牛\_s*膝\|稜\_s*威\|常\_s*春\_s*藤\|5\_s*[つ日]\|５\_s*[つ日]\|惡\_s*戲\|甚\_s*振\|潮\_s*来\|悪\_s*戯\|交\_s*喙\|細\_s*小\_s*魚\|小\_s*魚\|鯨\_s*魚\|鶏\_s*魚\|経\_s*緯\|礒\_s*[山田]\|気\_s*吹\|Ｅ\_s*\%(Ａ\_s*Ｓ\_s*Ｔ\|Ｖ\_s*Ｅ\)\|従\_s*[弟妹姉兄]\|鴨\_s*脚\_s*樹\|公\_s*孫\_s*樹\|G\_s*\%(r\_s*a\_s*m\_s*i\_s*n\_s*a\_s*l\_s*e\_s*s\|l\_s*u\_s*m\_s*i\_s*f\_s*l\_s*o\_s*r\_s*a\_s*e\|i\_s*n\_s*k\_s*g\_s*o\_s*p\_s*s\_s*i\_s*d\_s*a\)\|銀\_s*杏\|鳶\_s*尾\|巫\_s*子\|神\_s*巫\|無\_s*花\_s*果\|睦\_s*月\|都\_s*方\_s*流\|縊\_s*[殺死首]\|蝟\_s*[集縮]\|埋\_s*け\_s*[火炭]\|不\_s*[可如]\|守\_s*宮\|燕\_s*龍\_s*茶\|両\_s*班\|流\_s*鏑\_s*馬\|柵\_s*原\|箭\_s*[田内]\|R\_s*a\_s*f\_s*f\_s*l\_s*e\_s*s\_s*i\_s*a\_s*\%(c\_s*e\_s*a\_s*e\|l\_s*e\_s*s\)\|自\_s*棄\|火\_s*傷\|徐\_s*ら\|M\_s*y\_s*r\_s*i\_s*c\_s*a\_s*l\_s*e\_s*s\|天\_s*蚕\|倭\_s*絵\|日\_s*本\_s*武\_s*尊\|大\_s*和\|T\_s*\%(h\_s*e\_s*l\_s*i\_s*g\_s*o\_s*n\_s*a\_s*l\_s*e\_s*s\|r\_s*o\_s*c\_s*h\_s*o\_s*d\_s*e\_s*n\_s*d\_s*r\_s*a\_s*c\_s*e\_s*a\_s*e\)\|香\_s*具\_s*師\|玄\_s*孫\|P\_s*\%(o\_s*a\_s*l\_s*e\_s*s\|l\_s*u\_s*m\_s*b\_s*a\_s*g\_s*i\_s*n\_s*a\_s*l\_s*e\_s*s\|a\_s*l\_s*m\_s*a\_s*l\_s*e\_s*s\|r\_s*\%(o\_s*t\_s*e\_s*a\_s*l\_s*e\_s*s\|i\_s*n\_s*c\_s*i\_s*p\_s*e\_s*s\)\)\|A\_s*r\_s*a\_s*c\_s*a\_s*l\_s*e\_s*s\|妥\_s*子\|寿\_s*[詞男]\|エ\_s*\%(ホ\_s*バ\|フ\_s*ゲ\_s*ニ\_s*ー\|レ\_s*ヴ\_s*ァ\_s*ン\|ニ\_s*セ\_s*イ\|ー\_s*ル\)\|ワ\_s*イ\)',
      \ 'Z' : '\%([空損存揃園薗底續束足屬∈∋賊続粟族俗属慥僧梍臧噌賍臟贓憎像臓贈象増造曾初沿曽反添ぞ譱然繕禪苒薇千蠕∀髯禅善漸冉前全關関蝉膳錢銭絶噬説勢筮贅脆税攻是責ぜ狡詰桷寸喘鮨附◆惴蘂膸蕋髓蕊隧隋隨瑞髄随厨付圖頭刷鶴津酢逗図廚豆好ず塩嶋島嶌縞橲竺衂衄宍舳忸軸舌祖喰食直凝日實昵印者闍鮭邪蛇麝着鉐惹搦尺雀寂若弱尻侭仞刄臣恁儘潯贐稔進盡仭糂訊俥蕁迅刃靱荏甚靭燼櫁樒塵尽尋陣腎壬人敍莇茹杼洳敘汝蜍耡恕舒縟褥蓐辱溽所抒鋤徐絮序叙助帖穰疂聶疊驤襄淨讓繩禳絛蕘諚仗壌滌繞生靜蟐壤仍茸嬲疉塲乘遶星瀞拯釀躡孃如醤剩娘嬢錠静醸縄女尉饒丈成烝擾嫋穣丞場杖條条蒸貞状攘畳剰冗定浄乗情城上常譲懦愀鷲竪嬬戍得濡咒讐讎就聚笋篤盾徇凖楯詢隼筍蓴惇洵淳閏恂諄馴旬荀潤循醇巡遵順准殉純準襦誦需朮戌宿孰塾珠熟恤術述豎孺呪儒綬樹受授壽揉從澀狃中戎拾廿鞣从縱澁糅蹂神汁獸絨縦渋柔什充十従獣住銃重事迩爺滋除怩尓痔璽至児士寿茲孳染嗣柱寺磁仕治死爾路而仁辞塒時岻粫持恃敷焦字只地轜侍瓷亊知辭餌冶邇弍似祀以子峙二史自畤兒示耳慈司蒔次珥膩じ騒澤沢猿笊晒皿曝鮫参算懴慘竄鏨山殘塹巉懺嶄讒惨暫慚慙斬残実笹酒坂盛三嵜崎桜榴襍雜棹竿雑斉濟西才済劑戝剤材財罪在覚座咲戯冴坐蔵左裂冷藏差醒挫ざ→↑ЪЬьъ↓←жЖズゾ零〇〒ザＺジζЗゼзΖZ]\|ｯ\_s*\%(ｿ\_s*ﾞ\|ｾ\_s*ﾞ\|ｽ\_s*ﾞ\|ｼ\_s*ﾞ\|ｻ\_s*ﾞ\)\|ッ\_s*[ゾゼズジザ]\|っ\_s*[ぞぜずじざ]\|ｿ\_s*ﾞ\|簇\_s*生\|双\_s*紙\|草\_s*[履子紙]\|ｾ\_s*ﾞ\|台\_s*詞\|０\_s*次\|撥\_s*条\|発\_s*条\|發\_s*条\|z\_s*e\_s*\%(t\_s*t\_s*a\|p\_s*t\_s*o\)\|世\_s*阿\_s*弥\|ｽ\_s*ﾞ\|相\_s*撲\|木\_s*菟\|修\_s*法\|杜\_s*撰\|調\_s*所\|徒\_s*[罪刑]\|螟\_s*虫\|芋\_s*茎\|F\_s*i\_s*g\_s*u\_s*r\_s*e\|ｼ\_s*ﾞ\|G\_s*\%(メ\_s*ン\|パ\_s*ン\)\|D\_s*y\|Ｇ\_s*\%(メ\_s*ン\|パ\_s*ン\)\|支\_s*度\|試\_s*合\|２\_s*乗\|2\_s*乗\|J\_s*\%(I\_s*S\_s*コ\_s*ー\_s*ド\|ポ\_s*ッ\_s*プ\|R\_s*東\_s*日\_s*本\)\|獅\_s*子\|甲\_s*乙\_s*丙\_s*丁\_s*戊\_s*己\_s*庚\_s*辛\_s*壬\_s*癸\|k\_s*\$\_s*_\_s*{\_s*e\_s*f\_s*f\_s*}\_s*\$\|爪\_s*哇\|射\_s*礼\|砂\_s*利\|謝\_s*花\|著\_s*語\|杓\_s*子\|深\_s*\%(秘\|大\_s*寺\)\|秦\_s*泉\_s*寺\|沈\_s*\%(香\|丁\_s*花\)\|晨\_s*朝\|濁\_s*世\|判\_s*官\|諍\_s*論\|長\_s*夜\|漏\_s*斗\|焼\_s*酎\|鐘\_s*石\|橈\_s*脚\_s*類\|承\_s*久\|朱\_s*里\|C\_s*a\_s*b\_s*o\_s*m\_s*b\_s*o\_s*i\_s*d\_s*e\_s*a\_s*e\|Ｊ\_s*\%(リ\_s*ー\_s*グ\|ポ\_s*ッ\_s*プ\|Ｕ\_s*Ｎ\_s*Ｋ\_s*Ｏ\)\|絢\_s*子\|頌\_s*偈\|数\_s*珠\|入\_s*[魂牢来洛院内水棺]\|霜\_s*月\|１\_s*\%(２\|６\_s*進\|０\_s*[進月]\|１\_s*月\|８\_s*禁\)\|師\_s*走\|極\_s*月\|紐\_s*帯\|1\_s*\%(0\|1\_s*月\|8\_s*禁\|2\_s*月\)\|ｻ\_s*ﾞ\|搾\_s*菜\|蜊\_s*蛄\|粗\_s*目\|槧\_s*本\|散\_s*切\_s*り\|沙\_s*汰\|柘\_s*榴\|石\_s*榴\|細\_s*工\|亜\_s*鉛\|サ\_s*\%(モ\_s*ラ\|ン\_s*ポ\_s*ー\_s*ニ\_s*ャ\|ラ\_s*ゴ\_s*サ\)\|シ\_s*\%(タ\_s*ー\_s*ル\|オ\_s*\%(ン\|ニ\_s*\%(ス\_s*ト\|ズ\_s*ム\)\)\)\|ツ\_s*\%(ァ\_s*\%(ラ\_s*ト\_s*ゥ\_s*ス\_s*ト\_s*ラ\|イ\_s*ト\)\|ェ\_s*\%(ナ\_s*ー\|ッ\_s*ペ\_s*リ\_s*ン\|ル\_s*マ\_s*ッ\_s*ト\)\|ィ\_s*\%(ク\_s*ル\_s*ス\|タ\_s*ー\|ー\_s*グ\_s*ラ\_s*ー\|ン\_s*\%(バ\_s*ロ\_s*ン\|マ\_s*ー\_s*マ\_s*ン\)\|ゴ\_s*イ\_s*ネ\_s*ル\)\)\|チ\_s*\%(ク\_s*ル\_s*ス\|ア\_s*ノ\_s*ー\_s*ゼ\|ュ\_s*ー\_s*リ\_s*\%(ヒ\|ッ\_s*ヒ\)\|ャ\_s*ル\_s*ダ\_s*ッ\_s*シ\_s*ュ\|ゴ\_s*イ\_s*ネ\_s*ル\_s*ワ\_s*イ\_s*ゼ\_s*ン\)\)',
      \ '[' : '[□〔［『【[]',
      \ '\' : '[∨＼￥\\]',
      \ ']' : '[】』］〕]]',
      \ '_' : '[　＿_]',
      \ '`' : '[“‘｀`]',
      \ 'a' : '\%([ｱ餅母渉閔恤憐慌遽鰒蚫鮑袷淡∃主衽歩袵垤蟻麁凡塔蘭露著表霰非抗諍検革更改現競爭争洗殿鉱豫予粗嵐禮殺彪恠妖絢怪綺肖彩漢過謝謬誤礼操綾飴菴黯罨鱇鮟餡闇行按諳晏鞍暗鶩鬚鰓顎喘発肋豈嫂兄崇騰県購贖网罔與咫鼎中新邊邉辺恰頭価價値游遊畔畦堋杏梓与衵袙憬孔坑案侮窖強貴讎讐徒仇痣黶欺鮮糾字嘲薊姐姉曙炮焙炙蜚薹膏脂油危鐙虻泡蹟能痕踪跡東預輯蒐乢纂遏聚軋誂羹壓惇集陸敦暑淳篤熱扱暖温遖斡私圧焦汗央奥桜櫻媼奧塰蜑餘周遍普剰蔗余尼雨甘天押凹楝樗溢艶鰺庵網戯簣鯵味軛渥堊圷憧欠踵幄握芥齷厚蜊漁鯏蕣淺麻浅龝煥晢晰呆亮晄聡亨朖璋啓昜輝顯旭光陽洸鑑滉昿曠諦朗哲顕晶彬賈章商穐晃彰晧昭秋欸埃瞹阨穢噫姶文隘粟曖鮎藹饗靉挨間相哀葭趾晨朝愛跛蹇跫脚蘆葦芦桎鐐足赫淦燈赧紅旃朱茜藜銅赭曉閼暁垢皸皹證絳灯暴証赤扇呷黝榮碧葵蒼煽仰青穴併宛亞痾明逢吾悪婀在遭該飫褪浴荒揚編和會椏合襾安挙或當哇有開厭唖韲阿嗚当娃敢倦彼惡遇飽充上擧あａ藍金＠∧＆∩論&∠銀会∀域空→←↓⇒↑⇔⌒後Ц亜米¨´｀＾’≒〜ÅаαАアΑa]\|厦\_s*門\|廈\_s*門\|沫\_s*雪\|食\_s*蟻\_s*獣\|H\_s*a\_s*l\_s*o\_s*r\_s*a\_s*g\_s*a\_s*l\_s*e\_s*s\|浣\_s*熊\|菖\_s*蒲\|豆\_s*汁\|蛙\_s*鳴\_s*蝉\_s*噪\|塩\_s*梅\|家\_s*鴨\|趺\_s*坐\|Z\_s*\%(n\|i\_s*n\_s*c\)\|浮\_s*子\|痘\_s*痕\|窪\_s*地\|醤\_s*蝦\|糠\_s*蝦\|信\_s*天\_s*翁\|左\_s*沢\|雅\_s*典\|校\_s*倉\|小\_s*豆\|四\_s*阿\|鴉\_s*\%(片\|鷺\_s*合\_s*戦\_s*物\_s*語\)\|綽\_s*名\|渾\_s*名\|化\_s*野\|翌\_s*檜\|飛\_s*[魚鳥]\|総\_s*角\|通\_s*草\|木\_s*通\|L\_s*a\_s*r\_s*d\_s*i\_s*z\_s*a\_s*b\_s*a\_s*l\_s*a\_s*c\_s*e\_s*a\_s*e\|花\_s*鶏\|我\_s*\%(妻\|孫\_s*子\)\|数\_s*多\|奄\_s*美\|灰\_s*汁\|胡\_s*[座坐床葱]\|日\_s*明\|碩\_s*宏\|祥\_s*[仁彦]\|蜻\_s*蛉\|E\_s*\%(s\|i\_s*n\_s*s\_s*t\_s*e\_s*i\_s*n\_s*i\_s*u\_s*m\)\|生\_s*憎\|匕\_s*首\|英\_s*\%([保田]\|虞\_s*湾\|賀\_s*保\)\|靄\_s*[靄々]\|Ｉ\_s*\%(Ｐ\_s*電\_s*話\|Ｃ\_s*\%(タ\_s*グ\|カ\_s*ー\_s*ド\)\)\|I\_s*\%(r\_s*i\_s*d\_s*a\_s*l\_s*e\_s*s\|P\_s*\%(電\_s*話\|ア\_s*ド\_s*レ\_s*ス\)\|D\_s*カ\_s*ー\_s*ド\|C\_s*\%(タ\_s*グ\|カ\_s*ー\_s*ド\)\)\|走\_s*目\|鹹\_s*草\|馬\_s*酔\_s*木\|海\_s*[豹女士人部驢]\|R\_s*u\_s*b\_s*i\_s*a\_s*\%(l\_s*e\_s*s\|c\_s*e\_s*a\_s*e\)\|褐\_s*毛\_s*和\_s*種\|石\_s*蓴\|白\_s*馬\|水\_s*[馬黽綿]\|M\_s*a\_s*l\_s*v\_s*a\_s*l\_s*e\_s*s\|ト\_s*リ\_s*プ\_s*ル\_s*A\| \_s*ア\_s*ク\_s*シ\_s*ア\_s*ム\|公\_s*理\|砒\_s*素\|ヒ\_s*素\|京\_s*都\_s*高\_s*度\_s*技\_s*術\_s*研\_s*究\_s*所\|代\_s*入\|遺\_s*産\|抽\_s*象\|G\_s*o\_s*l\_s*d\|自\_s*動\_s*\%(現\_s*金\_s*取\_s*り\_s*扱\_s*い\_s*機\|預\_s*貯\_s*金\_s*機\)\|属\_s*性\|何\_s*か\|か\_s*つ\|お\_s*よ\_s*び\|セ\_s*ン\_s*ト\_s*キ\_s*ッ\_s*ツ\_s*ネ\|S\_s*\%(b\|i\_s*l\_s*v\_s*e\_s*r\)\|利\_s*用\_s*可\_s*能\|使\_s*用\_s*可\_s*能\|算\_s*法\|割\_s*り\_s*当\_s*て\|オ\_s*\%(レ\|ギ\_s*ュ\_s*ス\_s*タ\_s*ン\|ド\_s*レ\_s*イ\|ン\_s*グ\_s*ス\_s*ト\_s*ロ\_s*ー\_s*ム\|ル\_s*\%(ト\_s*キ\_s*ー\|タ\_s*\%([ーナ]\|ネ\_s*\%(ー\_s*ト\|イ\_s*ト\)\)\)\|ー\_s*\%([クガサトラル]\|ニ\_s*ン\_s*グ\|キ\_s*シ\_s*ン\|ブ\_s*リ\_s*ー\|バ\_s*ー\_s*ド\|ベ\_s*ル\_s*ジ\_s*ュ\|ギ\_s*ュ\_s*ス\_s*\%(ト\|タ\_s*ン\)\|ゾ\_s*ン\_s*ヌ\|ス\_s*\%(チ\_s*ン\|テ\_s*ィ\_s*ン\|タ\_s*ー\|ト\_s*\%(リ\_s*ア\|ラ\_s*リ\_s*ア\)\)\|ド\_s*リ\_s*ー\|ジ\_s*\%([ェー]\|オ\_s*ロ\_s*ジ\)\|デ\_s*ィ\_s*\%(オ\|エ\_s*ン\_s*ス\|シ\_s*ョ\_s*ン\|ト\_s*リ\_s*ア\_s*ム\)\|タ\_s*ム\|ソ\_s*\%(リ\_s*テ\_s*ィ\|ラ\_s*イ\_s*ズ\)\|セ\_s*ン\_s*テ\_s*ィ\_s*ッ\_s*ク\|ロ\_s*ラ\)\)\|配\_s*列\|バ\_s*イ\_s*ト\|ハ\_s*ル\_s*マ\_s*ゲ\_s*ド\_s*ン\|引\_s*数\|人\_s*工\_s*\%(現\_s*実\_s*感\|知\_s*能\)\|イ\_s*\%(ー\_s*ジ\_s*ス\|オ\_s*ン\|ソ\_s*ッ\_s*プ\)\|マ\_s*ル\_s*ド\_s*ゥ\_s*ー\_s*ク\|紫\_s*\%(陽\_s*花\|水\_s*晶\|石\_s*英\)\|A\_s*\%([tlrImc]\|n\_s*t\_s*i\_s*m\_s*o\_s*n\_s*y\|u\_s*s\_s*t\_s*r\_s*o\_s*b\_s*a\_s*i\_s*l\_s*e\_s*y\_s*a\_s*c\_s*e\_s*a\_s*e\|K\_s*C\_s*L\|S\_s*C\_s*I\_s*I\|s\_s*t\_s*a\_s*t\_s*i\_s*n\_s*e\|タ\_s*イ\_s*プ\|T\_s*O\_s*K\|N\_s*S\_s*I\|V\_s*シ\_s*ス\_s*テ\_s*ム\|L\_s*T\_s*キ\_s*ー\|ラ\_s*ン\_s*ク\|E\_s*R\_s*A\|D\_s*S\_s*L\_s*モ\_s*デ\_s*ム\|ド\_s*ラ\_s*イ\_s*ブ\|d\_s*a\|M\_s*ラ\_s*ジ\_s*オ\|b\_s*s\_s*t\_s*r\_s*a\_s*c\_s*t\_s* \_s*C\_s*o\_s*n\_s*t\_s*r\_s*o\_s*l\_s* \_s*M\_s*o\_s*d\_s*e\_s*l\|カ\_s*ッ\_s*プ\|ク\_s*ラ\_s*ス\|C\_s*ア\_s*ダ\_s*プ\_s*タ\)\|付\_s*録\|Ａ\_s*\%([４型面]\|ｘ\_s*ｏ\_s*ｎ\|Ｂ\_s*\%(型\|ｒ\_s*ｏ\_s*ａ\_s*ｄ\)\|タ\_s*イ\_s*プ\|Ｔ\_s*＆\_s*Ｔ\|ｔ\_s*\%(ｏ\_s*ｋ\|ｈ\_s*ｅ\_s*ｎ\_s*ａ\)\|ラ\_s*ン\_s*ク\|Ｉ\_s*エ\_s*キ\_s*ス\_s*パ\_s*ー\_s*ト\|／\_s*Ｄ\_s*コ\_s*ン\_s*バ\_s*ー\_s*タ\|ド\_s*ラ\_s*イ\_s*ブ\|ｄ\_s*ｏ\_s*ｂ\_s*ｅ\|カ\_s*ッ\_s*プ\|ク\_s*ラ\_s*ス\|ｐ\_s*ｐ\_s*ｌ\_s*ｅ\)\|応\_s*用\|エ\_s*\%([ニメアーイ]\|ッ\_s*チ\|ン\_s*\%(ド\_s*ラ\_s*ン\|ジ\_s*ェ\_s*\%(ル\|リ\_s*ッ\_s*ク\)\|ゼ\_s*ル\)\|リ\_s*ア\|オ\_s*リ\_s*ア\|ス\_s*テ\|プ\_s*ロ\_s*ン\)\)',
      \ 'b' : '\%([鯔鰡堀本凡盆煩梵骨凹歿鈕釦沒渤没睦穆樸目濮攵攴朴木僕墨卜牧星黽蠎髦罔袤鋩氓瑁虻卯茆貌謗网旄抱甍儚胞蟒肪旁鵬牟眸冐鉾蒡榜懋乏惘妨帽昴忙剖冒忘茅膀妄厖尨膨貿防紡滂茫望亡傍某謀乾牡掘姆保慕簿惚模戊墓拇菩謨暮呆干暈姥褒彫坊募誉母ぼ覓幎汨冖羃巾冪紅韈瞥鼈蔑塀汳采抃辯辧卞辨湎宀遍瓣辮眄冕勉娩弁可辺邉邊べ船房笛鞭渊斑淵縁渕樗椈太袋深蓋葢盖豚節勿佛物震勃蚋風鰤馼蚊聞文錻葡侮葺蒲憮舞撲撫廡毋無嘸誣悔奉吹蕪撃部伏打振武歩拭分不ぶ米謐人匹浸額鐚跛！広開繆別謬緡泯罎岷梹旻紊檳頻壜愍瓶鬢閔憫敏貧便闢百辟帛白杪緲猫票憑″鋲屏眇渺平錨苗秒描廟病琵弾未比眉毘尾靡瀰寐微糜媚備引麋美濔弭火枇縻嵋贔日糒び早速林針尿拂腹散払祓原幡悗蠻塙旛鑁旙鷭挽判棒絆版輓蕃板播礬阪坂磐番盤晩萬蛮万箱蠅芒挟伴桴鉢枹蜂撥働畑畠屎糞端花鼻離話V魅許秤拔魃罸筏閥走橋箸柱藐貘寞獏暴漠瀑麥縛博駁莫驀爆杯唄霾賣狽吠楳苺憊培煤黴貝焙賠買売陪倍梅媒跋伐末幕曝抜罰場貼馬刄芭化葉庭羽張這塲罵刃晴歯馳婆ばｂ“仏■□⊥底下×−‖｜＼∵麦ボバ］［｝｛ブビΒБбβベb]\|ｯ\_s*\%(ﾎ\_s*ﾞ\|ﾍ\_s*ﾞ\|ﾌ\_s*ﾞ\|ﾋ\_s*ﾞ\|ﾊ\_s*ﾞ\)\|ッ\_s*[ボベブビバ]\|っ\_s*[ぼべぶびば]\|ﾎ\_s*ﾞ\|小\_s*火\|襤\_s*褸\|孟\_s*買\|P\_s*a\_s*e\_s*o\_s*n\_s*i\_s*a\_s*\%(l\_s*e\_s*s\|c\_s*e\_s*a\_s*e\)\|南\_s*瓜\|耄\_s*耋\|孑\_s*孑\|包\_s*丁\|ﾍ\_s*ﾞ\|袂\_s*別\|箆\_s*棒\|篦\_s*棒\|胼\_s*胝\|ﾌ\_s*ﾞ\|補\_s*任\|毒\_s*島\|醜\_s*[女男]\|山\_s*毛\_s*欅\|F\_s*a\_s*g\_s*a\_s*l\_s*e\_s*s\|布\_s*団\|茯\_s*苓\|Ｖ\_s*\%(字\|ネ\_s*ッ\_s*ク\|シ\_s*ネ\_s*マ\)\|附\_s*子\|付\_s*子\|鞦\_s*韆\|豊\_s*[前後]\|ﾋ\_s*ﾞ\|魚\_s*[籠篭]\|彌\_s*縫\|弥\_s*[漫縫]\|吃\_s*驚\|天\_s*鵞\_s*絨\|緬\_s*甸\|賓\_s*頭\_s*盧\|編\_s*木\|柏\_s*槙\|S\_s*a\_s*n\_s*t\_s*a\_s*l\_s*a\_s*l\_s*e\_s*s\|兵\_s*[衛法]\|拍\_s*[板子]\|表\_s*紙\|ﾊ\_s*ﾞ\|囃\_s*子\|巴\_s*爾\_s*幹\|R\_s*o\_s*s\_s*a\_s*l\_s*e\_s*s\|薔\_s*薇\|蟠\_s*踞\|鈑\_s*金\|A\_s*n\_s*n\_s*o\_s*n\_s*a\_s*c\_s*e\_s*a\_s*e\|発\_s*条\|祖\_s*母\_s*さ\_s*ん\|梯\_s*子\|伯\_s*\%([林労楽]\|剌\_s*西\_s*爾\)\|莪\_s*原\|飛\_s*[車蝗]\|蝗\_s*虫\|掲\_s*示\_s*板\|プ\_s*ル\_s*コ\_s*ギ\|作\_s*業\_s*域\|オ\_s*ー\_s*ト\_s*バ\_s*イ\|基\_s*[礎底]\|フ\_s*ァ\_s*ゴ\_s*ッ\_s*ト\|背\_s*景\|北\_s*京\|ペ\_s*\%(キ\_s*ン\|テ\_s*ル\_s*ギ\_s*ウ\_s*ス\)\|臭\_s*素\|イ\_s*ギ\_s*リ\_s*ス\|Ｂ\_s*\%([面判級型ｙ]\|細\_s*胞\|タ\_s*イ\_s*プ\|ド\_s*ラ\_s*イ\_s*ブ\|カ\_s*ッ\_s*プ\|ク\_s*ラ\_s*ス\|−\_s*ス\_s*プ\_s*ラ\_s*イ\_s*ン\|ｌ\_s*ｕ\_s*ｅ\_s*Ｎ\_s*ｏ\_s*ｔ\_s*ｅ\|ｕ\_s*ｓ\_s* \_s*Ｅ\_s*ｒ\_s*ｒ\_s*ｏ\_s*ｒ\|ａ\_s*ｃ\_s*ｈ\|ｅ\_s*ｌ\_s*ｌ\_s*研\|ラ\_s*ン\_s*ク\)\|B\_s*\%([h面判級型kiae]\|C\_s*兵\_s*器\|N\_s*F\_s*(\_s*B\_s*a\_s*c\_s*k\_s*u\_s*s\_s*-\_s*N\_s*a\_s*u\_s*r\_s* \_s*F\_s*o\_s*r\_s*m\_s*)\|B\_s*C\|タ\_s*イ\_s*プ\|u\_s*r\_s*k\_s*i\_s*n\_s*a\_s* \_s*F\_s*a\_s*s\_s*o\|フ\_s*レ\_s*ッ\_s*ツ\|ド\_s*ラ\_s*イ\_s*ブ\|カ\_s*ッ\_s*プ\|ク\_s*ラ\_s*ス\|M\_s*P\_s*フ\_s*ァ\_s*イ\_s*ル\|ス\_s*プ\_s*ラ\_s*イ\_s*ン\|S\_s*\%(D\|キ\_s*ー\|チ\_s*ュ\_s*ー\_s*ナ\|ア\_s*ン\_s*テ\_s*ナ\|デ\_s*ジ\_s*タ\_s*ル\)\|O\_s*X\_s*セ\_s*ッ\_s*ト\|I\_s*T\_s*N\_s*E\_s*T\|r\_s*o\_s*m\_s*i\_s*n\_s*e\|ラ\_s*ン\_s*ク\|o\_s*\%(h\_s*r\_s*i\_s*u\_s*m\|v\_s*i\_s*n\_s*e\_s* \_s*S\_s*p\_s*o\_s*n\_s*g\_s*i\_s*f\_s*o\_s*r\_s*m\_s* \_s*E\_s*n\_s*c\_s*e\_s*p\_s*h\_s*a\_s*l\_s*o\_s*p\_s*a\_s*t\_s*h\_s*y\|o\_s*k\|r\_s*o\_s*n\)\)\|硼\_s*素\|ホ\_s*ウ\_s*素\)',
      \ 'c' : '\%([ｺ恐怖惟怺※米暦轉頃悃鶤獻艮鯤很袞坤壼琿狠建棍魂蒟菎滾梱溷献痕渾墾恨懇根杪王挙泥裔樸鞐熟枹醴蛩徑蹊径溢毀零錯苔拒亊箏斷判諺理断盡尽辞琴言異事今壽寿鯒冀希礫鯉拱齣狛細腓昆拳瘤鮗兄近谺応應答爰是凩惚榾兀忽輿甑腰拵拗鐺鏝桁杲磽絖昊耗闔狎靠冓汞湟塙慌嫦效頁礦冦淆遘仰昴誥鬨鴿鏗浤哮砿伉烋熕洽訌閧困鮫逅糠槹哽盍稾亙壙覯隍遑洸餃惶寇鵁皋黌椌扣晄矼肓頏蛤呷詬匣昿皐崗肱徨峇袷敲爻藁倥釦棡凰犒吭窖畊岡猴胱絋傚啌蚣缸紘湊搆閤峺羔鍠幌鱇扛肴恆紺鈩絳閘蒙冰氷郡蛟槁候楮媾溘后蝗酵嚆犢稿亢哄睾梗慷笄郊効岬肛項巷鑛洪佼狡叩昂勾喉晃滉糀晧剛曠宏控恍侯皓港膏耿皎坑煌向江膠虹巧鴻鉱興衡浩厚耕弘綱抗購講恒薨溝鋼航孝更校行肯光皇好荒高梏谷哭槲尅釛斛轂詰棘告刻酷穀踰懲蝴鴣袴觚虍粐乎沽餬胯菰瞽楜娘壺錮込葫⌒虚兒杞估冴漕痩虎冱倒戸呱媚粉夸詁木鈷捏濃故濾箍漉黄恋拠誇壷放転鼓股罟女己乕琥跨滬越古去糊滸扈瑚皷混怙弧辜戀蠱超児雇孤湖瓠蛄凅肥こｾ芹鬩槧羶甎揃倩翦箋燹濺苫栫槫孱孅簽吮纖湶纎亘筌蟾磚荐茜斬綫箭舩喘錢專僊贍鐫仟旃痊涎銛饌僣韆沾刋擶薦舛牋阡濳癬筅殱殲闡賎餞羨顫甅竰糎陝銓踐閃∨潺遷銑栴剪煽譫僉瞻践栓跣疝詮銭穿尠戰腺繊僭泉嬋淺仙擅鮮専扇浅蘚船線撰宣洗選煎戦尖先忙伜倅逼狹狭蝉旋洩椄§卩渫絏鱈泄攝啜紲緤薛刹褻浙竊截窃殺説拙摂節切蹐績蹠蓆籍跡跖晰威螫迹瘠勣裼晢夕鶺雪寂∫∬碩惜析席隻情甥躋貰淒婿嘶醒睛擠撕牲萋菁犀韲瀞穽齏筬晟齊歳栖棲掣腥逝惺斉臍旌悽整凄靖製晴急世堰攻脊丗迫勢畆糶塞瀬畝せｸ配椪栩櫪檪椡椚箜櫟含纐婚糞癖潛潜鵠凹窪縊跟軛頚珞頸諄窟鞋履狐轡覆沓碎砕条降件頽崩屑釘莖茎陸杙杭掘崛倔鶏鐃藥擽薬楠誓梳串釧與与挫籖鯀鯨鬮籤隈熊艸嚔藾叢鏈腐鎖ξΞ茸菌楔草圀邦國国嗽漱吻劫刧腔φ粂皹勳熏裙醺桾皸崑燻訓勲葷君委钁企咥銜桑某暝峅眛昏冥鮓比闇位鞍藏暗倉廚厨涅〃仝ヽゞヾ々ゝ公曇雲蜘佝栗狂包胡俥梍枢畔鐵★玄黒玖供苦九枸鳩煦狗来徠吼工絎駒朽眩垢口窶区劬繰呉宮暮貢久嶇來奇９庫惧組衢紅句吁懼區桍孔怐瞿汲くｼ埀謐Σσ蕋蘂蕊痺褥茵鵐蔀鷸鴫入責霑蔵嶌了縞嶋島凋搾澀澁渋縛暫屡柴荵凌鎬忍慕簧舖↓襪認从從．舌扱罔θ虐Θ粃秕椎椣貎尿肉臠猪衣榻黙蜆恵楙誠茂成繁鋪惻陣頻閾櫁樒汐鹽潮隰瑟嫉櫛蛭蟋疾隲悉漆躾膝失室沒鎭沈滴雫賤鎮靜静顰尓爾聢乍然併■□◇◆倖幸貭叱征質柵卯滋撓品鬼錣鍜錏凝痼而拉設垂萎栞襞吝咳什導汁徴験著記印☆〇銀城報調蝨虱白濕湿標七僕笞楚霜臀退斥後尻寫卸者炙冩柘舍砂＃♯暹諜喋煮這西娑沙謝紗鯱奢赦洒捨鮭瀉炸抉決皙勺釋蜥爍鑠妁斫蹟刳昔芍酌爵折癪笏赤綽灼杓石尺赭写鷓積遮舎車射斜釈社蛛麈諏洙殳娶娵鬚侏銖繻菽叔俶戚蓿倏蹙肅淑夙粛宿縮珠殊趣恤蟀卆出繍楢葺溲泅酬逎遒緝岫螽萩鷲甃駲楸穐蹤讎售讐洲綉收驟囚舅姑蓚皺鞦銹脩輯醜習羞酋聚舟秀祝袖拾啾蒐収執衆愁就臭蹴週終褶州宗集秋椶棕朱撞種修周手酒首須儁皴悛濬惷蕣雋墫順蠢舜旬浚竣峻駿逡筍瞬俊嗔蓁縉蔘鷏忱甄鷆寢岑畛矧疹槙齔臻娠譛譖哂脣袗怎晉瀋箴軫榛秦襯診鉐津駸讖紳斟唇針呻蜃賑芯瞋振殿侵薪晨辰震宸森伸愼眞慎寝晋進審深親臣鍼申心宍信真新藷墅薯杵岨胥蜍黍渚砠處嶼狙苜苴曙背緒雎蔗庶処署所暑誚篠聲橡奬觴舂囁蛸懾燮厰錆獎枩稍甞韶炒淞陞顳咲腫井摺嶂橸浹愴星升鍬樅簫慯廂霎庠剿筱鬆秤鯖政訟廠樵鷦邵愀妝璋湫艢劭峭殤梢將敞醤青慫従逍倡竦爿薔笙樟装肖菖＜≦湘誦聳檣稱声裳蒋蕉嘯慴盛精霄清鈔粧彰悚鏘悄蕭哨瀟焦憔匠鍾償鞘瘴漿頌詔妾沼請薑唱庄渉障奨牀娼床椒荘抄聖宵傷性生相召銷賞猩症昭燒猖昌少憧紹晶祥尚承證将焼笑照招消章詳証硝掌商昇小觸穡屬稷嗇禝寔稙昃謖軾矚拭属燭贖囑嘱織蝕式喰蜀殖初諸触埴植食職砥姉摯誣侈髭肆仔及岐址梔咫刺贄沚旨誌資豕鷙凍厮粢齒雌耜枝齎領篩四嗤貲諮巵止死強仕熾市師指厶妛諡祗閇姿駟嗜衰偲嗣趾此染締詞茲釶〆覗弛士徙至嘴駛屎占啻之揣如知錙糸絞孜尸獅瓷緊笥始泗咨觜只匙輜廝使敷恃思痴漬脂氏蚩時紫沁俟絲巳祉矢恣若賜次浸詩志識司弑笶翅謚示梓伺視緇自祠史試私痣滲茨肢歯幟祀施竢舐卮耆呰芝阯しｶ癢糜粥痒麹輕骨業軽鰈鰔餉通龜瓶甕亀鳫獵鴈殯K猟雁釀鳬鳧髢氈鴨巛側躱廁厠磧瓦獺翡為皮裘→紮〜搦苧碓柄躯躰軆體身体鴉犂烏絡空唐榧茅澗鸛厂蒄啣卷淦扞杆骭歛瞰讙奐戡豢坎瀚皖稈鐶拑酣陷繝嫺驩篏樌莟勸捍撼澣盥羹嫻鑵寰丱康懽憾羮揀歡潤罕觀橄涵渙堪覡巫鉋随萱簪舘艱咸翰柬駻悍燗槓浣邯攷稽宦考棺潅閂煥鉗疳癇函凾鹹緘款桓箝諫諌轗坩旱侃鰥　館莞橇韓患灌勧菅奸刊柑肝看桿寒緩干嵌廣広竿貫巻敢漢環喊陥監喚甘間歓閑寛管慣完汗艦乾幹官観壁椛屍姓庇鞄芳蔓千鯑一勘蜻⊃影陰蔭景＊棧梯筧庚辛柧門廉乞癩Κ川κ合’）《‘”｛〈“｝》〉囓柁鮖悴舵鰍梶錺餝飾篭籠歸孵卻皈還省顧楓槭却帰反返守帋督祇髮韮主裃雷髪紙鉦曲矩予鐘樺沫偏騙語潟刀象模仇固硬傍難容忝辱頑形旁方型肩風滓翳微幽掠緕纃綛絣擦糟鎹粕春戞猾曷剋黠瞎鞨恰∧濶蠍筈蝎羯喝轄餓蛞聒劼擔刮蘰鬘桂闊括嘗捷豁渇担滑松堅鰹功割戛活疽暈鵲瘡傘嵩重襲葛笠堵硴墻牆蠣蛎柿掲關罹抱踵嬶嚊拘関係顏貌郁薫顔母感釡罐窰鴎框叺喧竃竈窯釜缶蒲鎌數数槝栢膳傅畏賢橿姦樫爨炊圍喞託囲鈎「『鉤」』限鍵傾（禿蕪鏑頭齧被兜哉適敵必要称彜彝鬲鼎叶片哀愛悲鋺蛇鉄蜩神奏金楫裹磆餅徒褐粮糧茖椁覺幗槨貉擴壑隱愨寉殼癨嚇穫咯膕骼膈∠掴狢埆蠖覈霍礁恪擱匿撹攪喀廓較郭〕【［】］〔殻挌劃閣格隠覚矍革馘鶴攫核獲拡客隔角確廨囘隗嵬觧榿蠏匯徊迴壞褂獪丐械枴畍誨揩醢誡夬懈喙椢恠峡价櫂茴蛙瑰乖浬鰄傀糴柏街鳰懷蛔蠶蚕邂蟹潰壊恢腕芥垣楷會拐悔詼諧皆界疥魁偕改繪貝胛絵快甲灰槐晦懐介塊解廻回階戒開会怪海縢篝炬耀赫輝冠鑒鑑各屈鏡柯噛箇上苛暇蚊廈易嘩ヵ描苅枯佳彼兼哥缺霞藉架啝下渦踝堝闕華嗄荷馨刈假夥河科個蝸迦軻咼黴舸繋書賀夏萪支卦掛掻蝦痂謌渮歌過香禾狩買變家枷克駈花賈畫珂呵替代訶袈咬画顆貸價淅飼和ヶ果糅厦課可醸葭勝仮搗嘉墟嗅譌日斯禍換窩苟貨蝌価懸欠化罅伽賭翔靴且嚼訛何駆驅个嫁譁借跏戈稼寡涸耶崋鹿笳火茄菓遐舁かｃ・…塩閉倶錫呼∩取籐加交ФГДАжБъйдзьЖНкёЗрЭцУТвСЮюЪЯЁЛИноыбВмМХЬЕэаепПКЩсШщяхЫштОРилгуЙф♪╂┼×╋┿◎○●銅∪χΧ子Чч株Ц珈、，色ク衝競構簡制≡変接カ┏┓└┌┛┘┗┐正コシセ℃¢c]\|ｯ\_s*[ｺｾｸｼｶ]\|ッ\_s*[コセクシカ]\|っ\_s*[子こせくしか]\|焜\_s*炉\|嫡\_s*妻\|二\_s*合\_s*半\|牛\_s*尾\_s*魚\|巨\_s*勢\|独\_s*楽\|居\_s*士\|特\_s*牛\|粫\_s*門\|甦\_s*生\|f\_s*o\_s*o\_s*t\_s* \_s*a\_s*n\_s*d\_s* \_s*m\_s*o\_s*u\_s*s\_s*e\_s* \_s*d\_s*i\_s*s\_s*e\_s*a\_s*s\_s*e\|傴\_s*僂\|A\_s*\%(r\_s*c\_s*h\_s*i\_s*c\_s*h\_s*l\_s*a\_s*m\_s*y\_s*d\_s*e\_s*a\_s*e\|p\_s*i\_s*a\_s*l\_s*e\_s*s\)\|U\_s*m\_s*b\_s*e\_s*l\_s*l\_s*i\_s*f\_s*l\_s*o\_s*r\_s*a\_s*e\|台\_s*詞\|懺\_s*法\|前\_s*[妻栽]\|妹\_s*尾\|嘲\_s*笑\|儕\_s*輩\|斎\_s*次\|済\_s*[民済々]\|蒸\_s*[篭籠]\|救\_s*世\|莎\_s*草\|百\_s*[濟済]\|恭\_s*敬\|9\_s*[日月]\|秧\_s*鶏\|究\_s*竟\|釉\_s*掛\|典\_s*薬\_s*寮\|探\_s*湯\|球\_s*磨\|六\_s*合\|地\_s*祇\|都\_s*子\|群\_s*衆\|慈\_s*姑\|旧\_s*\%(訳\|唐\_s*書\)\|内\_s*蔵\_s*助\|H\_s*e\_s*l\_s*l\_s*e\_s*b\_s*o\_s*r\_s*o\_s*i\_s*d\_s*e\_s*a\_s*e\|J\_s*u\_s*g\_s*l\_s*a\_s*n\_s*d\_s*a\_s*l\_s*e\_s*s\|R\_s*h\_s*a\_s*m\_s*n\_s*a\_s*l\_s*e\_s*s\|老\_s*舗\|望\_s*潮\|健\_s*か\|L\_s*a\_s*\%(u\_s*r\_s*\%(a\_s*c\_s*e\_s*a\_s*e\|o\_s*i\_s*d\_s*e\_s*a\_s*e\)\|m\_s*i\_s*n\_s*a\_s*l\_s*e\_s*s\|b\_s*i\_s*a\_s*t\_s*a\_s*e\)\|埋\_s*葬\_s*虫\|幣\_s*原\|卓\_s*袱\|桎\_s*梏\|柳\_s*葉\_s*魚\|汚\_s*点\|蠹\_s*魚\|惠\_s*雄\|舗\_s*石\|磯\_s*城\|W\_s*i\_s*n\_s*t\_s*e\_s*r\_s*a\_s*c\_s*e\_s*a\_s*e\|倭\_s*文\|云\_s*[云々]\|明\_s*\%(々\_s*後\_s*日\|明\_s*後\_s*日\)\|７\_s*月\|7\_s*月\|文\_s*月\|４\_s*[分月]\|4\_s*月\|竹\_s*[篦刀]\|羊\_s*[齒歯]\|爲\_s*\%([留難置果送極手兼合業]\|ん\_s*方\|來\_s*り\|納\_s*め\)\|I\_s*\%(l\_s*l\_s*i\_s*c\_s*i\_s*a\_s*c\_s*e\_s*a\_s*e\|s\_s*o\_s*p\_s*y\_s*r\_s*o\_s*i\_s*d\_s*e\_s*a\_s*e\)\|素\_s*[魚人面]\|不\_s*[忍知]\|注\_s*連\|軍\_s*鶏\|髑\_s*髏\|三\_s*\%(味\|鞭\_s*酒\)\|吃\_s*逆\|差\_s*[別異]\|叉\_s*手\|輸\_s*[出贏]\|卒\_s*去\|B\_s*r\|隼\_s*[朗郎]\|笋\_s*[干羹]\|参\_s*差\|財\_s*産\|枌\_s*所\|縦\_s*容\|睫\_s*毛\|M\_s*\%(e\_s*t\_s*a\_s*c\_s*h\_s*l\_s*a\_s*m\_s*y\_s*d\_s*e\_s*a\_s*e\|u\_s*s\_s*a\_s*l\_s*e\_s*s\)\|S\_s*\%([ge]\|p\_s*e\_s*r\_s*m\_s*a\_s*t\_s*o\_s*p\_s*h\_s*y\_s*t\_s*a\|c\_s*i\_s*t\_s*a\_s*m\_s*i\_s*n\_s*e\_s*a\_s*e\)\|Z\_s*i\_s*n\_s*g\_s*i\_s*b\_s*e\_s*r\_s*a\_s*l\_s*e\_s*s\|続\_s*\%(日\_s*本\_s*\%(紀\|後\_s*紀\)\|後\_s*撰\_s*和\_s*歌\_s*集\)\|離\_s*れ\_s*離\_s*れ\|掃\_s*部\|羚\_s*羊\|土\_s*器\|蝙\_s*蝠\|魚\_s*狗\|P\_s*\%(i\_s*p\_s*e\_s*r\_s*a\_s*\%(l\_s*e\_s*s\|c\_s*e\_s*a\_s*e\)\|t\_s*e\_s*r\_s*i\_s*d\_s*o\_s*s\_s*p\_s*e\_s*r\_s*m\_s*\%(a\_s*l\_s*e\_s*s\|i\_s*d\_s*a\_s*e\)\|o\_s*\%(t\_s*a\_s*s\_s*s\_s*i\_s*u\_s*m\|d\_s*o\_s*s\_s*t\_s*e\_s*m\_s*o\_s*n\_s*a\_s*l\_s*e\_s*s\)\)\|連\_s*枷\|枳\_s*殻\|機\_s*関\|落\_s*葉\_s*松\|凵\_s*繞\|檻\_s*車\|顴\_s*骨\|T\_s*\%(h\_s*a\_s*l\_s*i\_s*c\_s*t\_s*o\_s*i\_s*d\_s*e\_s*a\_s*e\|u\_s*b\_s*i\_s*f\_s*l\_s*o\_s*r\_s*a\_s*e\)\|南\_s*瓜\|量\_s*子\|山\_s*\%(海\_s*経\|梔\_s*子\|陽\_s*道\)\|蜉\_s*蝣\|陽\_s*炎\|破\_s*片\|脚\_s*気\|旗\_s*魚\|鍛\_s*[治冶]\|挿\_s*頭\|駕\_s*\%(籠\|輿\_s*丁\)\|長\_s*[月官]\|剃\_s*刀\|天\_s*\%(牛\|鼠\_s*矢\)\|帷\_s*子\|酢\_s*漿\_s*草\|O\_s*x\_s*a\_s*l\_s*i\_s*d\_s*a\_s*c\_s*e\_s*a\_s*e\|飛\_s*[沫白]\|曽\_s*て\|曾\_s*て\|燕\_s*子\_s*花\|牡\_s*[蛎蠣]\|民\_s*部\|部\_s*曲\|E\_s*\%(b\_s*e\_s*n\_s*a\_s*l\_s*e\_s*s\|l\_s*a\_s*n\_s*a\_s*l\_s*e\_s*s\)\|案\_s*山\_s*子\|梭\_s*\%(魚\|子\_s*魚\)\|螳\_s*螂\|蟷\_s*螂\|瓜\_s*\%(田\|呂\_s*根\)\|拍\_s*手\|瑕\_s*[瑾疵]\|東\_s*\%([風雲]\|海\_s*林\|京\_s*都\_s*立\_s*科\_s*学\_s*技\_s*術\_s*大\_s*学\)\|気\_s*[質触]\|(\_s*株\_s*)\|贏\_s*ち\_s*得\|歩\_s*兵\|恁\_s*く\|杜\_s*\%(若\|父\_s*魚\)\|梅\_s*花\_s*皮\|頴\_s*田\|膾\_s*炙\|契\_s*経\|中\_s*央\_s*処\_s*理\_s*装\_s*置\|伊\_s*藤\_s*忠\_s*テ\_s*ク\_s*ノ\_s*サ\_s*イ\_s*エ\_s*ン\_s*ス\|分\_s*類\|ス\_s*リ\_s*ー\_s*ズ\|範\_s*疇\|ト\_s*ラ\_s*ン\_s*プ\|水\_s*[鶏母手夫晶]\|複\_s*雑\_s*命\_s*令\_s*セ\_s*ッ\_s*ト\_s*計\_s*算\_s*機\|サ\_s*\%(ン\_s*チ\_s*ー\_s*ム\|エ\_s*ラ\|イ\_s*\%(ト\_s*カ\_s*イ\_s*ン\|ラ\_s*ス\|ク\_s*\%([ルロ]\|リ\_s*\%(ン\|ッ\_s*ク\)\)\|ボ\_s*\%(ウ\_s*ズ\|ー\_s*グ\)\|バ\_s*\%(ー\|ネ\_s*テ\_s*ィ\_s*\%(ッ\_s*ク\|ク\_s*ス\)\)\|リ\_s*ュ\_s*ー\_s*ム\|ダ\_s*ー\|フ\_s*ァ\_s*ー\|ネ\_s*リ\_s*ア\)\|ー\_s*\%(テ\_s*ィ\_s*フ\_s*ィ\_s*ケ\_s*ー\_s*シ\_s*ョ\_s*ン\|ク\_s*ル\|カ\_s*\%(ス\|ム\_s*ス\_s*ク\_s*\%(ラ\_s*イ\_s*ブ\|リ\_s*プ\_s*シ\_s*ョ\_s*ン\)\)\|キ\_s*\%(ュ\_s*\%(ラ\_s*ー\|レ\_s*ー\_s*\%(タ\_s*ー\|シ\_s*ョ\_s*ン\)\)\|ッ\_s*ト\)\)\)\|マ\_s*ド\_s*ラ\_s*ス\|茶\_s*筅\|ケ\_s*\%([月アイ]\|フ\_s*ェ\_s*ウ\_s*ス\|プ\_s*ス\_s*ト\_s*ラ\_s*[ムル]\|チ\_s*ャ\_s*ッ\_s*プ\|ン\_s*\%(タ\_s*ウ\_s*\%(リ\|ロ\_s*ス\)\|ブ\_s*リ\_s*ッ\_s*ジ\)\|ー\_s*\%([キジブプスン]\|ク\_s*ウ\_s*ォ\_s*ー\_s*ク\|ソ\_s*ン\|タ\_s*リ\_s*ン\_s*グ\|パ\_s*\%(ー\|ビ\_s*リ\_s*テ\_s*ィ\)\|シ\_s*ン\_s*グ\|リ\_s*ー\)\|ル\_s*\%(ト\|ベ\_s*ロ\_s*ス\|テ\_s*ィ\_s*ッ\_s*ク\|ビ\_s*\%(ム\|ー\_s*ニ\)\)\|ミ\_s*\%(カ\_s*ル\|ス\_s*ト\)\)\|キ\_s*\%(ヤ\_s*ノ\_s*ン\|プ\_s*ロ\_s*ス\|ケ\_s*ロ\|ュ\_s*\%([イーア]\|ヴ\_s*ェ\|ビ\_s*\%(ズ\_s*ム\|ス\_s*ム\)\|ロ\_s*\%(ス\|ッ\_s*ト\)\|レ\_s*ー\_s*タ\_s*ー\|ラ\_s*ソ\_s*ー\|リ\_s*\%(ー\|ウ\_s*ム\|ア\_s*ス\|オ\_s*シ\_s*テ\_s*ィ\)\)\|ア\_s*\%(ラ\|ー\_s*ラ\|ン\_s*テ\_s*ィ\)\|チ\_s*ン\|ト\_s*サ\_s*ン\|メ\_s*ラ\|マ\_s*イ\_s*ラ\|ッ\_s*カ\|レ\_s*ー\_s*ト\|ャ\_s*\%([ドパスブンラ]\|デ\_s*\%(ィ\|ラ\_s*ッ\_s*ク\)\|ビ\_s*\%([アンネ]\|テ\_s*\%(ィ\|ー\_s*シ\_s*ョ\_s*ン\)\)\|ベ\_s*ツ\|バ\_s*\%(リ\_s*[エア]\|レ\_s*ー\)\|ト\_s*ル\|シ\_s*ー\|サ\_s*リ\_s*ン\|タ\_s*ピ\_s*ラ\|ピ\_s*\%(ト\_s*ル\|タ\_s*\%(ル\|リ\_s*ズ\_s*ム\)\)\|プ\_s*\%(ラ\|シ\_s*ョ\_s*ン\|テ\_s*ン\|チ\_s*ャ\)\|セ\_s*\%(イ\|ロ\_s*ー\_s*ル\)\|ッ\_s*\%([ツトチプ]\|サ\_s*バ\|ス\_s*ル\|シ\_s*\%(ュ\|ン\_s*グ\|ャ\_s*\%(ー\|ブ\_s*ル\)\)\)\|ニ\_s*\%(オ\_s*ン\|ス\_s*タ\_s*ー\)\|ナ\_s*ル\|ノ\_s*\%(ン\|ー\_s*ラ\|ピ\_s*ー\)\|ミ\_s*ソ\_s*ー\_s*ル\|メ\_s*\%(ル\|ロ\_s*\%(ン\|ッ\_s*ト\)\)\|ロ\_s*\%(ル\|ウ\_s*ェ\_s*イ\|リ\_s*ン\|ラ\_s*イ\_s*[ンナ]\|ッ\_s*ト\)\|レ\_s*ッ\_s*ト\|リ\_s*\%([コーア]\|バ\_s*ー\|ブ\_s*レ\_s*ー\_s*シ\_s*ョ\_s*ン\|ッ\_s*ジ\|ン\_s*グ\)\|ズ\_s*ム\)\|リ\_s*\%(コ\|ス\_s*ト\|シ\_s*タ\_s*ン\)\)\|総\_s*角\|チ\_s*\%([タリンマア]\|ワ\_s*ワ\|ラ\_s*ー\|ル\_s*ド\|ム\_s*ニ\_s*ー\|コ\_s*リ\|ッ\_s*\%([プク]\|テ\_s*リ\_s*オ\|タ\_s*ゴ\_s*ン\)\|キ\_s*\%(ン\|ー\_s*タ\)\|ュ\_s*\%(ア\_s*ブ\_s*ル\|ー\_s*イ\_s*ン\_s*ガ\_s*ム\)\|ー\_s*\%([フトプクズ]\|パ\_s*ー\|タ\_s*ー\)\|ェ\_s*\%([ロスカコアン]\|ザ\_s*\%(レ\|ー\_s*レ\)\|ル\_s*\%(ニ\_s*ー\|シ\_s*ー\|ノ\_s*ブ\_s*イ\_s*リ\)\|リ\_s*\%(ー\|ス\_s*ト\|ッ\_s*シ\_s*ュ\|モ\_s*ヤ\)\|レ\_s*\%(ス\_s*タ\|ン\_s*コ\_s*フ\)\|ビ\_s*チ\_s*ェ\_s*フ\|ダ\_s*ー\|チ\_s*ェ\_s*ン\|ッ\_s*\%([トクカ]\|キ\_s*ン\_s*グ\)\|イ\_s*\%([スン]\|ニ\_s*ー\|サ\_s*ー\|シ\_s*ン\_s*グ\)\|ー\_s*\%(ン\|ザ\_s*レ\|ホ\_s*フ\)\)\|ャ\_s*\%([オフドインコリウ]\|ツ\_s*ネ\|ク\_s*ラ\|プ\_s*タ\_s*ー\|パ\_s*テ\_s*ィ\|ペ\_s*\%(ル\|ッ\_s*ク\)\|チ\_s*ャ\|ネ\_s*\%(ル\|ラ\_s*ー\|リ\_s*ン\_s*グ\)\|ッ\_s*\%([クト]\|ピ\_s*ー\|プ\_s*\%(マ\_s*ン\|リ\_s*ン\)\)\|タ\_s*\%(レ\_s*[イー]\|リ\_s*ン\_s*グ\)\|ル\_s*マ\_s*ー\_s*ス\|レ\_s*ン\_s*ジ\|モ\_s*ロ\|ー\_s*\%([チタトムジ]\|ビ\_s*ル\|ミ\_s*\%(ー\|ン\_s*グ\)\|リ\_s*ー\|ル\_s*\%([ズス]\|ト\_s*ン\)\)\|ラ\_s*ン\_s*ゴ\)\|ョ\_s*\%([ンコ]\|イ\_s*ス\|ム\_s*ス\_s*キ\_s*ー\|ー\_s*\%(ク\|サ\_s*ー\|カ\_s*ー\|キ\_s*ン\_s*グ\)\|ゴ\_s*リ\|ッ\_s*\%(プ\|ピ\_s*ー\|パ\_s*ー\)\|リ\_s*ソ\)\)\|座\_s*標\|喜\_s*劇\|互\_s*換\|共\_s*\%(通\|産\_s*主\_s*義\_s*者\)\|継\_s*続\|C\_s*\%([srfdDeRoa]\|言\_s*語\|型\_s*肝\_s*炎\|y\_s*p\_s*e\_s*r\_s*a\_s*l\_s*e\_s*s\|P\_s*\%(U\|S\_s*(\_s*C\_s*o\_s*n\_s*t\_s*i\_s*n\_s*u\_s*a\_s*t\_s*i\_s*o\_s*n\_s*-\_s*P\_s*a\_s*s\_s*s\_s*i\_s*n\_s*g\_s* \_s*S\_s*t\_s*y\_s*l\_s*e\_s*)\)\|u\_s*r\_s*i\_s*u\_s*m\|M\_s*\%(U\|ソ\_s*ン\_s*グ\)\|タ\_s*イ\_s*プ\|T\_s*\%(ス\_s*キ\_s*ャ\_s*ン\|R\_s*L\_s*キ\_s*ー\)\|シ\_s*ェ\_s*ル\|S\_s*\%(V\_s*フ\_s*ァ\_s*イ\_s*ル\|チ\_s*ュ\_s*ー\_s*ナ\|ア\_s*ン\_s*テ\_s*ナ\)\|カ\_s*ッ\_s*プ\|ク\_s*ラ\_s*ス\|コ\_s*ン\_s*パ\_s*イ\_s*ラ\|C\_s*\%(R\_s*(\_s*C\_s*r\_s*e\_s*e\_s*d\_s*e\_s*n\_s*c\_s*e\_s* \_s*C\_s*l\_s*e\_s*a\_s*r\_s*w\_s*a\_s*t\_s*e\_s*r\_s* \_s*R\_s*e\_s*v\_s*i\_s*v\_s*a\_s*l\_s*)\|D\_s*カ\_s*メ\_s*ラ\)\|ド\_s*ラ\_s*イ\_s*ブ\|+\_s*+\|L\_s*\%(X\|O\_s*S\|I\_s*S\_s*P\)\|E\_s*S\_s*P\|A\_s*\%(D\|S\_s*[LE]\)\|ラ\_s*ン\_s*ク\|I\_s*S\_s*C\|h\_s*\%(l\_s*o\_s*r\_s*\%(a\_s*n\_s*t\_s*h\_s*a\_s*c\_s*e\_s*a\_s*e\|i\_s*n\_s*e\)\|r\_s*o\_s*m\_s*i\_s*u\_s*m\|a\_s*S\_s*e\_s*n\)\|O\_s*\%(B\_s*O\_s*L\|N\_s*T\_s*R\_s*O\_s*L\_s*キ\_s*ー\)\)\|Ｃ\_s*\%([型ｍ]\|Ｍ\_s*ソ\_s*ン\_s*グ\|タ\_s*イ\_s*プ\|カ\_s*ッ\_s*プ\|ク\_s*ラ\_s*ス\|ｄ\_s*Ｓ\|Ｄ\_s*−\_s*Ｒ\_s*Ｏ\_s*Ｍ\|ド\_s*ラ\_s*イ\_s*ブ\|＋\_s*＋\|ラ\_s*ン\_s*ク\|Ｏ\_s*2\|ｏ\_s*Ｃ\_s*\%(ｏ\|Ｏ\_s*ス\_s*ト\_s*ア\)\|言\_s*語\)\|ツ\_s*\%(ァ\_s*ー\|ィ\_s*リ\_s*ル\|ェ\_s*\%(ー\|ル\_s*ニ\_s*ー\|ラ\_s*ン\)\)\|炭\_s*素\)',
      \ 'd' : '\%([共吃巴錚鑼鶏鳥響嫩緞丼呑曇貪鈍肭遠蚌溝隣鄰塢床処所年時鯲鰍鰌讀得徳獨髑毒読僮萄鐃耨嫐橈儂撓陶働ゞ桐通閙藤々恫瞳憧鬧≡⇔慟撞導仝〃洞堂瞠獰艟胴銅童動同道堵戸奴退取呶解怒土駑留努録何止度弩融孥ど瓰竕凸竍籵瓧禰泥捏溺寺棯甸黏沺佃鈿畋淀澱臀傳殿電照でヅ鶴辛強妻綱勤伝筒包做造作尽机月塚遣冢疲使連付突積吊詰漬津図釣づヂ中近力痔持地ぢ種棚倒彩濃逹畳諾゛濁默球玉魂騙谷点館舘竹嶽岳高凧蛸怛妲獺奪脱梯餒迺岱廼戴弟臺平内醍橙］［題＞≧第台代大鱈頼便誰懶樽怠斷椴灘黙旦煖彈暖談段断檀団團壇弾男柁舵駄雫娜橢拏朶蛇墮拿佗垂沱溜懦楕炊鴕陀儺唾騨澑建荼立田惰抱陏駝打兌妥堕出だｄ直◎，丶、．\.‥・…＄”“↓†‡―┤達℃°独ド÷◇◆ダジДдΔδデ∂d]\|ｯ\_s*\%(ﾄ\_s*ﾞ\|ﾃ\_s*ﾞ\|ﾂ\_s*ﾞ\|ﾁ\_s*ﾞ\|ﾀ\_s*ﾞ\)\|ッ\_s*[ドデヅヂダ]\|っ\_s*[どでづぢだ]\|ﾄ\_s*ﾞ\|都\_s*々\_s*逸\|褞\_s*袍\|S\_s*a\_s*u\_s*r\_s*u\_s*r\_s*a\_s*c\_s*e\_s*a\_s*e\|C\_s*\%(u\|o\_s*p\_s*p\_s*e\_s*r\)\|満\_s*天\_s*星\|豆\_s*腐\|如\_s*何\|ﾃ\_s*ﾞ\|刑\_s*事\|粘\_s*葉\_s*装\|手\_s*間\|木\_s*偶\|丁\_s*[稚抹]\|蝸\_s*牛\|ﾂ\_s*ﾞ\|頭\_s*[腦痛]\|ﾁ\_s*ﾞ\|調\_s*子\|茶\_s*碗\|知\_s*恵\|忸\_s*怩\|ﾀ\_s*ﾞ\|忠\_s*幸\|壁\_s*蝨\|伊\_s*達\|山\_s*車\|韃\_s*靼\|提\_s*婆\_s*達\_s*多\|太\_s*\%([刀宰鼓]\|平\_s*広\|上\_s*天\_s*皇\|政\_s*\%(官\|大\_s*臣\)\)\|乃\_s*[公毅]\|体\_s*操\|葮\_s*竹\|演\_s*\%(し\_s*物\|繹\_s*デ\_s*ー\_s*タ\_s*ベ\_s*ー\_s*ス\)\|コ\_s*ロ\_s*ン\_s*ビ\_s*ア\|ズ\_s*\%(ロ\_s*ー\_s*ス\|ッ\_s*ク\)\|イ\_s*ル\_s*カ\|医\_s*者\|博\_s*士\|文\_s*書\|行\_s*列\_s*式\|発\_s*見\_s*す\_s*る\|ハ\_s*ー\_s*グ\|拒\_s*否\_s*さ\_s*れ\_s*た\|破\_s*壊\_s*\%(者\|す\_s*る\)\|消\_s*滅\_s*子\|記\_s*述\_s*子\|Ｄ\_s*\%(論\|タ\_s*イ\_s*プ\|ド\_s*ラ\_s*イ\_s*ブ\|カ\_s*ッ\_s*プ\|Ｃ\_s*ブ\_s*ラ\_s*ン\_s*ド\|ｙ\_s*ｌ\_s*ａ\_s*ｎ\|ラ\_s*ン\_s*ク\|ａ\_s*ｉ\_s*ｓ\_s*ｙ\|ｅ\_s*ｍ\_s*ａ\_s*ｃ\_s*ｓ\)\|十\_s*進\_s*数\|ゼ\_s*ッ\_s*ケ\_s*ン\|復\_s*号\_s*化\|省\_s*略\|金\_s*剛\_s*石\|辞\_s*書\|D\_s*\%(b\|タ\_s*イ\_s*プ\|T\_s*\%(E\|P\_s*ソ\_s*フ\_s*ト\|M\_s*ソ\_s*フ\_s*ト\)\|M\_s*A\|ド\_s*ラ\_s*イ\_s*ブ\|カ\_s*ッ\_s*プ\|C\_s*\%(カ\_s*ー\_s*ド\|ブ\_s*ラ\_s*ン\_s*ド\)\|u\_s*b\_s*n\_s*i\_s*u\_s*m\|B\_s*\%(M\_s*S\|サ\_s*ー\_s*バ\)\|H\_s*C\_s*P\_s*\%(サ\_s*ー\_s*バ\|ク\_s*ラ\_s*イ\_s*ア\_s*ン\_s*ト\)\|y\_s*\%(s\_s*p\_s*r\_s*o\_s*s\_s*i\_s*u\_s*m\|l\_s*a\_s*n\)\|r\_s* \_s*P\_s*e\_s*p\_s*p\_s*e\_s*r\|ラ\_s*ン\_s*ク\|V\_s*D\_s*\%(ボ\_s*ッ\_s*ク\_s*ス\|シ\_s*ョ\_s*ッ\_s*プ\|ケ\_s*ー\_s*ス\|デ\_s*ッ\_s*キ\|ド\_s*ラ\_s*イ\_s*ブ\|オ\_s*ー\_s*デ\_s*ィ\_s*オ\|プ\_s*レ\_s*\%(イ\_s*ヤ\_s*ー\|ー\_s*ヤ\_s*ー\)\|ラ\_s*ッ\_s*ク\|レ\_s*コ\_s*ー\_s*ダ\_s*ー\|マ\_s*ル\_s*チ\|ビ\_s*デ\_s*オ\)\|O\_s*S\|o\_s*\%(c\_s*u\_s*m\_s*e\_s*n\_s*t\_s* \_s*\%(T\_s*y\_s*p\_s*e\_s* \_s*D\_s*e\_s*f\_s*i\_s*n\_s*i\_s*t\_s*i\_s*o\_s*n\|O\_s*b\_s*j\_s*e\_s*c\_s*t\_s* \_s*M\_s*o\_s*d\_s*e\_s*l\)\|C\_s*o\_s*M\_s*o\)\|e\_s*\%(g\_s*e\_s*n\_s*e\_s*r\_s*i\_s*a\_s*c\_s*e\_s*a\_s*e\|l\_s*a\_s*w\_s*a\_s*r\_s*e\)\|E\_s*\%(C\|L\_s*キ\_s*ー\)\|I\_s*\%(P\_s*ス\_s*イ\_s*ッ\_s*チ\|S\_s*K\)\|i\_s*\%(r\_s*e\_s*c\_s*t\_s* \_s*M\_s*e\_s*m\_s*o\_s*r\_s*y\_s* \_s*A\_s*c\_s*c\_s*e\_s*s\_s*s\|s\_s*t\_s*r\_s*i\_s*c\_s*t\_s* \_s*o\_s*f\_s* \_s*C\_s*o\_s*l\_s*u\_s*m\_s*b\_s*i\_s*a\|g\_s*i\_s*t\_s*a\_s*l\)\)\)',
      \ 'e' : '\%([ｴ瘧腮偉鰓衿撰襟魘捐覃櫞湲檐薗篶￥渕鹽簷轅悁渊讌艷黶垣閼圜蜒爰掾媛鳶鴛焉宛嫣閻衍臙閹槐⌒援筵淹厭寃淵掩烟嚥圓沿宴蜿奄袁煙艶焔炎怨鉛園苑偃冤延婉遠堰燕演塩円縁刔刳抉猿狗描択鰕箙蛯蝦狄貊胡戎夷乢靨鉞戉粤咽噎桟悦閲謁亦繹伯懌掖蜴奕越役驛疫易益腋駅液咏瓔珱曵衡殪贏裔洩楹娃潁蠑瑩翳纓塋營頴瀛睿泳縊榮瑛暎曳盈郢影詠穎嬰鋭叡映営栄永枝会選衣依榎繪囘懷画絵衛會畫猥回恵獲惠慧衞荏重得餌江杖笑柄え━─┳┬┰┯┸┻┴┷фФ＝≡⇔∋∈РрмМｅН→英∃式！ηΗсСЛлεЭэエΕe]\|A\_s*\%([面判型級]\|V\_s*\%(機\_s*器\|女\_s*優\)\|B\_s*\%(型\|C\_s*順\)\)\|Ａ\_s*\%([面判型級]\|Ｖ\_s*\%(機\_s*器\|女\_s*優\)\|Ｂ\_s*型\)\|M\_s*サ\_s*イ\_s*ズ\|Ｍ\_s*サ\_s*イ\_s*ズ\|豪\_s*物\|Ｌ\_s*\%(サ\_s*イ\_s*ズ\|Ｌ\_s*サ\_s*イ\_s*ズ\)\|L\_s*\%(サ\_s*イ\_s*ズ\|L\_s*\%(サ\_s*イ\_s*ズ\|教\_s*室\)\)\|羨\_s*道\|豌\_s*豆\|C\_s*\%(l\|h\_s*l\_s*o\_s*r\_s*i\_s*n\_s*e\)\|似\_s*\%(非\|而\_s*非\)\|桧\_s*原\_s*湖\|烏\_s*帽\_s*子\|吉\_s*方\|胞\_s*衣\|淮\_s*南\_s*子\|埃\_s*及\|干\_s*支\|岐\_s*路\|支\_s*繞\|壊\_s*[疽死]\|葡\_s*萄\|蛭\_s*子\|愛\_s*\%([莉理媛]\|知\_s*川\)\|N\_s*極\|Ｎ\_s*\%([個極響]\|次\_s*元\|角\_s*形\|Ｈ\_s*Ｋ\_s*ホ\_s*ー\_s*ル\)\|斉\_s*魚\|兄\_s*鼓\|ヱ\_s*ス\_s*ビ\_s*ー\_s*食\_s*品\|S\_s*\%([式極]\|サ\_s*イ\_s*ズ\|N\_s*比\|F\_s*小\_s*説\)\|Ｓ\_s*\%([波字席極]\|サ\_s*イ\_s*ズ\|Ｎ\_s*比\|Ｆ\_s*小\_s*説\)\|穢\_s*[多土]\|Ｘ\_s*\%([軸脚線]\|染\_s*色\_s*体\)\|X\_s*\%([軸脚]\|O\_s*醤\|染\_s*色\_s*体\)\|海\_s*\%(老\|鷂\_s*魚\)\|帝\_s*都\_s*高\_s*速\_s*度\_s*交\_s*通\_s*営\_s*団\|ワ\_s*ー\_s*ク\_s*ス\_s*テ\_s*ー\_s*シ\_s*ョ\_s*ン\|欧\_s*\%(州\|羅\_s*巴\)\|歐\_s*\%(州\|羅\_s*巴\)\|ヨ\_s*ー\_s*ロ\_s*\%(ピ\_s*ア\_s*ン\|ッ\_s*パ\)\|ユ\_s*\%(ア\_s*ン\|ウ\_s*ロ\_s*ピ\_s*ウ\_s*ム\|リ\_s*イ\_s*カ\|ー\_s*\%(ロ\|ノ\_s*ス\|ニ\_s*ス\|ジ\_s*\%(ン\|ー\_s*ン\)\|ド\_s*ラ\|レ\_s*カ\|ラ\_s*\%(ス\|シ\_s*ア\)\|フ\_s*\%(ラ\_s*テ\_s*ス\|ォ\_s*\%(リ\_s*ア\|ニ\_s*ア\_s*ム\)\)\|ク\_s*リ\_s*ッ\_s*ド\|カ\_s*リ\)\)\|編\_s*集\|強\_s*調\|電\_s*子\_s*メ\_s*\%(ー\_s*ル\|イ\_s*ル\)\|発\_s*展\|評\_s*価\_s*す\_s*る\|符\_s*号\_s*化\|百\_s*科\_s*事\_s*典\|カ\_s*プ\_s*セ\_s*ル\_s*化\|オ\_s*\%(ー\|イ\_s*\%(ラ\_s*ー\|ゲ\_s*ン\)\)\|実\_s*行\|拡\_s*張\|例\_s*外\|感\_s*嘆\_s*符\|Ｅ\_s*\%(Ｐ\_s*Ｏ\|ド\_s*ラ\_s*イ\_s*ブ\|Ｄ\_s*ベ\_s*ー\_s*タ\|ｍ\_s*ａ\_s*ｃ\_s*ｓ\|カ\_s*ッ\_s*プ\|ａ\_s*ｓ\_s*ｔ\|ｘ\_s*ｅ\_s*ｒ\_s*ｃ\_s*ｉ\_s*ｓ\_s*ｅ\|タ\_s*イ\_s*プ\)\|ア\_s*\%([ンイ]\|ニ\_s*ド\|ー\_s*\%([マスル]\|ウ\_s*ィ\_s*ン\|ラ\_s*ン\|ニ\_s*ー\|ネ\_s*ス\_s*ト\|ミ\_s*ン\|シ\_s*ー\|リ\_s*ー\)\)\|設\_s*立\|E\_s*\%(r\|O\_s*F\|u\_s*\%(p\_s*o\_s*m\_s*a\_s*t\_s*i\_s*a\_s*c\_s*e\_s*a\_s*e\|r\_s*o\_s*p\_s*i\_s*u\_s*m\)\|U\_s*C\_s*コ\_s*ー\_s*ド\|P\_s*レ\_s*コ\_s*ー\_s*ド\|ド\_s*ラ\_s*イ\_s*ブ\|d\_s*i\_s*t\_s*i\_s*n\_s*g\_s* \_s*M\_s*A\_s*C\_s*r\_s*o\_s*S\|-\_s*m\_s*a\_s*i\_s*l\|メ\_s*ー\_s*ル\|カ\_s*ッ\_s*プ\|コ\_s*マ\_s*ー\_s*ス\|N\_s*T\_s*E\_s*R\_s*キ\_s*ー\|タ\_s*イ\_s*プ\|i\_s*n\_s*s\_s*t\_s*e\_s*i\_s*n\_s*i\_s*u\_s*m\|S\_s*\%(P\|C\_s*キ\_s*ー\)\|l\_s*k\|m\_s*a\_s*c\_s*s\)\|イ\_s*\%([ブヴアラー]\|ジ\_s*ェ\_s*ク\_s*ト\|フ\_s*ェ\_s*ク\_s*[トタ]\|コ\_s*\%(ー\_s*ル\|ラ\_s*イ\_s*[ズザ]\)\|プ\_s*シ\_s*ロ\_s*ン\|ミ\_s*ュ\_s*レ\_s*\%(ー\_s*[トタ]\|イ\_s*タ\)\|ベ\_s*ン\_s*\%(ト\|タ\_s*ー\)\|ノ\_s*ッ\_s*ク\|ネ\_s*ー\_s*ブ\_s*ル\|ギ\_s*リ\_s*ス\|ン\_s*グ\_s*\%(ラ\_s*ン\_s*ド\|リ\_s*ッ\_s*シ\_s*ュ\)\|ッ\_s*チ\|ヤ\_s*\%(ー\|リ\_s*ン\_s*グ\|フ\_s*ォ\_s*ン\|ホ\_s*ン\)\|グ\_s*ジ\_s*\%(ッ\_s*ト\|ス\_s*ト\)\|ク\_s*\%(ス\|ア\_s*リ\_s*テ\_s*ィ\)\|ス\_s*フ\_s*ァ\_s*ハ\_s*ン\|リ\_s*[アヤ]\|レ\_s*\%(ー\_s*\%(ス\|ザ\_s*ー\|サ\_s*ー\)\|イ\_s*\%(ン\|ザ\_s*ー\|サ\_s*ー\)\|ブ\_s*ン\)\)\|ウ\_s*\%(ー\|ジ\_s*ェ\_s*ー\_s*ヌ\)\)',
      \ 'f' : '\%([麓梺冬′枌賁汾濆吩刎氛雰糞褌忿墳吻紛焚扮分粉揮旧舊顫故震篩奮隹古衾襖贅燻筆鰒絃総惣總房閼鬱塞鞴章郁史艦簡札耽吭鰾笛文罧節苳蕗淦舩艙舷舟船肥太懷懐≧≪≠≫＜＞≦渊淵渕縁葢盖再弍蓋双藤鯊潭蒸鱶楓殕瘋封諷黻祓拂怫髴彿恚慍憤二払沸拒防茯蔔愎輹蝠箙腓⊇⊃膨脹嚢梟袋含⊆⊂袱覆輻腹幅復馥服副複福経俘麸賦麩蜉坿父附訃婦誣仆經舗咐符臥膚斧冨腑更俛觝怖腐斑踏深趺降畉譜履葺觸老敷歩布赴狂殖振夫苻噴罘伏匐賻風柎不巫蹈孵拭普芙郛埠鋪鯆付吹阜拊生桴溥榑扶俯触践負増傅鮒孚府芬呎ﾌ飜翻ふｆ鉄♀∀¶富⌒金仏佛偽誤♭弗浮フΦфFФφf]\|ｯ\_s*ﾌ\|ッ\_s*フ\|っ\_s*ふ\|鞦\_s*韆\|睾\_s*丸\|陰\_s*嚢\|乱\_s*吹\|相\_s*応\|E\_s*u\_s*p\_s*t\_s*e\_s*l\_s*e\_s*a\_s*c\_s*e\_s*a\_s*e\|回\_s*回\_s*教\|書\_s*司\|図\_s*書\_s*寮\|海\_s*蘿\|補\_s*\%(任\|陀\_s*[洛落]\)\|頭\_s*垢\|雲\_s*脂\|鳧\_s*鐘\|款\_s*冬\|菜\_s*蕗\|蒲\_s*団\|M\_s*y\_s*r\_s*t\_s*a\_s*l\_s*e\_s*s\|釜\_s*[中山]\|雙\_s*葉\|B\_s*u\_s*d\_s*d\_s*l\_s*e\_s*j\_s*a\_s*c\_s*e\_s*a\_s*e\|渓\_s*井\|G\_s*e\_s*r\_s*a\_s*n\_s*i\_s*a\_s*\%(c\_s*e\_s*a\_s*e\|l\_s*e\_s*s\)\|２\_s*[人つ日]\|宿\_s*酔\|2\_s*\%([人つ日]\|通\_s*り\)\|○\_s*○\_s*○\|□\_s*□\_s*□\|△\_s*△\_s*△\|×\_s*×\_s*×\|帛\_s*紗\|河\_s*豚\|比\_s*律\_s*賓\|I\_s*r\_s*o\_s*n\|極\_s*東\_s*放\_s*送\|論\_s*理\_s*式\|形\_s*式\|ホ\_s*\%(ワ\_s*イ\_s*エ\|イ\_s*ル\|ル\_s*\%(マ\_s*\%(ン\_s*ト\|リ\_s*ン\)\|ム\_s*ア\_s*\%(ミ\_s*ド\|ル\_s*デ\_s*ヒ\_s*ド\)\)\)\|一\_s*杯\|機\_s*能\|関\_s*数\|汎\_s*関\_s*数\|修\_s*正\|ヒ\_s*\%(レ\|ュ\_s*ー\_s*[ズム]\)\|第\_s*1\_s*要\_s*素\|１\_s*\%(／\_s*ｆ\_s*ゆ\_s*ら\_s*ぎ\|ｓ\_s*ｔ\)\|失\_s*敗\|ハ\_s*\%(エ\|ン\_s*ブ\_s*ル\|ロ\_s*ン\)\|柔\_s*軟\_s*な\|Ｆ\_s*\%(１\|カ\_s*ッ\_s*プ\|タ\_s*イ\_s*プ\|ａ\_s*\%(ｘ\|ｍ\_s*ｅ\)\|ｌ\_s*ａ\_s*ｖ\_s*ｏ\_s*ｒ\)\|周\_s*波\_s*数\|エ\_s*フ\)',
      \ 'g' : '\%([頃殺米諢魂權艮勤権鮴好蓙応駒事琴亊若毎如鏝埖込塵氷声肥聲腰拵心戀恋石国獄刧盒熬軣嗷壕敖噛濠哈遨拷囂轟毫傲鼇郷劫≡号豪剛沍五瑚晤珸呉超児檎庫互娯吾午極越護5篌兒冴茣梧誤寤５碁醐伍子唔忤期炬齬牾悟蜈后後宕ご〓戟屐鬩隙郤檄闃鷁撃激劇貎黥皃麑倪霓囈猊迎鯨芸藝蘖囓齧彦軒痃愿呟广監芫舷眩源儼衒弦絃験言諺現限幻玄減原拐実觧偈睨夏解下蹴毛げ靴草腐種口薬糞癖胡萸茱串藕遇嵎宮寓隅偶黒栗鞍倉蔵位昏麕羣郡群軍苦周包車狂惧組虞具弘暮食壷愚狗倶颶壺禺麌ぐ衣君嫌裂際牛垠崟斤岑憖吟銀圉圄禦馭魚嶷閠玉漁曉痙繞澆尭御翹嶢堯蟯驍僥仰業暁凝行謔瘧虐逆祇気曦議伎僞巍祁羲決城切艤礒擬沂犠萓嶬誼偽蟻宜斬疑木妓義犧技魏着欺戯儀戲ぎ巛皮川革乾側通殻絡辛柄鴉烏嵒頷巖厳嚴貫阮鳫偐岸厂⊃贋龕強翫岩鴈丸雁玩癌元願眼巌含頑神上紙髮髪金鐘係皈歸肯帰返潟固方語刀難型形鰹歹垳顏顔蟇釜鎌窯蒲蟹笠重傘號垣樫頭月合斈諤鄂壑鍔齶樂學萼愕嶽咢鰐額岳顎楽学乂既崖崕磑亥葢剴礙垓劾漑愾盖啀涯睚艾駭皚該咳階孩芥碍害鎧街凱慨概蓋骸外訛我伽臥哦換変借駕駆鵝貸画衙替代畫呀牙蛾訝勝ヶ果賀書餓芽河雅峩狩莪買峨掛ケヵ娥鵞刈俄が≫＞ｇ瓦≧ガゴΨβλΣΕΖΗΚΘοΤσνΠρΑκξιΝθμΜΩεΧδΞψΔπατΒΙυΦΥζΡφΟχΛηωギグгγΓゲГg]\|ｯ\_s*\%(ｺ\_s*ﾞ\|ｹ\_s*ﾞ\|ｸ\_s*ﾞ\|ｷ\_s*ﾞ\|ｶ\_s*ﾞ\)\|ッ\_s*[ゴゲグギガ]\|っ\_s*[ごげぐぎが]\|ｺ\_s*ﾞ\|小\_s*屋\|蒙\_s*御\_s*免\|巨\_s*頭\_s*鯨\|欣\_s*求\|独\_s*楽\|P\_s*e\_s*r\_s*s\_s*o\_s*n\_s*a\_s*l\_s*e\_s*s\|瞽\_s*女\|歩\_s*行\_s*虫\|向\_s*拝\|皐\_s*月\|穀\_s*潰\|寄\_s*居\_s*虫\|降\_s*魔\|格\_s*\%([間縁]\|天\_s*井\)\|恒\_s*河\_s*沙\|江\_s*\%([津湖商州]\|談\_s*抄\)\|豆\_s*[油汁]\|ｹ\_s*ﾞ\|蚰\_s*蜒\|景\_s*色\|化\_s*粧\|鴃\_s*舌\|稽\_s*古\|懸\_s*魚\|還\_s*[向俗]\|拳\_s*[万固骨]\|喧\_s*嘩\|顕\_s*界\|ｸ\_s*ﾞ\|救\_s*世\_s*菩\_s*薩\|工\_s*合\|供\_s*[奉祭香進]\|紅\_s*蓮\|ｷ\_s*ﾞ\|毬\_s*杖\|岐\_s*\%([南阜]\|セ\_s*ン\)\|棋\_s*将\_s*谷\|求\_s*\%([法道肥]\|不\_s*得\_s*苦\|聞\_s*持\_s*法\)\|A\_s*g\|S\_s*\%(c\_s*r\_s*o\_s*p\_s*h\_s*u\_s*l\_s*a\_s*r\_s*i\_s*a\_s*c\_s*e\_s*a\_s*e\|y\_s*m\_s*p\_s*e\_s*t\_s*a\_s*l\_s*a\_s*e\|i\_s*l\_s*v\_s*e\_s*r\)\|希\_s*臘\|杏\_s*葉\|餃\_s*子\|刑\_s*部\|ｶ\_s*ﾞ\|搦\_s*み\|鑑\_s*真\|仮\_s*名\|蝦\_s*[蟆蟇]\|T\_s*y\_s*p\_s*a\_s*l\_s*e\_s*s\|鉤\_s*状\_s*部\|菓\_s*子\|甲\_s*斐\|会\_s*社\|ヌ\_s*ー\|Ｇ\_s*\%(Ｏ\_s*Ｒ\_s*Ｏ\|Ｂ\_s*ｙ\_s*ｔ\_s*ｅ\|メ\_s*ン\|カ\_s*ッ\_s*プ\|タ\_s*イ\_s*プ\|ス\_s*ポ\_s*ッ\_s*ト\|パ\_s*ン\|ｎ\_s*ｕ\_s*ｓ\)\|ニ\_s*ュ\_s*ー\_s*ズ\|ノ\_s*ー\_s*ム\|総\_s*司\_s*令\_s*部\|連\_s*合\_s*国\_s*軍\_s*総\_s*司\_s*令\_s*部\|ヒ\_s*ル\|ク\_s*ッ\_s*パ\|硝\_s*子\|ハ\_s*ボ\_s*ロ\_s*ー\_s*ネ\|瞿\_s*曇\|ヨ\_s*ー\_s*テ\_s*ボ\_s*リ\|エ\_s*ー\_s*テ\_s*ボ\_s*リ\|イ\_s*ェ\_s*\%(ー\_s*テ\_s*ボ\_s*リ\|テ\_s*ボ\_s*リ\)\|得\_s*る\|G\_s*\%([dae]\|o\_s*m\_s*o\_s*r\_s*t\_s*e\_s*g\_s*a\_s*c\_s*e\_s*a\_s*e\|M\_s*\%(T\|D\_s*(\_s*G\_s*e\_s*r\_s*m\_s*a\_s*n\_s* \_s*N\_s*a\_s*t\_s*i\_s*o\_s*n\_s*a\_s*l\_s* \_s*R\_s*e\_s*s\_s*e\_s*a\_s*r\_s*c\_s*h\_s* \_s*C\_s*e\_s*n\_s*t\_s*e\_s*r\_s* \_s*f\_s*o\_s*r\_s* \_s*C\_s*o\_s*m\_s*p\_s*u\_s*t\_s*e\_s*r\_s* \_s*S\_s*c\_s*i\_s*e\_s*n\_s*c\_s*e\_s*)\)\|メ\_s*ン\|C\_s*L\|c\_s*c\|カ\_s*ッ\_s*プ\|タ\_s*イ\_s*プ\|ス\_s*ポ\_s*ッ\_s*ト\|パ\_s*ン\|P\_s*L\|n\_s*u\_s*s\|I\_s*\%(N\_s*A\_s*(\_s*t\_s*h\_s*e\_s* \_s*G\_s*e\_s*n\_s*e\_s*r\_s*i\_s*c\_s* \_s*I\_s*n\_s*t\_s*e\_s*r\_s*a\_s*c\_s*t\_s*i\_s*v\_s*e\_s* \_s*A\_s*p\_s*p\_s*l\_s*i\_s*c\_s*a\_s*t\_s*i\_s*o\_s*n\_s*)\|F\_s*\%(フ\_s*ァ\_s*イ\_s*ル\|ア\_s*ニ\_s*メ\)\)\|U\_s*I\|N\_s*U\|O\_s*サ\_s*イ\_s*ン\|E\_s*T\_s*メ\_s*ソ\_s*ッ\_s*ド\)\|ヘ\_s*\%(ラ\_s*ル\_s*ド\|ル\_s*マ\_s*ン\)\|ド\_s*イ\_s*ツ\|成\_s*吉\_s*思\_s*汗\|ゼ\_s*\%(ラ\_s*\%(チ\_s*ン\|ニ\_s*ウ\_s*ム\)\|ム\_s*ク\_s*リ\_s*ッ\_s*プ\|ノ\_s*ア\|ン\_s*ト\_s*ル\_s*マ\_s*ン\|ネ\_s*\%(コ\_s*ン\|ラ\_s*\%(ル\|リ\_s*ス\_s*ト\)\)\)\|大\_s*\%(蚊\|学\_s*院\_s*生\)\|ジ\_s*\%([ムルジグノナオンー]\|プ\_s*シ\_s*ー\|ア\_s*ン\|ッ\_s*ド\|イ\_s*ド\|タ\_s*ン\|ゼ\_s*ル\|リ\_s*ア\_s*ン\|レ\_s*ッ\_s*ト\|ゴ\_s*ロ\|ラ\_s*\%(フ\|ル\_s*\%(ド\|デ\_s*ィ\_s*ー\_s*ノ\)\)\|ロ\_s*\%(ー\|ン\_s*ド\)\|バ\_s*ン\_s*シ\_s*ー\|ブ\_s*\%(リ\|ラ\_s*ル\_s*タ\_s*ル\)\|ベ\_s*\%(ル\_s*ナ\_s*ウ\|レ\_s*リ\_s*ン\)\|ネ\_s*ッ\_s*ト\|ョ\_s*\%(ッ\_s*ト\|ヴ\_s*ァ\_s*ン\_s*[ニナ]\|バ\_s*ン\_s*[ニナ]\|コ\_s*\%(ー\_s*ソ\|ン\_s*ダ\)\|ル\_s*\%(ジ\|ダ\_s*ー\_s*ノ\)\|ー\_s*\%(ジ\|ゼ\_s*ッ\_s*ト\)\)\|ャ\_s*\%(ン\|イ\_s*\%(ロ\|ル\_s*ズ\|ア\_s*ン\_s*[ツト]\)\|コ\_s*\%(モ\|メ\_s*ッ\_s*テ\_s*ィ\)\|ー\_s*マ\_s*ン\)\|ニ\_s*ー\|ュ\_s*\%([レネ]\|ゼ\_s*ッ\_s*ペ\|リ\_s*\%(ア\|ー\_s*ニ\|エ\_s*ッ\_s*タ\)\|ヌ\_s*\%(ビ\_s*エ\_s*ー\_s*ブ\|ヴ\_s*ィ\_s*エ\_s*ー\_s*ヴ\)\)\|ェ\_s*\%([リルフムマネ]\|ス\_s*チ\_s*ャ\_s*ー\|ロ\_s*ニ\_s*モ\|ラ\_s*\%(ー\_s*[トルド]\|ル\_s*\%(ド\|デ\_s*ィ\_s*ン\|ダ\_s*イ\_s*ン\)\)\|ミ\_s*ニ\|ニ\_s*ー\|ノ\_s*\%([アバ]\|ヴ\_s*ァ\|ワ\_s*ー\_s*ズ\|サ\_s*イ\_s*ド\)\|ン\_s*\%(マ\|ト\_s*\%(ル\|リ\_s*[ィー]\)\|ダ\_s*ー\)\)\)\)',
      \ 'h' : '\%([ﾎ洞亡袰滅幌濠壕畚笨略檣艢焔炎仄朖朗塊程施滸幾殆缶熱解屠榾螢蛍骨細本＊※糒恣縦擅星戟戈桙綻祠誇埃鉾矛堀頬袍垉膀鞄抔磅峯堋弸皰舫篷麭怦呆蔀棚褓泙枋棒勹鴇朴峰豐苞葬琺寳炮鵬寶繃魴鋒髣逢朋烹鳳彗箒俸焙蓬烽幇抱崩訪泡澎彷縫捧萌萠彭包胞倣邦飽疱庖奉豊砲報硼宝攴攵瀑蹼樮北恍掘畝譽保穗賞埔餔咆惚穂葡抛哮耄堡脯哺襃黼捕彫褒欲吼舖輔葆浦逋誉ほﾍ謙遜篦廰廳貶褊胼諞篇駢蝙翩變∂遍返騙編扁変丿暼諛諂隔凹臍巳蛇蔕蒂瓸竡粨躄闢癖甓璧劈碧壁聘餅箆坪竝嬖幤閇娉病塀蔽并陛屏炳斃瓶弊幣併敝閉並辺邉減屁圧歴邊折舳戸へﾌ麓梺冬♭′枌賁汾濆吩氛雰糞褌忿墳吻紛焚扮分粉揮旧舊顫故震篩奮隹古衾襖贅燻鰒陰絃総惣總房閼鬱塞章郁艦簡補札耽吭鰾笛芬呎文罧節苳蕗淦舩艙舷舟船蒲懷懐≧≪≫＞≦渊淵渕縁葢盖弍蓋双B藤潭蒸鱶楓殕瘋封諷黻怫髴佛彿恚慍憤仏F弗沸Φφ拒防茯蔔愎輹蝠箙⊇⊃嚢梟袋含⊆⊂袱覆輻復馥副複福経俘麸賦麩蜉坿父附訃婦誣仆經舗咐符臥斧冨更俛觝怖腐踏深趺富降畉譜葺觸敷歩赴狂殖振夫苻噴罘伏匐賻風柎不巫蹈孵拭普芙郛埠鋪鯆付吹阜拊桴溥榑扶俯触践負増傅鮒孚府ふﾋ鶸彬禀斌蘋嬪繽殯賓擯牝貧頻瀕稟品怯葫晝飜蒜蛭昼綬胙紐鰭∝衡片鮃閃鵯辟百媛姫仭擴絋仞展尋宥太拡拓拾祐恕紘煕泰熙寛啓弘宏洋裕浩廣広髟馮飃飆殍冰冫凭俵驫彪雹飄豹漂驃慓剽嫖兵憑票評標平表燧老撚拈捫捻歪籤籖柊旱魃秀跪膝蜩羆攣佗−低隙閑暇雛髯鬚髭¬蹄濳潜潛顰密窃鬻提瓠蠡瓢匏壽央恒廂尚寿久率蟆痙蟇丙丁孤女史獨独稘斎均倫準斉等≠單偏単他仁瞳人1１柆蔆拉杓柄犇◇◆菱醢醤曾蘖彦酷浸漬鶲額聖肱肘熈芒光膕控皸皹響罅僻鰉蹕匹逼篳畢疋柩棺弼櫃謐坤未羊筆必襞養饑（＜「【←『左緋罷引披惹轡丕卑碑彼昜痺砒鞁退匪否毘皮蜚干疲蓖氷比匕桧日梭曳牽費扉魅肥痞灯豼鞴斐狒碾秕杼冷贔俾挽索被貔暃避火朏菲裨秘髀轢乾臂泌庇批紕脾霏檜飛悲妣妃樋祕陳鄙譬ひﾊ布鱧釖鉤蝟梁鍼磔針肚禳腑腸孕原拂祓払遼温玄請腹陽悠遙東遥治春捷頓鮠鶻駿疾囃林隼畔磐泛鈑潘膰樊笵釆胖拌絆蟠氾坂范凡燔楾洪瘢翻板攀゜大伴煩槃斑袢判範藩繙蕃版搬叛班阪般販犯汎帆頒反侍鯊櫨祝？硲間烈激勵劇励速蝿蠅省飯彈勢外筈弭辱逸育毓齦浮難掵阻憚幅巾柞母翅幟側圃旌旙旛将傍働鰰機叩疥畠籏幡畑旗斜鴿再鳩開秦跣膚肌裸弾薑椒元弌壹哉壱甫一創馨始鋼芳剪夾鋏螯挾挟脛萩贐餞離塙英蕚萼衂衄縹譚咄放噺話洟甚鼻華花觜赱迸枦奔艀婢梯燥箸柱走橋箪匣凾□筐繁方運匚筥箱函佰珀魄陌亳狛柏愽栢岶蘗粕膊璞擘箔舶泊搏迫帛拍諮測企圖秤謀量計図儚捗袴伯博墓秡癶髮釟溌肇廿二初椀蓮♪８鉢蜂發髪服法半醗白薄八発擺旆盃珮湃坏碚琲睥霈埴牌拜裴孛吠入沛榛杯悖―廢腓徘誹稗癈俳肺憊輩背鷂胚廃排拝敗灰配蛤濱浜跳馳霸羞爆禿杷碆叭匍怕栄玻撥穿愧歯膨破恥晴巴生派暎端覇着帚刃填腫吐刷菷刎菠羽琶張這頗簸佩耻早映履慙坡榮果脹跛陂葉播笆葩矧霽食芭把刄捌垪剥爬掃帶齒嵌貼はｈ━─┛┘┷┸┻┴┓┐┬┳┯┰┫┥┤┨╋┿┼╂波‐フ☆★非ヒホヘハh]\|ｯ\_s*[ﾎﾍﾌﾋﾊ]\|ッ\_s*[ホヘフヒハ]\|っ\_s*[ほへふひは]\|寄\_s*生\|珠\_s*鶏\|混\_s*一\_s*色\|紅\_s*[幇中]\|T\_s*r\_s*i\_s*u\_s*r\_s*i\_s*d\_s*a\_s*l\_s*e\_s*s\|微\_s*[酔笑]\|子\_s*規\|蜀\_s*魂\|杜\_s*[鵑宇]\|時\_s*鳥\|上\_s*枝\|鬼\_s*灯\|酸\_s*漿\|叢\_s*祠\|和\_s*了\|鮑\_s*魚\|謗\_s*法\|黒\_s*子\|部\_s*屋\|竹\_s*\%(畚\|麦\_s*魚\)\|巻\_s*子\|綜\_s*麻\|下\_s*手\|糸\_s*瓜\|霹\_s*靂\|c\_s*l\_s*a\_s*u\_s*s\_s*t\_s*r\_s*o\_s*p\_s*h\_s*o\_s*b\_s*i\_s*a\|鞦\_s*韆\|睾\_s*丸\|乱\_s*吹\|相\_s*応\|E\_s*\%(r\_s*i\_s*o\_s*c\_s*a\_s*u\_s*l\_s*a\_s*l\_s*e\_s*s\|u\_s*p\_s*t\_s*e\_s*l\_s*e\_s*a\_s*c\_s*e\_s*a\_s*e\)\|回\_s*\%(鍋\_s*肉\|回\_s*教\)\|書\_s*司\|頭\_s*垢\|鳧\_s*鐘\|款\_s*冬\|菜\_s*蕗\|f\_s*\%(o\_s*r\_s*t\_s*e\|e\_s*m\_s*t\_s*o\)\|釜\_s*[中山]\|雙\_s*葉\|渓\_s*井\|G\_s*e\_s*r\_s*a\_s*n\_s*i\_s*a\_s*\%(c\_s*e\_s*a\_s*e\|l\_s*e\_s*s\)\|宿\_s*酔\|○\_s*○\_s*○\|△\_s*△\_s*△\|×\_s*×\_s*×\|河\_s*\%(豚\|底\_s*撈\_s*魚\)\|神\_s*[庫籬]\|領\_s*巾\|肩\_s*巾\|素\_s*見\|曹\_s*白\_s*魚\|枚\_s*[田方]\|敬\_s*昌\|幸\_s*展\|容\_s*靖\|晃\_s*道\|宙\_s*子\|欧\_s*子\|祥\_s*加\|終\_s*日\|翡\_s*翠\|曽\_s*祖\_s*父\|豪\_s*将\|偉\_s*紀\|周\_s*[行男]\|茅\_s*蜩\|向\_s*日\_s*葵\|七\_s*宗\|桶\_s*坂\|永\_s*和\|蟾\_s*蜍\|抽\_s*\%([斗出]\|き\_s*出\_s*し\)\|告\_s*天\_s*子\|雲\_s*[脂雀]\|為\_s*人\|緊\_s*[と々]\|鎮\_s*火\_s*\%(祭\|の\_s*祭\)\|A\_s*\%(s\|r\_s*s\_s*e\_s*n\_s*i\_s*c\|n\_s*g\_s*i\_s*o\_s*s\_s*p\_s*e\_s*r\_s*m\_s*a\_s*e\)\|粃\_s*糠\_s*疹\|只\_s*管\|直\_s*[向走垂隠]\|常\_s*陸\|鹿\_s*尾\_s*菜\|撲\_s*り\_s*倒\|同\_s*胞\|赦\_s*い\|青\_s*春\|哈\_s*爾\_s*浜\|美\_s*佳\|流\_s*行\|勇\_s*[樹人]\|韓\_s*流\|漢\_s*堡\|汗\_s*国\|盤\_s*陀\|R\_s*S\_s*I\|蔓\_s*延\|沙\_s*魚\|蝦\_s*虎\_s*魚\|馬\_s*銜\|狭\_s*間\|南\_s*風\|延\_s*\%(縄\|い\_s*て\)\|義\_s*母\|旅\_s*籠\|N\_s*e\_s*l\_s*u\_s*m\_s*b\_s*o\_s*n\_s*a\_s*c\_s*e\_s*a\_s*e\|黄\_s*[酒櫨]\|土\_s*[方生師]\|嘔\_s*[吐気]\|支\_s*倉\|長\_s*谷\|接\_s*ぎ\_s*合\|纏\_s*頭\|煙\_s*火\|麻\_s*疹\|階\_s*[上子]\|嘴\_s*\%(細\_s*鴉\|太\_s*鴉\)\|学\_s*胤\|２\_s*\%([人つ日]\|０\_s*[歳日]\)\|2\_s*\%([人つ日]\|通\_s*り\|0\_s*日\)\|淡\_s*竹\|8\_s*月\|客\_s*家\|P\_s*\%(t\|o\_s*t\_s*a\_s*m\_s*o\_s*g\_s*e\_s*t\_s*o\_s*n\_s*a\_s*l\_s*e\_s*s\|l\_s*a\_s*t\_s*i\_s*n\_s*u\_s*m\)\|海\_s*\%([鞘永蘿星牙]\|拉\_s*爾\|底\_s*撈\_s*月\)\|M\_s*\%(y\_s*r\_s*t\_s*a\_s*l\_s*e\_s*s\|e\_s*r\_s*c\_s*u\_s*r\_s*y\)\|色\_s*調\|呼\_s*和\_s*浩\_s*特\|ウ\_s*ー\_s*ゴ\|ユ\_s*\%(ー\|ペ\_s*ー\_s*ル\|ベ\_s*ー\_s*ル\|イ\_s*ス\_s*マ\_s*ン\_s*ス\|ゴ\_s*ー\|グ\_s*ノ\_s*ー\|マ\_s*ニ\_s*\%(テ\|ス\_s*[トム]\)\)\|現\_s*代\|十\_s*六\_s*進\_s*数\|高\_s*さ\|香\_s*港\|イ\_s*\%(ダ\_s*ル\_s*ゴ\|ス\_s*パ\_s*ニ\_s*ア\|レ\_s*ー\_s*ル\|エ\_s*ロ\)\|Ｈ\_s*\%(ｚ\|カ\_s*ッ\_s*プ\|ｏ\_s*ｂ\_s*ｂ\_s*ｉ\_s*ｔ\|ｉ\_s*\%(８\|Ｂ\_s*ａ\_s*ｎ\_s*ｄ\)\)\|オ\_s*\%([ラー]\|ナ\_s*ー\|ノ\_s*レ\|ン\_s*フ\_s*ル\_s*ー\_s*ル\|ネ\_s*\%(ス\_s*\%(ト\|テ\_s*ィ\)\|ゲ\_s*ル\)\|テ\_s*ル\|ル\_s*ガ\_s*ー\|マ\_s*ー\_s*ジ\_s*ュ\)\|ア\_s*\%(ン\_s*\%(リ\|ベ\_s*ー\_s*ル\)\|ネ\_s*ス\_s*ト\|ワ\_s*ー\|ダ\_s*マ\_s*ー\_s*ル\|シ\_s*ェ\_s*ッ\_s*ト\|ビ\_s*タ\_s*シ\_s*オ\_s*ン\|ー\_s*\%(ネ\_s*ス\_s*ト\|ノ\_s*ン\_s*ク\_s*ー\_s*ル\)\)\|H\_s*\%([fsPeo]\|i\_s*m\_s*a\_s*n\_s*t\_s*a\_s*n\_s*d\_s*r\_s*a\_s*c\_s*e\_s*a\_s*e\|カ\_s*ッ\_s*プ\|T\_s*\%(M\_s*L\_s*フ\_s*ァ\_s*イ\_s*ル\|T\_s*P\_s*サ\_s*ー\_s*バ\)\|D\_s*D\_s*レ\_s*コ\_s*ー\_s*ダ\_s*ー\|u\_s*r\_s*d\|a\_s*\%(s\_s*s\_s*i\_s*u\_s*m\|f\_s*n\_s*i\_s*u\_s*m\|w\_s*a\_s*i\_s*i\)\|y\_s*\%(p\_s*e\_s*r\_s* \_s*T\_s*e\_s*x\_s*t\_s* \_s*M\_s*a\_s*r\_s*k\_s*u\_s*p\_s* \_s*L\_s*a\_s*n\_s*g\_s*u\_s*a\_s*g\_s*e\|d\_s*\%(n\_s*o\_s*r\_s*a\_s*c\_s*e\_s*a\_s*e\|r\_s*\%(a\_s*s\_s*t\_s*i\_s*d\_s*o\_s*i\_s*d\_s*e\_s*a\_s*e\|o\_s*\%(s\_s*t\_s*a\_s*c\_s*h\_s*y\_s*d\_s*a\_s*l\_s*e\_s*s\|g\_s*e\_s*n\)\)\)\)\)\|エ\_s*\%(デ\_s*ィ\|ン\_s*リ\_s*ケ\|レ\_s*\%(ナ\|ー\_s*ヌ\)\|ロ\_s*イ\_s*ー\_s*ズ\|ク\_s*ト\_s*ル\|ル\_s*\%(ゲ\_s*ラ\|ヴ\_s*ェ\|メ\_s*ス\|マ\_s*ン\|ミ\_s*\%(ッ\_s*ト\|ー\_s*ト\)\|ブ\_s*ラ\_s*ン\|ナ\_s*ン\_s*デ\_s*ス\|キ\_s*ュ\_s*ー\_s*ル\)\|ノ\_s*ク\|イ\_s*チ\|ッ\_s*チ\)\|水\_s*[銀平素]\)',
      \ 'i' : '\%([ｲηΗ賤鄙卑苟嫌弥薯妹芋藷夢艷鑪鈩彩鱗色鯆忽綺貸甍答応愈圦杁茵胤飮寅尹婬贇韵隱蚓氤酳霪蔭堙湮廴音飲慇韻咽淫殞姻隕院允隠殷陰窟巖巌頌祝鰮鰛鰯岩磐円￥鼾歪弋弑抱懐肬贅疣狗戌乾犬諱在坐未汝戒誡警縛今Εε曰禾稻員因蝗嘶鰍電引躄誘動≦忿鵤錨碇怒霆霹雷凧桴筏魚S菴庵彌雖家尿荊棘茨祈祷命豕猯古伍聿乙鎰鴪軼樹慈悼愴慯労格到至傷鼬頂戴病徒致鈑痛板柞沙砂聊些潔諍烈功諫勳勇勲漁諌憇＝憩粹熱粋憤域閾勢勤忙急磯孰焉湶泉厳何弄苛≧鎔范啀毬訝燻息挑絲縷厭營営愛幼稚緒遑暇糸弌壹肆莓苺櫟著市碑鐓礎甃臀弩石牲犧犠池溢Y佚壱1１鬻毓燠礇粥的戦戰軍郁幾育一稲否飯違居矮ゐ猪五煎彝醫斐逶貽善胆位萎可詑僞鑄熬活容依要斎行怡異衣逝猗胃洟好矣鋳揖椅去惟云懿熨痿射凍尉移将囗肄夷率囲姨慰頤忌唯緯逸噫挿鮪易偽苡彜莞往以韋遺炒謂李生威為維意倚良如彙已出淹言亥鰄井蔚痍圍幃渭堰饐医爲癒帷恚偉委詒畏い氷Йй→⇒⊂⊃▼▽伊ｉ印入∞吋∈∋∬∫∩ＩイИΙи私ιi]\|E\_s*メ\_s*ー\_s*ル\|灼\_s*然\|祖\_s*谷\|湯\_s*文\_s*字\|文\_s*身\|郎\_s*[女子]\|蕁\_s*麻\|刺\_s*[青草]\|U\_s*r\_s*t\_s*i\_s*c\_s*a\_s*l\_s*e\_s*s\|海\_s*[豚参]\|西\_s*表\|鸚\_s*哥\|影\_s*青\|況\_s*ん\_s*や\|所\_s*謂\|D\_s*i\_s*a\_s*p\_s*e\_s*n\_s*s\_s*i\_s*a\_s*l\_s*e\_s*s\|藺\_s*草\|J\_s*u\_s*n\_s*c\_s*a\_s*l\_s*e\_s*s\|田\_s*舎\|膝\_s*行\|十\_s*六\_s*夜\|寝\_s*穢\|英\_s*\%(蘭\|吉\_s*利\)\|斑\_s*鳩\|烏\_s*賊\|玉\_s*筋\_s*魚\|硫\_s*黄\|夜\_s*来\_s*香\|N\_s*a\_s*j\_s*a\_s*d\_s*a\_s*l\_s*e\_s*s\|牛\_s*膝\|稜\_s*威\|常\_s*春\_s*藤\|5\_s*[つ日]\|５\_s*[つ日]\|惡\_s*戲\|甚\_s*振\|潮\_s*来\|悪\_s*戯\|交\_s*喙\|細\_s*小\_s*魚\|小\_s*魚\|鯨\_s*魚\|鶏\_s*魚\|経\_s*緯\|礒\_s*[山田]\|P\_s*\%(o\_s*a\_s*l\_s*e\_s*s\|l\_s*u\_s*m\_s*b\_s*a\_s*g\_s*i\_s*n\_s*a\_s*l\_s*e\_s*s\)\|和\_s*泉\|気\_s*吹\|Ｅ\_s*\%(Ａ\_s*Ｓ\_s*Ｔ\|Ｖ\_s*Ｅ\)\|指\_s*宿\|拠\_s*所\|従\_s*[弟妹姉兄]\|鴨\_s*脚\_s*樹\|公\_s*孫\_s*樹\|G\_s*\%(r\_s*a\_s*m\_s*i\_s*n\_s*a\_s*l\_s*e\_s*s\|l\_s*u\_s*m\_s*i\_s*f\_s*l\_s*o\_s*r\_s*a\_s*e\|i\_s*n\_s*k\_s*g\_s*o\_s*p\_s*s\_s*i\_s*d\_s*a\)\|銀\_s*杏\|鳶\_s*尾\|檪\_s*本\|巫\_s*子\|神\_s*巫\|睦\_s*月\|都\_s*方\_s*流\|縊\_s*[殺死首]\|蝟\_s*[集縮]\|埋\_s*け\_s*[火炭]\|許\_s*[嫁婚]\|<\_s*=\_s*=\_s*>\|必\_s*要\_s*十\_s*分\_s*条\_s*件\|ヤ\_s*ン\|日\_s*本\_s*ア\_s*イ\_s*・\_s*ビ\_s*ー\_s*・\_s*エ\_s*ム\_s*株\_s*式\_s*会\_s*社\|国\_s*際\_s*\%(基\_s*督\_s*教\_s*大\_s*学\|標\_s*準\_s*化\_s*機\_s*構\)\|逆\_s*離\_s*散\_s*フ\_s*ー\_s*リ\_s*エ\_s*変\_s*換\|識\_s*別\_s*子\|即\_s*興\_s*曲\|な\_s*ら\_s*ば\|項\_s*目\|逐\_s*次\_s*型\|誤\_s*っ\_s*た\|無\_s*\%(花\_s*果\|効\_s*な\)\|帰\_s*納\_s*法\|字\_s*下\_s*げ\|不\_s*\%([可如足]\|充\_s*分\)\|具\_s*体\_s*化\|情\_s*報\|導\_s*入\|整\_s*数\|完\_s*全\|I\_s*\%([rPn]\|R\_s*Q\|カ\_s*ッ\_s*プ\|C\_s*\%(タ\_s*グ\|チ\_s*ッ\_s*プ\|カ\_s*ー\_s*ド\)\|l\_s*l\_s*i\_s*n\_s*o\_s*i\_s*s\|S\_s*\%(O\|B\_s*N\_s*\%(コ\_s*ー\_s*ド\|番\_s*号\)\|A\_s*バ\_s*ス\)\|d\_s*a\_s*h\_s*o\|D\_s*\%(カ\_s*ー\_s*ド\|E\_s*\%(ド\_s*ラ\_s*イ\_s*ブ\|デ\_s*バ\_s*イ\_s*ス\|ケ\_s*ー\_s*ブ\_s*ル\|コ\_s*ン\_s*ト\_s*ロ\_s*ー\_s*ラ\)\)\|タ\_s*ー\_s*ン\|T\_s*\%(シ\_s*ス\_s*テ\_s*ム\|バ\_s*ブ\_s*ル\)\|o\_s*\%(w\_s*a\|d\_s*i\_s*n\_s*e\)\)\|ヨ\_s*\%(ア\_s*ン\|シ\_s*フ\|ー\_s*ド\|ウ\_s*素\)\|ア\_s*\%(イ\|ー\_s*\%(ヴ\_s*ィ\_s*ン\|ビ\_s*ン\)\|ン\_s*\%(プ\_s*ロ\_s*ン\_s*プ\_s*\%(チ\_s*ュ\|テ\_s*ュ\)\|デ\_s*パ\_s*ン\_s*ダ\_s*ン\|フ\_s*ォ\_s*ル\_s*\%(メ\_s*ル\|マ\_s*テ\_s*ィ\_s*ー\_s*ク\)\)\)\)',
      \ 'j' : '\%([塩嶋島嶌縞橲竺衂衄宍舳忸軸舌喰食直凝實昵実印尻侭仞刄臣恁儘潯贐稔進盡仭糂訊俥蕁迅刃靱荏甚靭燼櫁樒塵尽尋陣腎壬人敍莇茹杼洳敘汝蜍耡恕舒縟褥蓐辱溽所抒鋤徐絮序叙助帖穰疂聶疊驤襄淨讓繩禳絛蕘諚仗壌滌繞生靜蟐壤仍茸嬲疉塲乘遶星瀞拯釀躡孃如剩娘嬢錠静醸縄女尉饒丈成烝擾嫋穣丞盛場杖條条蒸貞状攘畳剰冗定浄乗情城上常譲懦愀鷲竪嬬戍得濡咒讐讎就聚笋篤盾徇凖楯詢隼筍蓴惇洵淳閏恂諄馴旬荀潤循醇巡遵順准殉純準襦誦需朮戌宿孰塾珠熟恤術述豎孺呪儒綬樹受授壽揉從澀狃中戎拾廿鞣从縱澁糅蹂神汁獸絨縦渋柔什充十従獣住銃重事迩爺滋除怩尓痔璽至児士寿茲孳染嗣柱寺磁仕死爾路而仁辞塒時岻粫持恃敷焦字只地轜侍瓷亊知辭餌冶邇弍似祀以子峙二史自畤兒示耳慈司蒔次珥膩醤鮭着鉐惹搦尺雀寂若弱邪戯者蛇麝闍じｊ┃│┝┣├┠┌┏．еЕ治яЯ日ЮюЁёйЙジj]\|ｯ\_s*ｼ\_s*ﾞ\|ッ\_s*ジ\|っ\_s*じ\|G\_s*\%(メ\_s*ン\|パ\_s*ン\)\|D\_s*y\|Ｇ\_s*\%(メ\_s*ン\|パ\_s*ン\)\|支\_s*度\|試\_s*合\|２\_s*乗\|2\_s*乗\|祖\_s*父\_s*\%(さ\_s*ん\|祖\_s*母\)\|獅\_s*子\|甲\_s*乙\_s*丙\_s*丁\_s*戊\_s*己\_s*庚\_s*辛\_s*壬\_s*癸\|k\_s*\$\_s*_\_s*{\_s*e\_s*f\_s*f\_s*}\_s*\$\|Z\_s*\%(r\|i\_s*r\_s*c\_s*o\_s*n\_s*i\_s*u\_s*m\)\|深\_s*\%(秘\|大\_s*寺\)\|秦\_s*泉\_s*寺\|沈\_s*\%(香\|丁\_s*花\)\|晨\_s*朝\|濁\_s*世\|判\_s*官\|諍\_s*論\|長\_s*夜\|漏\_s*斗\|↑\_s*↓\_s*←\_s*→\|焼\_s*酎\|鐘\_s*石\|橈\_s*脚\_s*類\|承\_s*久\|朱\_s*里\|C\_s*a\_s*b\_s*o\_s*m\_s*b\_s*o\_s*i\_s*d\_s*e\_s*a\_s*e\|絢\_s*子\|頌\_s*偈\|数\_s*珠\|入\_s*[魂牢来洛院内水棺]\|霜\_s*月\|１\_s*\%(２\|６\_s*進\|０\_s*[進月]\|１\_s*月\|８\_s*禁\)\|師\_s*走\|極\_s*月\|紐\_s*帯\|1\_s*\%(0\|1\_s*月\|8\_s*禁\|2\_s*月\)\|ｼ\_s*ﾞ\|爪\_s*哇\|射\_s*礼\|砂\_s*利\|謝\_s*花\|三\_s*味\_s*線\|雑\_s*魚\|著\_s*語\|杓\_s*子\|共\_s*同\_s*企\_s*業\_s*体\|ゼ\_s*リ\_s*ー\|エ\_s*\%(ホ\_s*バ\|リ\_s*コ\|レ\_s*ミ\_s*ヤ\|ル\_s*サ\_s*レ\_s*ム\|ッ\_s*サ\_s*イ\)\|ヘ\_s*\%(レ\_s*ス\|ス\_s*ス\)\|ヒ\_s*メ\_s*ネ\_s*ス\|チ\_s*ゲ\|北\_s*陸\_s*先\_s*端\_s*\%(大\|科\_s*学\_s*技\_s*術\_s*大\_s*学\_s*院\_s*大\_s*学\)\|ハ\_s*\%(イ\_s*メ\|ラ\_s*ペ\_s*ー\_s*ニ\_s*ョ\)\|碧\_s*玉\|ヤ\_s*\%([リンニナー]\|イ\_s*ル\|エ\_s*ル\|ル\_s*ノ\|レ\_s*ド\|ヌ\_s*\%(ス\|シ\_s*ュ\)\|ス\_s*パ\_s*ー\_s*ス\|コ\_s*[ビブ]\|ッ\_s*ケ\)\|フ\_s*\%(ァ\_s*[ンナ]\|リ\_s*[オア]\)\|J\_s*\%(R\_s*東\_s*日\_s*本\|\.\_s*S\_s*\.\_s*\%(B\_s*a\_s*c\_s*h\|バ\_s*ッ\_s*ハ\)\|リ\_s*ー\_s*グ\|カ\_s*ッ\_s*プ\|C\_s*B\_s*カ\_s*ー\_s*ド\|-\_s*P\_s*O\_s*P\|ポ\_s*ッ\_s*プ\|P\_s*\%(G\_s*フ\_s*ァ\_s*イ\_s*ル\|E\_s*G\_s*フ\_s*ァ\_s*イ\_s*ル\)\|I\_s*S\_s*\%(マ\_s*ー\_s*ク\|コ\_s*ー\_s*ド\)\|a\_s*p\_s*a\_s*n\_s* \_s*A\_s*d\_s*v\_s*a\_s*n\_s*c\_s*e\_s*d\_s* \_s*I\_s*n\_s*s\_s*t\_s*i\_s*t\_s*u\_s*t\_s*e\_s* \_s*o\_s*f\_s* \_s*S\_s*c\_s*i\_s*e\_s*n\_s*c\_s*e\_s* \_s*a\_s*n\_s*d\_s* \_s*T\_s*e\_s*c\_s*h\_s*n\_s*o\_s*l\_s*o\_s*g\_s*y\|A\_s*\%(I\_s*S\_s*T\|N\_s*コ\_s*ー\_s*ド\|V\_s*A\_s*\%(ス\_s*ク\_s*リ\_s*プ\_s*ト\|ア\_s*プ\_s*レ\_s*ッ\_s*ト\)\)\|U\_s*N\_s*E\_s*T\)\|ズ\_s*ボ\_s*ン\|Ｊ\_s*\%(２\|−\_s*Ｗ\_s*Ａ\_s*Ｖ\_s*Ｅ\|リ\_s*ー\_s*グ\|カ\_s*ッ\_s*プ\|ポ\_s*ッ\_s*プ\|Ｉ\_s*Ｃ\_s*Ｃ\_s*出\_s*版\|ｕ\_s*ｓ\|Ｕ\_s*\%(Ｓ\|Ｎ\_s*Ｋ\_s*Ｏ\)\)\|ユ\_s*\%([ハリダノ]\|ル\_s*ゲ\_s*ン\|ー\_s*\%([リノ]\|ゲ\_s*ン\_s*ト\|デ\_s*ィ\_s*ッ\_s*ト\)\|ン\_s*\%(グ\|ケ\_s*ル\|カ\_s*ー\)\|ピ\_s*テ\_s*ル\|ッ\_s*[カシ]\)\|イ\_s*\%(エ\_s*\%([ナス]\|ン\_s*\%(ス\|セ\_s*ン\)\|ズ\_s*ス\)\|ェ\_s*\%(ナ\|ン\_s*\%(ス\|ゼ\_s*ン\|セ\_s*ン\)\|ー\_s*ガ\_s*ー\|ル\_s*\%(ク\|サ\_s*レ\_s*ム\)\)\)\|ホ\_s*\%([タセ]\|ル\_s*ヘ\|ホ\_s*バ\|ア\_s*\%(ン\|キ\_s*ン\)\)\|ヨ\_s*\%([ブナ]\|ル\_s*\%(グ\|ダ\_s*ン\)\|エ\_s*ル\|ア\_s*\%(キ\_s*ム\|ヒ\_s*ム\)\|ゼ\_s*フ\|シ\_s*\%(フ\|ュ\_s*ア\)\|ー\_s*\%([ドト]\|デ\_s*ル\|ゼ\_s*フ\)\|セ\_s*フ\|ハ\_s*[ナンネ]\)\)',
      \ 'k' : '\%([ｺ怖之旃惟怺薦米暦轉殺悃鶤艮鯤很袞坤壼琿狠漿棍魂菎滾梱溷痕渾墾恨懇根梢杪王泥裔樸鞐熟枹醴聲声蛩凍溢零錯苔亊箏斷判諺理断盡悉尽辞詞殊事壽寿鯒礫鯉齣狛腓昆瘤鮗谺応應答爰茲是試志心凩笏惚榾兀輿甑腰拵拗鐺鏝衝杲磽絖昊耗闔狎靠冓汞湟塙慌嫦礦冦淆遘亘仰昴誥鬨鴿鏗浤哮砿鎬伉熕洽訌閧困縞鮫逅糠槹哽盍稾亙壙覯隍簧遑洸餃惶寇鵁皋黌椌扣晄倖矼肓頏蛤呷詬匣昿皐崗肱徨峇袷敲爻藁倥釦棡凰犒吭窖畊岡猴胱絋傚啌蚣缸紘湊搆閤峺羔鍠幌鱇扛肴恆紺鈩絳閘蒙冰氷郡蛟槁候楮媾溘蝗酵嚆犢稿亢哄睾慷郊岬肛項巷鑛洪佼狡叩昂勾喉晃滉糀晧剛曠宏控恍侯皓港膏耿皎坑江絞膠虹巧鴻鉱衡浩厚耕幸弘綱抗購攻講恒薨溝鋼航行肯光皇好荒高梏谷哭槲尅釛斛轂石告酷穀踰懲蝴鴣袴焦觚虍粐乎沽餬胯菰瞽請楜娘壺錮込葫痼兒估冴漕痩虎冱倒戸呱媚粉夸詁子鈷捏濃故濾箍漉恋呼誇壷放転仔鼓小股罟女乕琥跨滬越古糊滸扈瑚皷混怙弧辜戀蠱超児雇凝孤湖此瓠蛄凅肥こｹ峻欅獸騫剱儉惓劵蜷謇鉉鵑綣幵娟險劒虔瞼俔顯臉圈釼歉權慊縣暄愃愆涓黔劔獻搴諠椦妍檢甄験慳捲倦遣羂嶮蹇鹸狷譴腱驗軒憲繭謙圏険硯倹献犬絢顕券劍剣見権拳研眷牽県建烟鑷言獣蓋涜吝削畩閲検貶健桁嗾竭訐亅碣杰譎偈抉厥蕨歇襭刔頡獗尻訣孑頁纈蹶桀穴傑結血憇夐彑勍攜迥冏檠絅蹊煢笄醯枅憬盻綮詣冂挈黥剄匸徑奚挂兮鮭瓊畦逕繼惠慧謦鷄系┻┣┠┨┝┴│┿┰╋━┛┬┥╂┤┸┯┼─┷├┏┳┫┃┓罫痙奎脛谿溪螢蛍渓閨憩圭携硅恵刑継勁珪計啓異毛蹴褻けｸ姑配椪栩櫪檪椡橡椚湫箜櫟含纐柵婚屎糞癖潛潜鵠凹窪縊跟軛頚珞頸首諄窟鞋履轡覆沓碎砕条降件頽崩屑釘莖茎陸杙杭掘崛倔鶏鐃藥擽薬樟楠梳櫛串釧與与挫籖鯀鯨籤隈熊艸嚔藾叢鏈腐鎖種ξΞ臭楔草圀邦國国髭嗽漱吻嘴脣唇梔腔φ粂皹勳熏裙醺桾皸崑燻訓勲葷委钁精詳鍬咥銜桑某暝峅眛昏罔冥鮓比闇位鞍藏暗倉廚厨涅曇蜘佝栗包俥車梍枢畔鐵玄蔵黒喰苦枸煦焼倶狗吼刳工絎駒眩垢口窶区劬繰呉暮貢嶇酌庫惧組衢紅食句吁懼區桍孔怐瞿くｷ段痍疵絆紲傷築鱚稷嚴黍帛後碪砧絹萌兆刻椈鞫掬辟君牙檗蘗迄訖狐屹詰佶拮吃鞠橘菊喫‥＼£、♀〇∵≡．＆＾‰▲‡｀§¶′＿〓☆；□↑↓・％■¢＝／≒←−￣★々≠♂〆ゝ◎―＄¨♭＋？ヽ…†♪‖＠゜◆ヾ´。±｜≪⌒≧○÷，≫＜∞●◇∴≦△！℃゛▼♯¬°▽‐ー∽￥：∨＞Ц＃∝∫〃仝Å″〒ゞ煙蚶衣更細妃后楸蕈茸乙雉轢杵軋岸桔汚穢北樵際裂燦煌雲嫌胆竏粁瓩浄澄淳潔清雰錐蛬吉霧檮桐襟磬釁覲箘掀噤衿鈞檎瑾忻饉箟听芹衾釿懃斤蒟径窘擒巾菌公禽筋錦欣僅琴均禁謹緊欽近勤鉅秬擧渠踞據舉筥嘘苣慶倨距歔遽鋸醵拠拒去勗亟蕀洫跼旭局挙許居巨虚頃峽筴鍄陜卿竟筺僵狹竅洶誑羌抂炯烱劫經刧襁繦蕎篋況徼恊恟棘轎竸况廾荊亰姜梗孝亨跫敬筐梟饗矯挾矜挟校拱嬌響鞏杏向興匈嚮享警競喬怯兄彊僑兢狂供橋莢凶郷兇驕叫夾匡侠狭恐経疆協境胸強驚脅共恭今教玖赳鬮舊蚯逑恷歙貅扱樛９烋摎邱笈皀疚岌厳胡翕朽泣穹糺糾及躬汲窮灸弓臼宮久柩究給丘求鳩級球休救急旧吸九瞶來著喜旡决羈祈揮窺起聞弃伎燬憙毅綺麾基机棄希噐棋其尋祁熹奇肌跂稀覬暉企黄愾欹几稘城軌諱岐決詭極記猗喟槻竒季碕鰭悸切禧消己效朞淇驥揆麒嬉崎僖匱屓既毀杞危卉器貴徽癸虧畿忌耆曁伐紀晞畸饑酒碁樹生木覊聽剪截櫃熈嵜冀跪气愧煕期効斬訊飢妓箕祺圻熙餽来徠鬼譏羇馗着寄倚氣利幾汽欷姫饋聴唏剞鑽騏逵騎掎規幃棊きｶ癢糜粥痒麹輕骨業軽鰈鰔餉通龜瓶甕亀鳫獵鴈殯猟雁釀鳬鳧髢鴨巛側躱廁厠磧瓦獺翡皮裘→紮搦苧碓柄枳躯躰軆體体鴉犂烏機絡空唐榧茅澗鸛厂蒄啣卷淦扞杆骭歛瞰讙奐戡豢坎瀚皖稈鐶拑酣陷繝嫺驩篏樌莟勸捍撼澣盥羹嫻鑵寰丱康懽憾羮揀歡潤罕觀橄涵渙凵堪覡巫鉋萱簪舘艱咸翰柬駻悍燗槓浣邯攷稽宦考棺潅閂煥鉗疳癇函凾鹹顴緘款桓箝諫諌轗坩旱侃鰥　館莞橇韓患灌勧菅簡奸刊柑肝看桿寒緩干嵌廣広竿貫巻敢漢環喊陥監喚甘間歓閑寛管慣完艦乾幹官観壁椛屍姓庇鞄芳蔓鯑一勘⊃影陰蔭景＊棧梯筧庚辛┘┐柧┌門廉脚乞癩∪川合’）《‘”｛〈“｝》〉囓柁旗鮖悴舵鰍鍛梶錺餝飾篭籠歸孵卻皈還省顧楓却帰反返守帋督祇髮韮裃雷髪紙鉦曲矩予鐘樺沫偏騙語潟刀象模仇固硬傍難容忝辱頑形旁方型肩風滓翳微幽掠緕纃綛絣擦糟鎹粕戞猾曷剋黠瞎鞨恰∧濶∩蠍筈蝎羯喝轄餓蛞聒劼擔刮蘰鬘桂闊括嘗捷豁渇担滑堅鰹割戛活疽暈鵲瘡傘嵩重襲葛笠堵硴墻牆蠣蛎柿掲關罹抱踵嬶嚊拘関係顏貌郁薫顔母感釡罐窰鴎框叺構喧竃竈釜缶蒲鎌數数槝栢膳傅瑕畏賢橿姦樫爨炊圍喞託囲鈎「『鉤」』限鍵傾禿蕪鏑頭齧気被兜哉適敵必要彜彝鬲鼎叶片哀愛悲鋺蛇鉄蜩神奏楫裹磆餅徒褐粮糧茖椁覺幗槨貉擴壑隱愨寉殼癨嚇穫咯膕骼膈∠掴狢埆蠖覈霍礁恪擱匿撹攪喀廓較郭〕【［】］〔殻挌劃閣格隠覚矍革馘鶴攫核獲拡客隔角確廨囘隗嵬觧榿蠏匯徊迴壞褂獪丐械枴畍誨揩醢誡夬懈喙椢恠峡价櫂茴蛙瑰乖浬鰄傀糴柏街鳰懷蛔蠶蚕邂蟹潰壊恢腕芥垣楷會拐悔詼諧契皆界疥魁偕改繪貝胛絵快甲灰槐晦懐介塊解廻回階戒開会怪海縢篝炬耀赫輝冠鑒鑑各屈鏡柯噛箇上苛暇蚊廈易嘩ヵ描苅枯佳彼兼哥缺霞藉架啝下渦踝堝闕華嗄荷馨刈假夥河科珈個蝸迦軻咼黴舸繋書賀夏萪支卦掛掻蝦痂謌渮歌過香禾狩買變家枷克駈花賈畫珂呵替代訶袈咬画顆貸價淅飼和ヶ果糅厦課可醸葭勝仮搗嘉墟嗅譌日斯禍換窩苟貨蝌価懸欠化罅伽賭翔靴且嚼訛交何駆驅个嫁譁借加跏戈稼寡涸耶変崋鹿笳火茄菓遐舁かｋ京節└┗※хХ忽コ汗〜功株（Kク×金窯κキΧカКΚкχケk]\|ｯ\_s*[ｺｹｸｷｶ]\|ッ\_s*[コケクキカ]\|っ\_s*[子こけくきか]\|蟀\_s*谷\|焜\_s*炉\|前\_s*妻\|嫡\_s*妻\|二\_s*合\_s*半\|秋\_s*桜\|牛\_s*尾\_s*魚\|庶\_s*幾\|独\_s*楽\|特\_s*牛\|粫\_s*門\|甦\_s*生\|M\_s*e\_s*t\_s*a\_s*c\_s*h\_s*l\_s*a\_s*m\_s*y\_s*d\_s*e\_s*a\_s*e\|f\_s*o\_s*o\_s*t\_s* \_s*a\_s*n\_s*d\_s* \_s*m\_s*o\_s*u\_s*s\_s*e\_s* \_s*d\_s*i\_s*s\_s*e\_s*a\_s*s\_s*e\|外\_s*連\_s*味\|螻\_s*蛄\|罌\_s*粟\|滅\_s*紫\|S\_s*i\|莎\_s*草\|百\_s*[濟済]\|9\_s*[日月]\|秧\_s*鶏\|釉\_s*掛\|典\_s*薬\_s*寮\|L\_s*a\_s*u\_s*r\_s*\%(a\_s*c\_s*e\_s*a\_s*e\|o\_s*i\_s*d\_s*e\_s*a\_s*e\)\|探\_s*湯\|誓\_s*湯\|六\_s*合\|地\_s*祇\|都\_s*子\|州\_s*光\|群\_s*衆\|慈\_s*姑\|c\_s*r\_s*e\_s*s\_s*c\|内\_s*蔵\_s*助\|H\_s*e\_s*l\_s*l\_s*e\_s*b\_s*o\_s*r\_s*o\_s*i\_s*d\_s*e\_s*a\_s*e\|J\_s*u\_s*g\_s*l\_s*a\_s*n\_s*d\_s*a\_s*l\_s*e\_s*s\|仁\_s*彦\|啄\_s*木\_s*鳥\|X\_s*e\|如\_s*月\|私\_s*市\|昨\_s*日\|素\_s*地\|布\_s*地\|欺\_s*罔\|聖\_s*[之子美]\|沈\_s*菜\|蟋\_s*蟀\|螽\_s*斯\|G\_s*o\_s*l\_s*d\|A\_s*\%(u\|r\_s*c\_s*h\_s*i\_s*c\_s*h\_s*l\_s*a\_s*m\_s*y\_s*d\_s*e\_s*a\_s*e\|s\_s*t\_s*e\_s*r\_s*a\_s*l\_s*e\_s*s\|c\_s*a\_s*n\_s*t\_s*h\_s*a\_s*c\_s*e\_s*a\_s*e\)\|菫\_s*青\_s*石\|槿\_s*花\|R\_s*\%(h\_s*\%(o\_s*e\_s*a\_s*d\_s*a\_s*l\_s*e\_s*s\|a\_s*m\_s*n\_s*a\_s*l\_s*e\_s*s\)\|u\_s*n\_s*u\_s*n\_s*c\_s*u\_s*l\_s*o\_s*i\_s*d\_s*e\_s*a\_s*e\|a\_s*n\_s*\%(u\_s*n\_s*c\_s*u\_s*l\_s*a\_s*\%(l\_s*e\_s*s\|c\_s*e\_s*a\_s*e\)\|a\_s*l\_s*e\_s*s\)\)\|裾\_s*礁\|脇\_s*[侍息]\|姉\_s*[妹弟]\|頬\_s*[骨筋]\|毬\_s*果\|舅\_s*姑\|厩\_s*\%([肥舎]\|務\_s*員\)\|廐\_s*舎\|離\_s*れ\_s*離\_s*れ\|掃\_s*部\|羚\_s*羊\|氈\_s*瓜\|土\_s*器\|蝙\_s*蝠\|魚\_s*狗\|為\_s*替\|連\_s*枷\|身\_s*体\|落\_s*葉\_s*松\|随\_s*神\|檻\_s*車\|T\_s*\%(h\_s*a\_s*l\_s*i\_s*c\_s*t\_s*o\_s*i\_s*d\_s*e\_s*a\_s*e\|u\_s*b\_s*i\_s*f\_s*l\_s*o\_s*r\_s*a\_s*e\)\|南\_s*瓜\|量\_s*子\|千\_s*典\|山\_s*\%(梔\_s*子\|陽\_s*道\)\|蜉\_s*蝣\|陽\_s*炎\|蜻\_s*蛉\|破\_s*片\|挿\_s*頭\|駕\_s*\%(籠\|輿\_s*丁\)\|槭\_s*樹\|長\_s*[月官]\|主\_s*[紀計神]\|剃\_s*刀\|天\_s*\%(牛\|鼠\_s*矢\)\|帷\_s*子\|酢\_s*漿\_s*草\|O\_s*x\_s*a\_s*l\_s*i\_s*d\_s*a\_s*c\_s*e\_s*a\_s*e\|飛\_s*白\|春\_s*日\|C\_s*\%([ormfda]\|h\_s*r\_s*o\_s*m\_s*i\_s*u\_s*m\|i\_s*r\_s*c\_s*a\_s*e\_s*a\_s*s\_s*t\_s*e\_s*r\_s*a\_s*c\_s*e\_s*a\_s*e\|u\_s*r\_s*i\_s*u\_s*m\|y\_s*p\_s*e\_s*r\_s*a\_s*l\_s*e\_s*s\|e\_s*r\_s*c\_s*i\_s*d\_s*i\_s*p\_s*h\_s*y\_s*l\_s*l\_s*a\_s*c\_s*e\_s*a\_s*e\)\|曽\_s*て\|曾\_s*て\|松\_s*魚\|燕\_s*子\_s*花\|牡\_s*[蛎蠣]\|民\_s*部\|部\_s*曲\|E\_s*\%(b\_s*e\_s*n\_s*a\_s*l\_s*e\_s*s\|l\_s*a\_s*n\_s*a\_s*l\_s*e\_s*s\)\|案\_s*山\_s*子\|梭\_s*\%(魚\|子\_s*魚\)\|螳\_s*螂\|蟷\_s*螂\|瓜\_s*\%(田\|呂\_s*根\)\|拍\_s*手\|水\_s*[鶏母手夫]\|東\_s*\%(風\|京\_s*都\_s*立\_s*科\_s*学\_s*技\_s*術\_s*大\_s*学\)\|(\_s*株\_s*)\|称\_s*子\|贏\_s*ち\_s*得\|歩\_s*兵\|恁\_s*く\|杜\_s*\%(若\|父\_s*魚\)\|梅\_s*花\_s*皮\|頴\_s*田\|膾\_s*炙\|ノ\_s*\%([ブウ]\|ー\_s*ン\|ッ\_s*\%([トク]\|テ\_s*ィ\_s*ン\_s*グ\|カ\_s*ー\|キ\_s*ン\_s*グ\)\)\|ナ\_s*\%(ッ\_s*\%(ク\|プ\_s*\%(サ\_s*ッ\_s*ク\|ザ\_s*ッ\_s*ク\)\)\|レ\_s*ッ\_s*ジ\|イ\_s*[フトツ]\)\|ニ\_s*\%(ー\|ッ\_s*\%(ト\|テ\_s*ィ\_s*ン\_s*グ\)\)\|ホ\_s*\%(ー\_s*\%(ミ\_s*ー\|メ\_s*イ\)\|メ\_s*イ\_s*ニ\)\|フ\_s*\%(ビ\_s*ラ\_s*イ\|ル\_s*シ\_s*チ\_s*ョ\_s*フ\)\|ハ\_s*\%(ン\|ラ\_s*シ\_s*ョ\_s*ー\|ー\_s*ン\|バ\_s*ロ\_s*フ\_s*ス\_s*ク\|ル\_s*ツ\_s*ー\_s*ム\|チ\_s*ャ\_s*ト\_s*ゥ\_s*リ\_s*ア\_s*ン\)\|Ｋ\_s*\%([点ｇｍ]\|カ\_s*ッ\_s*プ\|ｎ\_s*ｏ\_s*ｃ\_s*ｋ\_s*Ｏ\_s*ｕ\_s*ｔ\|ｅ\_s*ｎ\_s*ｗ\_s*ｏ\_s*ｏ\_s*ｄ\)\|P\_s*\%(i\_s*p\_s*e\_s*r\_s*a\_s*\%(l\_s*e\_s*s\|c\_s*e\_s*a\_s*e\)\|a\_s*p\_s*a\_s*v\_s*e\_s*r\_s*a\_s*l\_s*e\_s*s\|o\_s*\%(d\_s*o\_s*s\_s*t\_s*e\_s*m\_s*o\_s*n\_s*a\_s*l\_s*e\_s*s\|t\_s*a\_s*s\_s*s\_s*i\_s*u\_s*m\)\)\)',
      \ 'l' : '\%([ｫォぉｪェぇｩゥぅｨィぃｧァぁ＜≪ｌ＿￣≦李左←∃∨¬∀⊃ル∧レラ£ЛλлΛl]\|ｯ\_s*[ｫｪｩｨｧ]\|ッ\_s*[ォェゥィァ]\|っ\_s*[ぉぇぅぃぁ]\|液\_s*晶\|最\_s*小\_s*2\_s*乗\_s*法\|\.\_s*\.\_s*\.\|拉\_s*薩\|聯\_s*想\|補\_s*題\|檸\_s*檬\|手\_s*紙\|学\_s*習\|施\_s*錠\|局\_s*所\|論\_s*理\|ロ\_s*\%([キイアロリブボトメウスコゴグー]\|ペ\_s*ス\|ワ\_s*ー\_s*ル\|エ\_s*ベ\|ヨ\_s*ラ\|フ\_s*ト\|ル\_s*カ\|ベ\_s*リ\_s*ア\|ビ\_s*\%(ー\|ン\_s*グ\|イ\_s*\%(ス\_s*ト\|ン\_s*グ\)\)\|テ\_s*ィ\|サ\_s*ン\_s*\%(ジ\_s*ェ\_s*ル\_s*ス\|ゼ\_s*ル\_s*ス\)\|ニ\_s*ー\|ク\_s*リ\_s*ア\_s*ン\|ッ\_s*\%([ジタテトク]\|キ\_s*\%(ン\_s*グ\|ー\_s*ド\)\|カ\_s*ー\)\|ケ\_s*ー\_s*\%([トタル]\|シ\_s*ョ\_s*ン\)\|カ\_s*ー\_s*ル\|ガ\_s*ー\|ギ\_s*ン\_s*グ\|ジ\_s*\%(ー\|テ\_s*ッ\_s*ク\|ス\_s*テ\_s*ィ\_s*\%(ク\|ッ\_s*ク\)\|カ\_s*ル\|ク\_s*ー\_s*ル\|ッ\_s*[トク]\)\|ラ\_s*ン\|ン\_s*\%([ゴグダ]\|ボ\_s*\%(ク\|ッ\_s*ク\)\|バ\_s*ル\_s*デ\_s*ィ\|ズ\_s*デ\_s*ー\_s*ル\|リ\_s*[ーィ]\|ジ\_s*ン\|ド\_s*ン\)\|レ\_s*\%(ア\_s*ル\|ッ\_s*タ\|ー\_s*ヌ\|イ\_s*ン\|ン\_s*\%([ソス]\|ツ\_s*ォ\)\)\)\|\\\_s*L\_s*a\_s*T\_s*e\_s*X\|Ｌ\_s*\%(サ\_s*イ\_s*ズ\|Ｌ\_s*サ\_s*イ\_s*ズ\|Ｕ\_s*Ｎ\_s*Ａ\|ｕ\_s*\%(ｎ\_s*ａ\|ｃ\_s*\%(ｉ\_s*ｄ\|ｋ\_s*ｙ\)\)\|ｉ\_s*\%(ａ\_s*ｒ\|ｓ\_s*ｐ\|ｔ\_s*ｅ\)\|ｏ\_s*ｆ\_s*ｔ\|A\_s*Ｔ\_s*E\_s*Ｘ\|ａ\_s*\%(ｗ\_s*ｓ\_s*ｏ\_s*ｎ\|Ｔ\_s*ｅ\_s*Ｘ\|ｓ\_s*ｅ\_s*ｒ\_s*Ｗ\_s*ｒ\_s*ｉ\_s*ｔ\_s*ｅ\_s*ｒ\)\)\|L\_s*\%([DP]\|サ\_s*イ\_s*ズ\|L\_s*サ\_s*イ\_s*ズ\|u\_s*\%(t\_s*e\_s*t\_s*i\_s*u\_s*m\|c\_s*i\_s*d\)\|i\_s*\%(t\_s*h\_s*i\_s*u\_s*m\|s\_s*p\|n\_s*u\_s*x\)\|E\_s*D\_s*ラ\_s*イ\_s*ト\|e\_s*m\_s*m\_s*a\|o\_s*\%(g\_s*i\_s*c\_s*a\_s*l\_s* \_s*U\_s*n\_s*i\_s*t\_s* \_s*N\_s*u\_s*m\_s*b\_s*e\_s*r\|u\_s*i\_s*s\_s*i\_s*a\_s*n\_s*a\)\|a\_s*\%(w\_s*r\_s*e\_s*n\_s*c\_s*i\_s*u\_s*m\|n\_s*t\_s*h\_s*a\_s*n\_s*u\_s*m\|T\_s*e\_s*X\)\|A\_s*N\)\|研\_s*究\_s*室\|リ\_s*\%([ィセズザサスダポルラリマナノンヌブアー]\|ャ\_s*マ\|ヤ\_s*ド\_s*ロ\|ヨ\_s*ン\|ゾ\_s*チ\_s*ー\_s*ム\|コ\_s*\%(リ\_s*ス\|ピ\_s*ン\)\|ク\_s*ー\_s*ド\|カ\_s*\%(ー\|オ\_s*ン\)\|ジ\_s*[ンー]\|デ\_s*[ィル]\|ド\_s*カ\_s*イ\_s*ン\|プ\_s*ト\_s*ン\|パ\_s*ー\_s*ゼ\|グ\_s*\%(ニ\_s*ン\|ナ\_s*ン\)\|フ\_s*\%([エト]\|タ\_s*ー\|テ\_s*ィ\_s*ン\_s*グ\)\|テ\_s*ラ\_s*[ルシ]\|チ\_s*ウ\_s*ム\|ソ\_s*\%(ソ\_s*ー\_s*ム\|グ\_s*ラ\_s*フ\_s*ィ\)\|タ\_s*ー\|ト\_s*\%([レル]\|マ\_s*ス\|ア\_s*ニ\_s*ア\|グ\_s*ラ\_s*フ\|バ\_s*ル\_s*ス\_s*キ\_s*ー\)\|オ\_s*\%(タ\_s*ー\_s*ル\|ネ\_s*ル\)\|ミ\_s*\%(テ\_s*ッ\_s*ド\|ッ\_s*[タト]\)\|モ\_s*\%(ー\_s*ジ\_s*ュ\|ネ\_s*ン\|ン\_s*チ\_s*ェ\_s*ッ\_s*ロ\)\|ム\_s*ジ\_s*ン\|キ\_s*\%(ッ\_s*ド\|ュ\_s*ー\_s*ル\|テ\_s*ン\_s*\%(シ\_s*ュ\_s*タ\_s*イ\_s*ン\|ス\_s*タ\_s*イ\_s*ン\)\)\|エ\_s*\%(ゾ\_s*ン\|ー\_s*ジ\_s*ュ\)\|ヒ\_s*テ\_s*ン\_s*シ\_s*ュ\_s*タ\_s*イ\_s*ン\|ネ\_s*\%([アン]\|ッ\_s*ト\|ー\_s*ジ\_s*ュ\)\|ニ\_s*ア\|ベ\_s*\%([ロラ]\|リ\_s*ア\|レ\_s*ー\_s*シ\_s*ョ\_s*ン\|ル\_s*テ\)\|ビ\_s*\%([アー]\|ド\_s*ー\|ン\_s*グ\)\|ュ\_s*\%([スー]\|ブ\_s*リ\_s*ャ\_s*ー\_s*ナ\|リ\_s*ュ\|ド\_s*ミ\_s*ラ\|ク\_s*サ\_s*ン\_s*ブ\_s*ー\_s*ル\|ッ\_s*ク\|シ\_s*ア\_s*ン\|ミ\_s*エ\_s*ー\_s*ル\)\|ロ\_s*\%(イ\|ン\_s*グ\_s*ウ\_s*ェ\)\|ヴ\_s*\%(ィ\_s*ン\_s*グ\_s*ス\_s*ト\_s*ン\|ァ\_s*\%(プ\_s*ー\_s*ル\|イ\_s*ア\_s*サ\_s*ン\)\)\|バ\_s*\%(テ\_s*ィ\|タ\_s*リ\_s*ア\_s*\%(ン\|ニ\_s*ズ\_s*ム\)\|プ\_s*ー\_s*ル\|イ\_s*ア\_s*サ\_s*ン\)\|ッ\_s*\%([ドピプタクチト]\|ス\_s*ン\)\)\|エ\_s*ル\)',
      \ 'm' : '\%([ﾓ脆醪師諸催靄舫腿銛杜森捫聞匁紋問玩翫擡齎靠凭鵙鴃縺悶樅籾椛楓蛻濳潛艾潜殯黐餠用糯餅桃者懶專専物尤勿畚許故悖旧戻下乖求礎素基本元綟捩文默沐杢黙芒网莽檬罔耗耄朦魍艨矇濛曚亡蒙毛孟猛網漏裳望喪揉持母燃若藻以摸楙貰洩姆保茂模糢もﾒ麪緜眄緬麺門棉綿面蓍珎珍♀娶貭粧妾牝瞽盲娚暈繞萌惠慈恵萠溟暝滅謎姪瞑盟酩銘鳴芽睨召奴瑪碼賞減雌女めﾑ羣榁室簇屯邨連邑叢村紫梅葎宜憤葮毳槿椋酬報尨骸躯旨難睦酷麥麦邀対百迎昔虚空鞅宗棟胸掬娘結笞鞭徒蝕蠧蠹蟲席莚蓆寧筵虫毟貉狢豸貪壻聟婿无謀霧矛毋無鵡夢梦剥六群牟務蒸噎武向咽むﾐ渠霙溝妊澪薨岑嶺峰峯亂紊婬淫妄濫猥乱◇※■＊簔穣簑蓑醜儖慘短惨幹研耳壥廛店操陵鶚崎岬巫尊敕勅詔＞」砌頻汀→】』右翠碧緑認幣蹊径倫導途通路道瞠髻鬟湖自蹼蛟瑞癸禊晦漲源鏖港湊南櫁瞶謐水調貢密甕帝蜜覩幸脉脈韮韭竓粍瓱榠螟茗名妙命冥都宮罠閔皆眠明民魅深觀身實彌観己診看味美盈三御充稔視壬巳靡弥箕みﾏ毬鞠紕蝮麿転稀賓客檀繭黛眉囘巡周防衛衞護守荳菽豆槫・圓．◯°゜。）（丸鬘謾幡縵懣鰻幔蹣蔓瞞卍饅漫滿慢迄笆貧幻瞼蔟疎眩回廻設申儲招繚統纒的蟶孫彎弯籬擬免猿亮純信実委罷壗侭圸飯儘継随髷任蒭芻耙紛鮪見猯塗斈學眥眦眼俎愛学斑枡斗鱒舛升桝萬蠱呪薪槙槇牧窗惑悗円窓甼襠区街町前複亦俣叉跨全瞬木胯股又鍖枕膜幕參眛参瑁詣妹哩迷枚米賄賂埋昧邁毎秣靺抹沫枩奉祀纏祭睫末大秀太勝柾弄優成盛將松匡鉞賢征誠昌希将政正仁雅媽万俟茉満目先麼未卷散磨枉眞益真増負蒔坐交馬捲舞嘛雑在放墹痲撒待播間摩敗巻混曲魔まｍ光月♪♭♯ム⊃∴≦∞÷≫≧≪⌒±∈∀⊂∬∫∝∨∽Δ¬⇒⊥∃∠∧⊆⇔∵≡∩×⊇∂∋≠√∪∇≒♂曼麻◎〇○●モ〒′−マ最ミМΜμメm]\|ｯ\_s*[ﾓﾒﾑﾐﾏ]\|ッ\_s*[モメムミマ]\|っ\_s*[もめむみま]\|双\_s*\%([手墨親]\|向\_s*き\|差\_s*し\)\|蜀\_s*黍\|唐\_s*土\_s*\%(書\|文\_s*字\)\|両\_s*\%([角親刃]\|差\_s*し\)\|楊\_s*梅\_s*皮\|主\_s*水\|旺\_s*角\|紅\_s*[絹染葉]\|強\_s*請\|虎\_s*落\|痘\_s*瘡\|莫\_s*斯\_s*科\|固\_s*よ\_s*り\|一\_s*徳\|O\_s*l\_s*e\_s*a\_s*l\_s*e\_s*s\|惘\_s*然\|乙\_s*張\|赤\_s*目\_s*魚\|針\_s*孔\|妻\_s*[君合沼]\|墨\_s*西\_s*哥\|鍍\_s*金\|繍\_s*眼\_s*児\|夫\_s*婦\|乳\_s*母\|布\_s*の\_s*子\|没\_s*\%([薬後入却有]\|義\_s*道\|食\_s*子\)\|B\_s*\%(e\_s*r\_s*b\_s*e\_s*r\_s*i\_s*d\_s*a\_s*c\_s*e\_s*a\_s*e\|i\_s*o\_s*r\_s*r\_s*a\_s*g\_s*i\_s*n\_s*a\_s*l\_s*e\_s*s\)\|浮\_s*腫\|６\_s*日\|6\_s*日\|崇\_s*田\|刀\_s*背\|襁\_s*褓\|零\_s*余\_s*子\|蜈\_s*蚣\|産\_s*霊\|息\_s*子\|k\_s*\$\_s*_\_s*{\_s*i\_s*n\_s*f\_s*}\_s*\$\|蚯\_s*蚓\|A\_s*\%(b\_s*i\_s*e\_s*s\|p\_s*e\_s*t\_s*a\_s*l\_s*a\_s*e\|c\_s*r\_s*o\_s*s\_s*t\_s*i\_s*c\_s*h\_s*u\_s*m\)\|山\_s*陵\|雎\_s*鳩\|親\_s*王\|嬰\_s*児\|亨\_s*治\|陸\_s*奥\|皇\_s*[子女國]\|３\_s*[つ日]\|3\_s*[つ日]\|角\_s*[鴟子髪]\|七\_s*寸\|鳩\_s*尾\|鷦\_s*鷯\|孤\_s*児\|凝\_s*視\|兎\_s*唇\|R\_s*u\_s*t\_s*a\_s*l\_s*e\_s*s\|神\_s*[子輿酒]\|苗\_s*字\|海\_s*[雲蘊藻布蜂松山]\|P\_s*o\_s*d\_s*o\_s*p\_s*h\_s*y\_s*l\_s*l\_s*a\_s*c\_s*e\_s*a\_s*e\|土\_s*[龍竜産]\|京\_s*都\|横\_s*浜\_s*マ\_s*リ\_s*ノ\_s*ス\|忠\_s*実\|肉\_s*刺\|翻\_s*\%(筋\_s*斗\|車\_s*魚\)\|H\_s*a\_s*m\_s*a\_s*m\_s*e\_s*l\_s*i\_s*d\_s*a\_s*l\_s*e\_s*s\|不\_s*\%(味\|見\_s*[転点]\)\|兇\_s*々\|凶\_s*鳥\|澗\_s*潟\|勾\_s*玉\|禍\_s*[々禍言事]\|況\_s*し\|澳\_s*門\|苧\_s*麻\|茅\_s*台\_s*酒\|丈\_s*夫\|倍\_s*達\|微\_s*[塵妙睡]\|燐\_s*寸\|驀\_s*地\|L\_s*o\_s*g\_s*a\_s*n\_s*i\_s*a\_s*c\_s*e\_s*a\_s*e\|豫\_s*て\|陪\_s*臣\|売\_s*僧\|C\_s*\%(a\_s*s\_s*u\_s*a\_s*r\_s*i\_s*n\_s*a\_s*l\_s*e\_s*s\|e\_s*r\_s*a\_s*t\_s*o\_s*p\_s*y\_s*l\_s*l\_s*a\_s*c\_s*e\_s*a\_s*e\)\|S\_s*\%(a\_s*p\_s*i\_s*n\_s*d\_s*a\_s*l\_s*e\_s*s\|c\_s*h\_s*i\_s*s\_s*a\_s*n\_s*d\_s*r\_s*a\_s*c\_s*e\_s*a\_s*e\)\|理\_s*[之元]\|允\_s*彦\|祐\_s*史\|晶\_s*子\|公\_s*[美則輝]\|斉\_s*加\_s*年\|方\_s*夫\|多\_s*言\_s*語\_s*化\|ニ\_s*ー\_s*モ\_s*ニ\_s*ッ\_s*ク\|単\_s*量\_s*体\|会\_s*議\|和\_s*布\_s*[刈蕪]\|中\_s*間\_s*子\|薄\_s*荷\_s*脳\|行\_s*[幸列]\|写\_s*像\|日\_s*\%(米\_s*相\_s*互\_s*防\_s*衛\_s*援\_s*助\_s*協\_s*定\|本\_s*製\)\|Ｍ\_s*\%(Ｈ\_s*ｚ\|サ\_s*イ\_s*ズ\|Ｓ\_s*−\_s*Ｄ\_s*Ｏ\_s*Ｓ\|Ｌ\_s*サ\_s*イ\_s*ズ\|ｒ\_s*．\|ｂ\_s*ｐ\_s*ｓ\|ｃ\_s*Ｃ\_s*ａ\_s*ｒ\_s*ｔ\_s*ｈ\_s*ｙ\|ｏ\_s*ｔ\_s*ｉ\_s*ｆ\|ａ\_s*ｃ\)\|計\_s*算\_s*機\|手\_s*紙\|ザ\_s*ッ\_s*ヘ\_s*ル\_s*＝\_s*マ\_s*ゾ\_s*ッ\_s*ホ\|嗜\_s*虐\_s*的\_s*趣\_s*味\|被\_s*虐\_s*\%(淫\_s*乱\_s*症\|趣\_s*味\)\|修\_s*士\|仮\_s*面\|移\_s*送\|M\_s*\%([dngtOo式]\|X\_s*テ\_s*レ\_s*ビ\|サ\_s*イ\_s*ズ\|S\_s*-\_s*D\_s*O\_s*S\|L\_s*サ\_s*イ\_s*ズ\|P\_s*3\_s*プ\_s*レ\_s*\%(ー\_s*ヤ\_s*ー\|イ\_s*ヤ\_s*ー\)\|D\_s*\%(プ\_s*レ\_s*ー\_s*ヤ\_s*ー\|レ\_s*コ\_s*ー\_s*ダ\_s*ー\)\|c\_s*C\_s*a\_s*r\_s*t\_s*h\_s*y\|e\_s*\%(d\_s*u\_s*s\_s*a\_s*n\_s*d\_s*r\_s*a\_s*l\_s*e\_s*s\|i\_s*t\_s*n\_s*e\_s*r\_s*i\_s*u\_s*m\|t\_s*a\_s*F\_s*o\_s*n\_s*t\|n\_s*\%(y\_s*a\_s*n\_s*t\_s*h\_s*a\_s*l\_s*e\_s*s\|d\_s*e\_s*l\_s*e\_s*v\_s*i\_s*u\_s*m\)\|C\_s*a\_s*b\)\|u\_s*l\_s*e\|A\_s*C\_s*ア\_s*ド\_s*レ\_s*ス\|a\_s*\%(g\_s*n\_s*\%(o\_s*l\_s*i\_s*a\_s*\%(c\_s*e\_s*a\_s*e\|l\_s*e\_s*s\)\|e\_s*s\_s*i\_s*u\_s*m\)\|n\_s*\%(u\_s*\%(e\_s*d\|s\_s*c\_s*r\_s*i\_s*p\_s*t\_s* \_s*E\_s*d\_s*i\_s*t\_s*i\_s*n\_s*g\)\|g\_s*a\_s*n\_s*e\_s*s\_s*e\)\|r\_s*y\_s*l\_s*a\_s*n\_s*d\|i\_s*n\_s*e\|k\_s*e\_s*f\_s*i\_s*l\_s*e\|c\_s*\%(h\|i\_s*n\_s*t\_s*o\_s*s\_s*h\)\|s\_s*\%(s\_s*a\_s*c\_s*h\_s*u\_s*s\_s*e\_s*t\_s*t\_s*s\|t\_s*e\_s*r\_s*C\_s*a\_s*r\_s*d\)\)\|i\_s*\%(n\_s*n\_s*e\_s*s\_s*o\_s*t\_s*a\|s\_s*s\_s*\%(i\_s*s\_s*s\_s*i\_s*p\_s*p\_s*i\|o\_s*u\_s*r\_s*i\)\|c\_s*\%(r\_s*o\_s* \_s*S\_s*o\_s*f\_s*t\_s*w\_s*a\_s*r\_s*e\_s* \_s*A\_s*s\_s*s\_s*o\_s*c\_s*i\_s*a\_s*t\_s*e\_s*s\|h\_s*i\_s*g\_s*a\_s*n\)\)\|I\_s*\%(T\|P\_s*S\|M\_s*D\)\)\|エ\_s*ム\)',
      \ 'n' : '\%([ﾝンんﾉ麕咒燧烽詛呪悳孔伯朔弼雅教糊矩憲規哲宜紀範典惟亘修允攵展順暢信則法後罵吭咽喉鑿蚤々湾宣曰臨覘稀望覗遺殘残鋸芒禾騰幟昇登上簷檐軒遁逸衲瑙碯曩王皇腦嚢膿能脳農野伸嚥−陳除濃熨飲退飮延載之呑廼乘乗述埜のﾈ塒姉聹侫檸嚀濘寧佞鼡鼠拗猫嫉妬希願捏熱犒労葱狙閨睡棔眠然稔棯懇拈撚燃念年根寝音涅子捻禰袮練値錬粘捩祢寢嶺煉ねﾇ絖饅垈帛幣鵺主蛻拭温布沼盜偸窃盗抽擢緯糠額縫抜貫拔怒奴塗濡脱ぬﾆ楡蒻潦鷄鶏瀑庭繞獰女尿韭眈薤睨韮儿刄姙葫蒜刃忍∀妊認任人乳擔蜷担濁賑握俄鳰臭匂沸錵贄偐僞贋偽柔靤如苦膠霓滲虹躙廿》《◎∬『』悪憎兄螺鯡鰊錦西入新肉‖岻仁逃似邇弍荷貳弐２二尼迩煮2丹貮児迯にﾅ靡抔嫐嬲鯆屶釶鉈泥薺詰若慨歎嘆抛擲撲毆殴慰治癒等猶直泪波辺邉邊鍋浪某棘棗懷懐夏擦梨情懶譌艶訛鉛鯰癜鮠膾鱠韲憖怠鈍腥捺准準擬凖謎涙洋宥傾灘詠霖眺痼乍存流轅永和梛椥渚長莫毋勿半・媒仲中７斜七蔑乃尚内繩畷縄苗滑鞣惱悩就哉也斉形業徳娚垂喃∵楠爾尓汝男軟難何倣肄双枹均列柞→⇒⊃楢習嘗投爲綯啾啼熟那鳴泣慣生為儺舐菜奈涕並納痿嚶撫茄凪無哭做狎南萎竝魚娜薙亡馴拿失な┘┛│┃┨┫┤┥┣┝├┠╋┿╂┼成＃∋∇名┗└ｎ日≒ニネ¬〜≠ナヌノнνΝНn]\|帳\_s*面\|狼\_s*[烟煙]\|惚\_s*気\|暖\_s*[簾気]\|礼\_s*江\|功\_s*晶\|賀\_s*子\|訓\_s*子\|祈\_s*子\|式\_s*部\_s*省\|記\_s*代\|倫\_s*[明子宗]\|敬\_s*之\|賭\_s*弓\|誠\_s*也\|敦\_s*子\|悦\_s*旦\|祝\_s*[女詞]\|仰\_s*け\_s*反\|盧\_s*泰\_s*愚\|逆\_s*上\|凌\_s*霄\_s*花\|姐\_s*さ\_s*ん\|杜\_s*松\|強\_s*請\|合\_s*歓\|微\_s*温\|零\_s*余\_s*子\|酸\_s*漿\|鐃\_s*鉢\|鰾\_s*膠\|I\_s*I\_s*部\|耳\_s*根\|面\_s*皰\|M\_s*y\_s*r\_s*i\_s*s\_s*t\_s*i\_s*c\_s*a\_s*c\_s*e\_s*a\_s*e\|莞\_s*爾\|L\_s*e\_s*a\_s*d\|P\_s*b\|海\_s*[苔鼠]\|C\_s*\%(e\_s*l\_s*a\_s*s\_s*t\_s*r\_s*a\_s*\%(c\_s*e\_s*a\_s*e\|l\_s*e\_s*s\)\|a\_s*r\_s*y\_s*o\_s*p\_s*h\_s*y\_s*l\_s*l\_s*a\_s*l\_s*e\_s*s\)\|雪\_s*崩\|竹\_s*節\_s*虫\|7\_s*[日個]\|地\_s*震\|行\_s*[木方]\|大\_s*\%(蒜\|理\_s*石\)\|蛞\_s*蝓\|弱\_s*竹\|追\_s*儺\|済\_s*\%(し\_s*崩\|り\_s*物\)\|可\_s*成\|平\_s*城\|不\_s*成\|空\_s*リ\_s*ス\_s*ト\|T\_s*h\_s*e\_s* \_s*N\_s*e\_s*t\_s*w\_s*o\_s*r\_s*k\_s* \_s*I\_s*n\_s*f\_s*o\_s*r\_s*m\_s*a\_s*t\_s*i\_s*o\_s*n\_s* \_s*C\_s*e\_s*n\_s*t\_s*e\_s*r\|S\_s*o\_s*\%(l\_s*a\_s*n\_s*a\_s*l\_s*e\_s*s\|d\_s*i\_s*u\_s*m\)\|紐\_s*育\|フ\_s*ォ\_s*ン\_s*・\_s*ノ\_s*イ\_s*マ\_s*ン\|ヤ\_s*ー\_s*ノ\_s*ッ\_s*シ\_s*ュ\_s*・\_s*フ\_s*ォ\_s*ン\_s*・\_s*ノ\_s*イ\_s*マ\_s*ン\|オ\_s*ラ\_s*ン\_s*ダ\|ア\_s*メ\_s*リ\_s*カ\_s*ネ\_s*ッ\_s*ト\_s*ワ\_s*ー\_s*ク\|番\_s*号\|節\_s*点\|Ｎ\_s*\%([点Ｏ]\|ク\_s*ィ\_s*ー\_s*ン\|\.\_s*Ｙ\_s*\.\|Ｉ\_s*Ｆ\_s*Ｔ\_s*Ｙ\|ｉ\_s*ｆ\_s*ｔ\_s*ｙ\|ａ\_s*\%(ｖ\_s*ｉ\|ｔ\_s*ｕ\_s*ｒ\_s*ｅ\)\|ｅ\_s*\%(Ｘ\_s*Ｔ\|ｍ\_s*ａ\_s*ｃ\_s*ｓ\|ｗ\_s*−\_s*Ｊ\_s*ｅ\_s*ｒ\_s*ｓ\_s*ｅ\_s*ｙ\|Ｗ\_s*Ｓ\|ｕ\_s*ｒ\_s*ａ\_s*ｌ\)\|Ｅ\_s*\%(ｍ\_s*ａ\_s*ｃ\_s*ｓ\|Ｔ\_s*ｔ\_s*ａ\_s*ｌ\_s*ｋ\)\|ｏ\_s*\%(．\|ё\_s*ｌ\)\)\|夜\_s*想\_s*曲\|諾\_s*威\|正\_s*常\|エ\_s*ヌ\|N\_s*\%([dpbaeoi]\|R\_s*Z\_s*I\|-\_s*g\_s*r\_s*a\_s*m\|G\_s*ワ\_s*ー\_s*ド\|H\_s*K\_s*\%(ホ\_s*ー\_s*ル\|ラ\_s*ジ\_s*オ\)\|T\_s*T\|Y\_s*ダ\_s*ウ\|U\_s*L\_s*L\|A\_s*S\_s*A\|E\_s*\%(C\|p\_s*o\_s*c\_s*h\|m\_s*a\_s*c\_s*s\)\)\|窒\_s*素\)',
      \ 'o' : '\%([ｵ俺游泳指妖畢在澱檻氈拇親愚疎颪卸念錘惟慮赴徐趣俤羈主想表重面瘟隱園Å怨♀妾温恩悍鈍臣覺溺朦朧思覚榲現朮桶威嚇踴戯縅棘駭愕驚躍踊傲奢驕嚴厳痴遣瘧怒行怠蒹補荻懼惧獺虞怐畏恐襲甥笈及綬葹ヽゞ〃仝ゝヾ々同唖繦襁鴛鴦教几忍筬收兎抑稚長幼理収治修遲檍納後遅饋賻諡贈送憶袵臆拜拝峻侵奇冒犯崗阜陵岳女陸丘岡欄斧自己各戦鬼衰劣囮頤訪貶乙漢♂音弟阿脅怯首夥誘屋膃億穩穏煽熈煕熾燠諚掟興隠沖翁鴬澳嚶毆泓浤惶罌瓮泱閘蓊墺悒凰殃徃奧秧襖枉姶鸚懊媼嫗鴎怏鏖謳旺凹櫻鴨樗欒楝殴朷甌汪横往鞅歐嘔陷陥遠果応掩蔽應夛奄蓋概欧公邑麋薤被仰扇皇狼弁鵬鴻鳳黄奥多衽覆粱凡鰲頁王穂怖桜壓緒居起降落墮将帶麻央小牡勇捺圧措唹織追悪苧汚下御置帯生折朗於負郎擱押推雄塢老男夫逐墜尾惜嗚乎堕終淤おｏ大◎∞和∝♪∪∨開○ωΟОオΩοоo]\|濠\_s*太\_s*剌\_s*利\|父\_s*[娘子]\|母\_s*[娘子屋]\|万\_s*年\_s*青\|本\_s*懸\_s*魚\|玩\_s*具\|沢\_s*瀉\|A\_s*l\_s*i\_s*s\_s*m\_s*a\_s*t\_s*a\_s*l\_s*e\_s*s\|厭\_s*離\|乳\_s*母\_s*日\_s*傘\|陰\_s*[陽地]\|飲\_s*[食酒]\|慍\_s*色\|婦\_s*系\_s*図\|手\_s*術\|螻\_s*蛄\|十\_s*八\_s*番\|鉄\_s*漿\|海\_s*髪\_s*海\_s*苔\|虎\_s*魚\|花\_s*魁\|美\_s*味\|含\_s*羞\_s*草\|白\_s*粉\|渡\_s*島\|訳\_s*語\|通\_s*事\|晩\_s*[稲生]\|可\_s*笑\|惡\_s*寒\|傍\_s*[目惚見]\|叔\_s*[父母]\|伯\_s*[父母]\|姨\_s*捨\|少\_s*女\|侠\_s*気\|D\_s*i\_s*l\_s*l\_s*e\_s*n\_s*i\_s*a\_s*l\_s*e\_s*s\|G\_s*u\_s*t\_s*t\_s*i\_s*f\_s*e\_s*r\_s*a\_s*l\_s*e\_s*s\|H\_s*y\_s*p\_s*e\_s*r\_s*i\_s*c\_s*a\_s*l\_s*e\_s*s\|霊\_s*屋\|蝌\_s*蚪\|飫\_s*肥\|佩\_s*物\|良\_s*人\|纓\_s*田\|C\_s*o\_s*p\_s*t\_s*i\_s*d\_s*o\_s*i\_s*d\_s*e\_s*a\_s*e\|鷹\_s*揚\|椀\_s*飯\_s*振\_s*\%(舞\|る\_s*舞\)\|相\_s*知\|鶯\_s*語\|近\_s*江\|零\_s*落\|越\_s*[生訴智知度]\|彼\_s*方\|祖\_s*[神父母]\|車\_s*前\|従\_s*祖\_s*[母父]\|青\_s*[梅海木]\|太\_s*\%(田\|安\_s*万\_s*侶\|上\_s*天\_s*皇\)\|巨\_s*頭\|逢\_s*[魔瀬隈坂]\|そ\_s*の\_s*他\|承\_s*知\_s*し\_s*ま\_s*し\_s*た\_s*\.\|烏\_s*[滸龍]\|t\_s*h\_s*e\_s* \_s*O\_s*b\_s*j\_s*e\_s*c\_s*t\_s* \_s*M\_s*a\_s*n\_s*a\_s*g\_s*e\_s*m\_s*e\_s*n\_s*t\_s* \_s*G\_s*r\_s*o\_s*u\_s*p\|立\_s*石\_s*電\_s*機\|職\_s*業\|楕\_s*円\|ウ\_s*\%(ィ\|ー\_s*\%(ズ\|ロ\_s*ン\)\|ロ\_s*ボ\_s*ロ\_s*ス\)\|出\_s*力\|ア\_s*\%(ワ\|ザ\_s*ー\|ウ\_s*\%([チト]\|タ\_s*ー\)\)\|基\_s*本\_s*ソ\_s*フ\_s*ト\_s*ウ\_s*ェ\_s*ア\|一\_s*\%(昨\_s*[年日]\|対\_s*一\)\|ワ\_s*ン\|ま\_s*た\_s*は\|論\_s*理\_s*和\|聖\_s*譚\_s*曲\|水\_s*中\_s*酸\_s*素\_s*破\_s*壊\_s*剤\|蛋\_s*白\_s*石\|最\_s*適\_s*化\|Ｏ\_s*\%([脚型]\|Ｒ\_s*Ｅ\|\.\_s*Ｋ\_s*\.\|Ｓ\_s*９\|リ\_s*ン\_s*グ\|ｐ\_s*ｅ\_s*ｎ\_s*\%(Ｌ\_s*ｏ\_s*ｏ\_s*ｋ\|Ｗ\_s*ｉ\_s*ｎ\_s*ｄ\_s*ｏ\_s*ｗ\_s*ｓ\)\)\|歌\_s*劇\|演\_s*算\_s*子\|操\_s*作\|酸\_s*素\|O\_s*\%([型脚sS]\|h\_s*i\_s*o\|k\_s*l\_s*a\_s*h\_s*o\_s*m\_s*a\|b\_s*j\_s*e\_s*c\_s*t\_s*-\_s*O\_s*r\_s*i\_s*e\_s*n\_s*t\_s*e\_s*d\|O\_s*\%(D\_s*L\|P\_s*L\)\|M\_s*R\_s*O\_s*N\|A\_s*ク\_s*リ\_s*ー\_s*ナ\_s*ー\|C\_s*R\_s*ソ\_s*フ\_s*ト\|r\_s*e\_s*g\_s*o\_s*n\|''\_s*R\_s*e\_s*i\_s*l\_s*l\_s*y\_s* \_s*J\_s*a\_s*p\_s*a\_s*n\|リ\_s*ン\_s*グ\|p\_s*e\_s*n\_s*W\_s*i\_s*n\_s*d\_s*o\_s*w\|x\_s*y\_s*g\_s*e\_s*n\)\)',
      \ 'p' : '\%([本磅椪烹方砲報法舖歩舗ぽ併蔽閇閉×邊編片邉辺遍篇屁ぺ幅服風分布符腐泌匹憑票俵品筒平日版幇搬板犯腹払発發走箱朴駮博拍泊愽包放敗杯盃配牌八播波破羽張ぱｐ鉛ψΨぴ±＋ぷφΦ┣├∝北┴‰．％£〒点・プポ頁）（∂¶‖ペパПπピпΠ燐p]\|ｯ\_s*\%(ﾎ\_s*ﾟ\|ﾍ\_s*ﾟ\|ﾌ\_s*ﾟ\|ﾋ\_s*ﾟ\|ﾊ\_s*ﾟ\)\|ッ\_s*[ポペプピパ]\|っ\_s*[ぽぺぷぴぱ]\|ﾎ\_s*ﾟ\|先\_s*斗\_s*町\|ﾍ\_s*ﾟ\|祕\_s*[露魯]\|ﾌ\_s*ﾟ\|釜\_s*山\|普\_s*魯\_s*西\|ﾋ\_s*ﾟ\|皮\_s*蛋\|光\_s*一\|ﾊ\_s*ﾟ\|麺\_s*麭\|巴\_s*\%(里\|奈\_s*馬\)\|S\_s*y\_s*n\_s*a\_s*n\_s*t\_s*h\_s*a\_s*e\|C\_s*y\_s*c\_s*l\_s*a\_s*n\_s*t\_s*h\_s*a\_s*l\_s*e\_s*s\|排\_s*骨\|B\_s*r\_s*o\_s*m\_s*e\_s*l\_s*i\_s*a\_s*l\_s*e\_s*s\|L\_s*e\_s*a\_s*d\|白\_s*[板酒金]\|シ\_s*\%(ュ\_s*ー\_s*ド\|ロ\_s*シ\_s*ビ\_s*ン\)\|サ\_s*\%(ー\_s*ム\|イ\_s*\%([ズクケコ]\|ロ\_s*シ\_s*ビ\_s*ン\|リ\_s*ウ\_s*ム\|キ\_s*ッ\_s*ク\)\)\|+\_s*α\|ホ\_s*\%(ン\|ス\_s*ゲ\_s*ン\)\|ヒ\_s*ロ\_s*ポ\_s*ン\|比\_s*\%(布\|律\_s*賓\)\|フ\_s*\%(リ\_s*ジ\_s*ア\_s*ン\|レ\_s*\%(ー\_s*\%(ズ\|ジ\_s*ン\_s*グ\)\|イ\_s*ジ\_s*ン\_s*グ\)\|タ\_s*レ\_s*イ\_s*ン\|ォ\_s*\%([ーンノト]\|ボ\_s*ス\|ビ\_s*ア\|ス\_s*フ\_s*ァ\_s*ー\|ニ\_s*ー\)\|ァ\_s*\%(イ\|ラ\_s*オ\|ー\_s*\%([ジマ]\|ミ\_s*ン\_s*グ\)\|ン\_s*\%(ト\_s*ム\|タ\_s*ズ\_s*[ムマ]\)\|ル\_s*[ツス]\|レ\_s*ノ\_s*プ\_s*シ\_s*ス\)\|ィ\_s*\%([ロル]\|ジ\_s*\%(ッ\_s*ク\_s*ス\|カ\_s*ル\)\|ー\_s*ビ\_s*ー\|ッ\_s*シ\_s*ン\_s*グ\|レ\_s*モ\_s*ン\|ラ\_s*デ\_s*ル\_s*フ\_s*ィ\_s*ア\|リ\_s*\%([スーアパ]\|ッ\_s*[プパ]\|ピ\_s*\%(ン\|ー\_s*ヌ\)\)\)\|ェ\_s*\%(ー\_s*\%([ベズ]\|ジ\_s*ン\_s*グ\)\|イ\_s*ズ\|ロ\_s*モ\_s*ン\|ニ\_s*\%(ル\|ッ\_s*ク\_s*ス\|キ\_s*ア\|ー\_s*ル\)\|ノ\_s*\%(キ\_s*シ\|ー\_s*ル\)\)\)\|述\_s*語\|証\_s*明\|タ\_s*ン\_s*パ\_s*ク\_s*質\|処\_s*理\|手\_s*続\_s*き\|進\_s*行\|算\_s*譜\|利\_s*潤\|南\_s*瓜\|公\_s*告\|宣\_s*伝\|真\_s*珠\|Ｐ\_s*\%(波\|Ｌ\_s*法\|Ｃ\_s*\%(／\_s*Ａ\_s*Ｔ\|９\_s*８\|モ\_s*デ\_s*ル\)\|ｏ\_s*ｓ\_s*ｔ\_s*Ｓ\_s*ｃ\_s*ｒ\_s*ｉ\_s*ｐ\_s*ｔ\|Ｓ\_s*．\|．\_s*Ｓ\_s*．\|ｉ\_s*ｔ\_s*Ｉ\_s*ｎ\_s*ｎ\|ｒ\_s*ｏ\_s*\%(ｌ\_s*ｏ\_s*ｇ\|ｔ\_s*ｅ\_s*ｏ\_s*ｎ\)\|ｅ\_s*ｒ\_s*\%(ｌ\|ｉ\_s*ｏ\_s*ｄ\)\)\|永\_s*続\|カ\_s*リ\_s*ウ\_s*ム\|葡\_s*萄\_s*牙\|重\_s*合\_s*体\|多\_s*相\_s*型\|バ\_s*テ\_s*レ\_s*ン\|貼\_s*り\_s*付\_s*け\|論\_s*文\|偏\_s*執\_s*[狂病]\|引\_s*数\|P\_s*\%([umdCaor]\|K\_s*戦\|D\_s*F\_s*フ\_s*ァ\_s*イ\_s*ル\|コ\_s*ー\_s*ド\|タ\_s*イ\_s*ル\|\.\_s*S\_s*\.\|S\_s*\%(\.\|Y\_s*・\_s*S\)\|I\_s*C\_s*マ\_s*イ\_s*コ\_s*ン\|l\_s*\%(a\_s*t\_s*i\_s*n\_s*u\_s*m\|u\_s*t\_s*o\_s*n\_s*i\_s*u\_s*m\)\|E\_s*T\_s*ボ\_s*ト\_s*ル\|O\_s*S\_s*\%(シ\_s*ス\_s*テ\_s*ム\|I\_s*X\|T\_s*メ\_s*ソ\_s*ッ\_s*ド\)\|e\_s*\%(r\_s*l\|n\_s*\%(t\_s*\%(o\_s*x\_s*y\_s*l\_s*i\_s*d\_s*a\_s*e\|i\_s*u\_s*m\)\|n\_s*s\_s*y\_s*l\_s*v\_s*a\_s*n\_s*i\_s*a\)\)\|h\_s*o\_s*s\_s*p\_s*h\_s*o\_s*r\_s*u\_s*s\)\|リ\_s*ン\)',
      \ 'q' : '\%([配椪栩櫪椢檪椡橡椚湫櫟含纐柵婚屎糞癖潛潜鵠裹凹窪馘括縊踵跟軛頚珞頸首諄窟鞋履寛狐轡覆靴沓碎砕管条降件頽崩屑葛釘莖茎陸杙株杭掘崛倔鶏鐃藥擽薬樟楠酒髪梳櫛串釧與与挫籖鯀鯨鬮籤隈熊艸嚔藾叢鏈腐鎖種ξΞ臭日茸菌楔草圀邦國国髭嗽漱吻喙嘴脣唇蛇梔劫刧腔φ　空粂皹勳熏裙醺桾皸下薫燻訓勲葷君委钁精詳企鍬加咥銜桑塊某暝競峅眛昏晦罔冥鮓比較闇位鞍藏暗倉廚厨涅〃仝ヽゞヾ々ゝ曇雲蜘栗狂包俥車廓曲郭梍枢踝畔鉄鐵★●■玄蔵黒玖柧供喰苦九枸鳩煦悔焼功倶狗来拘徠吼刳工絎駒朽眩垢口屈窶駈区劬繰呉宮暮貢久嶇來矩奇鉤９酌庫惧躯組衢紅食句吁懼區桍孔驅駆怐瞿汲ｸくｑ”‘’“♪ケ？ク¶q]\|ｯ\_s*ｸ\|ッ\_s*ク\|っ\_s*く\|姑\_s*娘\|箜\_s*篌\|救\_s*世\|莎\_s*草\|傀\_s*儡\|被\_s*下\_s*度\|百\_s*[濟済]\|果\_s*物\|恭\_s*敬\|長\_s*月\|9\_s*月\|秧\_s*鶏\|究\_s*竟\|釉\_s*掛\|典\_s*薬\_s*寮\|天\_s*鼠\_s*矢\|L\_s*a\_s*u\_s*r\_s*\%(a\_s*c\_s*e\_s*a\_s*e\|o\_s*i\_s*d\_s*e\_s*a\_s*e\)\|探\_s*湯\|誓\_s*湯\|球\_s*磨\|六\_s*合\|地\_s*祇\|都\_s*子\|州\_s*光\|山\_s*梔\_s*子\|崑\_s*央\|群\_s*衆\|慈\_s*姑\|旧\_s*\%(訳\|唐\_s*書\)\|c\_s*r\_s*e\_s*s\_s*c\|水\_s*[鶏母]\|海\_s*月\|内\_s*蔵\_s*助\|K\_s*r\|H\_s*e\_s*l\_s*l\_s*e\_s*b\_s*o\_s*r\_s*o\_s*i\_s*d\_s*e\_s*a\_s*e\|公\_s*\%([家方卿界美事文]\|出\_s*挙\)\|佝\_s*僂\_s*病\|J\_s*u\_s*g\_s*l\_s*a\_s*n\_s*d\_s*a\_s*l\_s*e\_s*s\|胡\_s*桃\|C\_s*\%(r\|h\_s*r\_s*o\_s*m\_s*i\_s*u\_s*m\)\|R\_s*h\_s*a\_s*m\_s*n\_s*a\_s*l\_s*e\_s*s\|Ｑ\_s*＆\_s*Ａ\|珠\_s*穆\_s*朗\_s*瑪\|チ\_s*ョ\_s*モ\_s*ラ\_s*ン\_s*マ\|Q\_s*\%(I\_s*C\|R\_s*コ\_s*ー\_s*ド\|C\_s*サ\_s*ー\_s*ク\_s*ル\|U\_s*O\_s*カ\_s*ー\_s*ド\)\|『\_s*』\|コ\_s*\%(ー\_s*ラ\_s*ン\|ン\_s*テ\_s*ィ\_s*フ\_s*ァ\_s*イ\_s*ア\)\|問\_s*合\_s*せ\|カ\_s*\%(ザ\_s*ン\|タ\_s*ー\_s*ル\|ス\_s*バ\|ー\_s*ヌ\_s*ー\_s*ン\|ナ\_s*ー\_s*ト\|ダ\_s*フ\_s*ィ\|リ\_s*テ\|ド\_s*リ\_s*ー\_s*[ユル]\|ル\_s*\%(チ\_s*[ェエ]\|テ\_s*\%(ィ\_s*エ\|ッ\_s*ト\)\)\|ン\_s*タ\_s*[ムスン]\)\|質\_s*問\|キ\_s*\%(ト\|ブ\_s*ラ\|ホ\_s*ー\_s*テ\|ハ\_s*ー\_s*ダ\|ル\_s*\%(ト\|テ\_s*ィ\_s*ン\_s*グ\)\|ー\_s*ン\|ノ\_s*ン\|ッ\_s*シ\_s*ュ\|ュ\_s*\%(ー\|エ\_s*リ\)\)\)',
      \ 'r' : '\%([ﾛ侖崙崘堽栄論祿漉轆碌肋勒麓禄鹿６録弄榔薐勞琅實樓焜瓏潦簍僂咾鑞柆螂臈槞瑯哢隴朖蘢螻滝朧壟撈臘郎瘻廊牢浪蝋癆聾楼篭籠狼漏朗轤瀘廬櫓櫨艪顱驢蕗鷺鹵蘆枦櫚炉輅艫滷臚爐賂髏ろﾚ洌澪蛉儷犁勵鴒齢苓綟砺囹糲唳聆〇蛎齡蠡黎羚戻禮祈隸茘麗玲隷伶癘励零冷例冽劣烈裂列靂檪癧轣鬲櫪瀝礫轢歴濂戀匳嗹奩斂鏈瀲漣鎌縺輦簾櫺∧聨憐恋蓮煉錬攣練聯廉連れﾙ♪路盧縲泪壘瘰誄涙羸塁累類縷璢鏤屡褸婁陋るﾘ犂篥葎率慄栗勠淕六戮陸律擽畧暦掠略澑苙嶐瀏鏐瑠窿餾鉚旒瘤畄霤嚠笠榴溜硫琉留立柳粒劉隆流躪藺醂痳棆懍鄰菻躙鈴廩麟P淪厘凜霖琳悋綸淋禀稟凛鱗倫吝隣林燐臨絽踉侶梠膂虜呂慮仂力緑魎粮獵靈粱裲倆怜輌鷯繆廖凉鬣椋楞崚嶺暸兩鐐蓼輛燎瞭聊陵令梁糧諒霊遼凌龍漁亮寮⇔涼撩繚綾療竜量菱僚領了寥稜喨両料閭旅璃籬履釐悧裏梨俚里離浬莅驪痢李哩罹俐漓吏利裡詈理莉りﾗΛλ婪儖繿纜嬾覧瀾臠亂檻欒欖攬籃襴巒覽襤懶爛藍鸞卵濫闌嵐欄乱蘭労剌溂老埓埒猟辣薤喇珞樂犖絡駱酪烙楽落洛徠醴罍櫑耒賚蕾籟擂儡莱磊癩來礼雷頼来螺拉裸們良蘿騾等邏鑼らｒ右→ДжАГБФдзъЧйёЗкНЖьЭцТУСвюЮЁЯЪЛВбХМмЦоынИэа露епЕЬКПЩсчщя魯ШглушЫхОитфЙ輪√根羅ロ々ラルレリРρрΡr]\|ｯ\_s*[ﾛﾚﾙﾘﾗ]\|ッ\_s*[ロレルリラ]\|っ\_s*[ろれるりら]\|鱸\_s*魚\|芦\_s*[有花]\|濾\_s*[胞過紙]\|水\_s*無\_s*月\|6\_s*[時月]\|檸\_s*檬\|坩\_s*堝\|C\_s*\%(a\_s*l\_s*y\_s*c\_s*a\_s*n\_s*t\_s*h\_s*a\_s*c\_s*e\_s*a\_s*e\|h\_s*o\_s*r\_s*i\_s*p\_s*e\_s*t\_s*a\_s*l\_s*a\_s*e\)\|A\_s*\%(c\_s*t\_s*a\_s*e\_s*a\|p\_s*o\_s*p\_s*e\_s*t\_s*a\_s*l\_s*a\_s*e\)\|鯉\_s*[魚城]\|二\_s*\%(索\|翻\_s*縛\)\|V\_s*e\_s*r\_s*t\_s*i\_s*c\_s*i\_s*l\_s*l\_s*a\_s*t\_s*a\_s*e\|O\_s*r\_s*c\_s*h\_s*i\_s*d\_s*a\_s*l\_s*e\_s*s\|M\_s*i\_s*c\_s*r\_s*o\_s*s\_s*p\_s*e\_s*r\_s*m\_s*a\_s*e\|L\_s*\%([ruia]\|e\_s*i\_s*t\_s*n\_s*e\_s*r\_s*i\_s*a\_s*l\_s*e\_s*s\|A\_s*N\_s*ケ\_s*ー\_s*ブ\_s*ル\)\|海\_s*獺\|G\_s*\%(e\_s*n\_s*t\_s*i\_s*a\_s*n\_s*a\_s*l\_s*e\_s*s\|y\_s*\%(n\_s*a\_s*n\_s*d\_s*r\_s*a\_s*e\|m\_s*n\_s*o\_s*s\_s*p\_s*e\_s*r\_s*m\_s*a\_s*e\)\)\|関\_s*係\_s*デ\_s*ー\_s*タ\_s*ベ\_s*ー\_s*ス\|数\_s*理\_s*解\_s*析\_s*研\_s*究\_s*所\|京\_s*都\_s*大\_s*学\_s*数\_s*理\_s*解\_s*析\_s*研\_s*究\_s*所\|東\_s*北\_s*大\_s*\%(通\_s*研\|学\_s*電\_s*気\_s*通\_s*信\_s*研\_s*究\_s*所\)\|電\_s*気\_s*通\_s*信\_s*研\_s*究\_s*所\|限\_s*定\_s*命\_s*令\_s*セ\_s*ッ\_s*ト\_s*計\_s*算\_s*機\|範\_s*囲\|規\_s*則\|紅\_s*玉\|要\_s*求\|検\_s*索\|復\_s*帰\|返\_s*[信事]\|拒\_s*否\|反\_s*射\_s*鏡\|参\_s*\%(考\_s*文\_s*献\|照\_s*型\)\|Ｒ\_s*\%(Ｉ\_s*Ｎ\_s*Ａ\|＆\_s*Ｄ\|Ｓ\_s*−\_s*２\_s*３\_s*２\_s*Ｃ\|ｕ\_s*ｍ\_s*ｂ\_s*ｌ\_s*ｅ\|ｅ\_s*ｎ\_s*ｏ\)\|機\_s*能\_s*回\_s*復\_s*訓\_s*練\|再\_s*帰\_s*的\|認\_s*識\|R\_s*\%([bnfeauh]\|i\_s*c\_s*h\_s*a\_s*r\_s*d\_s* \_s*M\_s*\.\_s* \_s*S\_s*t\_s*a\_s*l\_s*l\_s*m\_s*a\_s*n\|C\_s*S\|S\_s*S\_s*リ\_s*ー\_s*ダ\|I\_s*S\_s*C\|A\_s*M\|O\_s*M\|E\_s*\%(M\_s*睡\_s*眠\|T\_s*U\_s*R\_s*N\_s*キ\_s*ー\|A\_s*D\_s*M\_s*E\)\)\|正\_s*規\_s*表\_s*現\|ア\_s*ー\_s*ル\)',
      \ 's' : '\%([ｿ似杣灌傍峙毓育具供備害底苑薗園儲貮酘妬埆埣譏讒詆誹謗濡外猝率喞熄仄息足促束測側赱澡鯵嗾掫筝竃裝弉髞瀧勦輳嗽搶蔟爭偬瘡窗菷葱剏梍壯竈譟崢蚤笊嫂薮雙帚叟諍屮滝槽贈湊箱艘愡甑箒艚抓燥樔奘懆歃孀窓踪匝噪遭艙爪糟莊倉怱曹匆淙繰宋漕簇槍躁鎗箏綜痩喪藻艸葬壮操掻掃奏蹌滄争草層創蒼叢僧走惣送叛乖抑諳某橇轌艝拵噂巽邨鱒忖蹲樽孫遜存尊損噌其反踈組粗租胙俎礎爼詛麁囎蔬姐塑甦疎副措訴愬疽酥逸鼡沮蘓徂沿阻齟疏祖鼠咀想祚そｾ芹鬩槧羶甎揃倩翦箋燹濺苫栫槫孱孅簽吮纖湶纎亘筌蟾磚荐茜綫箭舩喘錢專僊贍鐫仟旃痊涎巛銛饌僣氈韆籤沾刋擶舛牋阡濳籖癬潛筅殱殲闡釧賎餞羨顫甅竰糎¢陝銓踐閃潺遷銑栴川剪煽譫僉瞻践栓跣疝詮銭穿戰腺繊僭泉嬋淺擅鮮専潜扇浅蘚船線撰宣洗煎戦千忙伜倅逼蝉旋洩椄卩屑絏鱈泄攝紲緤薛褻浙竊℃窃拙摂接節楔淅蹐績蹠蓆籍磧跡跖關藉晰威迹瘠勣裼晢夕鶺潟碩惜析関席隻情甥躋貰淒婿嘶睛擠撕牲萋菁韲瀞穽齏筬晟掣腥逝惺旌蜻整靖誓制晴競急世堰攻脊丗勢畆糶瀬畝せｽ鯣鋭坐座李既已昴術辷全滑皇脛臑裾双英村選優営寸漱薦啌勸雪濯啜勧芒薄煤賺鼈捩筋頗丞輔佑亮甫祐介助蘇裔陶曽乃曾即則淳漁凉鑾篶漫硯雀涼鱸鮓鮨遊椙犂犁耒篦隙尽末眇縋管菅頽廢廃窘救掬寡尠糘粭菫速純鈴炭角墨隅】【鄒數菘陬雛芻嵩崇趨樞∝∫∠∞≫∧∋÷⇒∬∃∂∴±∩≒Δ¬∇×∀∈⌒≪≧≠∨∵⇔枢翆榱陲悴隹粹瘁帥騅萃邃錘捶忰誰醉遂膵燧彗綏錐穂炊翠⊥H吹粋推水酔睡掏鋤總巣直簾拗耡醋棲総過饐剃澄籔空透磨壽澂寿統梳喫栖棄据吸擂剥住好漉ｼ埀謐蕋蘂蕊痺褥茵鵐蔀鷸鴫入霑蔵嶌縞嶋島凋澀沫澁渋縛暫屡荵凌鎬忍慕簧舖↓襪健認随从啝從．舌扱罔θ虐Θ粃秕椎椣卓貎尿肉臠猪榻黙蜆楙誠茂成繁重鋪惻陣頻閾櫁樒汐鹽潮隰瑟嫉櫛蛭蟋疾隲漆躾膝失室沒鎭沈滴雫賤鎮靜顰尓爾確聢併◇◆鹿貭叱征質卯滋撓科品鬼錣鍜錏凝痼而拉設萎栞襞吝咳爲什導怪汁徴験著記印〇○』銀城代『報調蝨濕湿七僕笞楚霜臀退斥尻寫卸者炙冩柘舍暹諜喋煮這謝鯱奢赦捨瀉嚼抉決皙勺釋蜥爍鑠妁斫蹟刳昔芍酌爵折癪笏赤綽灼石尺借赭写鷓積舎車斜釈社蛛株麈諏洙殳娶娵鬚侏銖繻卒菽粥叔俶戚蓿倏蹙槭肅淑夙粛縮取珠殊趣恤蟀卆出鰍繍楢葺溲泅嗅楫酬逎遒緝岫螽萩鷲甃駲楸穐蹤讎售讐洲綉收驟囚舅姑蓚鞦脩輯醜習羞酋聚舟秀祝袖拾啾蒐収執衆襲愁就臭蹴週終褶州宗椶棕守朱撞種修周手首狩須儁皴悛惷蕣雋墫順蠢舜旬竣峻駿逡筍春瞬俊嗔蓁縉蔘鷏忱簪甄鷆寢岑畛矧疹槙齔臻娠譛譖哂脣袗怎晉瀋箴軫榛秦襯診鉐津駸讖紳斟唇針呻蜃賑芯瞋振殿侵辛薪晨辰震宸森伸愼眞慎寝晋身進審深親臣鍼心宍信神藷墅薯杵岨胥蜍黍渚砠處嶼且狙苜苴曙背塩緒枌雎蔗庶処所書暑誚聲橡奬觴舂蛸懾燮厰姓獎枩稍甞韶炒淞陞顳腫井摺嶂橸浹愴星升鍬樅嘗簫慯廂霎庠剿筱鬆秤政訟廠樵鷦礁邵餉愀妝璋湫艢劭峭殤梢將敞醤慫従逍倡竦爿牆墻薔笙樟装肖菖＜≦湘誦聳檣稱声裳（）蒋蕉嘯慴精霄鈔粧彰悚鏘悄蕭哨瀟焦憔匠鍾償瘴漿頌詔妾沼請衝薑唱庄渉奨牀娼床椒鉦荘翔抄宵傷踵召銷賞猩症昭燒猖昌少憧松捷紹晶尚象承證正将称焼笑照勝招消章詳証鐘硝掌省商昇穡屬稷嗇禝寔稙昃謖軾矚拭餝属燭贖色飾囑嘱織蝕式喰蜀殖初諸埴植食職砥姉摯誣侈髭肆仔及岐址梔咫贄沚旨誌資豕鷙凍厮粢齒雌耜枝齎領篩四祇嗤貲諮巵死強紙熾市師厶妛飼諡祗閇姿駟嗣趾此染締詞茲釶柿覗弛徙至屍嘴斯駛屎占啻之揣如閉錙糸絞孜尸滓獅瓷緊笥始泗咨觜只輜廝使敷恃思帋痴漬脂氏蚩時紫沁俟絲巳祉矢恣若賜次浸詩志識司弑笶翅謚示梓伺視緇自祠史試子痣滲茨肢歯幟祀施竢舐卮耆呰為芝阯しｻ杓雨寤鮫清鞘莢觸騷触椹鰆爽騒澤沢濬掠新攫渫杷浚更士桾申白素汕纉潸餐蒜衫讚粲芟爨鑚蠶戔嶄跚驂慘攅斬彡杉秋桑…≡簒纂鯢燦珊繖棧刪卅參蚕鑽算傘３▼▽贊3参賛O散惨産酸嘸摩遉樣彷碍妨様山漣貶蔑垂鮭叫仙鏥寞寥皺淋生鯆虱鯖捌偖扨偵宿禎貞定哘誘蝎蠍授皿祥桟匙簓障囁私篠支捧笹逧迫讃鐸蛹宛真碕嵜尖前崎魁遮峺哢囀候侍核実説俚了達逹暁叡聰敏諭慧哲知訓郷恵聡智悟理杆里小棹竿箚扎刹紮皐撮搜寒捜相主盛盞柧觚杯盃榮栄倒肴魚界阪堺境酒泝逆賢坂榊猿麾挟鷺拶撒擦颯先数察薩刷札綵衰縡偲腮樶責哉殺霽崔淬顋寨切洒纔碎晒犲濟凄砦灑釵靫悽摧倖豺呵苛幸猜塞蔡栽儕采齊財臍截載孥宰済齋犀際災柴賽菜砕採斉斎祭妻債催才細鰓裁歳最埼捉辟柞縒咋簀筰齪筴窄册槊酢嘖朔柵遡溯鑿索搾昨炸冊策錯櫻桜裟提砂乍去射狭狹紗刺唆曝柤蓑裂捺做梭磋褪銹荒插醒挫差莎削止冷早避些槎嵳嵯嗟沙娑然再渣蹉扠詐割咲注覚嗄茶螫簑瑣下左搓瑳冴寂鎖挿叉査佐作覺点冱錆さ√錫す／仕指製西　┓┐〆□■шШ上＃♯щЩ添∪日ｓ⊂⊆⊃⊇文静★☆＊標嗜青三聖土彩△▲悉署〜∽‘’┌┏集＼探§″性セサシソス秒σΣСсs]\|ｯ\_s*[ｿｾｽｼｻ]\|ッ\_s*[ソセスシサ]\|っ\_s*[そせすしさ]\|遽\_s*走\|蕎\_s*麦\|内\_s*障\|彼\_s*杵\|諷\_s*歌\|幾\_s*許\|錚\_s*[錚々]\|十\_s*\%(路\|露\_s*盤\)\|冬\_s*青\|微\_s*風\|虚\_s*言\|宙\_s*組\|夫\_s*[々夫]\|返\_s*田\|傴\_s*僂\|U\_s*m\_s*b\_s*e\_s*l\_s*l\_s*i\_s*f\_s*l\_s*o\_s*r\_s*a\_s*e\|台\_s*詞\|c\_s*e\_s*n\_s*t\_s*i\|妹\_s*尾\|嘲\_s*笑\|海\_s*象\|蒸\_s*[篭籠]\|魑\_s*魅\|凡\_s*て\|典\_s*侍\|季\_s*雄\|天\_s*[皇蛾]\|蘿\_s*蔔\|V\_s*i\_s*o\_s*l\_s*a\_s*l\_s*e\_s*s\|N\_s*y\_s*m\_s*p\_s*h\_s*a\_s*e\_s*\%(a\_s*c\_s*e\_s*a\_s*e\|o\_s*i\_s*d\_s*e\_s*a\_s*e\)\|夊\_s*繞\|隧\_s*道\|Ｃ\_s*\%(型\|言\_s*語\)\|老\_s*舗\|望\_s*潮\|飛\_s*沫\|L\_s*a\_s*\%(m\_s*i\_s*n\_s*a\_s*l\_s*e\_s*s\|b\_s*i\_s*a\_s*t\_s*a\_s*e\)\|埋\_s*葬\_s*虫\|幣\_s*原\|桎\_s*梏\|柳\_s*葉\_s*魚\|衣\_s*魚\|汚\_s*点\|蠹\_s*魚\|惠\_s*雄\|舗\_s*石\|磯\_s*城\|W\_s*i\_s*n\_s*t\_s*e\_s*r\_s*a\_s*c\_s*e\_s*a\_s*e\|倭\_s*文\|閑\_s*[谷か]\|云\_s*[云々]\|明\_s*\%(々\_s*後\_s*日\|明\_s*後\_s*日\)\|７\_s*月\|7\_s*月\|４\_s*[分月]\|4\_s*月\|羊\_s*[齒歯]\|I\_s*\%(l\_s*l\_s*i\_s*c\_s*i\_s*a\_s*c\_s*e\_s*a\_s*e\|s\_s*o\_s*p\_s*y\_s*r\_s*o\_s*i\_s*d\_s*e\_s*a\_s*e\)\|不\_s*[忍知]\|後\_s*\%([輪口志目]\|込\_s*み\)\|軍\_s*鶏\|香\_s*菜\|吃\_s*逆\|蝦\_s*蛄\|輸\_s*[出贏]\|隼\_s*[朗郎]\|笋\_s*[干羹]\|縦\_s*容\|睫\_s*毛\|翡\_s*翠\|東\_s*\%(雲\|海\_s*林\)\|Z\_s*i\_s*n\_s*g\_s*i\_s*b\_s*e\_s*r\_s*a\_s*l\_s*e\_s*s\|続\_s*\%(日\_s*本\_s*\%(紀\|後\_s*紀\)\|後\_s*撰\_s*和\_s*歌\_s*集\)\|髑\_s*髏\|匣\_s*鉢\|復\_s*習\|百\_s*日\_s*紅\|胡\_s*孫\_s*眼\|←\_s*→\|霰\_s*弾\|弥\_s*生\|懺\_s*\%(法\|悔\_s*懺\_s*悔\)\|流\_s*[離石]\|蠑\_s*螺\|覇\_s*王\_s*樹\|C\_s*\%([es]\|y\_s*c\_s*a\_s*d\_s*\%(i\_s*d\_s*a\_s*e\|o\_s*\%(p\_s*s\_s*i\_s*d\_s*a\|f\_s*i\_s*l\_s*i\_s*c\_s*a\_s*l\_s*e\_s*s\)\)\|h\_s*l\_s*o\_s*r\_s*a\_s*n\_s*t\_s*h\_s*a\_s*c\_s*e\_s*a\_s*e\|言\_s*語\|D\_s*店\|型\_s*肝\_s*炎\|a\_s*\%(s\_s*s\_s*y\_s*t\_s*h\_s*o\_s*i\_s*d\_s*e\_s*a\_s*e\|c\_s*t\_s*a\_s*l\_s*e\_s*s\)\)\|竹\_s*[篦刀筒]\|大\_s*角\_s*豆\|防\_s*人\|曩\_s*に\|向\_s*坂\|一\_s*昨\_s*\%(昨\_s*[年日]\|々\_s*[年日]\)\|實\_s*藤\|甘\_s*藷\|五\_s*月\|月\_s*代\|匂\_s*坂\|税\_s*所\|雑\_s*賀\|骰\_s*子\|P\_s*\%(a\_s*r\_s*i\_s*e\_s*t\_s*a\_s*l\_s*e\_s*s\|t\_s*e\_s*r\_s*i\_s*d\_s*o\_s*s\_s*p\_s*e\_s*r\_s*m\_s*\%(a\_s*l\_s*e\_s*s\|i\_s*d\_s*a\_s*e\)\|r\_s*i\_s*m\_s*u\_s*l\_s*a\_s*l\_s*e\_s*s\)\|A\_s*\%(p\_s*i\_s*a\_s*l\_s*e\_s*s\|r\_s*a\_s*l\_s*e\_s*s\|n\_s*t\_s*i\_s*m\_s*o\_s*n\_s*y\)\|瑞\_s*[典西]\|B\_s*\%(r\|シ\_s*ェ\_s*ル\)\|拡\_s*張\_s*子\|部\_s*分\|置\_s*換\|ア\_s*ン\_s*チ\_s*モ\_s*ン\|構\_s*造\_s*体\|D\_s*o\_s*n\_s*a\_s*t\_s*i\_s*o\_s*n\_s* \_s*A\_s*l\_s*p\_s*h\_s*o\_s*n\_s*s\_s*e\_s* \_s*F\_s*r\_s*a\_s*n\_s*c\_s*o\_s*i\_s*s\_s* \_s*d\_s*e\_s* \_s*S\_s*a\_s*d\_s*e\|M\_s*\%(e\_s*r\_s*c\_s*u\_s*r\_s*y\|u\_s*s\_s*a\_s*l\_s*e\_s*s\|a\_s*r\_s*q\_s*u\_s*i\_s*s\_s* \_s*d\_s*e\_s* \_s*S\_s*a\_s*d\_s*e\)\|加\_s*\%(之\|虐\_s*\%(淫\_s*乱\_s*症\|趣\_s*味\)\)\|T\_s*\%(e\_s*t\_s*r\_s*a\_s*c\_s*e\_s*n\_s*t\_s*r\_s*a\_s*c\_s*e\_s*a\_s*e\|i\_s*n\|h\_s*e\_s* \_s*S\_s*i\_s*m\_s*p\_s*l\_s*e\_s* \_s*A\_s*P\_s*I\_s* \_s*f\_s*o\_s*r\_s* \_s*e\_s*v\_s*e\_s*n\_s*t\_s*-\_s*b\_s*a\_s*s\_s*e\_s*d\_s* \_s*X\_s*M\_s*L\_s* \_s*p\_s*a\_s*r\_s*s\_s*i\_s*n\_s*g\)\|ケ\_s*イ\_s*素\|珪\_s*素\|計\_s*測\_s*自\_s*動\_s*制\_s*御\_s*学\_s*会\|ネ\_s*ッ\_s*ト\_s*サ\_s*ー\_s*ビ\_s*ス\|ザ\_s*\%(ッ\_s*ク\|ク\_s*セ\_s*ン\|ビ\_s*ー\_s*ネ\|ウ\_s*バ\_s*ー\|ワ\_s*ー\_s*ク\_s*ラ\_s*ウ\_s*ト\|ム\_s*ザ\|ル\_s*ツ\|イ\_s*\%([ルン]\|ラ\_s*ー\|デ\_s*ル\)\|ー\_s*\%([ルラ]\|メ\_s*ン\)\)\|意\_s*味\|ゼ\_s*ミ\|ナ\_s*ト\_s*リ\_s*ウ\_s*ム\|ゾ\_s*\%(ル\|ン\_s*デ\|ー\_s*\%(ム\|リ\_s*ン\_s*ゲ\_s*ン\)\|フ\_s*ィ\_s*ー\)\|ジ\_s*\%(ム\|ー\_s*\%([グク]\|メ\_s*ン\_s*[ズス]\)\|グ\_s*ム\_s*ン\_s*ト\|ン\_s*\%(メ\_s*ル\|グ\_s*シ\_s*ュ\_s*ピ\_s*ー\_s*ル\|テ\_s*ー\_s*ゼ\)\)\|Ｓ\_s*\%([席式]\|サ\_s*イ\_s*ズ\|Ｓ\_s*サ\_s*イ\_s*ズ\|ｍ\_s*ａ\_s*ｌ\_s*ｌ\_s*ｔ\_s*ａ\_s*ｌ\_s*ｋ\|ｐ\_s*ａ\_s*ｉ\_s*ｎ\|ｃ\_s*ｏ\_s*ｔ\_s*ｃ\_s*ｈ\|Ｕ\_s*Ｎ\|ｕ\_s*\%(ｎ\|ｐ\_s*ｅ\_s*ｒ\_s*Ａ\_s*ｓ\_s*ｃ\_s*ｉ\_s*ｉ\)\|Ｉ\_s*Ｃ\_s*Ｐ\_s*(\_s*S\_s*t\_s*r\_s*u\_s*c\_s*t\_s*u\_s*r\_s*e\_s* \_s*a\_s*n\_s*d\_s* \_s*I\_s*n\_s*t\_s*e\_s*r\_s*p\_s*r\_s*e\_s*t\_s*a\_s*t\_s*i\_s*o\_s*n\_s* \_s*o\_s*f\_s* \_s*C\_s*o\_s*m\_s*p\_s*u\_s*t\_s*e\_s*r\_s* \_s*P\_s*r\_s*o\_s*g\_s*r\_s*a\_s*m\_s*s\_s*)\|−\_s*ｅ\_s*ｘ\_s*ｐ\_s*ｒ\_s*ｅ\_s*ｓ\_s*ｓ\_s*ｉ\_s*ｏ\_s*ｎ\|Ｏ\_s*Ｎ\_s*Ｙ\_s* \_s*Ｎ\_s*Ｅ\_s*Ｗ\_s*Ｓ\|ｏ\_s*ｌ\_s*ａ\_s*ｒ\_s*ｉ\_s*ｓ\|ｙ\_s*ｓ\_s*Ｖ\)\|硫\_s*黄\|エ\_s*ス\|S\_s*\%([nrgmce式]\|G\_s*M\_s*L\|サ\_s*イ\_s*ズ\|S\_s*サ\_s*イ\_s*ズ\|F\_s*マ\_s*ガ\_s*ジ\_s*ン\|Q\_s*U\_s*A\_s*R\_s*E\_s* \_s*E\_s*N\_s*I\_s*X\|K\_s*\%(K\|Y\_s* \_s*P\_s*e\_s*r\_s*f\_s*e\_s*c\_s*T\_s*V\_s*!\)\|a\_s*\%(r\_s*\%(r\_s*a\_s*c\_s*e\_s*n\_s*i\_s*a\_s*l\_s*e\_s*s\|g\_s*e\_s*n\_s*t\_s*o\_s*d\_s*o\_s*x\_s*a\_s*c\_s*e\_s*a\_s*e\)\|m\_s*a\_s*r\_s*i\_s*u\_s*m\)\|M\_s*\%(プ\_s*レ\_s*イ\|ク\_s*ラ\_s*ブ\)\|P\_s*\%(レ\_s*コ\_s*ー\_s*ド\|A\_s*C\_s*E\_s*キ\_s*ー\)\|p\_s*\%(l\_s*u\_s*s\|e\_s*\%(r\_s*m\_s*a\_s*t\_s*o\_s*p\_s*h\_s*y\_s*t\_s*a\|c\_s*a\_s*l\_s*i\_s*t\_s*y\_s* \_s*S\_s*t\_s*o\_s*r\_s*e\_s* \_s*R\_s*e\_s*t\_s*a\_s*i\_s*l\_s*e\_s*r\_s* \_s*o\_s*f\_s* \_s*P\_s*r\_s*i\_s*v\_s*a\_s*t\_s*e\_s* \_s*L\_s*a\_s*b\_s*e\_s*l\_s* \_s*A\_s*p\_s*p\_s*a\_s*r\_s*e\_s*l\)\|a\_s*\%(t\_s*h\_s*i\_s*f\_s*l\_s*o\_s*r\_s*a\_s*e\|r\_s*c\)\)\|H\_s*I\_s*F\_s*T\_s*キ\_s*ー\|C\_s*S\_s*I\|T\_s*\%(k\|A\_s*R\)\|h\_s*u\_s*g\_s*a\_s*r\_s*t\_s* \_s*A\_s*s\_s*s\_s*o\_s*c\_s*i\_s*a\_s*t\_s*e\_s*s\_s* \_s*S\_s*y\_s*s\_s*t\_s*e\_s*m\_s* \_s*I\_s*n\_s*t\_s*e\_s*r\_s*f\_s*a\_s*c\_s*e\|A\_s*\%(P\|S\_s*I\)\|i\_s*\%(m\_s*p\_s*l\_s*e\_s* \_s*K\_s*a\_s*n\_s*a\_s* \_s*t\_s*o\_s* \_s*K\_s*a\_s*n\_s*j\_s*i\_s* \_s*c\_s*o\_s*n\_s*v\_s*e\_s*r\_s*s\_s*i\_s*o\_s*n\_s* \_s*p\_s*r\_s*o\_s*g\_s*r\_s*a\_s*m\|l\_s*i\_s*c\_s*o\_s*n\)\|t\_s*r\_s*o\_s*n\_s*t\_s*i\_s*u\_s*m\|o\_s*\%(u\_s*t\_s*h\_s* \_s*\%(D\_s*a\_s*k\_s*o\_s*t\_s*a\|C\_s*a\_s*r\_s*o\_s*l\_s*i\_s*n\_s*a\)\|l\_s*a\_s*r\_s*i\_s*s\|f\_s*t\_s*w\_s*a\_s*r\_s*e\_s* \_s*R\_s*e\_s*s\_s*e\_s*a\_s*r\_s*c\_s*h\_s* \_s*A\_s*s\_s*s\_s*o\_s*c\_s*i\_s*a\_s*t\_s*e\_s*,\_s*I\_s*n\_s*c\_s*\.\)\|u\_s*\%(n\|l\_s*f\_s*u\_s*r\)\)\)',
      \ 't' : '\%([ﾄ乕囚寅虎瀞侶舮靹供纜燭艫朋倶鞆輩讎讐伴共友巴沌惇丼飩團暾団遯燉遁豚鷄禽酉砦塞俘擒虜豐恍惚枢乏塒迚科咎篷笘攴苫鶏伽唱稱鄰隣朿棘刺整鎖處処所床享鴟鵄扉鳶嫁訥晨穐秋刻鴇鬨斎頓幄幃帷柮杤栃閼軣轟屆届咄吶凸世暁祀駿壽繁稔寿豊歳俊利敏年慝牘悳黷犢匿督徳涜∃得特磴稻鞜剳宕滕鬥纛櫂讀盜綯橦叨桶盪竇抖縢礑荅閙塘罩帑棹兜檮納亠嶋棠搨档嶝溏鞳夲蘯道黨酘陦榻樋梼沓涛朸淌篤吋擣萄釖鬧籘諮迯儻潼鐙嶌逗螳蟷稲■幢滔鼕掏當峠読饕疼淘濤籐董悼棟搭痘套＝豆燈桃韜遠統騰橈冬討骰祷藤灯島橙凍刀陶糖謄唐答投等桐兎砿外富止礪研閇觧疾莵梳穫融録問砥採飛杜賭翔留冨図熔人途登菟畄蠧泊戸跿荼蠹十蚪砺盗屠渡解取執溶睹兔脱妬鍍磨説摂覩鎔堵秉獲汢塗肚圖とﾃ瑛晃輝衒寺靦囀躔忝、鷆鷏碾巓，槙沾殄霑腆壥諂廛轉‥．：輾填甜奠顛纒癲恬殿纏覘展篆添梃輦輟鐡耋咥餮垤跌屮銕姪迭俶逖荻鏑狄糴廸笛覿擲迪滴轍的哲敵撤剔徹鐵鉄酲眤碵羝觝幀嚔嚏渟柢酊掟睇楴詆棣汀騁鵜叮遉釘弟碇剃蹄邸締梯悌訂程底偵廷遞逓抵牴呈艇鄭涕啼庭定低弖照てﾂ模幹劈聾列辛貫面液汁露冷錘舶紡系艷艶絃鉉寉橡剱劒釼劍劔剣弦蔓敦鶴幣兵鉗噤鶫償桓恆典恒常夙務勉努勤拙拐倹抓嬬撮詳審爪褄妻募角晦螺瞑円呟礫具粒辻辟罪捉捕閊把曹阜丘元首寮司官柄仕掴遣攫搏疲使窄莟蕾局壷壺坪綱繋壌蝪培霾戊己伝傳鐔翅翼鍔燕唾續約皷鼓続葛綴番栂槌縋弊費序潰終墜遂鎚椎追做殱殲捏繕傍旁創造作熟机佃蹲拒欟坏鴾槻月裹砲障躑榴謹慎筒愼恙包堤痛椄衝告點附撞繼津搗継嗣支突積尾漬詰尽通憑浸次盡攣連就接付つﾁ吃釁岐巷衢粽粡因杠契鵆児交腟帙膣些蟄N窒斉秩父捷矗筑築逐盟税力親邇誓迩近苣尖縮鏤塵朕珎趁抻鎭碪狆亭跛闖鴆砧椿枕鎮陳珍沈賃杖找摘茶嫡着潴儲豬箸紵竚躇瀦墸杼苧緒樗楮⊥陟飭敕捗稙躅猪勅著悵髫廳樢微聽鵈楪齠甼漲佻膓吊鼎趙迢萇誂廰澂脹疔輙昶糶蔦窕晁鬯塚輒雕挺凋帖掉停諜跳眺貼鐇澄提喋頭銚ー蝶暢帳丁牒重逃鳥張弔懲肇嘲徴兆釣聴彫潮町頂調庁貂腸超挑朝丶黜寵儔冑肘蟲惆鍮晝紬綢廚籌※冢丑胄稠酎紐鑄冲沖偸宙虫｝［｛］厨誅鋳紂仲註駐柱衷注籀昼抽中躓蜘踟褫魑夊黐笞黹池値夂輊治耻千薙家血岻痴散地稚遲知茅恥置穉緻致智遅乳禿癡馳ちﾀ便党屯椽榱架樽弛膤鰔蕩鱈盥戯俵袂保躊為樣様爲啗猯擔疸餤湍覃彖亶鄲靼綻站潭憺酖殫膽襌賺毯摶袒檀褝槫緞椴憚攤壇慱湯澹‡†蛋耽W旦痰啖坦眈反C嘆歎誕胆箪譚担淡鍛單短探貪単覊栲妙戲訊攜携尋訪比畴疇類民髱娯樂恃頼愉楽喩例譬激滾斃仆嵶垰殕倒嫋旅貍狸讃称賛敲蹈踏祟湛鬪戰斗戦闘彳佇叩疊疂疉畳箍鏨違互畉耕畊掌店棚到炭辿燵撻斬韃闥巽辰佐扶＋援相佑輔弼助襷髻椨誑胤種塔龍竜糜糺爛漂維伊理貞是直禎忠惟匡徒唯只窘嗜慥確鮹鱆胝凧蛸嶽哮誥茸英豪威毅猛笋筍酣雄健丈斌武靈彈珪承賚珠霊魂卵偶適環弾球玉丹謀莨束縱｜盾鬣奉楯蓼縦竪質城達館忽橘舘瀑薪滝瀧峪溪渓谿谷尭亨臣任集宇昂楼小剛恭岳洪喬嵩孚尚尊敬孝崇隆貴鷹竹篁簟寶財高寳宝但濯綰鐸倬澤拆柝擢柘戳啅擇鈬魄畜企啄磔匠巧択沢逞琢蓄度宅託卓謫托拓躰隶殆抬靆黛紿替滯體碓帶軆平駘擡逮腿当怠玳諦岱鯛對颱袋戴堆頽態苔滞待代帝貸隊褪胎帯体退泰大対足手斷垂佗闌経炊撓焚矯溜躱經咤食發朶薫詫誰他詑耐太強蛇起逹貯給堪長揉閉埀発断勃多澑岔截絶田立裁汰点夛侘建它賜たｔцЦ〜天時×型火土→吐都東上噸瓲┃│台表第木スジ∴Θθザ正ツ¨転透▲△▼▽トチ…・試端タт┝Τ┯┰┣┷┸┤┬┥┴┻┠τ┫┳├〒Т┨テt]\|ｯ\_s*[ﾄﾃﾂﾁﾀ]\|ッ\_s*[トテツチタ]\|っ\_s*[とてつちた]\|門\_s*渡\_s*り\|薯\_s*蕷\|船\_s*尾\_s*座\|公\_s*[明暁]\|倫\_s*[子明]\|邑\_s*中\|蜻\_s*蛉\|A\_s*c\_s*o\_s*n\_s*i\_s*t\_s*u\_s*m\|蜷\_s*局\|跡\_s*[絶切]\|蜥\_s*蜴\|舎\_s*人\|馴\_s*鹿\|野\_s*老\|瓊\_s*脂\|永\_s*[遠久]\|宿\_s*直\|朱\_s*鷺\|左\_s*見\_s*右\_s*見\|朽\_s*木\|H\_s*y\_s*d\_s*r\_s*o\_s*c\_s*h\_s*a\_s*r\_s*i\_s*t\_s*a\_s*l\_s*e\_s*s\|独\_s*鈷\|季\_s*[衣道栄]\|聡\_s*[明徳]\|祈\_s*年\_s*祭\|淑\_s*[夫子]\|洞\_s*爺\|光\_s*男\|晧\_s*史\|紅\_s*娘\|瓢\_s*虫\|F\_s*e\|I\_s*r\_s*o\_s*n\|劇\_s*村\|滌\_s*除\|２\_s*×\_s*４\|悪\_s*阻\|石\_s*\%(蕗\|竜\_s*子\)\|心\_s*[太算]\|自\_s*\%(摸\|模\_s*和\)\|氷\_s*柱\|倩\_s*々\|黴\_s*雨\|入\_s*梅\|梅\_s*雨\|再\_s*見\|悉\_s*に\|備\_s*に\|旋\_s*[風毛]\|B\_s*a\_s*l\_s*a\_s*n\_s*o\_s*p\_s*h\_s*o\_s*r\_s*a\_s*l\_s*e\_s*s\|１\_s*\%(日\|０\_s*日\)\|朔\_s*日\|1\_s*\%(日\|0\_s*日\)\|美\_s*人\_s*局\|E\_s*\%(u\_s*p\_s*h\_s*o\_s*r\_s*b\_s*i\_s*a\_s*l\_s*e\_s*s\|r\_s*i\_s*c\_s*a\_s*l\_s*e\_s*s\)\|字\_s*\%(牌\|一\_s*色\)\|少\_s*と\|義\_s*父\|主\_s*[殿税]\|周\_s*夫\|睦\_s*子\|渠\_s*睦\_s*子\|萵\_s*苣\|身\_s*柱\|似\_s*指\|清\_s*\%(老\_s*頭\|一\_s*色\)\|青\_s*\%([幇島]\|梗\_s*菜\|椒\_s*肉\_s*絲\)\|全\_s*帯\|昌\_s*洙\|J\_s*i\_s*a\_s*n\_s*g\_s*s\_s*u\|江\_s*蘇\|焼\_s*豚\|叉\_s*焼\|察\_s*哈\_s*爾\|餃\_s*子\|雑\_s*砕\|炒\_s*[麺飯]\|北\_s*谷\|甘\_s*露\_s*子\|錯\_s*和\|総\_s*角\|一\_s*[日寸]\|植\_s*字\|魚\_s*[屋蝨]\|金\_s*魚\_s*蝨\|草\_s*石\_s*蚕\|春\_s*\%(麗\|宮\_s*坊\)\|九\_s*\%(十\_s*九\|連\_s*宝\_s*[灯燈]\)\|揺\_s*蕩\|容\_s*易\|白\_s*痴\|猶\_s*豫\|蜑\_s*民\|段\_s*銭\|蒲\_s*公\_s*英\|騨\_s*州\|M\_s*\%(e\_s*n\_s*i\_s*s\_s*p\_s*e\_s*r\_s*m\_s*a\_s*c\_s*e\_s*a\_s*e\|o\_s*n\_s*o\_s*\%(p\_s*e\_s*t\_s*a\_s*l\_s*a\_s*e\|c\_s*\%(h\_s*l\_s*a\_s*m\_s*y\_s*d\_s*e\_s*a\_s*e\|o\_s*t\_s*y\_s*l\_s*e\_s*d\_s*o\_s*n\_s*e\_s*a\_s*e\)\)\)\|仮\_s*令\|打\_s*[擲坐]\|七\_s*\%(夕\|対\_s*子\)\|活\_s*計\|方\_s*便\|無\_s*料\|黄\_s*\%(昏\|蜀\_s*葵\)\|章\_s*魚\|胼\_s*胝\|P\_s*\%(\.\_s*S\_s*\.\|o\_s*l\_s*y\_s*\%(g\_s*o\_s*n\_s*a\_s*l\_s*e\_s*s\|c\_s*a\_s*r\_s*p\_s*i\_s*c\_s*a\_s*e\)\|a\_s*n\_s*d\_s*a\_s*n\_s*a\_s*l\_s*e\_s*s\)\|壮\_s*聡\|煙\_s*草\|殺\_s*陣\|賢\_s*明\|性\_s*質\|怱\_s*ち\|亢\_s*ぶ\|堂\_s*子\|学\_s*聡\|能\_s*[文之]\|内\_s*匠\|松\_s*明\|奈\_s*子\|幇\_s*間\|切\_s*符\|デ\_s*ィ\_s*ス\|３\_s*ｒ\_s*ｄ\|閾\_s*値\|ソ\_s*\%(ー\_s*[トンプ]\|ロ\_s*ー\)\|ヘ\_s*ー\_s*グ\|ゼ\_s*[インムア]\|セ\_s*\%(オ\|ル\_s*マ\|ロ\_s*\%(ン\|ニ\_s*ア\_s*ス\)\|ラ\_s*ピ\_s*\%(ー\|ス\_s*ト\)\)\|シ\_s*\%(ン\|ッ\_s*ク\|ス\_s*ル\|ア\_s*タ\_s*ー\|ソ\_s*ー\_s*ラ\_s*ス\|オ\_s*ド\_s*ア\|ー\_s*[フタ]\)\|サ\_s*\%([イム]\|ミ\_s*ン\_s*グ\|ウ\_s*ザ\_s*ン\_s*ド\|ラ\_s*ブ\_s*レ\_s*ッ\_s*ド\|ー\_s*\%([ドモ]\|テ\_s*ィ\|ス\_s*ト\_s*ン\|ズ\_s*デ\_s*[イィー]\|マ\_s*ル\)\|ッ\_s*チ\_s*ャ\_s*ー\|ン\_s*\%(ク\|ダ\_s*ー\|キ\_s*ュ\_s*ー\)\|リ\_s*ド\_s*マ\_s*イ\_s*ド\)\|ポ\_s*リ\_s*ペ\_s*プ\_s*チ\_s*ド\|三\_s*\%(和\_s*土\|連\_s*文\_s*字\)\|\\\_s*T\_s*e\_s*X\|文\_s*字\_s*列\|教\_s*科\_s*書\|用\_s*語\|電\_s*\%([視話]\|気\_s*通\_s*信\_s*研\_s*究\_s*所\)\|Ｔ\_s*\%([字ｉ]\|細\_s*胞\|Ｋ\_s*８\_s*０\|ゾ\_s*ー\_s*ン\|バ\_s*ッ\_s*ク\|シ\_s*ャ\_s*ツ\|Ｖ\_s*\%(ニ\_s*ュ\_s*ー\_s*ス\|ゲ\_s*ー\_s*ム\|ド\_s*ラ\_s*マ\|ア\_s*ニ\_s*メ\)\|Ｃ\_s*Ｐ\_s*／\_s*Ｉ\_s*Ｐ\|ａ\_s*ｇ\|ｒ\_s*ｕ\_s*ｅ\_s*Ｔ\_s*ｙ\_s*ｐ\_s*ｅ\|E\_s*Ｘ\|ｅ\_s*[Ｘｌ]\)\|T\_s*\%([bc字mliahe]\|r\_s*i\_s*m\_s*e\_s*n\_s*i\_s*a\_s*c\_s*e\_s*a\_s*e\|u\_s*n\_s*g\_s*s\_s*t\_s*e\_s*n\|ゾ\_s*ー\_s*ン\|X\_s*T\_s*フ\_s*ァ\_s*イ\_s*ル\|シ\_s*ャ\_s*ツ\|バ\_s*ッ\_s*ク\|V\_s*\%(ニ\_s*ュ\_s*ー\_s*ス\|ゲ\_s*ー\_s*ム\|ド\_s*ラ\_s*マ\|モ\_s*ニ\_s*タ\|ア\_s*ニ\_s*メ\|シ\_s*ョ\_s*ッ\_s*ピ\_s*ン\_s*グ\)\|C\_s*P\|コ\_s*ー\_s*ド\|-\_s*C\_s*o\_s*d\_s*e\|O\_s*E\_s*I\_s*C\|A\_s*\%(C\|I\_s*N\_s*S\|B\_s*キ\_s*ー\)\|E\_s*L\)\)',
      \ 'u' : '\%([ｳ孳蛤礼敬恭洞鱗愛潤煩騒粳漆閏患慯悄恙騷愁呻楳梅嫐釉噂褞吽曇紜耘黄云繧慍蘊薀暈運錙怏麗羨卦憾怨恨占卜末嬉心裏浦糶瓜汝己畦疇畆畴畝疎踈宜諾奪姥腕莵兔驢鑿穿嗽魘唸促令項頷訴鷽獺嘯嘘蠢蠕動覘窺伺海萼台詠謌唱唄宴讌転詩謠謳謡疑歌葎鯏鴬鶯ヱゑゐヰ鶉疼堆踞蹲渦舂臼碓羅薄筌食槽朮肯凵魚巧茨廏廐厩鰻午甘秣孫餞馬旨蔚寫暎冩遷噐器移慈俯映写現虚美笂靭靱靫空鰾萍初蛆雲氏上後喪艮丑潮牛裡鬱欝中袿梁家内紆嫗羽打禹請浮攴得雨有飢熟于埋倦鵜迂生賣挧受撃泛傴憂茹射膿売撲菟盂搏齲右胡承卯攵績産芋討夘兎植饂宇享失烏うｕ¨↑∪уウΥυУUu]\|武\_s*漢\|狼\_s*狽\|夏\_s*枯\_s*草\|蟒\_s*蛇\|蠎\_s*蛇\|譫\_s*言\|琅\_s*珠\|温\_s*[麺気州]\|C\_s*u\_s*c\_s*u\_s*r\_s*b\_s*i\_s*t\_s*a\_s*l\_s*e\_s*s\|自\_s*惚\|采\_s*女\|乳\_s*母\|姨\_s*捨\_s*山\|独\_s*活\|優\_s*\%(婆\_s*[塞夷]\|曇\_s*華\)\|合\_s*格\|親\_s*族\|斥\_s*候\|泡\_s*沫\|雅\_s*楽\_s*[頭寮]\|楽\_s*官\|干\_s*莉\|維\_s*納\|太\_s*秦\|護\_s*田\_s*鳥\_s*尾\|淡\_s*\%(青\|口\_s*醤\_s*油\)\|五\_s*\%(加\|月\_s*蝿\)\|稲\_s*魂\|誓\_s*約\|石\_s*\%(女\|斑\_s*魚\)\|不\_s*生\_s*女\|味\_s*酒\|苜\_s*蓿\|A\_s*r\_s*i\_s*s\_s*t\_s*o\_s*l\_s*o\_s*c\_s*h\_s*i\_s*a\_s*\%(c\_s*e\_s*a\_s*e\|l\_s*e\_s*s\)\|伝\_s*染\|呆\_s*気\_s*者\|茴\_s*香\|外\_s*郎\|餓\_s*\%(死\|え\_s*死\_s*に\)\|裲\_s*襠\|団\_s*扇\|イ\_s*ギ\_s*リ\_s*ス\|オ\_s*マ\_s*ル\|識\_s*別\_s*不\_s*能\|共\_s*\%(用\_s*体\|有\_s*体\)\|ア\_s*\%([スン]\|グ\_s*リ\_s*ー\|ー\_s*\%(シ\_s*ュ\_s*ラ\|ジ\_s*ェ\_s*ン\_s*ト\|バ\_s*ン\)\|ル\_s*テ\_s*ィ\_s*メ\_s*ッ\_s*ト\|ポ\_s*ン\|ッ\_s*\%(プ\|パ\_s*ー\|シ\_s*ャ\_s*ー\)\)\|単\_s*\%(位\|一\_s*化\)\|Ｕ\_s*\%(ボ\_s*ー\_s*ト\|タ\_s*ー\_s*ン\|ネ\_s*ッ\_s*ク\|Ｎ\_s*Ｉ\_s*Ｘ\_s*\%(フ\_s*ェ\_s*ア\_s*ー\|マ\_s*ガ\_s*ジ\_s*ン\)\)\|ユ\_s*\%([タニー]\|ト\_s*\%(リ\_s*ロ\|レ\_s*ヒ\_s*ト\)\|リ\_s*\%(ア\|シ\_s*ー\_s*ズ\)\|プ\_s*シ\_s*ロ\_s*ン\|ネ\_s*ス\_s*コ\|ナ\_s*\%(カ\_s*イ\_s*ト\|イ\_s*テ\_s*ッ\_s*ド\)\|ビ\_s*キ\_s*\%(タ\_s*ス\|ノ\_s*ン\)\)\)',
      \ 'v' : '\%([ｖ：├値⊥版в↓В∨ヴv]\|ｯ\_s*ｳ\_s*ﾞ\|ッ\_s*ヴ\|っ\_s*ヴ\|ｳ\_s*ﾞ\|チ\_s*ェ\_s*ロ\|ヰ\_s*タ\| \_s*ビ\_s*ク\_s*ト\_s*ー\_s*ル\|視\_s*覚\|仮\_s*想\|ニ\_s*ス\|変\_s*数\|恒\_s*真\|ワ\_s*\%(デ\_s*ィ\_s*ム\|ギ\_s*ナ\|ニ\_s*ス\|セ\_s*リ\_s*ン\|ク\_s*チ\_s*ン\|ル\_s*キ\_s*ュ\_s*ー\_s*レ\|レ\_s*リ\_s*ー\|ー\_s*ニ\_s*ャ\)\|Ｖ\_s*\%(ｃ\|ゾ\_s*ー\_s*ン\|サ\_s*イ\_s*ン\|ネ\_s*ッ\_s*ク\|ゴ\_s*ー\_s*ル\|シ\_s*ネ\|リ\_s*ー\_s*グ\|ｉ\_s*ｅ\_s*ｗ\|ａ\_s*ｌ\_s*ｕ\_s*ｅ\|ｏ\_s*ｌ\_s*ｋ\_s*ｌ\)\|語\_s*彙\|ボ\_s*\%(ス\_s*ト\_s*ー\_s*ク\|ン\_s*ゴ\_s*レ\|ル\_s*\%([ガボトタ]\|テ\_s*\%(ッ\_s*ク\_s*ス\|ー\_s*[ジル]\)\)\|リ\_s*ュ\_s*ー\_s*ム\|ラ\_s*ン\_s*\%(チ\|テ\_s*ィ\_s*ア\|タ\_s*リ\_s*ー\)\|レ\_s*ー\|コ\_s*ー\_s*ダ\|ー\_s*\%([ントグ]\|ル\_s*ト\|ド\_s*ビ\_s*\%(ル\|リ\_s*ア\_s*ン\)\|パ\_s*ル\|ダ\_s*フ\_s*ォ\_s*ン\|カ\_s*\%(ル\|リ\_s*ス\_s*ト\)\)\|キ\_s*ャ\_s*ブ\_s*ラ\_s*リ\|イ\_s*\%([ドス]\|ジ\_s*ャ\_s*ー\|シ\_s*ン\_s*グ\)\)\|ヘ\_s*ッ\_s*ト\|冗\_s*長\_s*な\|垂\_s*直\|フ\_s*\%(ァ\_s*\%(ン\|ド\_s*ー\_s*ツ\)\|ォ\_s*\%(ン\|ル\_s*\%(ク\|カ\_s*ー\)\)\|ェ\_s*ル\_s*メ\_s*ー\_s*ル\)\|ウ\_s*\%(ラ\_s*\%(デ\_s*ィ\_s*ミ\_s*ー\_s*ル\|ジ\_s*\%(ー\_s*ミ\_s*ル\|ミ\_s*ー\_s*ル\|オ\_s*ス\_s*ト\_s*\%(ク\|ッ\_s*ク\)\)\)\|ィ\_s*\%(ン\_s*ナ\|ル\_s*ス\)\|ォ\_s*ッ\_s*カ\|イ\_s*\%(ル\_s*ス\|ン\_s*ナ\_s*ー\)\|ェ\_s*\%(ル\_s*ギ\_s*リ\_s*ウ\_s*ス\|ヌ\_s*ス\)\)\|ビ\_s*\%([アラブバスザ]\|ガ\_s*ー\|ハ\_s*ー\_s*ラ\|タ\_s*ミ\_s*ン\|レ\_s*\%(ッ\_s*ジ\|ロ\_s*イ\)\|ビ\_s*\%(ア\_s*ン\|ッ\_s*ド\)\|ッ\_s*\%(ク\|キ\_s*ー\)\|セ\_s*ン\_s*テ\|ク\_s*\%(タ\_s*ー\|ト\_s*\%(ル\|リ\_s*[ーア]\)\)\|シ\_s*\%(ャ\_s*ス\|ソ\_s*ワ\_s*ー\_s*ズ\)\|ン\_s*\%([チス]\|ソ\_s*ン\|テ\_s*ー\_s*ジ\|セ\_s*ン\_s*ト\)\|ネ\_s*\%(ガ\_s*ー\|グ\_s*レ\_s*ッ\_s*ト\)\|ニ\_s*\%([ール]\|リ\_s*デ\_s*ン\)\|ュ\_s*ー\|エ\_s*ン\_s*チ\_s*ャ\_s*ン\|ジ\_s*\%(ャ\|ッ\_s*ト\|タ\_s*ー\|ョ\_s*\%(ン\|ナ\_s*リ\_s*ー\)\|ュ\_s*ア\_s*\%(ル\|ラ\_s*イ\_s*\%(ズ\|ゼ\_s*ー\_s*シ\_s*ョ\_s*ン\)\)\)\|ダ\_s*ル\|デ\_s*オ\|ル\_s*\%(ゴ\|ヌ\_s*ー\_s*ブ\)\|オ\_s*ラ\|リ\_s*ジ\_s*ア\_s*ン\|ィ\_s*ー\_s*ナ\_s*ス\|ー\_s*\%(ボ\|ル\_s*ス\|ク\_s*ル\|ナ\_s*ス\)\)\|ベ\_s*\%([ガラン]\|ト\_s*ナ\_s*ム\|イ\_s*ダ\_s*ー\|ー\_s*\%(ル\|ダ\_s*ー\)\|テ\_s*ラ\_s*ン\|ッ\_s*セ\_s*ル\|ス\_s*\%([トタパ]\|ビ\_s*オ\)\|ク\_s*\%(タ\|ト\_s*ル\)\|ジ\_s*タ\_s*\%(ブ\_s*ル\|リ\_s*ア\_s*ン\)\|リ\_s*\%([ィー]\|フ\_s*ァ\_s*イ\|サ\_s*イ\_s*ン\)\|ロ\_s*\%(ナ\|シ\_s*テ\_s*ィ\|ー\_s*ナ\|ニ\_s*[カク]\)\|ル\_s*\%(デ\|ベ\_s*ッ\_s*ト\|ダ\_s*ン\|レ\_s*ー\_s*ヌ\|サ\_s*\%(ー\_s*チ\|イ\_s*ユ\)\|モ\_s*ッ\_s*ト\)\|ノ\_s*ム\|ニ\_s*[スヤア]\|ネ\_s*\%(シ\_s*ャ\_s*ン\|チ\_s*ア\|ツ\_s*ィ\_s*ア\|ズ\_s*エ\_s*ラ\)\)\|V\_s*\%(H\_s*L\_s*L\_s*(\_s*V\_s*e\_s*r\_s*y\_s* \_s*H\_s*i\_s*g\_s*h\_s* \_s*L\_s*e\_s*v\_s*e\_s*l\_s* \_s*L\_s*a\_s*n\_s*g\_s*u\_s*a\_s*g\_s*e\_s*)\|ゾ\_s*ー\_s*ン\|サ\_s*イ\_s*ン\|ネ\_s*ッ\_s*ク\|ゴ\_s*ー\_s*ル\|J\_s*E\_s*-\_s*β\|シ\_s*ネ\|リ\_s*ー\_s*グ\|I\_s*S\_s*A\_s*カ\_s*ー\_s*ド\|i\_s*r\_s*g\_s*i\_s*n\_s*i\_s*a\|A\_s*X\|e\_s*r\_s*\%(m\_s*o\_s*n\_s*t\|i\_s*S\_s*i\_s*g\_s*n\)\|a\_s*n\_s*a\_s*d\_s*i\_s*u\_s*m\)\|ブ\_s*\%(イ\|ラ\_s*\%(ド\|ッ\_s*ド\)\|ー\_s*ド\_s*ゥ\_s*ー\)\|バ\_s*\%([ルン]\|イ\_s*\%([アブンオ]\|パ\_s*ー\|タ\_s*\%(ル\|リ\_s*テ\_s*ィ\)\|キ\_s*ン\_s*グ\|ザ\_s*ー\|シ\_s*ャ\)\|ッ\_s*ト\|チ\_s*カ\_s*ン\|ギ\_s*ナ\|ガ\_s*ボ\_s*ン\_s*ド\|ラ\_s*\%(ナ\_s*シ\|エ\_s*テ\_s*ィ\)\|サ\_s*ロ\|ス\_s*\%(コ\|ケ\_s*ス\)\|カ\_s*ン\_s*ス\|ケ\_s*ー\_s*シ\_s*ョ\_s*ン\|キ\_s*ュ\_s*ー\_s*ム\|ウ\_s*チ\_s*ャ\_s*ー\|リ\_s*\%(ン\|エ\_s*ー\_s*シ\_s*ョ\_s*ン\|ュ\_s*ー\|ア\_s*\%(ブ\_s*ル\|ン\_s*ト\)\|ッ\_s*ド\|デ\_s*ー\_s*シ\_s*ョ\_s*ン\)\|ヌ\_s*ア\_s*ツ\|ニ\_s*\%(ラ\|ー\_s*ユ\)\|レ\_s*\%([ラー]\|ロ\_s*ン\|リ\_s*ー\|ン\_s*\%(シ\_s*ア\|チ\_s*ノ\|タ\_s*イ\_s*ン\)\)\|ー\_s*\%([ゴグ]\|チ\_s*ャ\_s*ル\|リ\_s*ト\_s*ゥ\_s*ー\_s*ド\|バ\_s*ル\|ボ\_s*ス\|ベ\_s*ナ\|テ\_s*ィ\_s*カ\_s*ル\|サ\_s*ス\|ジ\_s*\%(ン\|ニ\_s*ア\|ョ\_s*ン\)\|ノ\_s*ン\|ニ\_s*ア\|モ\_s*ン\_s*ト\|ミ\_s*\%(リ\_s*オ\_s*ン\|キ\_s*ュ\_s*ラ\_s*イ\_s*ト\)\)\|ナ\_s*\%(キ\_s*ュ\_s*ラ\_s*ー\|ジ\_s*ウ\_s*ム\)\)\)',
      \ 'w' : '\%([ｦヲ女翁緒牡小雄汚惜尾男をｳ孳蛤礼敬恭洞鱗愛潤騒粳漆閏慯悄恙騷愁呻楳梅嫐釉噂褞吽曇紜耘云繧慍蘊薀暈運錙怏麗羨U卦憾怨恨占卜末嬉心裏浦糶瓜汝己Υυ畦疇畆畴畝疎踈宜諾奪姥莵兔驢鑿穿嗽魘唸促令項頷訴鷽獺嘯嘘蠢蠕動覘窺伺萼台詠謌唱唄宴讌転詩謠謳謡疑歌葎鯏鴬鶯ヱゑ鶉疼堆踞蹲渦舂臼碓羅薄筌食槽朮肯凵魚巧茨廏廐厩鰻午甘秣孫餞馬旨蔚寫暎冩遷噐器移慈俯映写現虚美笂靭靱靫空鰾萍初蛆氏↑上後喪艮丑潮牛裡鬱欝中袿梁家内紆嫗打禹請浮攴得雨有飢熟于埋倦鵜迂生賣挧受撃泛傴憂茹射膿売撲菟盂搏齲右胡承卯攵績産芋討夘兎植饂宇享失烏うヰ居ゐﾜ叫喚惡÷悪原稿嗤妾蕨童藁鞋笑灣綰萬豌万弯彎椀雲腕碗湾横黄皇往羂罠毫纔微僅患煩伎術厄禍災態業技佗王鰐忘掖弁腋譯腸緜渉亙道航弥亘棉渡綿私隈薈賄淮脇矮猥歪轍海蟠儂∪解頒觧判訣別稚若或枠惑鷲沸詫輪和涌湧我吾把話侘杷訳破萵啝割倭環分琶羽わｗ幅水∧波ウワw]\|ｯ\_s*[ｦヱｳヰﾜ]\|ッ\_s*[ヲヱウヰワ]\|っ\_s*[をゑうゐわ]\|乎\_s*古\_s*止\_s*点\|武\_s*漢\|狼\_s*狽\|夏\_s*枯\_s*草\|蟒\_s*蛇\|蠎\_s*蛇\|譫\_s*言\|琅\_s*珠\|温\_s*[麺気州]\|C\_s*u\_s*c\_s*u\_s*r\_s*b\_s*i\_s*t\_s*a\_s*l\_s*e\_s*s\|自\_s*惚\|采\_s*女\|乳\_s*母\|姨\_s*捨\_s*山\|独\_s*活\|優\_s*\%(婆\_s*[塞夷]\|曇\_s*華\)\|合\_s*格\|親\_s*族\|斥\_s*候\|泡\_s*沫\|雅\_s*楽\_s*[頭寮]\|楽\_s*官\|干\_s*莉\|維\_s*納\|護\_s*田\_s*鳥\_s*尾\|淡\_s*\%(青\|口\_s*醤\_s*油\)\|五\_s*\%(加\|月\_s*蝿\)\|稲\_s*魂\|誓\_s*約\|石\_s*\%(女\|斑\_s*魚\)\|不\_s*生\_s*女\|味\_s*酒\|苜\_s*蓿\|A\_s*r\_s*i\_s*s\_s*t\_s*o\_s*l\_s*o\_s*c\_s*h\_s*i\_s*a\_s*\%(c\_s*e\_s*a\_s*e\|l\_s*e\_s*s\)\|伝\_s*染\|呆\_s*気\_s*者\|茴\_s*香\|外\_s*郎\|餓\_s*\%(死\|え\_s*死\_s*に\)\|裲\_s*襠\|団\_s*扇\|草\_s*鞋\|（\_s*笑\_s*）\|(\_s*笑\_s*)\|戦\_s*慄\|俳\_s*優\|勿\_s*忘\_s*草\|早\_s*[生稲]\|山\_s*葵\|戯\_s*奴\|度\_s*会\|Ｙ\_s*\%(軸\|シ\_s*ャ\_s*ツ\|染\_s*色\_s*体\)\|Y\_s*\%(軸\|シ\_s*ャ\_s*ツ\|染\_s*色\_s*体\)\|華\_s*盛\_s*頓\|裙\_s*蔕\_s*菜\|理\_s*[由解]\|公\_s*魚\|病\_s*葉\|大\_s*東\_s*亜\_s*戰\_s*爭\|太\_s*\%(秦\|平\_s*洋\_s*戦\_s*争\)\|歐\_s*州\_s*大\_s*戰\|第\_s*\%(二\_s*次\_s*世\_s*界\_s*大\_s*戦\|一\_s*次\_s*世\_s*界\_s*大\_s*戦\)\|ブ\_s*ル\_s*ツ\_s*ブ\_s*ル\_s*ク\|ロ\_s*ン\_s*グ\|レ\_s*\%(ン\|イ\_s*ス\|ッ\_s*カ\_s*ー\|ス\_s*\%(ラ\_s*ー\|リ\_s*ン\_s*グ\)\)\|リ\_s*\%(ー\_s*ス\|ン\_s*ク\_s*ル\|ス\_s*ト\)\|書\_s*き\_s*込\_s*み\|ラ\_s*\%(ッ\_s*\%([プパ]\|ピ\_s*ン\_s*グ\)\|イ\_s*\%([タト]\|テ\_s*ィ\_s*ン\_s*グ\)\)\|ボ\_s*ル\_s*フ\|フ\_s*\%([ムー]\|ァ\_s*イ\_s*ル\|ィ\_s*\%(ー\_s*ト\|ッ\_s*チ\)\)\|ホ\_s*\%(エ\_s*[ーイア]\|ー\_s*ル\|イ\_s*\%(ー\_s*\%(ル\|ラ\_s*ー\)\|ッ\_s*\%(プ\|ス\_s*ル\|パ\_s*ー\|ト\_s*\%(ニ\_s*ー\|マ\_s*ン\)\)\)\|ワ\_s*\%(イ\|ッ\_s*[トツ]\)\)\|ベ\_s*ル\_s*ナ\_s*ー\|W\_s*\%(S\|N\_s*N\|y\_s*o\_s*m\_s*i\_s*n\_s*g\|O\_s*W\_s*O\_s*W\|I\_s*\%(D\_s*E\|N\_s*T\_s*E\_s*R\_s*P\_s*(\_s*W\_s*i\_s*d\_s*g\_s*e\_s*t\_s* \_s*I\_s*n\_s*t\_s*e\_s*r\_s*p\_s*r\_s*e\_s*t\_s*e\_s*r\_s*)\)\|i\_s*\%(s\_s*c\_s*o\_s*n\_s*s\_s*i\_s*n\|d\_s*g\_s*e\_s*t\|n\_s*d\_s*o\_s*w\_s*s\)\|h\_s*\%(y\_s* \_s*d\_s*o\_s*n\_s*e\_s* \_s*i\_s*t\_s*?\|o\_s* \_s*d\_s*o\_s*n\_s*e\_s* \_s*i\_s*t\_s*?\)\|E\_s*B\_s*\%(ブ\_s*ラ\_s*ウ\_s*ザ\|マ\_s*ガ\_s*ジ\_s*ン\)\|e\_s*\%(s\_s*t\_s* \_s*V\_s*i\_s*r\_s*g\_s*i\_s*n\_s*i\_s*a\|b\_s*\%(ペ\_s*ー\_s*ジ\|ラ\_s*ジ\_s*オ\|コ\_s*ミ\_s*ッ\_s*ク\|サ\_s*\%(イ\_s*ト\|ー\_s*\%(バ\|ビ\_s*ス\)\)\|ド\_s*ラ\_s*マ\)\)\|a\_s*s\_s*h\_s*i\_s*n\_s*g\_s*t\_s*o\_s*n\|A\_s*V\_s*フ\_s*ァ\_s*イ\_s*ル\)\|警\_s*告\|Ｗ\_s*\%(杯\|ｎ\_s*ｎ\|ｉ\_s*ｎ\_s*ｋ\|ａ\_s*ｒ\_s*ｅ\)\|バ\_s*ル\_s*タ\_s*ー\|ヴ\_s*\%(ュ\_s*ル\_s*ツ\_s*ブ\_s*ル\_s*ク\|ォ\_s*ル\_s*フ\|ィ\_s*\%([ーム]\|ル\_s*\%(ム\|ヘ\_s*ル\_s*ム\)\)\|ェ\_s*\%(ン\_s*ダ\_s*ー\_s*ス\|ル\_s*ナ\_s*ー\|ー\_s*バ\_s*ー\|イ\_s*ユ\)\|ァ\_s*\%(イ\_s*[ンス]\|ー\_s*グ\_s*ナ\_s*ー\|ン\_s*ダ\|ル\_s*\%(タ\_s*ー\|キ\_s*ュ\_s*ー\_s*レ\)\)\)\|T\_s*\%(h\_s*e\_s* \_s*W\_s*o\_s*r\_s*l\_s*d\_s* \_s*W\_s*i\_s*d\_s*e\_s* \_s*W\_s*e\_s*b\_s* \_s*C\_s*o\_s*n\_s*s\_s*o\_s*r\_s*t\_s*i\_s*u\_s*m\|u\_s*n\_s*g\_s*s\_s*t\_s*e\_s*n\)\|ダ\_s*ブ\_s*リ\_s*ュ\_s*ー\|タ\_s*ン\_s*グ\_s*ス\_s*テ\_s*ン\)',
      \ 'x' : '\%([ｫォぉｪェぇｩゥぅｨィぃｧァぁｘξ×ХхΞx]\|ｯ\_s*[ｫｪｩｨｧ]\|ッ\_s*[ォェゥィァ]\|っ\_s*[ぉぇぅぃぁ]\|シ\_s*ロ\_s*\%(フ\_s*ォ\_s*ン\|ホ\_s*ン\)\|Ｘ\_s*\%([軸線]\|デ\_s*[イー]\|ｖ\_s*ｉ\_s*ｅ\_s*ｗ\|Ｓ\_s*サ\_s*イ\_s*ズ\|Ｌ\_s*\%(ｉ\_s*ｓ\_s*ｐ\|サ\_s*イ\_s*ズ\)\|ウ\_s*ィ\_s*ン\_s*ド\_s*ウ\|端\_s*末\)\|X\_s*\%([軸線]\|C\_s*o\_s*n\_s*s\_s*o\_s*r\_s*t\_s*i\_s*u\_s*m\|デ\_s*[イー]\|P\_s*S\_s*(\_s*e\_s*X\_s*p\_s*a\_s*n\_s*s\_s*i\_s*o\_s*n\_s* \_s*P\_s*a\_s*s\_s*s\_s*i\_s*n\_s*g\_s* \_s*S\_s*t\_s*y\_s*l\_s*e\_s*)\|S\_s*サ\_s*イ\_s*ズ\|l\_s*i\_s*b\|L\_s*\%(i\_s*s\_s*p\|サ\_s*イ\_s*ズ\)\|e\_s*n\_s*o\_s*n\)\|ジ\_s*オ\_s*ン\|ゼ\_s*\%(ビ\_s*ウ\_s*ス\|ロ\_s*\%(ッ\_s*ク\_s*ス\|グ\_s*ラ\_s*フ\_s*ィ\)\)\|ハ\_s*ビ\_s*エ\_s*ル\|ザ\_s*\%(ン\|ビ\_s*エ\_s*ル\)\|キ\_s*\%(シ\_s*\%(ロ\|レ\_s*ン\|リ\_s*ト\_s*ー\_s*ル\)\|セ\_s*ノ\_s*ン\|サ\_s*ン\_s*\%(チ\_s*ン\|タ\_s*ン\)\)\|E\_s*x\_s*t\_s*e\_s*n\_s*s\_s*i\_s*b\_s*l\_s*e\_s* \_s*M\_s*a\_s*r\_s*k\_s*u\_s*p\_s* \_s*L\_s*a\_s*n\_s*g\_s*u\_s*a\_s*g\_s*e\|ク\_s*\%(シ\_s*ー\|ロ\_s*ス\_s*ポ\_s*ス\_s*ト\|セ\_s*\%(ナ\_s*キ\_s*ス\|ノ\_s*フ\_s*ォ\_s*ン\)\|ザ\_s*ヴ\_s*ィ\_s*エ\|サ\_s*\%(イ\|ン\_s*\%(ト\_s*ス\|テ\_s*ィ\_s*ッ\_s*ペ\|チ\_s*ッ\_s*ペ\)\)\|リ\_s*ス\_s*マ\_s*ス\)\|エ\_s*\%(ク\_s*ス\|ッ\_s*ク\_s*ス\)\)',
      \ 'y' : '\%([ﾖ艾蒿蓬娵嫁齡齢據頼弱歓憙鎧万萬過便婚汚涎捩峪杙翊緘慾欲翌翼抑米比裝粧装澱淀縦誼祥葭悦宜克純圭禎葦慶淑禧美喜芳吉義癰穃慂踴遙榕幺怏曄陶甬瀁燿珱踊暘廱樣蓉恙慵泱姚雍癢瑶昜瘍痒孕窰謠漾鷹瓔煬邀遥拗擁瑤窯徭膺窈殀耀曜庸夭揚葉蛹腰羊熔杳沃壅様妖溶用佯謡陽洋嘉宵蘇甦蘓奸辟横攀豫世与酔縒輿読讀訓預與喚予醉誉余憑能４舁蕷四譱畭譽餘撚呼詠除選飫歟丗代避よﾕ潤赦緩弛聴岼閖梦努纈∴故濯檠穰豐豊倖志裄之幸雪趾梼讓譲牀紫縁浴床攸犹黝俑邑熊猷悒酉蝣蚰囿莠尢蕕佳尤佑〒右郵涌祐侑游猶湧融宥夕幽悠釉友雄憂有楡油諭瘉汰徃柚逾揺弓踰諛愉瑜臾渝遊結覦腴由兪喩揃蝓淘揄輸茹征搖ゆｲηΗ賤鄙卑苟嫌妹湯芋藷夢艷鑪鈩彩鱗色鯆忽綺貸甍答応愈圦杁茵胤飮寅尹婬贇韵隱蚓氤酳霪蔭堙湮吋廴I音慇韻咽淫殞姻隕院允隠殷陰窟巖巌頌祝鰮鰛鰯岩磐鼾歪弋弑抱懐肬贅疣狗戌乾犬諱在坐未汝戒誡警縛今Εε曰禾稻員因蝗印嘶鰍電引躄誘動≦忿鵤錨碇怒霆霹雷凧桴筏Ιι魚菴庵雖尿荊棘茨祈祷命豕猯古伍聿乙鎰鴪軼樹慈悼愴慯労格到至傷鼬頂戴徒致鈑痛板柞沙砂聊些潔諍烈功諫勳勇勲漁諌憇＝憩粹熱粋憤域閾勢勤忙急磯孰焉湶泉厳何弄苛≧鎔范啀毬訝燻息指挑拠絲縷厭營営愛幼緒遑暇糸Ｉ弌壹肆莓苺櫟著市碑鐓礎甃臀弩石牲犧犠池溢佚壱1１鬻毓燠礇粥的戦戰軍郁幾一稲許否飯違居矮ゐ猪五煎彝醫斐逶貽善胆位萎可詑僞鑄熬活容依要斎行怡異衣入逝猗胃洟好矣鋳揖椅去惟云懿熨痿射凍移将囗肄夷率囲姨慰頤忌唯緯逸噫挿鮪伊偽苡彜莞往以韋遺炒謂李生威為維意倚良如彙出淹言亥鰄井蔚痍圍幃渭堰饐医爲癒帷恚偉委詒畏いﾔ稚稍飲鎗鑓槍孀寡鰥Я碼傭雇闇敗吝藪薮殕脂寄宿櫓軈軅簗梁S漸鋏刃灸軟柔和窶鱧奴僕萢優柳喧宅館舘輩族鏃鑰≒籥繹譯葯蜴檪藥龠扼益厄疫躍約役訳薬疾岾疚楊谺邪薯豺犲《》〈〉山邸壥廛豢養社鑢育尉寧廉裕恭泰易休康保安靖妬已瘠弥辭埜辞家輻矢痩屋灼笶八罷冶焼破夜爺谷也殺⇒病耶演⇔野燒遣彌熄椰止哉揶やｙеЕ円￥→↑↓←Ёё─━ユヤヨыイЙYΥυЫйy]\|ｯ\_s*[ﾖﾕｲﾔ]\|ッ\_s*[ヨユイヤ]\|っ\_s*[よゆいや]\|歐\_s*羅\_s*巴\|欧\_s*羅\_s*巴\|尸\_s*童\|蹌\_s*踉\|蹣\_s*跚\|終\_s*夜\|4\_s*\%([項者つ日]\|番\_s*目\|種\_s*類\)\|他\_s*所\|仁\_s*史\|隆\_s*克\|尚\_s*武\|孝\_s*高\|悌\_s*也\|彬\_s*伯\|賀\_s*[子悟]\|栄\_s*伸\|新\_s*生\|昌\_s*[美男]\|宗\_s*生\|暢\_s*[子一]\|永\_s*沈\|８\_s*日\|8\_s*日\|黄\_s*泉\|左\_s*手\|百\_s*合\|L\_s*i\_s*l\_s*i\_s*\%(o\_s*p\_s*s\_s*i\_s*d\_s*a\|a\_s*\%(c\_s*e\_s*a\_s*e\|l\_s*e\_s*s\)\)\|Ｕ\_s*\%(字\|タ\_s*ー\_s*ン\)\|鞦\_s*韆\|強\_s*請\|梅\_s*桃\|桜\_s*桃\|靫\_s*負\|宙\_s*美\|礼\_s*暁\|温\_s*\%(雄\|泉\_s*津\)\|長\_s*庚\|昨\_s*夜\|又\_s*木\|木\_s*綿\|E\_s*\%(u\|メ\_s*ー\_s*ル\)\|祖\_s*谷\|文\_s*身\|郎\_s*[女子]\|蕁\_s*麻\|刺\_s*[青草]\|U\_s*\%(字\|タ\_s*ー\_s*ン\|r\_s*t\_s*i\_s*c\_s*a\_s*l\_s*e\_s*s\)\|海\_s*[豚参]\|西\_s*表\|鸚\_s*哥\|影\_s*[向青]\|況\_s*ん\_s*や\|所\_s*[以縁謂]\|D\_s*i\_s*a\_s*p\_s*e\_s*n\_s*s\_s*i\_s*a\_s*l\_s*e\_s*s\|藺\_s*草\|J\_s*u\_s*\%(l\_s*i\_s*a\_s*n\_s*i\_s*a\_s*l\_s*e\_s*s\|n\_s*c\_s*a\_s*l\_s*e\_s*s\)\|田\_s*舎\|膝\_s*行\|十\_s*六\_s*夜\|寝\_s*穢\|英\_s*\%([一桃蘭]\|吉\_s*利\)\|斑\_s*鳩\|烏\_s*賊\|玉\_s*筋\_s*魚\|硫\_s*黄\|N\_s*a\_s*j\_s*a\_s*d\_s*a\_s*l\_s*e\_s*s\|牛\_s*膝\|稜\_s*威\|常\_s*春\_s*藤\|5\_s*[つ日]\|５\_s*[つ日]\|惡\_s*戲\|甚\_s*振\|潮\_s*来\|悪\_s*戯\|交\_s*喙\|細\_s*小\_s*魚\|小\_s*魚\|鯨\_s*魚\|鶏\_s*魚\|経\_s*緯\|礒\_s*[山田]\|気\_s*吹\|Ｅ\_s*\%(Ａ\_s*Ｓ\_s*Ｔ\|Ｖ\_s*Ｅ\)\|従\_s*[弟妹姉兄]\|鴨\_s*脚\_s*樹\|公\_s*孫\_s*樹\|G\_s*\%(r\_s*a\_s*m\_s*i\_s*n\_s*a\_s*l\_s*e\_s*s\|l\_s*u\_s*m\_s*i\_s*f\_s*l\_s*o\_s*r\_s*a\_s*e\|i\_s*n\_s*k\_s*g\_s*o\_s*p\_s*s\_s*i\_s*d\_s*a\)\|銀\_s*杏\|鳶\_s*尾\|巫\_s*子\|神\_s*巫\|無\_s*花\_s*果\|睦\_s*月\|都\_s*方\_s*流\|縊\_s*[殺死首]\|蝟\_s*[集縮]\|埋\_s*け\_s*[火炭]\|不\_s*[可如]\|守\_s*宮\|燕\_s*龍\_s*茶\|両\_s*班\|流\_s*鏑\_s*馬\|柵\_s*原\|箭\_s*[田内]\|R\_s*a\_s*f\_s*f\_s*l\_s*e\_s*s\_s*i\_s*a\_s*\%(c\_s*e\_s*a\_s*e\|l\_s*e\_s*s\)\|自\_s*棄\|火\_s*傷\|徐\_s*ら\|M\_s*y\_s*r\_s*i\_s*c\_s*a\_s*l\_s*e\_s*s\|天\_s*蚕\|倭\_s*絵\|日\_s*本\_s*武\_s*尊\|大\_s*和\|T\_s*\%(h\_s*e\_s*l\_s*i\_s*g\_s*o\_s*n\_s*a\_s*l\_s*e\_s*s\|r\_s*o\_s*c\_s*h\_s*o\_s*d\_s*e\_s*n\_s*d\_s*r\_s*a\_s*c\_s*e\_s*a\_s*e\)\|香\_s*具\_s*師\|玄\_s*孫\|P\_s*\%(o\_s*a\_s*l\_s*e\_s*s\|l\_s*u\_s*m\_s*b\_s*a\_s*g\_s*i\_s*n\_s*a\_s*l\_s*e\_s*s\|a\_s*l\_s*m\_s*a\_s*l\_s*e\_s*s\|r\_s*\%(o\_s*t\_s*e\_s*a\_s*l\_s*e\_s*s\|i\_s*n\_s*c\_s*i\_s*p\_s*e\_s*s\)\)\|A\_s*r\_s*a\_s*c\_s*a\_s*l\_s*e\_s*s\|妥\_s*子\|寿\_s*[詞男]\|Ｙ\_s*\%([談軸]\|シ\_s*ャ\_s*ツ\)\|エ\_s*\%(ホ\_s*バ\|フ\_s*ゲ\_s*ニ\_s*ー\|レ\_s*ヴ\_s*ァ\_s*ン\|ニ\_s*セ\_s*イ\|ー\_s*ル\)\|ワ\_s*イ\)',
      \ 'z' : '\%([空損存揃園薗底續束足屬∈∋賊続粟族俗属慥僧梍臧噌賍臟贓憎像臓贈象増造曾初沿曽反添ぞ譱然繕禪苒薇千蠕∀髯禅善漸冉前全關関蝉膳錢銭絶噬説勢筮贅脆税攻是責ぜ狡詰桷寸喘鮨附◆惴蘂膸蕋髓蕊隧隋隨瑞髄随厨付圖頭刷鶴津酢逗図廚豆好ず塩嶋島嶌縞橲竺衂衄宍舳忸軸舌祖喰食直凝日實昵印者闍鮭邪蛇麝着鉐惹搦尺雀寂若弱尻侭仞刄臣恁儘潯贐稔進盡仭糂訊俥蕁迅刃靱荏甚靭燼櫁樒塵尽尋陣腎壬人敍莇茹杼洳敘汝蜍耡恕舒縟褥蓐辱溽所抒鋤徐絮序叙助帖穰疂聶疊驤襄淨讓繩禳絛蕘諚仗壌滌繞生靜蟐壤仍茸嬲疉塲乘遶星瀞拯釀躡孃如醤剩娘嬢錠静醸縄女尉饒丈成烝擾嫋穣丞場杖條条蒸貞状攘畳剰冗定浄乗情城上常譲懦愀鷲竪嬬戍得濡咒讐讎就聚笋篤盾徇凖楯詢隼筍蓴惇洵淳閏恂諄馴旬荀潤循醇巡遵順准殉純準襦誦需朮戌宿孰塾珠熟恤術述豎孺呪儒綬樹受授壽揉從澀狃中戎拾廿鞣从縱澁糅蹂神汁獸絨縦渋柔什充十従獣住銃重事迩爺滋除怩尓痔璽至児士寿茲孳染嗣柱寺磁仕治死爾路而仁辞塒時岻粫持恃敷焦字只地轜侍瓷亊知辭餌冶邇弍似祀以子峙二史自畤兒示耳慈司蒔次珥膩じ騒澤沢猿笊晒皿曝鮫参算懴慘竄鏨山殘塹巉懺嶄讒惨暫慚慙斬残実笹酒坂盛三嵜崎桜榴襍雜棹竿雑斉濟西才済劑戝剤材財罪在覚座咲戯冴坐蔵左裂冷藏差醒挫ざｚ→↑ЪЬьъ↓←жЖズゾ零〇〒ザジζЗゼзΖz]\|ｯ\_s*\%(ｿ\_s*ﾞ\|ｾ\_s*ﾞ\|ｽ\_s*ﾞ\|ｼ\_s*ﾞ\|ｻ\_s*ﾞ\)\|ッ\_s*[ゾゼズジザ]\|っ\_s*[ぞぜずじざ]\|ｿ\_s*ﾞ\|簇\_s*生\|双\_s*紙\|草\_s*[履子紙]\|ｾ\_s*ﾞ\|台\_s*詞\|０\_s*次\|撥\_s*条\|発\_s*条\|發\_s*条\|世\_s*阿\_s*弥\|ｽ\_s*ﾞ\|相\_s*撲\|木\_s*菟\|修\_s*法\|杜\_s*撰\|調\_s*所\|徒\_s*[罪刑]\|螟\_s*虫\|芋\_s*茎\|F\_s*i\_s*g\_s*u\_s*r\_s*e\|ｼ\_s*ﾞ\|G\_s*\%(メ\_s*ン\|パ\_s*ン\)\|D\_s*y\|Ｇ\_s*\%(メ\_s*ン\|パ\_s*ン\)\|支\_s*度\|試\_s*合\|２\_s*乗\|2\_s*乗\|J\_s*\%(I\_s*S\_s*コ\_s*ー\_s*ド\|ポ\_s*ッ\_s*プ\|R\_s*東\_s*日\_s*本\)\|獅\_s*子\|甲\_s*乙\_s*丙\_s*丁\_s*戊\_s*己\_s*庚\_s*辛\_s*壬\_s*癸\|k\_s*\$\_s*_\_s*{\_s*e\_s*f\_s*f\_s*}\_s*\$\|爪\_s*哇\|射\_s*礼\|砂\_s*利\|謝\_s*花\|著\_s*語\|杓\_s*子\|深\_s*\%(秘\|大\_s*寺\)\|秦\_s*泉\_s*寺\|沈\_s*\%(香\|丁\_s*花\)\|晨\_s*朝\|濁\_s*世\|判\_s*官\|諍\_s*論\|長\_s*夜\|漏\_s*斗\|焼\_s*酎\|鐘\_s*石\|橈\_s*脚\_s*類\|承\_s*久\|朱\_s*里\|C\_s*a\_s*b\_s*o\_s*m\_s*b\_s*o\_s*i\_s*d\_s*e\_s*a\_s*e\|Ｊ\_s*\%(リ\_s*ー\_s*グ\|ポ\_s*ッ\_s*プ\|Ｕ\_s*Ｎ\_s*Ｋ\_s*Ｏ\)\|絢\_s*子\|頌\_s*偈\|数\_s*珠\|入\_s*[魂牢来洛院内水棺]\|霜\_s*月\|１\_s*\%(２\|６\_s*進\|０\_s*[進月]\|１\_s*月\|８\_s*禁\)\|師\_s*走\|極\_s*月\|紐\_s*帯\|1\_s*\%(0\|1\_s*月\|8\_s*禁\|2\_s*月\)\|ｻ\_s*ﾞ\|搾\_s*菜\|蜊\_s*蛄\|粗\_s*目\|槧\_s*本\|散\_s*切\_s*り\|沙\_s*汰\|柘\_s*榴\|石\_s*榴\|細\_s*工\|亜\_s*鉛\|サ\_s*\%(モ\_s*ラ\|ン\_s*ポ\_s*ー\_s*ニ\_s*ャ\|ラ\_s*ゴ\_s*サ\)\|Z\_s*\%([r軸]\|i\_s*\%(r\_s*c\_s*o\_s*n\_s*i\_s*u\_s*m\|n\_s*c\)\|ガ\_s*ン\_s*ダ\_s*ム\|バ\_s*ッ\_s*フ\_s*ァ\|I\_s*P\_s*フ\_s*ァ\_s*イ\_s*ル\)\|シ\_s*\%(タ\_s*ー\_s*ル\|オ\_s*\%(ン\|ニ\_s*\%(ス\_s*ト\|ズ\_s*ム\)\)\)\|Ｚ\_s*\%([旗軸]\|変\_s*換\|ｉ\_s*ｇ\_s*ｇ\_s*ｙ\)\|ツ\_s*\%(ァ\_s*\%(ラ\_s*ト\_s*ゥ\_s*ス\_s*ト\_s*ラ\|イ\_s*ト\)\|ェ\_s*\%(ナ\_s*ー\|ッ\_s*ペ\_s*リ\_s*ン\|ル\_s*マ\_s*ッ\_s*ト\)\|ィ\_s*\%(ク\_s*ル\_s*ス\|タ\_s*ー\|ー\_s*グ\_s*ラ\_s*ー\|ン\_s*\%(バ\_s*ロ\_s*ン\|マ\_s*ー\_s*マ\_s*ン\)\|ゴ\_s*イ\_s*ネ\_s*ル\)\)\|チ\_s*\%(ク\_s*ル\_s*ス\|ア\_s*ノ\_s*ー\_s*ゼ\|ュ\_s*ー\_s*リ\_s*\%(ヒ\|ッ\_s*ヒ\)\|ャ\_s*ル\_s*ダ\_s*ッ\_s*シ\_s*ュ\|ゴ\_s*イ\_s*ネ\_s*ル\_s*ワ\_s*イ\_s*ゼ\_s*ン\)\)',
      \ '{' : '[｛{]',
      \ '|' : '[├┣｜‖│┃|]',
      \ '}' : '[｝}]',
      \ '~' : '[¬〜￣~]',
    \ }
endfunction
